proc database_statistics_init {} {
    global env
    global closeImg
    global checkedImg
    global uncheckedImg
    global statistics_aVSb_downL
    global statistics_aVSb_upL
    global statistics_lists
    global statistics_entries
    global statistics_num
    global db_stat_feat
    global db_stat_canTagL
    
    set env(db_stat.num) +
    set env(db_stat.name) +
    set env(db_stat.a) +
    set env(db_stat.b) +
    set env(db_stat.aLog2) +
    set env(db_stat.bLog2) +
    set env(db_stat.fchangeMean) -
    set env(db_stat.fchangeMeanN) -
    set env(db_stat.fchangeMedian) -
    set env(db_stat.fchangeMedianN) -
    set env(db_stat.fchangeTotal) -
    set env(db_stat.fchangeTotalN) -
    set env(db_stat.meanA) -
    set env(db_stat.meanAN) -
    set env(db_stat.meanB) -
    set env(db_stat.meanBN) -
    set env(db_stat.medianA) -
    set env(db_stat.medianAN) -
    set env(db_stat.medianB) -
    set env(db_stat.medianBN) -
    set env(db_stat.pvalA) -
    set env(db_stat.pvalAN) -
    set env(db_stat.pvalB) -
    set env(db_stat.pvalBN) -
    set env(db_stat.pvaltt) -
    set env(db_stat.pvalttN) -
    set env(db_stat.pvalttCorr) -
    set env(db_stat.pvalttNCorr) -
    set env(db_stat.distinctA) -
    set env(db_stat.distinctAN) -
    set env(db_stat.distinctB) -
    set env(db_stat.distinctBN) -
    
    set statistics_aVSb_downL ""
    set statistics_aVSb_upL ""
    set statistics_lists ""
    set statistics_entries 0
    set statistics_num 0
    set db_stat_canTagL ""
    
    #Creating menu buttons
    .menubar.tool.menu add command -label "Expression analysis" -command "statistics_aVSbList_window"
    .menubar.tab.menu add command -label "Database Statistics" -command "catch {create_tab db_stat}"
    
    # Database Statistics
    set notebook .result.notebook1.nb
    global db_stat_length_start
    global db_stat_length_end
    global db_stat_length_step
    global db_stat_ccover_min
    global db_stat_ccover_max
    global db_stat_clength_min
    global db_stat_clength_max
    global db_stat_fold_change
    global db_stat_fold_change_pvalCheck
    global db_stat_fold_change_distinctCheck
    global db_stat_fold_change_distinctValue
    global db_stat_fold_change_mean
    global db_stat_fold_change_normalized
    global db_stat_rnumber
    global db_stat_length
    variable db_stat_fold_change_pval
    variable db_stat_length_start
    variable db_stat_length_end
    variable db_stat_length_step
    variable db_stat_ccover_min
    variable db_stat_ccover_max
    variable db_stat_clength_min
    variable db_stat_clength_max
    variable db_stat_fold_change
    variable db_stat_rnumber
    variable db_stat_length
    set db_stat_length_start 0
    set db_stat_length_end 100000
    set db_stat_length_step 500
    set db_stat_ccover_min 0
    set db_stat_ccover_max 10000
    set db_stat_clength_min 50
    set db_stat_clength_max 100000
    set db_stat_fold_change 4
    set db_stat_fold_change_pvalCheck 0
    set db_stat_fold_change_pval 0.05
    set db_stat_fold_change_distinctCheck 0
    set db_stat_fold_change_distinctValue 100
    set db_stat_rnumber 20
    set db_stat_length 100
    
    set frame [$notebook insert end db_stat -text "Database statistics" -raisecmd "statistics_aVSb_ckeckruns"]
    frame $frame.0
    button $frame.0.prev -text "<"  -command "statistics_switch 0"
    label $frame.0.label1 -text "0"
    label $frame.0.label2 -text " of "
    label $frame.0.label3 -text "0"
    button $frame.0.next -text ">" -command "statistics_switch 1"
    label $frame.0.label4 -text "   "
    button $frame.0.remove -text "Remove" -command "statistics_switch 2"
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command ".result.notebook1.nb raise dbb; close_tab db_stat"
    frame $frame.1
    frame $frame.1.params
    label $frame.1.params.l1 -text ""
    ComboBox $frame.1.params.cb -width 20 -hottrack 1 -background white -text "Expression analysis" -values {{Coverage} {Expression analysis} {Frequency}} -modifycmd {statistics_modify type}
    label $frame.1.params.l2 -text ""
    #frequency
    frame $frame.1.params.length -bd 2 -relief groove
    label $frame.1.params.length.label1 -text ""
    frame $frame.1.params.length.t
    ComboBox $frame.1.params.length.t.cb -width 20 -hottrack 1 -background white -text "Contigs by length" -values {{Contigs by length} {Contigs by reads} {Reads by length}} -modifycmd {statistics_modify frequency}
    frame $frame.1.params.length.p
    label $frame.1.params.length.p.label1 -text "Start:"
    entry $frame.1.params.length.p.start -width 6 -background white -textvariable db_stat_length_start
    label $frame.1.params.length.p.label2 -text " End:"
    entry $frame.1.params.length.p.end -width 6 -background white -textvariable db_stat_length_end
    frame $frame.1.params.length.s
    label $frame.1.params.length.s.label1 -text "Step width:"
    entry $frame.1.params.length.s.step -width 6 -background white -textvariable db_stat_length_step
    button $frame.1.params.length.but -text "Run" -command "statistics_frequency"
    #coverage
    frame $frame.1.params.cover -bd 2 -relief groove
    ComboBox $frame.1.params.cover.cb -width 20 -hottrack 1 -background white -text "Contig coverage" -values {{Contig coverage} {Contig num. of reads} {Coverage per base} {Coverage per base (gaps)}} -modifycmd {statistics_modify coverage}
    label $frame.1.params.cover.labelL -text "\nLength:"
    frame $frame.1.params.cover.l
    label $frame.1.params.cover.l.label1 -text "Min."
    entry $frame.1.params.cover.l.start -width 5 -background white -textvariable db_stat_clength_min
    label $frame.1.params.cover.l.label2 -text " Max."
    entry $frame.1.params.cover.l.end -width 6 -background white -textvariable db_stat_clength_max
    label $frame.1.params.cover.labelC -text "\nCov/Num:"
    frame $frame.1.params.cover.c
    label $frame.1.params.cover.c.label1 -text "Min."
    entry $frame.1.params.cover.c.start -width 5 -background white -textvariable db_stat_ccover_min
    label $frame.1.params.cover.c.label2 -text " Max."
    entry $frame.1.params.cover.c.end -width 6 -background white -textvariable db_stat_ccover_max
    button $frame.1.params.cover.but -text "Run" -command "statistics_coverage"
    #expression analysis
    frame $frame.0.foldchange
    button $frame.0.foldchange.refresh -text "Refresh" -command "statistics_aVSb_draw"
    button $frame.0.foldchange.showup -text "Show UP" -command "statistics_aVSb_show up"
    button $frame.0.foldchange.showdown -text "Show DOWN" -command "statistics_aVSb_show down"
    
    frame $frame.1.params.aVSb -bd 2 -relief groove
    ComboBox $frame.1.params.aVSb.cb -width 20 -hottrack 1 -background white -text "Fold change" -values {{Linear} {Log2} {Fold change} {Fold change (Log2)}} -modifycmd {statistics_modify aVSb}
    label $frame.1.params.aVSb.feat_cbl -text "\nChoose contig List:"
    ComboBox $frame.1.params.aVSb.feat_cb -width 15 -hottrack 1 -background white -text "all" -values {{all} {with hits} {without hits} blast blastprodom coil gene3d go interpro panther patternscan pfam pir profilescan smart superfamily tigr {with comment}}
    frame $frame.1.params.aVSb.n
    label $frame.1.params.aVSb.n.label1 -text "Min. number of reads:"
    entry $frame.1.params.aVSb.n.num -width 5 -background white -textvariable db_stat_rnumber
    frame $frame.1.params.aVSb.l
    label $frame.1.params.aVSb.l.label1 -text "Min. contig length:"
    entry $frame.1.params.aVSb.l.len -width 5 -background white -textvariable db_stat_length
    frame $frame.1.params.aVSb.f -bd 2 -relief groove
    frame $frame.1.params.aVSb.f.ent
    label $frame.1.params.aVSb.f.ent.label1 -text "Min. fold change:"
    entry $frame.1.params.aVSb.f.ent.foldchange -width 5 -background white -textvariable db_stat_fold_change
    frame $frame.1.params.aVSb.f.mean
    radiobutton $frame.1.params.aVSb.f.mean.median -text "median" -variable db_stat_fold_change_mean -value "median"
    radiobutton $frame.1.params.aVSb.f.mean.mean -text "mean" -variable db_stat_fold_change_mean -value "mean"
    radiobutton $frame.1.params.aVSb.f.mean.total -text "total" -variable db_stat_fold_change_mean -value "total"
    $frame.1.params.aVSb.f.mean.median select
    frame $frame.1.params.aVSb.f.normalized
    radiobutton $frame.1.params.aVSb.f.normalized.normalized -text "normalized" -variable db_stat_fold_change_normalized -value "normalized"
    radiobutton $frame.1.params.aVSb.f.normalized.absolute -text "absolute" -variable db_stat_fold_change_normalized -value "absolute"
    $frame.1.params.aVSb.f.normalized.normalized select
    frame $frame.1.params.aVSb.f.pval
    checkbutton $frame.1.params.aVSb.f.pval.check -text "Max. pValue:" -variable db_stat_fold_change_pvalCheck
    entry $frame.1.params.aVSb.f.pval.ent -width 5 -background white -textvariable db_stat_fold_change_pval
    frame $frame.1.params.aVSb.f.distinct
    checkbutton $frame.1.params.aVSb.f.distinct.check -text "distinct (%): " -variable db_stat_fold_change_distinctCheck
    entry $frame.1.params.aVSb.f.distinct.ent -width 5 -background white -textvariable db_stat_fold_change_distinctValue
    button $frame.1.params.aVSb.but -text "Run" -command "statistics_aVSb tab"
    
    frame $frame.1.fr
    frame $frame.1.fr.view
    radiobutton $frame.1.fr.view.diagram -text "Diagram" -variable dbview_rb -value "Diagram" -command {pack forget .result.notebook1.nb.fdb_stat.1.fr.table; pack .result.notebook1.nb.fdb_stat.1.fr.can -side bottom -fill both -expand true}
    radiobutton $frame.1.fr.view.text -text "List" -variable dbview_rb -value "List" -command {pack forget .result.notebook1.nb.fdb_stat.1.fr.can; pack .result.notebook1.nb.fdb_stat.1.fr.table -side bottom -fill both -expand true}
    $frame.1.fr.view.diagram select
    canvas $frame.1.fr.can -background white -width 600 -height 1
    scrollbar $frame.1.fr.x -orient horizontal -command "$frame.1.fr.table.l xview"
    frame $frame.1.fr.table
    tablelist::tablelist $frame.1.fr.table.l \
            -width 24 -height 1 -showseparators 1 -stripebackground lightblue\
            -labelcommand "$frame.1.fr.table.l finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.fr.table.y set" \
            -xscrollcommand "$frame.1.fr.x set" \
            -background white
    
    scrollbar $frame.1.fr.table.y -orient vertical -command "$frame.1.fr.table.l yview"
    
    pack $frame.0.prev $frame.0.label1 $frame.0.label2 $frame.0.label3 $frame.0.next $frame.0.label4 $frame.0.remove -side left -fill both -anchor w
    pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.0.foldchange.showup $frame.0.foldchange.showdown -side left -anchor w; pack $frame.0.foldchange.refresh -side right -anchor e
    pack $frame.0.foldchange
    pack $frame.1.params.length.t.cb -anchor w -side top
    pack $frame.1.params.length.p.label1 $frame.1.params.length.p.start $frame.1.params.length.p.label2 $frame.1.params.length.p.end -anchor w -side left
    pack $frame.1.params.length.s.label1 $frame.1.params.length.s.step -anchor w -side left
    pack $frame.1.params.length.t $frame.1.params.length.label1 $frame.1.params.length.p $frame.1.params.length.s $frame.1.params.length.but -anchor w -side top
    pack $frame.1.params.cover.l.start $frame.1.params.cover.l.label2 $frame.1.params.cover.l.end -anchor w -side left
    pack $frame.1.params.cover.c.label1 $frame.1.params.cover.c.start $frame.1.params.cover.c.label2 $frame.1.params.cover.c.end -anchor w -side left
    pack $frame.1.params.cover.cb -anchor w -side top; pack $frame.1.params.cover.but $frame.1.params.cover.c $frame.1.params.cover.labelC $frame.1.params.cover.l $frame.1.params.cover.labelL -side bottom -anchor w
    pack $frame.1.params.aVSb.f.ent.label1 -anchor w -side left; pack $frame.1.params.aVSb.f.ent.foldchange -side right
    pack $frame.1.params.aVSb.f.mean.median $frame.1.params.aVSb.f.mean.mean -anchor w -side left; pack $frame.1.params.aVSb.f.mean.total -side right
    pack $frame.1.params.aVSb.f.normalized.normalized -anchor w -side left; pack $frame.1.params.aVSb.f.normalized.absolute -side right
    pack $frame.1.params.aVSb.f.pval.check -anchor w -side left; pack $frame.1.params.aVSb.f.pval.ent -side right
    pack $frame.1.params.aVSb.f.distinct.check $frame.1.params.aVSb.f.distinct.ent -anchor w -side left
    pack $frame.1.params.aVSb.n.label1 -anchor w -side left; pack $frame.1.params.aVSb.n.num -side right
    pack $frame.1.params.aVSb.l.label1 -anchor w -side left; pack $frame.1.params.aVSb.l.len -side right
    pack $frame.1.params.aVSb.f.ent $frame.1.params.aVSb.f.mean $frame.1.params.aVSb.f.normalized $frame.1.params.aVSb.f.pval $frame.1.params.aVSb.f.distinct -side top -anchor w
    pack $frame.1.params.aVSb.f -side bottom -anchor w
    pack $frame.1.params.aVSb.cb $frame.1.params.aVSb.feat_cbl $frame.1.params.aVSb.feat_cb -anchor w -side top
    pack $frame.1.params.aVSb.l $frame.1.params.aVSb.n -fill both -side top; pack $frame.1.params.aVSb.but -side top -anchor w
    pack $frame.1.params.l1 $frame.1.params.cb $frame.1.params.l2 $frame.1.params.aVSb -side top -anchor w
    pack $frame.1.fr.table.l -fill both -side left -expand true; pack $frame.1.fr.table.y  -fill both -side left
    pack $frame.1.params -fill both -side left
    pack $frame.1.fr.view.diagram $frame.1.fr.view.text -fill both -side left
    pack $frame.1.fr.view -fill both -side top; pack $frame.1.fr.x -fill both -side bottom; pack $frame.1.fr.can -fill both -side bottom -expand true
    pack $frame.1.fr -fill both -side left -expand true
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    #Database_statistics
    set tl .result.notebook1.nb.fdb_stat.1.fr.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    rightmenu_database_statistics db_stat db_stat - \$coord
    "
}

proc database_statistics_remove {} {
    #Remove menu buttons
    .menubar.config.menu delete "Database Statistics"
    .result.notebook1.nb delete db_stat
}

proc statistics_draw {} {
    global env
    global db_stat_canTagL
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    foreach tag $db_stat_canTagL {
        .result.notebook1.nb.fdb_stat.1.fr.can delete $tag
    }
    set db_stat_canTagL ""
    .result.notebook1.nb.fdb_stat.1.fr.can delete a
    .result.notebook1.nb.fdb_stat.1.fr.table.l delete 0 end
    catch {.result.notebook1.nb.fdb_stat.1.fr.table.l deletecolumns 0 end}
    
    .result.notebook1.nb.fdb_stat.0.label1 configure -text "[expr $statistics_num + 1]"
    .result.notebook1.nb.fdb_stat.0.label3 configure -text "$statistics_entries"
    if {$statistics_entries ne 0} {
        if {[lindex [lindex $statistics_lists $statistics_num] 0] eq "aVSb"} {
            statistics_aVSb_draw
        } elseif {[lindex [lindex $statistics_lists $statistics_num] 0] eq "coverage"} {
            statistics_coverage_draw
        } elseif {[lindex [lindex $statistics_lists $statistics_num] 0] eq "frequency"} {
            statistics_frequency_draw
        }
    }
}

proc statistics_switch {mode} {
    global env
    global statistics_lists
    global statistics_entries
    global statistics_num
    if {$mode eq 1} {
        incr statistics_num
        if {$statistics_num >= $statistics_entries} {
            set statistics_num [expr $statistics_entries - 1]
        } else {
            statistics_draw
        }
    } elseif {$mode eq 0} {
        set statistics_num [expr $statistics_num - 1]
        if {$statistics_num < 0} {
            set statistics_num 0
        } else {
            statistics_draw
        }
    } elseif {$mode eq 2} {
        if {$statistics_entries ne 0} {
            set statistics_lists [lreplace $statistics_lists $statistics_num $statistics_num]
            set statistics_entries [expr $statistics_entries - 1]
            set statistics_num [expr $statistics_num - 1]
            if {$statistics_num < 0} {
                set statistics_num 0
            }
            statistics_draw
        }
    }
}

proc statistics_frequency {} {
    global env
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    if {$env(dbName) ne " "} {
        if {[.result.notebook1.nb.fdb_stat.1.params.length.t.cb get] eq "Contigs by length"} {
            set type "sequences_nucleotide length"
        } elseif {[.result.notebook1.nb.fdb_stat.1.params.length.t.cb get] eq "Contigs by reads"} {
            set type "sequences_nucleotide numreads"
        } elseif {[.result.notebook1.nb.fdb_stat.1.params.length.t.cb get] eq "Reads by length"} {
            set type "sequences_read length"
        }
        
        set start [.result.notebook1.nb.fdb_stat.1.params.length.p.start get]
        set stop [.result.notebook1.nb.fdb_stat.1.params.length.p.end get]
        set stepsize [.result.notebook1.nb.fdb_stat.1.params.length.s.step get]
        set step [expr $start + $stepsize]
        set count 0
        set max 0
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT [lindex $type 1] AS res FROM $env(dbName).[lindex $type 0] ORDER BY [lindex $type 1]"}}]]
        foreach sRes $sql_res {
            if {[lindex $sRes 0] <= $step} {
                incr count
            } elseif {[lindex $sRes 0] > $stop} {
                break
            } else {
                if {$count > $max} {
                    set max $count
                }
                lappend resL "$step $count"
                set step [expr $step + $stepsize]
                while {[lindex $sRes 0] > $step} {
                    lappend resL "$step 0"
                    set step [expr $step + $stepsize]
                }
                set count 1
            }
        }
        unset sql_res
        lappend resL "$step $count"
        if {$count > $max} {
            set max $count
        }
        lappend statistics_lists "frequency {$type} {$resL} $max $start $stop $stepsize $env(dbName)"
        set statistics_entries [llength $statistics_lists]
        set statistics_num [expr $statistics_entries - 1]
        statistics_draw
        
        unset resL
    }
}

proc statistics_frequency_draw {} {
    global env
    global db_stat_canTagL
    global db_stat_length_start
    global db_stat_length_end
    global db_stat_length_step
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    .result.notebook1.nb.fdb_stat.1.params.cb configure -text "Frequency"
    set type [lindex [lindex $statistics_lists $statistics_num] 1]
    set resL [lindex [lindex $statistics_lists $statistics_num] 2]
    set max [lindex [lindex $statistics_lists $statistics_num] 3]
    
    pack forget .result.notebook1.nb.fdb_stat.1.params.cover; pack forget .result.notebook1.nb.fdb_stat.1.params.aVSb; pack .result.notebook1.nb.fdb_stat.1.params.length
    if {$type eq "sequences_nucleotide length"} {
        .result.notebook1.nb.fdb_stat.1.params.length.t.cb configure -text "Contigs by length"
    } elseif {$type eq "sequences_nucleotide numreads"} {
        .result.notebook1.nb.fdb_stat.1.params.length.t.cb configure -text "Contigs by reads"
    } elseif {$type eq "sequences_read length"} {
        .result.notebook1.nb.fdb_stat.1.params.length.t.cb configure -text "Reads by length"
    }
    set db_stat_length_start [lindex [lindex $statistics_lists $statistics_num] 4]
    set db_stat_length_end [lindex [lindex $statistics_lists $statistics_num] 5]
    set db_stat_length_step [lindex [lindex $statistics_lists $statistics_num] 6]
    set db [lindex [lindex $statistics_lists $statistics_num] 7]
    
    set width [expr [winfo width .result.notebook1.nb.fdb_stat.1.fr.can] - 70]
    set height [expr [winfo height .result.notebook1.nb.fdb_stat.1.fr.can] - 50]
    
    .result.notebook1.nb.fdb_stat.1.fr.can create line 50 20 50 $height -tag a
    .result.notebook1.nb.fdb_stat.1.fr.can create line 50 $height [expr $width + 50] $height -tag a
    if {[lindex $type 0] eq "sequences_nucleotide"} {
        set txt "y: Number of Contigs"
        if {[lindex $type 1] eq "length"} {
            append txt "          x: Contig length"
            .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Contig length" left 0 "Quantity" left
        } else  {
            append txt "          x: Number of Reads in Contig"
            .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Num. of reads" left 0 "Quantity" left
        }
    } else {
        set txt "y: Number of Reads          x: Read length"
        .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Reads length" left 0 "Quantity" left
    }
    append txt "   -   $db"
    
    .result.notebook1.nb.fdb_stat.1.fr.can create text 50 [expr 40 + $height] -text $txt -anchor w -tag "a"
    
    set levels [string length $max]
    set max [expr log10(pow(10, $levels))]
    for {set i 0} {$i <= $levels} {incr i} {
        .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [lindex [split [expr 20.0 + ($height.0 - 20.0) / $levels * $i.0] .] 0] 50 [lindex [split [expr 20.0 + ($height.0 - 20.0) / $levels * $i.0] .] 0] -tag "a"
        set txt "10^[expr $levels - $i]"
        if {$txt eq "10^1"} {
            set txt 10
        } elseif {$txt eq "10^0"} {
            set txt 0
        }
        .result.notebook1.nb.fdb_stat.1.fr.can create text 5 [lindex [split [expr 20.0 + ($height.0 - 20.0) / $levels * $i.0] .] 0] -text $txt -anchor w -tag "a"
    }
    set w [expr $width / [llength $resL]]
    if {$w > 100} {
        set w 100
    }
    
    set j 0
    set tmp [expr int([llength $resL] / 9)]
    set txt 0
    foreach res $resL {
        set lh [lindex [split [expr 1 + ($height.0 - 20) / $max * log10([lindex $res 1])] .] 0]
        if {$lh ne "-Inf"} {
            .result.notebook1.nb.fdb_stat.1.fr.can create rect [expr 50 + $j * $w] [expr $height - $lh] [expr 50 + ($j + 1) * $w] $height -fill green -tag "a"
        }
        .result.notebook1.nb.fdb_stat.1.fr.can create line [expr 50 + ($j + 1) * $w] $height [expr 50 + ($j + 1) * $w] [expr $height + 10] -tag "a"
        if {$j >= $txt} {
            .result.notebook1.nb.fdb_stat.1.fr.can create text [expr 50 + ($j + 1) * $w] [expr 20 + $height] -text [lindex $res 0] -anchor c -tag "a"
            set txt [expr $txt + $tmp]
        }
        incr j
        .result.notebook1.nb.fdb_stat.1.fr.table.l insert end "[lindex $res 0] [lindex $res 1]"
    }
    unset resL
}

proc statistics_coverage {} {
    global env
    global db_stat_canTagL
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    variable maxC
    variable bases
    
    foreach tag $db_stat_canTagL {
        .result.notebook1.nb.fdb_stat.1.fr.can delete $tag
    }
    set db_stat_canTagL ""
    .result.notebook1.nb.fdb_stat.1.fr.can delete a
    .result.notebook1.nb.fdb_stat.1.fr.table.l delete 0 end
    
    if {$env(dbName) ne " "} {
        if {[.result.notebook1.nb.fdb_stat.1.params.cover.cb get] eq "Coverage per base"} {
            set type "base"
        } elseif {[.result.notebook1.nb.fdb_stat.1.params.cover.cb get] eq "Coverage per base (gaps)"} {
            set type "baseGaps"
        } elseif {[.result.notebook1.nb.fdb_stat.1.params.cover.cb get] eq "Contig coverage"} {
            set type "coverage"
        } elseif {[.result.notebook1.nb.fdb_stat.1.params.cover.cb get] eq "Contig num. of reads"} {
            set type "numreads"
        }
        set lenMin [.result.notebook1.nb.fdb_stat.1.params.cover.l.start get]
        set lenMax [.result.notebook1.nb.fdb_stat.1.params.cover.l.end get]
        set coverMin [regsub -all {,} [.result.notebook1.nb.fdb_stat.1.params.cover.c.start get] "."]
        set coverMax [regsub -all {,} [.result.notebook1.nb.fdb_stat.1.params.cover.c.end get] "."]
        set ::threadCoverage [thread::create {
            proc coverage {dbName processID mainThreadID phpThreadID type lenMin lenMax coverMin coverMax} {
                global env
                set maxC 0
                set maxL 0
                set bases 0
                set coverL ""
                if {$type eq "base" || $type eq "baseGaps"} {
                    if {$type eq "base"} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT base_cover FROM $dbName.sequences_nucleotide"}}]]
                    } elseif {$type eq "baseGaps"} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT base_cover FROM $dbName.sequences_nucleotide"}}]]
                    }
                    foreach sRes $sql_res {
                        append out "[lindex $sRes 0]\n"
                    }
                    unset sRes; unset sql_res
                    if {[catch {set ft [open [pwd]/tmp_cover w]}]} {
                    } else {
                        puts -nonewline $ft $out
                        unset out
                        close $ft
                    }
                    if {[catch {set ft [open [pwd]/tmp_cover r]}]} {
                    } else {
                        if {$type eq "base"} {
                            while {[gets $ft line] != -1} {
                                foreach cover $line {
                                    if {[lindex $cover 4] <= [lindex $cover 0] || [lindex $cover 4] <= [lindex $cover 1] || [lindex $cover 4] <= [lindex $cover 2] || [lindex $cover 4] <= [lindex $cover 3]} {
                                        set c [expr [lindex $cover 0] + [lindex $cover 1] + [lindex $cover 2] + [lindex $cover 3]]
                                        if {$c > $maxC} {
                                            set maxC $c
                                        }
                                        if {[catch {incr coverArr($c)}]} {set coverArr($c) 1}
                                        incr bases
                                        unset cover; unset c
                                    }
                                }
                            }
                            unset line
                        } elseif {$type eq "baseGaps"} {
                            while {[gets $ft line] != -1} {
                                foreach cover $line {
                                    set c [expr [lindex $cover 0] + [lindex $cover 1] + [lindex $cover 2] + [lindex $cover 3]]
                                    if {$c > $maxC} {
                                        set maxC $c
                                    }
                                    if {[catch {incr coverArr($c)}]} {set coverArr($c) 1}
                                    incr bases
                                    unset cover; unset c
                                }
                            }
                            unset line
                        }
                        close $ft
                        catch {file delete [pwd]/tmp_cover}
                    }
                    
                    for {set i 1} {$i <= $maxC} {incr i} {
                        if {[catch {
                                lappend coverL $coverArr($i)
                                unset coverArr($i)
                            }]} {
                            lappend coverL 0
                        }
                    }
                } else {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, length, $type AS cover FROM $dbName.seq_info WHERE length >= $lenMin AND length <= $lenMax AND $type >= $coverMin AND $type <= $coverMax ORDER BY id_seq"}}]]
                    foreach sRes $sql_res {
                        if {[lindex $sRes 1] > $maxL} {
                            set maxL [lindex $sRes 1]
                        }
                        if {[lindex $sRes 2] > $maxC} {
                            set maxC [lindex $sRes 2]
                        }
                        lappend coverL "[lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 2]"
                    }
                    unset sql_res
                }
                returnResult $processID finished $dbName $mainThreadID
                set coverL "coverage $type {$coverL} $maxC $maxL {$bases} $lenMin $lenMax $coverMin $coverMax $env(dbName)"
                eval [subst {thread::send $mainThreadID {::statistics_update "$coverL"}}]
                eval [subst {thread::send -async $mainThreadID {::statistics_draw}}]
                unset coverL
            }
            proc returnResult {processID status dbName mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status - $dbName 1}}]
            }
            thread::wait
        }]
        
        set processID [llength $env(processL)]
        if {$type eq "base" || $type eq "baseGaps"} {
            process_update $processID running "Running Coverage, type: $type" $env(dbName) 0
        } else {
            process_update $processID running "Running Coverage, type: $type; minCoverage: $coverMin; maxCoverage: $coverMax; minLength: $lenMin; maxLength: $lenMax" $env(dbName) 0
        }
        eval [subst {thread::send -async $::threadCoverage {::coverage $env(dbName) $processID $env(mainThreadID) $env(phpThreadID) $type $lenMin $lenMax $coverMin $coverMax}}]
    }
}

proc statistics_coverage_draw {} {
    global env
    global db_stat_ccover_min
    global db_stat_ccover_max
    global db_stat_clength_min
    global db_stat_clength_max
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    .result.notebook1.nb.fdb_stat.1.params.cb configure -text "Coverage"
    set type [lindex [lindex $statistics_lists $statistics_num] 1]
    set coverL [lindex [lindex $statistics_lists $statistics_num] 2]
    set maxC [lindex [lindex $statistics_lists $statistics_num] 3]
    set maxL [lindex [lindex $statistics_lists $statistics_num] 4]
    set bases [lindex [lindex $statistics_lists $statistics_num] 5]
    
    set width [expr [winfo width .result.notebook1.nb.fdb_stat.1.fr.can] - 70]
    set height [expr [winfo height .result.notebook1.nb.fdb_stat.1.fr.can] - 70]
    
    pack forget .result.notebook1.nb.fdb_stat.1.params.length; pack forget .result.notebook1.nb.fdb_stat.1.params.aVSb; pack .result.notebook1.nb.fdb_stat.1.params.cover
    if {$type eq "coverage"} {
        .result.notebook1.nb.fdb_stat.1.params.cover.cb configure -text "Contig coverage"
    } elseif {$type eq "numreads"} {
        .result.notebook1.nb.fdb_stat.1.params.cover.cb configure -text "Contig num. of reads"
    } elseif {$type eq "base"} {
        .result.notebook1.nb.fdb_stat.1.params.cover.cb configure -text "Coverage per base"
    } elseif {$type eq "baseGaps"} {
        .result.notebook1.nb.fdb_stat.1.params.cover.cb configure -text "Coverage per base (gaps)"
    }
    
    set db_stat_clength_min [lindex [lindex $statistics_lists $statistics_num] 6]
    set db_stat_clength_max [lindex [lindex $statistics_lists $statistics_num] 7]
    set db_stat_ccover_min [lindex [lindex $statistics_lists $statistics_num] 8]
    set db_stat_ccover_max [lindex [lindex $statistics_lists $statistics_num] 9]
    set db [lindex [lindex $statistics_lists $statistics_num] 10]
    
    .result.notebook1.nb.fdb_stat.1.fr.can create line 50 20 50 [expr 20 + $height] -tag a
    
    if {$type eq "base" || $type eq "baseGaps"} {
        set stepC [expr $height.0 / 5.0]
        set stepL [expr $width.0 / $maxC.0]
        if {$stepL < 3} {
            set stepL 3
        }
        set txt "y: Number of bases (Log10)    x: Coverage per base    Total number of bases: $bases   -   $db"
        .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Coverage" left 0 "Bases" left
        .result.notebook1.nb.fdb_stat.1.fr.can create text [expr $width / 2] [expr 60 + $height] -text $txt -anchor w -tag a
        
        for {set i 0} {$i <= 5} {incr i} {
            .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [expr 20 + int($height.0 / 5 * $i.0)] [expr 50 + 3 * [llength $coverL]] [expr 20 + int($height.0 / 5 * $i.0)] -tag a
            set y "10^[expr 5 - $i]"
            .result.notebook1.nb.fdb_stat.1.fr.can create text 3 [expr 20 + int($height.0 / 5 * $i.0)] -text $y -anchor w -tag a
        }
        for {set i 0} {$i <= [llength $coverL]} {set i [expr $i + 50]} {
            .result.notebook1.nb.fdb_stat.1.fr.can create line [expr 49 + 3 * $i] [expr 20 + $height] [expr 49 + 3 * $i] [expr 30 + $height] -tag a
            .result.notebook1.nb.fdb_stat.1.fr.can create text [expr 49 + 3 * $i] [expr 40 + $height] -text $i -anchor c -tag a
        }
        
        set i 0
        foreach cover $coverL {
            set x [expr 49 + int($i * $stepL)]
            if {$cover eq 0} {
                .result.notebook1.nb.fdb_stat.1.fr.table.l insert end "[expr $i + 1] 0"
                set y 0
            } else {
                .result.notebook1.nb.fdb_stat.1.fr.table.l insert end "[expr $i + 1] $cover"
                set y [expr log10($cover)]
                if {$y > 5} {
                    set y 5
                }
                set y [expr 19 + $height - int($y * $stepC)]
                .result.notebook1.nb.fdb_stat.1.fr.can create rect $x $y [expr 2 + $x] [expr 19 + $height] -fill green -tag a
            }
            incr i
        }
        set scrollregion "0 0 [expr 69 + 3 * $i] 0"
    } else {
        set stepC [expr $height.0 / $maxC]
        set stepL [expr $width.0 / $maxL.0]
        
        if {$type eq "coverage"} {
            set txt "y: Contig coverage          x: Contigs by length   -   $db"
            .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Name" left 0 "Length" left 0 "Coverage" left
        } else {
            set txt "y: Number of reads in Contig          x: Contigs by length   -   $db"
            .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Name" left 0 "Length" left 0 "Num. of Reads" left
        }
        .result.notebook1.nb.fdb_stat.1.fr.can create text [expr $width / 2] [expr 60 + $height] -text $txt -anchor w -tag a
        
        for {set i 0} {$i <= 5} {incr i} {
            .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [expr 20 + int($height.0 / 5 * $i.0)] 50 [expr 20 + int($height.0 / 5 * $i.0)] -tag a
            set y [split [expr $maxC / 5 * (5 - $i.0)] .]
            if {[lindex $y 0] > 99} {
                set y "[lindex $y 0]"
            } else {
                set y "[lindex $y 0].[string range [lindex $y 1] 0 1]"
            }
            .result.notebook1.nb.fdb_stat.1.fr.can create text 3 [expr 20 + int($height.0 / 5 * $i.0)] -text $y -anchor w -tag a
        }
        .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + $height] [expr 50 + $width] [expr 20 + $height] -tag a
        for {set i 0} {$i <= 10} {incr i} {
            .result.notebook1.nb.fdb_stat.1.fr.can create line [expr 50 + int($width.0 / 10 * $i.0)] [expr 20 + $height] [expr 50 + int($width.0 / 10 * $i.0)] [expr 30 + $height] -tag a
            .result.notebook1.nb.fdb_stat.1.fr.can create text [expr 50 + int($width.0 / 10 * $i.0)] [expr 40 + $height] -text [expr int($maxL / 10 * $i.0)] -anchor c -tag a
        }
        
        foreach c $coverL {
            catch {
                set x [expr 49 + int([lindex $c 1] * $stepL)]
                set y [expr 19 + $height - int([lindex $c 2] * $stepC)]
                .result.notebook1.nb.fdb_stat.1.fr.can create rect $x $y [expr 2 + $x] [expr 2 + $y] -fill green -tag a
                .result.notebook1.nb.fdb_stat.1.fr.table.l insert end "[lindex $c 0] [lindex $c 1] [regsub {\.} [lindex $c 2] ,]"
            }
        }
        set scrollregion "0 0 [expr $x + 20] 0"
    }
    
    .result.notebook1.nb.fdb_stat.1.fr.can configure -scrollregion $scrollregion
    unset coverL
}

proc statistics_modify {mode} {
    global db_stat_length_start
    global db_stat_length_end
    global db_stat_length_step
    global db_stat_ccover_min
    global db_stat_ccover_max
    global db_stat_fold_change
    
    if {$mode eq "type"} {
        set type [.result.notebook1.nb.fdb_stat.1.params.cb get]
        if {$type eq "Frequency"} {
            pack forget .result.notebook1.nb.fdb_stat.0.foldchange; pack forget .result.notebook1.nb.fdb_stat.1.params.cover; pack forget .result.notebook1.nb.fdb_stat.1.params.aVSb; pack .result.notebook1.nb.fdb_stat.1.params.length; .result.notebook1.nb.fdb_stat.1.params.length.t.cb configure -text "Contigs by length"; statistics_modify frequency
        } elseif {$type eq "Coverage"} {
            pack forget .result.notebook1.nb.fdb_stat.0.foldchange; pack forget .result.notebook1.nb.fdb_stat.1.params.length; pack forget .result.notebook1.nb.fdb_stat.1.params.aVSb; pack .result.notebook1.nb.fdb_stat.1.params.cover; .result.notebook1.nb.fdb_stat.1.params.cover.cb configure -text "Contig coverage"; statistics_modify coverage
        } elseif {$type eq "Expression analysis"} {
            pack forget .result.notebook1.nb.fdb_stat.1.params.length; pack forget .result.notebook1.nb.fdb_stat.1.params.cover; pack .result.notebook1.nb.fdb_stat.1.params.aVSb; .result.notebook1.nb.fdb_stat.1.params.aVSb.cb configure -text "Fold change"; pack .result.notebook1.nb.fdb_stat.0.foldchange; statistics_modify aVSb
        }
    } elseif {$mode eq "frequency"} {
        pack forget .result.notebook1.nb.fdb_stat.0.foldchange; set type [.result.notebook1.nb.fdb_stat.1.params.length.t.cb get]
        if {$type eq "Contigs by length"} {
            set db_stat_length_start 0; set db_stat_length_end 100000; set db_stat_length_step 500
        } elseif {$type eq "Contigs by reads"} {
            set db_stat_length_start 1; set db_stat_length_end 200; set db_stat_length_step 1
        } elseif {$type eq "Reads by length"} {
            set db_stat_length_start 50; set db_stat_length_end 10000; set db_stat_length_step 10
        }
    } elseif {$mode eq "coverage"} {
        pack forget .result.notebook1.nb.fdb_stat.0.foldchange; set type [.result.notebook1.nb.fdb_stat.1.params.cover.cb get]
        if {$type eq "Contig coverage"} {
            set db_stat_ccover_min 1; set db_stat_ccover_max 10000; pack .result.notebook1.nb.fdb_stat.1.params.cover.but .result.notebook1.nb.fdb_stat.1.params.cover.c .result.notebook1.nb.fdb_stat.1.params.cover.labelC .result.notebook1.nb.fdb_stat.1.params.cover.l .result.notebook1.nb.fdb_stat.1.params.cover.labelL -side bottom -anchor w
        } elseif {$type eq "Contig num. of reads"} {
            set db_stat_ccover_min 2; set db_stat_ccover_max 100000; pack .result.notebook1.nb.fdb_stat.1.params.cover.but .result.notebook1.nb.fdb_stat.1.params.cover.c .result.notebook1.nb.fdb_stat.1.params.cover.labelC .result.notebook1.nb.fdb_stat.1.params.cover.l .result.notebook1.nb.fdb_stat.1.params.cover.labelL -side bottom -anchor w
        } elseif {$type eq "Coverage per base"} {
            pack forget .result.notebook1.nb.fdb_stat.1.params.cover.labelL .result.notebook1.nb.fdb_stat.1.params.cover.l .result.notebook1.nb.fdb_stat.1.params.cover.labelC .result.notebook1.nb.fdb_stat.1.params.cover.c
        } elseif {$type eq "Coverage per base (gaps)"} {
            pack forget .result.notebook1.nb.fdb_stat.1.params.cover.labelL .result.notebook1.nb.fdb_stat.1.params.cover.l .result.notebook1.nb.fdb_stat.1.params.cover.labelC .result.notebook1.nb.fdb_stat.1.params.cover.c
        }
    } elseif {$mode eq "aVSb"} {
        set type [.result.notebook1.nb.fdb_stat.1.params.aVSb.cb get]
        if {$type eq "Linear"} {
            pack forget .result.notebook1.nb.fdb_stat.0.foldchange; pack forget .result.notebook1.nb.fdb_stat.1.params.aVSb.f
        } elseif {$type eq "Log2"} {
            pack forget .result.notebook1.nb.fdb_stat.0.foldchange; pack forget .result.notebook1.nb.fdb_stat.1.params.aVSb.f
        } elseif {$type eq "Fold change"} {
            set db_stat_fold_change 4; pack .result.notebook1.nb.fdb_stat.0.foldchange; pack .result.notebook1.nb.fdb_stat.1.params.aVSb.f -side bottom -anchor w
        } elseif {$type eq "Fold change (Log2)"} {
            set db_stat_fold_change 1.5; pack .result.notebook1.nb.fdb_stat.0.foldchange; pack .result.notebook1.nb.fdb_stat.1.params.aVSb.f -side bottom -anchor w
        }
    }
}

proc statistics_update {resL} {
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    lappend statistics_lists "$resL"
    set statistics_entries [llength $statistics_lists]
    set statistics_num [expr $statistics_entries - 1]
    unset resL
}

proc statistics_aVSb {mode} {
    global env
    global aVSb_pvalueCheck
    global aVSb_distinctCheck
    global db_stat_fold_change_pvalCheck
    global db_stat_fold_change_distinctCheck
    global db_stat_fold_change_distinctValue
    global db_stat_fold_change_mean
    global db_stat_fold_change_normalized
    global aVSb_bOnlyCheck
    global aVSb_aOnlyCheck
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    if {$env(dbName) ne " "} {
        if {$mode eq "tab"} {
            set num [.result.notebook1.nb.fdb_stat.1.params.aVSb.n.num get]
            set len [.result.notebook1.nb.fdb_stat.1.params.aVSb.l.len get]
            set foldchange [regsub -all {,} [.result.notebook1.nb.fdb_stat.1.params.aVSb.f.ent.foldchange get] "."]
            set pval [regsub -all {,} [.result.notebook1.nb.fdb_stat.1.params.aVSb.f.pval.ent get] "."]
            set feat [.result.notebook1.nb.fdb_stat.1.params.aVSb.feat_cb cget -text]
            set type [.result.notebook1.nb.fdb_stat.1.params.aVSb.cb cget -text]
        } elseif {$mode eq "export"} {
            set num [.aVSbList.num.ent get]
            set len [.aVSbList.len.ent get]
            set foldchange [regsub -all {,} [.aVSbList.foldchange.ent get] "."]
            set pval [regsub -all {,} [.aVSbList.pvalue.ent get] "."]
            set feat [.aVSbList.param.cb get]
            set desc [.aVSbList.paramD.cb get]
            set type [.aVSbList.paramT.cb cget -text]
            destroy .aVSbList
            set ofile [browse save {{{Text Files} {.txt} } {{All Files} * }} "$env(dbName)_aVSb.txt"]
        }
        
        .result.notebook1.nb.fdb_info.1.table.l finishediting
        set run_info ""
        set run_type ""
        set stop 1
        set i 0
        while {$stop} {
            if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
                set stop 0
            } elseif {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq "1"} {
                #Text from ComboBox
                set run_type [[.result.notebook1.nb.fdb_info.1.table.l windowpath $i,2] get]
                lappend run_info "[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3] $run_type [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 7]"
            }
            incr i
        }
        unset run_type
        if {$run_info ne ""} {
            set cL ""
            
            set ::threadaVSbRun [thread::create {
                proc aVSb_export {dbName processID mainThreadID phpThreadID type desc feat num len foldchange pval pvalCheck distinctValue distinctCheck meanType normalizedType bOnlyCheck aOnlyCheck ofile run_info} {
                    global env
                    
                    set contig_aVSbList [aVSb $phpThreadID $mainThreadID "$run_info" "{$feat} $num $len $foldchange {$type} $pval $pvalCheck $distinctCheck $distinctValue $meanType $normalizedType {$desc} $bOnlyCheck $aOnlyCheck" export $dbName]
                    set aTotal [lindex $contig_aVSbList 7]
                    set bTotal [lindex $contig_aVSbList 8]
                    set contig_aVSbList [lindex $contig_aVSbList 0]
                    
                    if {$aTotal eq 0 || $bTotal eq 0} {
                        eval [subst {thread::send -async $mainThreadID {::errorPopUp "Error" "Please select runs for A and B before running."}}]
                        returnResult $processID error - $dbName "No runs in one group." $mainThreadID
                    } else {
                        if {[catch {set out [open "$ofile" w]}]} {
                            eval [subst {thread::send -async $mainThreadID {::errorPopUp "Error" "The chosen directory does not exist.\nPlease change HomeFolder."}}]
                        } else {
                            set o "Num\tName"
                            if {$desc ne ""} {
                                append o "\tDescription"
                            }
                            append o "\tA ($aTotal)\tB ($bTotal)"
                            if {$type eq "Log2"} {
                                append o "\tA (log2)\tB (log2)"
                            } elseif {$type eq "Fold change" || $type eq "Fold change (Log2)"} {
                                set indx ""
                                if {$type eq "Fold change"} {
                                    append o "\tFold change"
                                } elseif {$type eq "Fold change (Log2)"} {
                                    append o "\tFold change (log2)"
                                }
                                if {$normalizedType eq "normalized"} {
                                    if {$meanType eq "median"} {
                                        lappend indx 5
                                        lappend indx 16
                                        lappend indx 17
                                        append o "\tA (normalized, median)\tB (normalized, median)"
                                    } elseif {$meanType eq "mean"} {
                                        lappend indx 3
                                        lappend indx 12
                                        lappend indx 13
                                        append o "\tA (normalized, mean)\tB (normalized, mean)"
                                    } else {
                                        lappend indx 7
                                        #lappend indx 12
                                        #lappend indx 13
                                        #append o "\tA (normalized, total)\tB (normalized, total)"
                                    }
                                    if {$pvalCheck} {
                                        lappend indx 19
                                        append o "\tpValue (normalized)"
                                    }
                                    if {$distinctCheck} {
                                        lappend indx 22
                                        lappend indx 23
                                        append o "\tA (normalized, distinct)\tB (normalized, distinct)"
                                    }
                                } else {
                                    if {$meanType eq "median"} {
                                        lappend indx 4
                                        lappend indx 14
                                        lappend indx 15
                                        append o "\tA (absolut, median)\tB (absolut, median)"
                                    } elseif {$meanType eq "mean"} {
                                        lappend indx 2
                                        lappend indx 10
                                        lappend indx 11
                                        append o "\tA (absolut, mean)\tB (absolut, mean)"
                                    } else {
                                        lappend indx 6
                                    }
                                    if {$pvalCheck} {
                                        lappend indx 18
                                        append o "\tpValue (absolut)"
                                    }
                                    if {$distinctCheck} {
                                        lappend indx 20
                                        lappend indx 21
                                        append o "\tA (absolut, distinct)\tB (absolut, distinct)"
                                    }
                                }
                            }
                            append o "\n"
                            
                            if {$type eq "Linear"} {
                                foreach ent $contig_aVSbList {
                                    catch {
                                        append o "[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\n"
                                    }
                                }
                            } elseif {$type eq "Log2"} {
                                foreach ent $contig_aVSbList {
                                    catch {
                                        append o "[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $c_tmp 0],[string range [lindex $c_tmp 1] 0 2]\t[lindex $s_tmp 0],[string range [lindex $s_tmp 1] 0 2]\n"
                                    }
                                }
                            } elseif {$type eq "Fold change" || $type eq "Fold change (Log2)"} {
                                foreach ent $contig_aVSbList {
                                    if {[expr [lindex $ent 8] + [lindex $ent 9]] >= $num} {
                                        if {$meanType eq "median"} {
                                            if {$normalizedType eq "normalized"} {
                                                set f_change [lindex $ent 5]
                                            } else {
                                                set f_change [lindex $ent 4]
                                            }
                                        } elseif {$meanType eq "mean"} {
                                            if {$normalizedType eq "normalized"} {
                                                set f_change [lindex $ent 3]
                                            } else {
                                                set f_change [lindex $ent 2]
                                            }
                                        } else {
                                            if {$normalizedType eq "normalized"} {
                                                set f_change [lindex $ent 7]
                                            } else {
                                                set f_change [lindex $ent 6]
                                            }
                                        }
                                        catch {
                                            if {$desc ne ""} {
                                                set tmpo "[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent end]\t[lindex $ent 8]\t[lindex $ent 9]"
                                            } else {
                                                set tmpo "[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 8]\t[lindex $ent 9]"
                                            }
                                            foreach i $indx {
                                                set tmp [split [lindex $ent $i] .]
                                                if {[llength $tmp] eq 2} {
                                                    set e [split [lindex $tmp end] e]
                                                    if {[llength $e] eq 2} {
                                                        append tmpo "\t[lindex $tmp 0],[string range [lindex $e 0] 0 2]e[lindex $e 1]"
                                                    } else {
                                                        if {[lindex $tmp 0] eq 0} {
                                                            for {set k 0} {$k < [string length [lindex $tmp 1]]} {incr k} {
                                                                if {[string index [lindex $tmp 1] $k] ne 0} {
                                                                    break
                                                                }
                                                            }
                                                            if {$k >= 3} {
                                                                append tmpo "\t[string index [lindex $tmp 1] $k],[string range [lindex $tmp 1] [expr $k + 1] [expr $k + 3]]e-[expr $k + 1]"
                                                            } else {
                                                                append tmpo "\t[lindex $tmp 0],[string range [lindex $tmp 1] 0 2]"
                                                            }
                                                        } else {
                                                            append tmpo "\t[lindex $tmp 0],[string range [lindex $tmp 1] 0 2]"
                                                        }
                                                    }
                                                } else {
                                                    append tmpo "\t[lindex $ent $i]"
                                                }
                                            }
                                            if {$f_change >= $foldchange || $f_change <= -$foldchange} {
                                                set add 1
                                            }
                                            if {$add} {
                                                set add 0
                                                if {$pvalCheck eq 0} {
                                                    if {$distinctCheck eq 0} {
                                                        set add 1
                                                    } else {
                                                        if {$normalizedType eq "normalized"} {
                                                            if {[lindex $ent 20] || [lindex $ent 21]} {
                                                                set add 1
                                                            }
                                                        } else {
                                                            if {[lindex $ent 18] || [lindex $ent 19]} {
                                                                set add 1
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if {$distinctCheck eq 0} {
                                                        if {$normalizedType eq "normalized"} {
                                                            if {[lindex $ent 17] ne "N/A" && [lindex $ent 17] <= $pval} {
                                                                set add 1
                                                            }
                                                        } else {
                                                            if {[lindex $ent 16] ne "N/A" &&[lindex $ent 16] <= $pval} {
                                                                set add 1
                                                            }
                                                        }
                                                    } else {
                                                        if {$normalizedType eq "normalized"} {
                                                            if {([lindex $ent 17] ne "N/A" &&[lindex $ent 17] <= $pval) || [lindex $ent 20] || [lindex $ent 21]} {
                                                                set add 1
                                                            }
                                                        } else {
                                                            if {([lindex $ent 1] ne "N/A" &&[lindex $ent 16] <= $pval) || [lindex $ent 18] || [lindex $ent 19]} {
                                                                set add 1
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            if {$add} {
                                                append o "$tmpo\n"
                                            }
                                        }
                                    }
                                }
                            }
                            puts $out $o
                            unset o
                            unset contig_aVSbList
                            close $out
                        }
                        returnResult $processID finished - $dbName "Written to: $ofile" $mainThreadID
                    }
                    
                    
                }
                proc aVSb_tab {dbName processID mainThreadID phpThreadID type feat num len foldchange pval pvalCheck distinctValue distinctCheck meanType normalizedType run_info} {
                    global env
                    
                    set res [aVSb $phpThreadID $mainThreadID "$run_info" "{$feat} $num $len $foldchange {$type} $pval $pvalCheck $distinctCheck $distinctValue $meanType $normalizedType" tab $dbName]
                    if {$res eq "noAorB"} {
                        returnResult $processID error - $dbName "No runs in one group." $mainThreadID
                    } else {
                        returnResult $processID finished -  $dbName 1 $mainThreadID
                        set aVSbList "aVSb {$type} {[lindex $res 0]} [lindex $res 1] [lindex $res 2] [lindex $res 3] [lindex $res 4] $len {[lindex $res 5]} {[lindex $res 6]} [lindex $res 7] [lindex $res 8] $env(dbName)"
                        eval [subst {thread::send $mainThreadID {::statistics_update "$aVSbList"}}]
                        unset aVSbList
                        eval [subst {thread::send -async $mainThreadID {::statistics_draw}}]
                    }
                    
                }
                proc aVSb {phpThreadID mainThreadID run_info params mode dbName} {
                    global env
                    set aVSbArr(runs.aL) ""
                    set aVSbArr(runs.bL) ""
                    set aVSbArr(runs.a.total) 0
                    set aVSbArr(runs.b.total) 0
                    
                    set feat [lindex $params 0]
                    set num [lindex $params 1]
                    set len [lindex $params 2]
                    set foldchange [lindex $params 3]
                    set foldchangeCheck 0
                    set foldchangeLog2Check 0
                    set log2Check 0
                    set linearCheck 0
                    set bOnlyCheck 0
                    set aOnlyCheck 0
                    if {[lindex $params 4] eq "Fold change"} {
                        set foldchangeCheck 1
                    } elseif {[lindex $params 4] eq "Fold change (Log2)"} {
                        set foldchangeLog2Check 1
                    }  elseif {[lindex $params 4] eq "Log2"} {
                        set log2Check 1
                    } elseif {[lindex $params 4] eq "Linear"} {
                        set linearCheck 1
                    }
                    set pval [lindex $params 5]
                    set pvalCheck [lindex $params 6]
                    set distinctCheck [lindex $params 7]
                    set dictinctValue [lindex $params 8]
                    set meanType [lindex $params 9]
                    set normalizedType [lindex $params 10]
                    if {$mode eq "tab"} {
                        set desc ""
                    } elseif {$mode eq "export"} {
                        set desc [lindex $params 11]
                        set bOnlyCheck [lindex $params 12]
                        set aOnlyCheck [lindex $params 13]
                    }
                    
                    set c 0; set s 0; set name ""
                    set maxC 0
                    set maxS 0
                    set maxF 0
                    set minF 0
                    set add 0
                    set contig_aVSbList ""
                    
                    foreach run $run_info {
                        if {[lindex $run 1] eq "A"} {
                            lappend aVSbArr(runs.aL) [lindex $run 0]
                            set aVSbArr(runs.a.[lindex $run 0]) [lindex $run 2]
                            set aVSbArr(runs.a.total) [expr $aVSbArr(runs.a.total) + [lindex $run 2]]
                        } else {
                            lappend aVSbArr(runs.bL) [lindex $run 0]
                            set aVSbArr(runs.b.[lindex $run 0]) [lindex $run 2]
                            set aVSbArr(runs.b.total) [expr $aVSbArr(runs.b.total) + [lindex $run 2]]
                        }
                    }
                    
                    if {[llength $aVSbArr(runs.aL)] eq 0 || [llength $aVSbArr(runs.bL)] eq 0} {
                        return "noAorB"
                    } else {
                        if {$feat eq "all"} {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq FROM $dbName.seq_info WHERE length >= $len AND numreads >= $num"}}]]
                            foreach sRes $sql_res {
                                append cL ", '[lindex $sRes 0]'"
                            }
                            unset sql_res
                        } elseif {$feat eq "with hits"} {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq FROM $dbName.seq_info WHERE gotHits = 1 AND length >= $len AND numreads >= $num"}}]]
                            foreach sRes $sql_res {
                                append cL ", '[lindex $sRes 0]'"
                            }
                            unset sql_res
                        } elseif {$feat eq "without hits"} {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq FROM $dbName.seq_info WHERE gotHits = 0 AND length >= $len AND numreads >= $num"}}]]
                            foreach sRes $sql_res {
                                append cL ", '[lindex $sRes 0]'"
                            }
                            unset sql_res
                        } else {
                            if {$feat eq "with comment"} {
                                set feat comment
                            }
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq FROM $dbName.seq_info WHERE $feat != 0 AND length >= $len AND numreads >= $num"}}]]
                            foreach sRes $sql_res {
                                append cL ", '[lindex $sRes 0]'"
                            }
                            unset sql_res
                        }
                        set cL [string range $cL 2 end]
                        if {$desc ne ""} {
                            if {[lindex $desc 0] eq "Blast"} {
                                set des Blast
                            } else {
                                set des [string tolower $desc]
                            }
                            set sql "SELECT A.name AS name, $dbName.sequences_nucleotide_description.$des AS description"
                            foreach run $aVSbArr(runs.aL) {
                                append sql ", A.runid_$run AS runid_$run"
                            }
                            foreach run $aVSbArr(runs.bL) {
                                append sql ", A.runid_$run AS runid_$run"
                            }
                            append sql " FROM $dbName.sequences_nucleotide_description INNER JOIN (SELECT $dbName.seq_info.id_seq AS id_seq, $dbName.seq_info.name AS name"
                            foreach run $aVSbArr(runs.aL) {
                                append sql ", $dbName.read_distribution.runid_$run AS runid_$run"
                            }
                            foreach run $aVSbArr(runs.bL) {
                                append sql ", $dbName.read_distribution.runid_$run AS runid_$run"
                            }
                            append sql " FROM $dbName.read_distribution INNER JOIN $dbName.seq_info ON $dbName.seq_info.id_seq = CAST($dbName.read_distribution.id_seq AS integer) \
                                    WHERE $dbName.read_distribution.id_seq IN ($cL) ORDER BY name) A \
                                    ON $dbName.sequences_nucleotide_description.id_seq = A.id_seq ORDER BY A.name"
                        } else {
                            set sql "SELECT $dbName.seq_info.name AS name"
                            foreach run $aVSbArr(runs.aL) {
                                append sql ", $dbName.read_distribution.runid_$run AS runid_$run"
                            }
                            foreach run $aVSbArr(runs.bL) {
                                append sql ", $dbName.read_distribution.runid_$run AS runid_$run"
                            }
                            append sql " FROM $dbName.read_distribution INNER JOIN $dbName.seq_info ON $dbName.seq_info.id_seq = CAST($dbName.read_distribution.id_seq AS integer) WHERE $dbName.read_distribution.id_seq IN ($cL) ORDER BY name"
                        }
                        unset cL
                        
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "$sql"}}]]
                        if {[lindex [lindex $sql_res 0] 0] eq "Fehler:"} {
                            eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "Please update the read distribution."}}]
                        } else {
                            set pValL ""
                            set pValLN ""
                            foreach sRes $sql_res {
                                set c 0; set s 0
                                set add 1
                                set name [lindex $sRes 0]
                                set i 1
                                if {$desc ne ""} {
                                    set description [lindex $sRes 1]
                                    incr i
                                }
                                set tmpCL ""; set tmpCLN ""
                                foreach run $aVSbArr(runs.aL) {
                                    lappend tmpCL [lindex $sRes $i].0
                                    lappend tmpCLN [expr [lindex $sRes $i].0 / $aVSbArr(runs.a.$run).0]
                                    set c [expr $c + [lindex $sRes $i]]
                                    incr i
                                }
                                set tmpCL [lsort -increasing -real $tmpCL]
                                set tmpCLN [lsort -increasing -real $tmpCLN]
                                set m [aVSb_meanMedian $tmpCL $tmpCLN]
                                set aVSbArr($name.a.mean) [lindex $m 0]
                                set aVSbArr($name.a.median) [lindex $m 1]
                                set aVSbArr($name.a.total) [lindex $m 2]
                                set aVSbArr($name.a.meanN) [lindex $m 3]
                                set aVSbArr($name.a.medianN) [lindex $m 4]
                                set aVSbArr($name.a.totalN) [lindex $m 5]
                                set tmpSL ""; set tmpSLN ""
                                foreach run $aVSbArr(runs.bL) {
                                    lappend tmpSL [lindex $sRes $i].0
                                    lappend tmpSLN [expr [lindex $sRes $i].0 / $aVSbArr(runs.b.$run).0]
                                    set s [expr $s + [lindex $sRes $i]]
                                    incr i
                                }
                                set tmpSL [lsort -increasing -real $tmpSL]
                                set tmpSLN [lsort -increasing -real $tmpSLN]
                                set m [aVSb_meanMedian $tmpSL $tmpSLN]
                                set aVSbArr($name.b.mean) [lindex $m 0]
                                set aVSbArr($name.b.median) [lindex $m 1]
                                set aVSbArr($name.b.total) [lindex $m 2]
                                set aVSbArr($name.b.meanN) [lindex $m 3]
                                set aVSbArr($name.b.medianN) [lindex $m 4]
                                set aVSbArr($name.b.totalN) [lindex $m 5]
                                
                                set p [aVSb_utest $tmpCL $tmpSL $tmpCLN $tmpSLN]
                                set aVSbArr($name.twotail.p) [lindex $p 0]
                                lappend pValL "$name [lindex $p 0]"
                                set aVSbArr($name.twotail.pN) [lindex $p 1]
                                lappend pValNL "$name [lindex $p 0]"
                                
                                set aVSbArr($name.b.distinct) 0
                                set aVSbArr($name.a.distinct) 0
                                set distinctOverlapA [lindex [split [expr [llength $tmpCL].0 * ($dictinctValue / 100)] .] 0]
                                set distinctOverlapB [lindex [split [expr [llength $tmpSL].0 * ($dictinctValue / 100)] .] 0]
                                if {[lindex $tmpSL 0] > [lindex $tmpCL [expr $distinctOverlapA - 1]] || $tmpCL eq ""} {
                                    set aVSbArr($name.b.distinct) 1
                                } elseif {[lindex $tmpCL 0] > [lindex $tmpSL [expr $distinctOverlapB - 1]] || $tmpSL eq ""} {
                                    set aVSbArr($name.a.distinct) 1
                                }
                                set aVSbArr($name.b.distinctN) 0
                                set aVSbArr($name.a.distinctN) 0
                                set distinctOverlapA [lindex [split [expr [llength $tmpCLN].0 * ($dictinctValue / 100)] .] 0]
                                set distinctOverlapB [lindex [split [expr [llength $tmpSLN].0 * ($dictinctValue / 100)] .] 0]
                                if {[lindex $tmpSLN 0] > [lindex $tmpCLN [expr $distinctOverlapA - 1]] || $tmpCLN eq ""} {
                                    set aVSbArr($name.b.distinctN) 1
                                } elseif {[lindex $tmpCLN 0] > [lindex $tmpSLN [expr $distinctOverlapB - 1]] || $tmpSLN eq ""} {
                                    set aVSbArr($name.a.distinctN) 1
                                }
                                unset tmpCL; unset tmpCLN; unset tmpSL; unset tmpSLN; unset m; unset i; unset distinctOverlapA; unset distinctOverlapB
                                if {[expr $c + $s] >= $num} {
                                    if {($bOnlyCheck || $aOnlyCheck)} {
                                        if {$bOnlyCheck && $c eq 0 && $s >= $num} {
                                            set tmp "[lindex [split $name _] end] $name $c $s bOnly"
                                        } elseif {$aOnlyCheck && $s eq 0 && $c >= $num} {
                                            set tmp "[lindex [split $name _] end] $name $c $s aOnly"
                                        }
                                    } elseif {($c ne 0 || $s ne 0) && [expr $c + $s] >= $num} {
                                        set tmp "[lindex [split $name _] end] $name"
                                        if {$linearCheck} {
                                            if {$c > $maxC} {
                                                set maxC $c
                                            }
                                            if {$s > $maxS} {
                                                set maxS $s
                                            }
                                            append tmp " $c $s"
                                        }
                                        if {$log2Check} {
                                            set c_log2 [expr log($c) / log(2)]
                                            set s_log2 [expr log($s) / log(2)]
                                            if {$c_log2 > $maxC} {
                                                set maxC $c_log2
                                            }
                                            if {$s_log2 > $maxS} {
                                                set maxS $s_log2
                                            }
                                            append tmp " $c $s $c_log2 $s_log2"
                                        }
                                        if {$foldchangeCheck} {
                                            if {$aVSbArr($name.a.total) == 0} {
                                                set aVSbArr($name.fchange.total) "Inf"
                                                set aVSbArr($name.fchangeN.total) "Inf"
                                                set aVSbArr($name.fchange.mean) "Inf"
                                                set aVSbArr($name.fchangeN.mean) "Inf"
                                                set aVSbArr($name.fchange.median) "Inf"
                                                set aVSbArr($name.fchangeN.median) "Inf"
                                            } elseif {$aVSbArr($name.b.total) == 0} {
                                                set aVSbArr($name.fchange.total) "-Inf"
                                                set aVSbArr($name.fchangeN.total) "-Inf"
                                                set aVSbArr($name.fchange.mean) "-Inf"
                                                set aVSbArr($name.fchangeN.mean) "-Inf"
                                                set aVSbArr($name.fchange.median) "-Inf"
                                                set aVSbArr($name.fchangeN.median) "-Inf"
                                            } else {
                                                if {$aVSbArr($name.b.total) >= $aVSbArr($name.a.total)} {
                                                    set aVSbArr($name.fchange.total) [expr $aVSbArr($name.b.total) / $aVSbArr($name.a.total)]
                                                } else {
                                                    set aVSbArr($name.fchange.total) [expr -$aVSbArr($name.a.total) / $aVSbArr($name.b.total)]
                                                }
                                                if {$aVSbArr(runs.a.total) eq 0 || $aVSbArr(runs.b.total) eq 0} {
                                                    set aVSbArr($name.fchangeN.total) N/A
                                                } else {
                                                    if {$aVSbArr($name.b.totalN) >= $aVSbArr($name.a.totalN)} {
                                                        set aVSbArr($name.fchangeN.total) [expr $aVSbArr($name.b.totalN) / $aVSbArr($name.a.totalN)]
                                                    } else {
                                                        set aVSbArr($name.fchangeN.total) [expr -$aVSbArr($name.a.totalN) / $aVSbArr($name.b.totalN)]
                                                    }
                                                }
                                                
                                                if {$aVSbArr($name.a.mean) == 0} {
                                                    set aVSbArr($name.fchange.mean) "Inf"
                                                    set aVSbArr($name.fchangeN.mean) "Inf"
                                                } elseif {$aVSbArr($name.b.mean) == 0} {
                                                    set aVSbArr($name.fchange.mean) "-Inf"
                                                    set aVSbArr($name.fchangeN.mean) "-Inf"
                                                } else {
                                                    if {$aVSbArr($name.b.mean) >= $aVSbArr($name.a.mean)} {
                                                        flush stdout
                                                        set aVSbArr($name.fchange.mean) [expr $aVSbArr($name.b.mean) / $aVSbArr($name.a.mean)]
                                                    } else {
                                                        set aVSbArr($name.fchange.mean) [expr -$aVSbArr($name.a.mean) / $aVSbArr($name.b.mean)]
                                                    }
                                                    if {$aVSbArr(runs.a.total) eq 0 || $aVSbArr(runs.b.total) eq 0} {
                                                        set aVSbArr($name.fchangeN.mean) N/A
                                                    } else {
                                                        if {$aVSbArr($name.b.meanN) >= $aVSbArr($name.a.meanN)} {
                                                            set aVSbArr($name.fchangeN.mean) [expr $aVSbArr($name.b.meanN) / $aVSbArr($name.a.meanN)]
                                                        } else {
                                                            set aVSbArr($name.fchangeN.mean) [expr -$aVSbArr($name.a.meanN) / $aVSbArr($name.b.meanN)]
                                                        }
                                                    }
                                                }
                                                if {$aVSbArr($name.a.median) == 0} {
                                                    if {$aVSbArr($name.b.median) == 0} {
                                                        set aVSbArr($name.fchange.median) "N/A"
                                                        set aVSbArr($name.fchangeN.median) "N/A"
                                                    } else {
                                                        set aVSbArr($name.fchange.median) "Inf"
                                                        set aVSbArr($name.fchangeN.median) "Inf"
                                                    }
                                                } elseif {$aVSbArr($name.b.median) == 0} {
                                                    if {$aVSbArr($name.a.median) == 0} {
                                                        set aVSbArr($name.fchange.median) "N/A"
                                                        set aVSbArr($name.fchangeN.median) "N/A"
                                                    } else {
                                                        set aVSbArr($name.fchange.median) "-Inf"
                                                        set aVSbArr($name.fchangeN.median) "-Inf"
                                                    }
                                                } else {
                                                    if {$aVSbArr($name.b.median) >= $aVSbArr($name.a.median)} {
                                                        set aVSbArr($name.fchange.median) [expr $aVSbArr($name.b.median) / $aVSbArr($name.a.median)]
                                                    } else {
                                                        set aVSbArr($name.fchange.median) [expr -$aVSbArr($name.a.median) / $aVSbArr($name.b.median)]
                                                    }
                                                    if {$aVSbArr(runs.a.total) eq 0 || $aVSbArr(runs.b.total) eq 0} {
                                                        set aVSbArr($name.fchangeN.median) N/A
                                                    } else {
                                                        if {$aVSbArr($name.b.medianN) >= $aVSbArr($name.a.medianN)} {
                                                            set aVSbArr($name.fchangeN.median) [expr $aVSbArr($name.b.medianN) / $aVSbArr($name.a.medianN)]
                                                        } else {
                                                            set aVSbArr($name.fchangeN.median) [expr -$aVSbArr($name.a.medianN) / $aVSbArr($name.b.medianN)]
                                                        }
                                                    }
                                                }
                                            }
                                            
                                            if {$meanType eq "median"} {
                                                if {$normalizedType eq "absolute"} {
                                                    if {$aVSbArr($name.fchange.median) > $maxF} {
                                                        set maxF $aVSbArr($name.fchange.median)
                                                    }
                                                    if {$aVSbArr($name.fchange.median) < $minF} {
                                                        set minF $aVSbArr($name.fchange.median)
                                                    }
                                                } else {
                                                    if {$aVSbArr($name.fchangeN.median) > $maxF} {
                                                        set maxF $aVSbArr($name.fchangeN.median)
                                                    }
                                                    if {$aVSbArr($name.fchangeN.median) < $minF} {
                                                        set minF $aVSbArr($name.fchangeN.median)
                                                    }
                                                }
                                            } elseif {$meanType eq "mean"} {
                                                if {$normalizedType eq "absolute"} {
                                                    if {$aVSbArr($name.fchange.mean) > $maxF} {
                                                        set maxF $aVSbArr($name.fchange.mean)
                                                    }
                                                    if {$aVSbArr($name.fchange.mean) < $minF} {
                                                        set minF $aVSbArr($name.fchange.mean)
                                                    }
                                                } else {
                                                    if {$aVSbArr($name.fchangeN.mean) > $maxF} {
                                                        set maxF $aVSbArr($name.fchangeN.mean)
                                                    }
                                                    if {$aVSbArr($name.fchangeN.mean) < $minF} {
                                                        set minF $aVSbArr($name.fchangeN.mean)
                                                    }
                                                }
                                            } else  {
                                                if {$normalizedType eq "absolute"} {
                                                    if {$aVSbArr($name.fchange.total) > $maxF} {
                                                        set maxF $aVSbArr($name.fchange.total)
                                                    }
                                                    if {$aVSbArr($name.fchange.total) < $minF} {
                                                        set minF $aVSbArr($name.fchange.total)
                                                    }
                                                } else {
                                                    if {$aVSbArr($name.fchangeN.total) > $maxF} {
                                                        set maxF $aVSbArr($name.fchangeN.total)
                                                    }
                                                    if {$aVSbArr($name.fchangeN.total) < $minF} {
                                                        set minF $aVSbArr($name.fchangeN.total)
                                                    }
                                                }
                                            }
                                            append tmp " $aVSbArr($name.fchange.mean) $aVSbArr($name.fchangeN.mean) $aVSbArr($name.fchange.median) $aVSbArr($name.fchangeN.median) $aVSbArr($name.fchange.total) $aVSbArr($name.fchangeN.total) $c $s $aVSbArr($name.a.mean) $aVSbArr($name.b.mean) $aVSbArr($name.a.meanN) $aVSbArr($name.b.meanN) $aVSbArr($name.a.median) $aVSbArr($name.b.median) $aVSbArr($name.a.medianN) $aVSbArr($name.b.medianN) $aVSbArr($name.twotail.p) $aVSbArr($name.twotail.pN) $aVSbArr($name.a.distinct) $aVSbArr($name.b.distinct) $aVSbArr($name.a.distinctN) $aVSbArr($name.b.distinctN)"
                                        } elseif {$foldchangeLog2Check} {
                                            if {$aVSbArr($name.a.mean) eq 0} {
                                                set $aVSbArr($name.fchange.mean) "Inf"
                                            } elseif {$aVSbArr($name.b.mean) eq 0} {
                                                set $aVSbArr($name.fchange.mean) "-Inf"
                                            } else {
                                                set $aVSbArr($name.fchange.mean) [expr log([expr $aVSbArr($name.b.mean) / $aVSbArr($name.a.mean)]) / log(2)]
                                                set $aVSbArr($name.fchangeN.mean) [expr log([expr $aVSbArr($name.b.meanN) / $aVSbArr($name.a.meanN)] / log(2)]
                                            }
                                            if {$aVSbArr($name.a.median) eq 0} {
                                                set $aVSbArr($name.fchange.median) "Inf"
                                            } elseif {$aVSbArr($name.b.median) eq 0} {
                                                set $aVSbArr($name.fchange.median) "-Inf"
                                            } else {
                                                set $aVSbArr($name.fchange.median) [expr log([expr $aVSbArr($name.b.median) / $aVSbArr($name.a.median)]) / log(2)]
                                                set $aVSbArr($name.fchangeN.median) [expr log([expr $aVSbArr($name.b.medianN) / $aVSbArr($name.a.medianN)] / log(2)]
                                            }
                                            if {$meanType eq "median"} {
                                                if {$normalizedType eq "normalized"} {
                                                    if {$aVSbArr($name.fchange.median) > $maxF} {
                                                        set maxF $aVSbArr($name.fchange.median)
                                                    }
                                                    if {$aVSbArr($name.fchange.median) < $minF} {
                                                        set minF $aVSbArr($name.fchange.median)
                                                    }
                                                } else {
                                                    if {$aVSbArr($name.fchangeN.median) > $maxF} {
                                                        set maxF $aVSbArr($name.fchangeN.median)
                                                    }
                                                    if {$aVSbArr($name.fchangeN.median) < $minF} {
                                                        set minF $aVSbArr($name.fchangeN.median)
                                                    }
                                                }
                                            } else {
                                                if {$normalizedType eq "normalized"} {
                                                    if {$aVSbArr($name.fchange.mean) > $maxF} {
                                                        set maxF $aVSbArr($name.fchange.mean)
                                                    }
                                                    if {$aVSbArr($name.fchange.mean) < $minF} {
                                                        set minF $aVSbArr($name.fchange.mean)
                                                    }
                                                } else {
                                                    if {$aVSbArr($name.fchangeN.mean) > $maxF} {
                                                        set maxF $aVSbArr($name.fchangeN.mean)
                                                    }
                                                    if {$aVSbArr($name.fchangeN.mean) < $minF} {
                                                        set minF $aVSbArr($name.fchangeN.mean)
                                                    }
                                                }
                                            }
                                            append tmp " $aVSbArr($name.fchange.mean) $aVSbArr($name.fchangeN.mean) $aVSbArr($name.fchange.median) $aVSbArr($name.fchangeN.median) $aVSbArr($name.fchange.total) $aVSbArr($name.fchangeN.total) $c $s $aVSbArr($name.a.mean) $aVSbArr($name.b.mean) $aVSbArr($name.a.meanN) $aVSbArr($name.b.meanN) $aVSbArr($name.a.median) $aVSbArr($name.b.median) $aVSbArr($name.a.medianN) $aVSbArr($name.b.medianN) $aVSbArr($name.twotail.p) $aVSbArr($name.twotail.pN) $aVSbArr($name.a.distinct) $aVSbArr($name.b.distinct) $aVSbArr($name.a.distinctN) $aVSbArr($name.b.distinctN)"
                                        }
                                        if {$desc ne ""} {
                                            set des ""
                                            if {[lindex $desc 0] eq "Blast"} {
                                                if {[lindex $desc 2] eq ""} {
                                                    set des "[lindex [lindex $description 0] 1]"
                                                } else {
                                                    foreach d $description {
                                                        if {[lindex $d 0] eq [lindex $desc 2]} {
                                                            set des "[lindex $d 1]"
                                                            break
                                                        }
                                                    }
                                                }
                                            } else {
                                                set des $description
                                            }
                                            append tmp " {$des}"
                                        }
                                        if {$add} {
                                            lappend contig_aVSbList "$tmp"
                                        }
                                    }
                                }
                            }
                            unset sql_res
                            
                            if {$foldchangeLog2Check || $foldchangeCheck} {
                                #get corrected pValues
                                set pValL [lsort -real -index 1 -decreasing $pValL]
                                set pValNL [lsort -real -index 1 -decreasing $pValNL]
                                set max [llength $pValL]
                                for {set i 0} {$i < $max} {incr i} {
                                    if {$i eq 0} {
                                        set aVSbArr([lindex [lindex $pValL $i] 0].twotail.pCorr) [lindex [lindex $pValL $i] 1]
                                        set pVal_min [lindex [lindex $pValL $i] 1]
                                    } else {
                                        set pVal_curr [expr $max.0 / ($max.0 - $i.0) * [lindex [lindex $pValL $i] 1]]
                                        if {$pVal_curr <= $pVal_min} {
                                            set aVSbArr([lindex [lindex $pValL $i] 0].twotail.pCorr) $pVal_curr
                                            set pVal_min $pVal_curr
                                        } else {
                                            set aVSbArr([lindex [lindex $pValL $i] 0].twotail.pCorr) $pVal_min
                                        }
                                    }
                                }
                                set max [llength $pValNL]
                                for {set i 0} {$i < $max} {incr i} {
                                    if {$i eq 0} {
                                        set aVSbArr([lindex [lindex $pValNL $i] 0].twotail.pNCorr) [lindex [lindex $pValNL $i] 1]
                                        set pVal_min [lindex [lindex $pValNL $i] 1]
                                    } else {
                                        set pVal_curr [expr $max.0 / ($max.0 - $i.0) * [lindex [lindex $pValNL $i] 1]]
                                        if {$pVal_curr <= $pVal_min} {
                                            set aVSbArr([lindex [lindex $pValNL $i] 0].twotail.pNCorr) $pVal_curr
                                            set pVal_min $pVal_curr
                                        } else {
                                            set aVSbArr([lindex [lindex $pValNL $i] 0].twotail.pNCorr) $pVal_min
                                        }
                                    }
                                }
                                set contig_aVSbListTMP ""
                                foreach ent $contig_aVSbList {
                                    lappend contig_aVSbListTMP "[lrange $ent 0 19] $aVSbArr([lindex $ent 1].twotail.pCorr) $aVSbArr([lindex $ent 1].twotail.pNCorr) [lrange $ent 20 end]"
                                }
                                set contig_aVSbList $contig_aVSbListTMP
                                unset contig_aVSbListTMP
                            }
                            
                            unset c; unset s; unset add; unset foldchange; unset num; unset len; unset feat; unset desc
                            catch {
                                set contig_aVSbList [lsort -integer -index 0 $contig_aVSbList]
                            }
                            return "{$contig_aVSbList} $maxC $maxS $maxF $minF {$aVSbArr(runs.aL)} {$aVSbArr(runs.bL)} $aVSbArr(runs.a.total) $aVSbArr(runs.b.total)"
                        }
                    }
                }
                
                proc aVSb_meanMedian {runs runsN} {
                    set num [llength $runs]
                    
                    if {$num eq 0} {
                        set mean 0
                        set median 0
                        set total 0
                        set meanN 0
                        set medianN 0
                        set totalN 0
                    } elseif {$num eq 1} {
                        set mean [lindex $runs 0]
                        set median $mean
                        set total $mean
                        set meanN [lindex $runsN 0]
                        set medianN $meanN
                        set totalN $meanN
                    } elseif {$num eq 2} {
                        set mean [expr ([lindex $runs 0] + [lindex $runs 1]) / 2.0]
                        set median $mean
                        set total [expr [lindex $runs 0] + [lindex $runs 1]]
                        set meanN [expr ([lindex $runsN 0] + [lindex $runsN 1]) / 2.0]
                        set medianN $meanN
                        set totalN [expr [lindex $runsN 0] + [lindex $runsN 1]]
                    } else {
                        set sum 0
                        set sumN 0
                        foreach run $runs {
                            set sum [expr $sum + $run]
                        }
                        foreach run $runsN {
                            set sumN [expr $sumN + $run]
                        }
                        set mean [expr $sum / $num.0]
                        set meanN [expr $sumN / $num.0]
                        set total $sum
                        set totalN $sumN
                        set middle [split [expr $num.0 / 2.0] .]
                        if {[lindex $middle 1] ne 0} {
                            set median [lindex $runs [lindex $middle 0]]
                            set medianN [lindex $runsN [lindex $middle 0]]
                        } else {
                            set median [expr ([lindex $runs [lindex $middle 0]] + [lindex $runs [expr [lindex $middle 0] - 1]]) / 2.0]
                            set medianN [expr ([lindex $runsN [lindex $middle 0]] + [lindex $runsN [expr [lindex $middle 0] - 1]]) / 2.0]
                        }
                        unset sum; unset run; unset num; unset middle; unset runs
                    }
                    return "$mean $median $total $meanN $medianN $totalN"
                }
                
                proc aVSb_utest {runsC runsS runsCN runsSN} {
                    if {[llength $runsC] eq 0 || [llength $runsS] eq 0} {
                        set ptt N/A
                        set pttN N/A
                    } else {
                        set runs ""
                        set nC [llength $runsC]
                        set nS [llength $runsS]
                        foreach run $runsC {
                            lappend runs "c $run"
                        }
                        foreach run $runsS {
                            lappend runs "s $run"
                        }
                        set runs [lsort -increasing -real -index 1 $runs]
                        set ptt [aVSb_pValue $nC $nS "$runs"]
                        set runs ""
                        set nC [llength $runsCN]
                        set nS [llength $runsSN]
                        foreach run $runsCN {
                            lappend runs "c $run"
                        }
                        foreach run $runsSN {
                            lappend runs "s $run"
                        }
                        set runs [lsort -increasing -real -index 1 $runs]
                        set pttN [aVSb_pValue $nC $nS "$runs"]
                        unset runs
                    }
                    return "$ptt $pttN"
                }
                
                proc aVSb_pValue {nC nS runs} {
                    set sum 0
                    for {set i 0} {$i < [llength $runs]} {incr i} {
                        if {[lindex [lindex $runs $i] 0] eq "s"} {
                            set sum [expr $sum + 1 + $i]
                        }
                    }
                    set n [expr $nC + $nS]
                    
                    set tot [expr ($n * ($n + 1)) / 2]
                    set totS [expr ($nS * ($nS + 1)) / 2]
                    
                    set clip 0.5
                    if {[expr $sum - (($nS * ($n + 1)) / 2)] > 0} {set clip -0.5}
                    
                    #set u [expr $nS * $nC + $totS - $sum]
                    
                    set num [expr $sum + $clip - (($nS * ($n + 1)) / 2)]
                    set denom [expr sqrt(($nS * $nC * ($n + 1)) / 12)]
                    
                    set z [expr abs(($num / $denom))];
                    
                    set ptt [expr (((((0.000005383* $z + 0.0000488906) * $z + 0.0000380036) * $z + 0.0032776263)* $z + 0.0211410061) * $z + 0.049867347) * $z + 1]
                    set ptt [expr pow($ptt, -16)]
                    return $ptt
                }
                
                proc returnResult {processID status process dbName result mainThreadID} {
                    eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
                }
                thread::wait
            }]
            
            set processID [llength $env(processL)]
            if {$mode eq "tab"} {
                process_update $processID running "Running aVSb, type: $type; minReads: $num; minLength: $len" $env(dbName) 0
                eval [subst {thread::send -async $::threadaVSbRun {::aVSb_tab $env(dbName) $processID $env(mainThreadID) $env(phpThreadID) {$type} {$feat} $num $len $foldchange $pval $db_stat_fold_change_pvalCheck $db_stat_fold_change_distinctValue $db_stat_fold_change_distinctCheck $db_stat_fold_change_mean $db_stat_fold_change_normalized {$run_info}}}]
            } elseif {$mode eq "export" && $ofile ne ""} {
                process_update $processID running "Running aVSb (export), minReads: $num; minLength: $len" $env(dbName) 0
                eval [subst {thread::send -async $::threadaVSbRun {::aVSb_export $env(dbName) $processID $env(mainThreadID) $env(phpThreadID) {$type} {$desc} {$feat} $num $len $foldchange $pval $aVSb_pvalueCheck $db_stat_fold_change_distinctValue $aVSb_distinctCheck $db_stat_fold_change_mean $db_stat_fold_change_normalized $aVSb_bOnlyCheck $aVSb_aOnlyCheck "$ofile" {$run_info}}}]
            }
        }
    }
}

proc statistics_aVSb_ckeckruns {} {
    global db_stat_fold_change_pvalCheck
    global db_stat_fold_change_distinctCheck
    set stop 1
    set i 0
    set b 0
    set a 0
    .result.notebook1.nb.fdb_info.1.table.l finishediting
    while {$stop} {
        if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
            set stop 0
        } elseif {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq "1"} {
            if {[[.result.notebook1.nb.fdb_info.1.table.l windowpath $i,2] get] eq "B"} {
                incr b
            } else  {
                incr a
            }
        }
        incr i
    }
    if {[expr $a + $b] < 3} {
        set db_stat_fold_change_pvalCheck 0
        set db_stat_fold_change_distinctCheck 0
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.pval.check configure -state disabled
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.pval.ent configure -state disabled
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.distinct.check configure -state disabled
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.distinct.ent configure -state disabled
    } else {
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.pval.check configure -state normal
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.pval.ent configure -state normal
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.distinct.check configure -state normal
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.distinct.ent configure -state normal
    }
    if {$a < 3 && $b < 3} {
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.mean.median configure -state disabled
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.mean.mean select
    } else {
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.mean.median configure -state normal
        .result.notebook1.nb.fdb_stat.1.params.aVSb.f.mean.median select
    }
}

proc statistics_aVSb_draw {} {
    global env
    global db_stat_canTagL
    global statistics_aVSb_downL
    global statistics_aVSb_upL
    global db_stat_fold_change_pvalCheck
    global db_stat_fold_change_distinctCheck
    global db_stat_fold_change_mean
    global db_stat_fold_change_normalized
    global db_stat_fold_change
    global db_stat_rnumber
    global db_stat_length
    global statistics_lists
    global statistics_entries
    global statistics_num
    
    if {$statistics_entries > 0} {
        set statistics_aVSb_downL ""
        set statistics_aVSb_upL ""
        set pval [regsub -all {,} [.result.notebook1.nb.fdb_stat.1.params.aVSb.f.pval.ent get] "."]
        set foldchange [regsub -all {,} [.result.notebook1.nb.fdb_stat.1.params.aVSb.f.ent.foldchange get] "."]
        set pvalCheck $db_stat_fold_change_pvalCheck
        set distinctCheck $db_stat_fold_change_distinctCheck
        set meanType $db_stat_fold_change_mean
        set normalizedType $db_stat_fold_change_normalized
        set db_stat_rnumber [.result.notebook1.nb.fdb_stat.1.params.aVSb.n.num get]
        
        .result.notebook1.nb.fdb_stat.1.params.cb configure -text "Expression analysis"
        .result.notebook1.nb.fdb_stat.1.params.aVSb.cb configure -text [lindex [lindex $statistics_lists $statistics_num] 1]
        set type [lindex [lindex $statistics_lists $statistics_num] 1]
        set contig_aVSbList [lindex [lindex $statistics_lists $statistics_num] 2]
        set maxC [lindex [lindex $statistics_lists $statistics_num] 3]
        set maxS [lindex [lindex $statistics_lists $statistics_num] 4]
        set maxF [lindex [lindex $statistics_lists $statistics_num] 5]
        set minF [lindex [lindex $statistics_lists $statistics_num] 6]
        
        #Cleaning canvas
        .result.notebook1.nb.fdb_stat.1.fr.can delete a
        foreach tag $db_stat_canTagL {
            .result.notebook1.nb.fdb_stat.1.fr.can delete $tag
        }
        set db_stat_canTagL ""
        
        pack forget .result.notebook1.nb.fdb_stat.1.params.length; pack forget .result.notebook1.nb.fdb_stat.1.params.cover; pack .result.notebook1.nb.fdb_stat.1.params.aVSb; pack .result.notebook1.nb.fdb_stat.0.foldchange
        if {$type eq "Linear" || $type eq "Log2"} {
            pack forget .result.notebook1.nb.fdb_stat.1.params.aVSb.f
        } elseif {$type eq "Fold change (Log2)" || $type eq "Fold change"} {
            pack .result.notebook1.nb.fdb_stat.1.params.aVSb.f -side bottom -anchor w
        }
        set db_stat_fold_change $foldchange
        set db_stat_length [lindex [lindex $statistics_lists $statistics_num] 7]
        set a [lindex [lindex $statistics_lists $statistics_num] 8]
        set b [lindex [lindex $statistics_lists $statistics_num] 9]
        set aTotal [lindex [lindex $statistics_lists $statistics_num] 10]
        set bTotal [lindex [lindex $statistics_lists $statistics_num] 11]
        set db [lindex [lindex $statistics_lists $statistics_num] 12]
        
        set width [expr [winfo width .result.notebook1.nb.fdb_stat.1.fr.can] - 70]
        set height [expr [winfo height .result.notebook1.nb.fdb_stat.1.fr.can] - 70]
        set stepS [expr $height.0 / $maxS]
        set stepC [expr $width.0 / $maxC]
        
        if {$foldchange eq ""} {
            set foldchange 1
        }
        if {$foldchange < 1} {
            set foldchange 1
            set stepSize 1
        } else  {
            set stepSize $foldchange
        }
        
        if {$type eq "Linear"} {
            set txt "y: B reads          x: A Reads   -   $db"
            .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Num" left 0 "Name" left 0 "A ($aTotal)" left 0 "B ($bTotal)" left
            .result.notebook1.nb.fdb_stat.1.fr.can create text [expr $width / 2] [expr 60 + $height] -text $txt -anchor w -tag a
            .result.notebook1.nb.fdb_stat.1.fr.can create line 50 20 50 [expr 20 + $height] -tag a -arrow first
            .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + $height] [expr $width + 50] [expr 20 + $height] -tag a -arrow last
            for {set i 0} {$i <= 5} {incr i} {
                .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [expr 20 + int($height.0 / 5 * $i.0)] 50 [expr 20 + int($height.0 / 5 * $i.0)] -tag a
                .result.notebook1.nb.fdb_stat.1.fr.can create text 5 [expr 20 + int($height.0 / 5 * $i.0)] -text [expr int($maxS / 5 * (5 - $i.0))] -anchor w -tag a
            }
            for {set i 0} {$i <= 10} {incr i} {
                .result.notebook1.nb.fdb_stat.1.fr.can create line [expr 50 + int($width.0 / 10 * $i.0)] [expr 20 + $height] [expr 50 + int($width.0 / 10 * $i.0)] [expr 30 + $height] -tag a
                .result.notebook1.nb.fdb_stat.1.fr.can create text [expr 50 + int($width.0 / 10 * $i.0)] [expr 40 + $height] -text [expr int($maxC / 10 * $i.0)] -anchor c -tag a
            }
        } elseif {$type eq "Log2"} {
            set txt "y: B reads          x: A Reads"
            .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Num" left 0 "Name" left 0 "A ($aTotal)" left 0 "B ($bTotal)" left 0 "A (log2)" left 0 "B (log2)" left
            .result.notebook1.nb.fdb_stat.1.fr.can create text [expr $width / 2] [expr 60 + $height] -text $txt -anchor w -tag a
            .result.notebook1.nb.fdb_stat.1.fr.can create line 50 20 50 [expr 20 + $height] -tag a -arrow first
            .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + $height] [expr $width + 50] [expr 20 + $height] -tag a -arrow last
            for {set i 0} {$i <= 5} {incr i} {
                .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [expr 20 + int($height.0 / 5 * $i.0)] 50 [expr 20 + int($height.0 / 5 * $i.0)] -tag a
                .result.notebook1.nb.fdb_stat.1.fr.can create text 5 [expr 20 + int($height.0 / 5 * $i.0)] -text [expr int($maxS / 5 * (5 - $i.0))] -anchor w -tag a
            }
            for {set i 0} {$i <= 10} {incr i} {
                .result.notebook1.nb.fdb_stat.1.fr.can create line [expr 50 + int($width.0 / 10 * $i.0)] [expr 20 + $height] [expr 50 + int($width.0 / 10 * $i.0)] [expr 30 + $height] -tag a
                .result.notebook1.nb.fdb_stat.1.fr.can create text [expr 50 + int($width.0 / 10 * $i.0)] [expr 40 + $height] -text [expr int($maxC / 10 * $i.0)] -anchor c -tag a
            }
        } elseif {$type eq "Fold change" || $type eq "Fold change (Log2)"} {
            set env(contig.dbName) $env(dbName)
            catch {.result.notebook1.nb.fdb_stat.1.fr.table.l delete 0 end}
            catch {.result.notebook1.nb.fdb_stat.1.fr.table.l deletecolumns 0 end}
            if {$type eq "Fold change (Log2)"} {
                set txt "y: Fold induction (Log2)"
                .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Num" left 0 "Name" left 0 "A ($aTotal)" left 0 "B ($bTotal)" left 0 "Fold change (log2, mean)" left 0 "Fold change (log2, normalized, mean)" left  0 "Fold change (log2, median)" left 0 "Fold change (log2, normalized, median)" left 0 "Fold change (log2, total)" left 0 "Fold change (log2, normalized, total)" left 0 "aMean" left 0 "bMean" left 0 "aMeanN" left 0 "bMeanN" left 0 "aMedian" left 0 "bMedian" left 0 "aMedianN" left 0 "bMedianN" left 0 "ttPvalue" left 0 "ttPvalueN" left 0 "ttPvalueCorr" left 0 "ttPvalueNCorr" left 0 "aDistinct" left 0 "bDistinct" left 0 "aDistinctN" left 0 "bDistinctN" left
            } else {
                set txt "y: Fold induction"
                .result.notebook1.nb.fdb_stat.1.fr.table.l insertcolumns end 0 "Num" left 0 "Name" left 0 "A ($aTotal)" left 0 "B ($bTotal)" left 0 "Fold change (mean)" left 0 "Fold change (normalized, mean)" left  0 "Fold change (median)" left 0 "Fold change (normalized, median)" left 0 "Fold change (total)" left 0 "Fold change (normalized, total)" left 0 "aMean" left 0 "bMean" left 0 "aMeanN" left 0 "bMeanN" left 0 "aMedian" left 0 "bMedian" left 0 "aMedianN" left 0 "bMedianN" left 0 "ttPvalue" left 0 "ttPvalueN" left 0 "ttPvalueCorr" left 0 "ttPvalueNCorr" left 0 "aDistinct" left 0 "bDistinct" left 0 "aDistinctN" left 0 "bDistinctN" left
            }
            
            if {$normalizedType eq "normalized"} {
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 4 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 6 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 8 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 10 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 11 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 14 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 15 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 18 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 20 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 22 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 23 -hide yes
                set env(db_stat.fchangeMean) -
                set env(db_stat.fchangeMedian) -
                set env(db_stat.fchangeTotal) -
                set env(db_stat.meanA) -
                set env(db_stat.meanB) -
                set env(db_stat.medianA) -
                set env(db_stat.medianB) -
                set env(db_stat.pvaltt) -
                set env(db_stat.pvalttCorr) -
                set env(db_stat.distinctA) -
                set env(db_stat.distinctB) -
                
                if {$meanType eq "median"} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 5 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 9 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 12 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 13 -hide yes
                    set env(db_stat.fchangeMedianN) +
                    set env(db_stat.medianAN) +
                    set env(db_stat.medianBN) +
                    set env(db_stat.fchangeMeanN) -
                    set env(db_stat.meanAN) -
                    set env(db_stat.meanBN) -
                    set env(db_stat.fchangeTotalN) -
                } elseif {$meanType eq "mean"} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 7 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 9 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 16 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 17 -hide yes
                    set env(db_stat.fchangeMeanN) +
                    set env(db_stat.meanAN) +
                    set env(db_stat.meanBN) +
                    set env(db_stat.fchangeMedianN) -
                    set env(db_stat.medianAN) -
                    set env(db_stat.medianBN) -
                    set env(db_stat.fchangeTotalN) -
                } else {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 5 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 7 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 12 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 13 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 16 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 17 -hide yes
                    set env(db_stat.fchangeTotalN) +
                    set env(db_stat.fchangeMeanN) -
                    set env(db_stat.meanAN) -
                    set env(db_stat.meanBN) -
                    set env(db_stat.fchangeMedianN) -
                    set env(db_stat.medianBN) -
                    set env(db_stat.medianSN) -
                }
                if {$pvalCheck eq 0} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 19 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 21 -hide yes
                    set env(db_stat.pvalttN) -
                    set env(db_stat.pvalttNCorr) -
                } else {
                    set env(db_stat.pvalttN) +
                    set env(db_stat.pvalttNCorr) +
                }
                if {$distinctCheck eq 0} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 24 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 25 -hide yes
                    set env(db_stat.distinctAN) -
                    set env(db_stat.distinctBN) -
                } else {
                    set env(db_stat.distinctAN) +
                    set env(db_stat.distinctBN) +
                }
            } else {
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 5 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 7 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 9 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 12 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 13 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 16 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 17 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 19 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 21 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 24 -hide yes
                .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 25 -hide yes
                set env(db_stat.fchangeMeanN) -
                set env(db_stat.fchangeMedianN) -
                set env(db_stat.fchangeTotalN) -
                set env(db_stat.meanAN) -
                set env(db_stat.meanBN) -
                set env(db_stat.medianAN) -
                set env(db_stat.medianBN) -
                set env(db_stat.pvalttN) -
                set env(db_stat.pvalttNCorr) -
                set env(db_stat.distinctAN) -
                set env(db_stat.distinctBN) -
                if {$meanType eq "median"} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 4 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 8 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 10 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 11 -hide yes
                    set env(db_stat.fchangeMedian) +
                    set env(db_stat.medianA) +
                    set env(db_stat.medianB) +
                    set env(db_stat.fchangeMean) -
                    set env(db_stat.meanA) -
                    set env(db_stat.meanB) -
                    set env(db_stat.fchangeTotal) -
                } elseif {$meanType eq "mean"} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 6 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 8 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 14 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 15 -hide yes
                    set env(db_stat.fchangeMean) +
                    set env(db_stat.meanA) +
                    set env(db_stat.meanB) +
                    set env(db_stat.fchangeMedian) -
                    set env(db_stat.medianA) -
                    set env(db_stat.medianB) -
                    set env(db_stat.fchangeTotal) -
                } else {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 4 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 6 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 12 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 13 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 14 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 15 -hide yes
                    set env(db_stat.fchangeTotal) +
                    set env(db_stat.fchangeMean) -
                    set env(db_stat.meanA) -
                    set env(db_stat.meanB) -
                    set env(db_stat.fchangeMedian) -
                    set env(db_stat.medianA) -
                    set env(db_stat.medianB) -
                }
                if {$pvalCheck eq 0} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 18 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 20 -hide yes
                    set env(db_stat.pvaltt) -
                    set env(db_stat.pvalttCorr) -
                } else {
                    set env(db_stat.pvaltt) +
                    set env(db_stat.pvalttCorr) +
                }
                if {$distinctCheck eq 0} {
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 22 -hide yes
                    .result.notebook1.nb.fdb_stat.1.fr.table.l columnconfigure 23 -hide yes
                    set env(db_stat.distinctA) -
                    set env(db_stat.distinctB) -
                } else {
                    set env(db_stat.distinctA) +
                    set env(db_stat.distinctB) +
                }
            }
            
            .result.notebook1.nb.fdb_stat.1.fr.can create text [expr $width / 2] [expr 60 + $height] -text $txt -anchor w -tag a
            .result.notebook1.nb.fdb_stat.1.fr.can create line 50 20 50 [expr 20 + $height] -tag a -arrow both
            if {$maxF > [expr 8 * $stepSize]} {
                set maxF [expr 8 * $stepSize]
                set up 8
            } else {
                set up 1
                set tmpF $stepSize
                while {$maxF > $tmpF} {
                    incr up
                    set tmpF [expr $tmpF + $stepSize]
                }
            }
            if {$minF < [expr 8 * -$stepSize]} {
                set minF [expr 8 * -$stepSize]
                set down 8
            } else {
                set down 1
                set tmpF -$stepSize
                while {$minF < $tmpF} {
                    incr down
                    set tmpF [expr $tmpF - $stepSize]
                }
            }
            set h [expr $height.0 / ($up.0 + $down.0)]
            if {$type eq "Fold change"} {
                set shift [expr int($h / $stepSize)]
            } else {
                set shift 0
            }
            
            for {set i 0} {$i <= [expr $up + $down]} {incr i} {
                if {$i < $up} {
                    .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [expr 20 + int($h * $i.0) + $shift] 50 [expr 20 + int($h * $i.0) + $shift] -tag a
                    .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + int($h * $i.0) + $shift] [expr $width + 50] [expr 20 + int($h * $i.0) + $shift] -tag a -fill grey
                    if {$i eq [expr $up - 1]} {
                        .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + int($h * ($i.0 + 1.0 - 1.0 / $stepSize * $foldchange)) + $shift] [expr $width + 50] [expr 20 + int($h * ($i.0 + 1.0 - 1.0 / $stepSize * $foldchange)) + $shift] -tag a -fill red
                    }
                    .result.notebook1.nb.fdb_stat.1.fr.can create text 5 [expr 20 + int($h * $i.0) + $shift] -text [expr $stepSize * ($up - $i)] -anchor w -tag a
                } elseif {$i > $up} {
                    .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [expr 20 + int($h * $i.0) - $shift] 50 [expr 20 + int($h * $i.0) - $shift] -tag a
                    .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + int($h * $i.0) - $shift] [expr $width + 50] [expr 20 + int($h * $i.0) - $shift] -tag a -fill grey
                    if {$i eq [expr $up + 1]} {
                        .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + int($h * ($i.0 - 1.0 + 1.0 / $stepSize * $foldchange)) - $shift] [expr $width + 50] [expr 20 + int($h * ($i.0 - 1.0 + 1.0 / $stepSize * $foldchange)) - $shift] -tag a -fill red
                    }
                    .result.notebook1.nb.fdb_stat.1.fr.can create text 5 [expr 20 + int($h * $i.0) - $shift] -text [expr -$stepSize * ($i - $up)] -anchor w -tag a
                } else {
                    if {$type eq "Fold change (Log2)"} {
                        .result.notebook1.nb.fdb_stat.1.fr.can create text 5 [expr 20 + int($h * $i.0)] -text "0" -anchor w -tag a
                        .result.notebook1.nb.fdb_stat.1.fr.can create line 40 [expr 20 + int($h * $i.0)] 50 [expr 20 + int($h * $i.0)] -tag a
                    }
                    .result.notebook1.nb.fdb_stat.1.fr.can create line 50 [expr 20 + int($h * $i.0)] [expr $width + 50] [expr 20 + int($h * $i.0)] -tag a -fill grey -dash -
                }
            }
            unset h; unset shift
        }
        
        if {$contig_aVSbList ne ""} {
            if {$type eq "Linear"} {
                foreach ent $contig_aVSbList {
                    catch {
                        set x [expr 49 + int([lindex $ent 2] * $stepC)]
                        set y [expr 19 + $height - int([lindex $ent 3] * $stepS)]
                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 2 + $x] [expr 2 + $y] -fill green -tag a
                        .result.notebook1.nb.fdb_stat.1.fr.table.l insert end "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3]"
                    }
                }
            } elseif {$type eq "Log2"} {
                foreach ent $contig_aVSbList {
                    catch {
                        if {[lindex $ent 4] eq "Inf"} {
                            set x [expr 49 + int($maxC * $stepC)]
                        } elseif {[lindex $ent 2] eq "-Inf"} {
                            set x 49
                        } else {
                            set x [expr 49 + int([lindex $ent 2] * $stepC)]
                        }
                        if {[lindex $ent 5] eq "Inf"} {
                            set y [expr 19 + $height - int($maxS * $stepS)]
                        } elseif {[lindex $ent 3] eq "-Inf"} {
                            set y [expr 19 + $height]
                        } else {
                            set y [expr 19 + $height - int([lindex $ent 3] * $stepS)]
                        }
                        set c_tmp [split [lindex $ent 4] .]
                        set s_tmp [split [lindex $ent 5] .]
                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 2 + $x] [expr 2 + $y] -fill green -tag a
                        .result.notebook1.nb.fdb_stat.1.fr.table.l insert end "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $c_tmp 0],[string range [lindex $c_tmp 1] 0 2] [lindex $s_tmp 0],[string range [lindex $s_tmp 1] 0 2]"
                    }
                }
            } elseif {$type eq "Fold change" || $type eq "Fold change (Log2)"} {
                set stepC [expr $width / 6]
                set stepS [expr $height.0 / (($up.0 + $down.0) * $stepSize)]
                set zero [expr int(19.0 + ($height.0 / ($up.0 + $down.0)) * $up.0)]
                set j 0
                set k 0
                if {$type eq "Fold change"} {
                    set shift 1
                } else  {
                    set shift 0
                }
                
                foreach ent $contig_aVSbList {
                    if {[expr [lindex $ent 8] + [lindex $ent 9]] >= $db_stat_rnumber} {
                        if {$meanType eq "median"} {
                            if {$normalizedType eq "normalized"} {
                                set f_change [lindex $ent 5]
                            } else {
                                set f_change [lindex $ent 4]
                            }
                        } elseif {$meanType eq "mean"} {
                            if {$normalizedType eq "normalized"} {
                                set f_change [lindex $ent 3]
                            } else {
                                set f_change [lindex $ent 2]
                            }
                        } else {
                            if {$normalizedType eq "normalized"} {
                                set f_change [lindex $ent 7]
                            } else {
                                set f_change [lindex $ent 6]
                            }
                        }
                        
                        catch {
                            set x [expr 49 + $k + 6 * $j]
                            if {$f_change eq "Inf"} {
                                set y [expr int($zero.0 - [expr 8.0 * $stepSize] * $stepS)]
                                set pos [expr 8.0 * $stepSize]
                            } elseif {$f_change eq "-Inf"} {
                                set y [expr int($zero.0 - [expr 8.0 * -$stepSize] * $stepS)]
                                set pos [expr 8.0 * -$stepSize]
                            } elseif {$f_change eq "N/A"} {
                                set pos err
                            } else {
                                if {$f_change > 0} {
                                    set f [expr $f_change - $shift]
                                } elseif {$f_change < 0} {
                                    set f [expr $f_change + $shift]
                                }
                                if {$f < [expr 8.0 * -$stepSize]} {
                                    set y [expr int($zero.0 - [expr 8.0 * -$stepSize] * $stepS)]
                                } elseif {$f > [expr 8.0 * $stepSize]} {
                                    set y [expr int($zero.0 - [expr 8.0 * $stepSize] * $stepS)]
                                } else {
                                    set y [expr int($zero.0 - $f * $stepS)]
                                }
                                set pos $f_change
                            }
                            if {$pos ne "err"} {
                                incr j
                                if {$j >= $stepC} {
                                    set j 0
                                    incr k
                                    if {$k > 5} {
                                        set k 0
                                    }
                                }
                                
                                set out "[lindex $ent 0] [lindex $ent 1] [lindex $ent 8] [lindex $ent 9]"
                                foreach i {2 3 4 5 6 7 10 11 12 13 14 15 16 17 18 19 20 21} {
                                    set tmp [split [lindex $ent $i] .]
                                    if {[llength $tmp] eq 2} {
                                        set e [split [lindex $tmp end] e]
                                        if {[llength $e] eq 2} {
                                            append out " [lindex $tmp 0],[string range [lindex $e 0] 0 2]e[lindex $e 1]"
                                        } else {
                                            if {[lindex $tmp 0] eq 0} {
                                                for {set k 0} {$k < [string length [lindex $tmp 1]]} {incr k} {
                                                    if {[string index [lindex $tmp 1] $k] ne 0} {
                                                        break
                                                    }
                                                }
                                                if {$k >= 3} {
                                                    append out " [string index [lindex $tmp 1] $k],[string range [lindex $tmp 1] [expr $k + 1] [expr $k + 3]]e-[expr $k + 1]"
                                                } else {
                                                    append out " [lindex $tmp 0],[string range [lindex $tmp 1] 0 2]"
                                                }
                                            } else {
                                                append out " [lindex $tmp 0],[string range [lindex $tmp 1] 0 2]"
                                            }
                                        }
                                    } else {
                                        append out " [lindex $ent $i]"
                                    }
                                }
                                append out " [lindex $ent 22] [lindex $ent 23] [lindex $ent 24] [lindex $ent 25]"
                                set add 0
                                if {$f_change >= $foldchange || $f_change <= -$foldchange} {
                                    set add 1
                                }
                                set f_change [split $f_change .]
                                if {[llength $f_change] eq 2} {
                                    set e [split [lindex $f_change end] e]
                                    if {[llength $e] eq 2} {
                                        set f_change "[lindex $f_change 0],[string range [lindex $e 0] 0 2]e[lindex $e 1]"
                                    } else {
                                        set f_change "[lindex $f_change 0],[string range [lindex $f_change 1] 0 2]"
                                    }
                                }
                                if {$add} {
                                    set add 0
                                    if {$pvalCheck eq 0} {
                                        if {$distinctCheck eq 0} {
                                            set add 1
                                        } else {
                                            if {$normalizedType eq "normalized"} {
                                                if {[lindex $ent 24] || [lindex $ent 25]} {
                                                    set add 1
                                                }
                                            } else {
                                                if {[lindex $ent 22] || [lindex $ent 23]} {
                                                    set add 1
                                                }
                                            }
                                        }
                                    } else {
                                        if {$distinctCheck eq 0} {
                                            if {$normalizedType eq "normalized"} {
                                                if {[lindex $ent 19] ne "N/A" && [lindex $ent 19] <= $pval} {
                                                    set add 1
                                                }
                                            } else {
                                                if {[lindex $ent 18] ne "N/A" && [lindex $ent 18] <= $pval} {
                                                    set add 1
                                                }
                                            }
                                        } else {
                                            if {$normalizedType eq "normalized"} {
                                                if {([lindex $ent 19] ne "N/A" && [lindex $ent 19] <= $pval) || [lindex $ent 24] || [lindex $ent 25]} {
                                                    set add 1
                                                }
                                            } else {
                                                if {([lindex $ent 18] ne "N/A" && [lindex $ent 18] <= $pval) || [lindex $ent 22] || [lindex $ent 23]} {
                                                    set add 1
                                                }
                                            }
                                        }
                                    }
                                }
                                if {$add} {
                                    .result.notebook1.nb.fdb_stat.1.fr.table.l insert end "$out"
                                }
                                lappend db_stat_canTagL [lindex $ent 1]
                                if {$pos >= $foldchange} {
                                    if {$add} {
                                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 5 + $x] [expr 5 + $y] -fill red -tag [lindex $ent 1]
                                    } else {
                                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 5 + $x] [expr 5 + $y] -fill grey -tag [lindex $ent 1]
                                    }
                                    lappend statistics_aVSb_upL "[lindex $ent 1] {Fold change ($meanType, $normalizedType): $f_change; A: [lindex $ent 8]; B: [lindex $ent 9]}"
                                    set comm "update_info_get_name [lindex $ent 1] name"
                                    .result.notebook1.nb.fdb_stat.1.fr.can bind "[lindex $ent 1]" <Button-1> $comm
                                } elseif {$pos <= -$foldchange} {
                                    if {$add} {
                                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 5 + $x] [expr 5 + $y] -fill blue -tag [lindex $ent 1]
                                    } else {
                                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 5 + $x] [expr 5 + $y] -fill grey -tag [lindex $ent 1]
                                    }
                                    lappend statistics_aVSb_downL "[lindex $ent 1] {Fold change ($meanType, $normalizedType): $f_change; A: [lindex $ent 8]; B: [lindex $ent 9]}"
                                    set comm "update_info_get_name [lindex $ent 1] name"
                                    .result.notebook1.nb.fdb_stat.1.fr.can bind "[lindex $ent 1]" <Button-1> $comm
                                } else {
                                    if {$add} {
                                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 5 + $x] [expr 5 + $y] -fill green -tag [lindex $ent 1]
                                    } else {
                                        .result.notebook1.nb.fdb_stat.1.fr.can create oval $x $y [expr 5 + $x] [expr 5 + $y] -fill grey -tag [lindex $ent 1]
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        unset contig_aVSbList
        unset foldchange
        unset a
        unset b
        unset maxC
        unset maxS
        unset maxF
        unset minF
        unset width
        unset height
        unset stepS
        unset stepC
        unset type
        
        # Bindings.
        bind [.result.notebook1.nb.fdb_stat.1.fr.table.l bodypath] <Button-1> "
        set y \[.result.notebook1.nb.fdb_stat.1.fr.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[.result.notebook1.nb.fdb_stat.1.fr.table.l get \$y\] 1\]
        set env(contig.dbName) \$env(dbName)
        update_info_get_name \$name name
        "
    } else {
        errorPopUp "Error" "No data to refresh."
    }
}

proc statistics_aVSb_show {mode} {
    global env
    global page_counter
    global statistics_aVSb_downL
    global statistics_aVSb_upL
    global search_results
    
    set tmpString ""
    set search_results ""
    set refList {id_seq name length numreads id_prot description prot blast blastprodom coil gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr coverage}
    if {$mode eq "up"} {
        foreach ent $statistics_aVSb_upL {
            append tmpString ", '[lindex $ent 0]'"
        }
        set tmpString [string range $tmpString 2 end]
        if {$tmpString ne ""} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE name IN ($tmpString)"}}]]
            foreach sRes $sql_res {
                foreach ent $statistics_aVSb_upL {
                    if {[lindex $ent 0] eq [lindex $sRes 1]} {
                        set des [lindex $ent 1]
                        break
                    }
                }
                lappend search_results "[lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] {[lindex $sRes 4]} {$des} [lindex $sRes 5] [lindex $sRes 6] [lindex $sRes 7] [lindex $sRes 8] [lindex $sRes 9] [lindex $sRes 10] [lindex $sRes 11] [lindex $sRes 12] [lindex $sRes 13] [lindex $sRes 14] [lindex $sRes 15] [lindex $sRes 16] [lindex $sRes 17] [lindex $sRes 18] [lindex $sRes 19] [lindex $sRes 20] [lindex $sRes 21] $env(dbName)"
            }
            unset sql_res
        }
    } elseif {$mode eq "down"} {
        foreach ent $statistics_aVSb_downL {
            append tmpString ", '[lindex $ent 0]'"
        }
        set tmpString [string range $tmpString 2 end]
        if {$tmpString ne ""} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE name IN ($tmpString)"}}]]
            foreach sRes $sql_res {
                foreach ent $statistics_aVSb_downL {
                    if {[lindex $ent 0] eq [lindex $sRes 1]} {
                        set des [lindex $ent 1]
                        break
                    }
                }
                lappend search_results "[lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] {[lindex $sRes 4]} {$des} [lindex $sRes 5] [lindex $sRes 6] [lindex $sRes 7] [lindex $sRes 8] [lindex $sRes 9] [lindex $sRes 10] [lindex $sRes 11] [lindex $sRes 12] [lindex $sRes 13] [lindex $sRes 14] [lindex $sRes 15] [lindex $sRes 16] [lindex $sRes 17] [lindex $sRes 18] [lindex $sRes 19] [lindex $sRes 20] [lindex $sRes 21] $env(dbName)"
            }
            unset sql_res
        }
    }
    unset tmpString
    if {$search_results ne ""} {
        incr page_counter
        set name "AvsB_${mode}_$page_counter"
        create_project_tab prj_$page_counter $name
        fillTable .result.notebook1.nb.fprj_$page_counter.1.table.l 0 [llength $search_results]
    }
}

proc statistics_aVSbList_window {} {
    global env
    global aVSb_pvalueCheck
    global aVSb_distinctCheck
    global aVSb_bOnlyCheck
    global aVSb_aOnlyCheck
    global db_stat_fold_change_mean
    global db_stat_fold_change_normalized
    global db_stat_fold_change_distinctValue
    
    if {$env(dbName) ne " "} {
        set t .aVSbList
        catch {destroy $t}
        toplevel $t
        wm title $t "Expression analysis"
        wm resizable $t 0 0
        
        variable num
        variable len
        variable foldchange
        variable pvalue
        set num 20
        set len 100
        set foldchange 0.0
        set pvalue 0.05
        set aVSb_foldchangeCheck 1
        set aVSb_linearCheck 1
        
        frame $t.param
        label $t.param.l -text "Choose contig List:"
        ComboBox $t.param.cb -width 15 -hottrack 1 -background white -text "all" -values $env(dbbCBL)
        frame $t.paramD
        label $t.paramD.l -text "Choose description:"
        set desL "{} Blast"
        foreach db $env(blastRefDBL) {
            lappend desL "Blast -> $db"
        }
        append desL " BlastProdom Gene3d GO Interpro KEGG Panther Patternscan Pfam PIR Profilescan Smart Superfamily TIGR Comment"
        ComboBox $t.paramD.cb -width 15 -hottrack 1 -background white -text "" -values $desL
        unset desL
        
        frame $t.paramT -bd 2 -relief groove
        label $t.paramT.l -text "Choose tpye:"
        ComboBox $t.paramT.cb -width 20 -hottrack 1 -background white -text "Fold change" -values {{Linear} {Log2} {Fold change} {Fold change (Log2)}} -modifycmd {statistics_modify aVSbList}
        
        label $t.l -text ""
        frame $t.num
        label $t.num.label -text "min. number of reads in contig:"
        entry $t.num.ent -textvariable num -width 6 -background white
        frame $t.len
        label $t.len.label -text "min. contig length:"
        entry $t.len.ent -textvariable len -width 6 -background white
        frame $t.foldchange
        label $t.foldchange.label -text "min. fold change:"
        entry $t.foldchange.ent -textvariable foldchange -width 6 -background white
        frame $t.pvalue
        label $t.pvalue.label -text "max. pValue:"
        entry $t.pvalue.ent -textvariable pvalue -width 6 -background white
        label $t.l2 -text ""
        
        frame $t.param2
        label $t.param2.labelD -text "Output:"
        frame $t.param2.mean
        radiobutton $t.param2.mean.median -text "median" -variable db_stat_fold_change_mean -value "median"
        radiobutton $t.param2.mean.mean -text "mean" -variable db_stat_fold_change_mean -value "mean"
        radiobutton $t.param2.mean.total -text "total" -variable db_stat_fold_change_mean -value "total"
        frame $t.param2.normalized
        radiobutton $t.param2.normalized.normalized -text "normalized" -variable db_stat_fold_change_normalized -value "normalized"
        radiobutton $t.param2.normalized.absolute -text "absolute" -variable db_stat_fold_change_normalized -value "absolute"
        frame $t.param2.feat
        checkbutton $t.param2.feat.pvalue -text "pValue" -variable aVSb_pvalueCheck
        checkbutton $t.param2.feat.distinct -text "distinct" -variable aVSb_distinctCheck
        
        frame $t.param3
        checkbutton $t.param3.b -text "B only" -variable aVSb_bOnlyCheck
        checkbutton $t.param3.a -text "A only" -variable aVSb_aOnlyCheck
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.oke -text "Export" -command "statistics_aVSb export"
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.param.l -side left -anchor w; pack $t.param.cb -side right -anchor e
        pack $t.paramD.l -side left -anchor w; pack $t.paramD.cb -side right -anchor e
        pack $t.paramT.l -side left -anchor w; pack $t.paramT.cb -side right -anchor e
        pack $t.num.label -side left -anchor w; pack $t.num.ent -side right -anchor e
        pack $t.len.label -side left -anchor w; pack $t.len.ent -side right -anchor e
        pack $t.param2.mean.mean $t.param2.mean.median -side left -anchor w; pack $t.param2.mean.total -side right -anchor e
        pack $t.param2.normalized.normalized -side left -anchor w; pack $t.param2.normalized.absolute -side right -anchor e
        pack $t.param2.feat.pvalue $t.param2.feat.distinct -side left -anchor w
        pack $t.foldchange.label -side left -anchor w; pack $t.foldchange.ent -side right -anchor e
        pack $t.pvalue.label -side left -anchor w; pack $t.pvalue.ent -side right -anchor e
        pack $t.param3.b $t.param3.a -side right -anchor e
        pack $t.param2.labelD $t.param2.mean $t.param2.normalized $t.param2.feat -side top -anchor w
        pack $t.buts.oke $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.param $t.paramD $t.paramT $t.l $t.num $t.len $t.foldchange $t.pvalue $t.l2 $t.param2 $t.param3 $t.buts -side top -fill x
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        errorPopUp "Error" "No database selected."
    }
}

proc rightmenu_database_statistics {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
    .rightmenu.hidemenuColumn add command -label "$env(db_stat.num) num" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.num 0"
    .rightmenu.hidemenuColumn add command -label "$env(db_stat.name) name" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.name 1"
    .rightmenu.hidemenuColumn add command -label "$env(db_stat.a) A" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.a 2"
    .rightmenu.hidemenuColumn add command -label "$env(db_stat.b) B" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.b 3"
    if {[lindex [.result.notebook1.nb.fdb_stat.1.fr.table.l get 0] 6] ne ""} {
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.fchangeMean) fold change (mean)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.fchangeMean 4"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.fchangeMeanN) fold change (mean, normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.fchangeMeanN 5"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.fchangeMedian) fold change (median)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.fchangeMedian 6"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.fchangeMedianN) fold change (median, normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.fchangeMedianN 7"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.fchangeTotal) fold change (total)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.fchangeTotal 8"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.fchangeTotalN) fold change (total, normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.fchangeTotalN 9"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.meanA) A (mean)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.meanA 10"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.meanB) B (mean)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.meanB 11"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.meanAN) A (mean, normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.meanAN 12"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.meanBN) B (mean, normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.meanBN 13"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.medianA) A (median)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.medianA 14"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.medianB) B (median)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.medianB 15"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.medianAN) A (median, normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.medianAN 16"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.medianBN) B (median, normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.medianBN 17"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.pvaltt) pValue two-tailed" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.pvaltt 18"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.pvalttN) pValue two-tailed (normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.pvalttN 19"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.pvalttCorr) pValue two-tailed corrected" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.pvalttCorr 20"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.pvalttNCorr) pValue two-tailed corrected (normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.pvalttNCorr 21"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.distinctA) distinct A" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.distinctA 22"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.distinctB) distinct B" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.distinctB 23"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.distinctAN) distinct A (normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.distinctAN 24"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.distinctBN) distinct B (normalized)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.distinctBN 25"
    } elseif {[lindex [.result.notebook1.nb.fdb_stat.1.fr.table.l get 0] 4] ne ""} {
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.aLog2) A (log2)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.aLog2 4"
        .rightmenu.hidemenuColumn add command -label "$env(db_stat.bLog2) B (log2)" -command "table_col_sh .result.notebook1.nb.fdb_stat.1.fr.table.l db_stat.bLog2 5"
    }
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook1.nb.fdb_stat.1.fr.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook1.nb.fdb_stat.1.fr.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook1.nb.fdb_stat.1.fr.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook1.nb.fdb_stat.1.fr.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}
