proc mapping_init {} {
    global env
    global closeImg
    global checkedImg
    global uncheckedImg
    
    #Creating menu buttons
    .menubar.config.menu add command -label "Mapping" -command "mapping_config"
    .menubar.tab.menu add command -label "Mapping" -command "catch {create_tab rm}"
    
    if {[catch {set ft [open [pwd]/conf/mapping_tace.conf r]} ]} {
        #Mapping
        set env(read_mapping.run) +
        set env(read_mapping.read) +
        set env(read_mapping.length) +
        set env(read_mapping.strand) +
        set env(read_mapping.cstart) +
        set env(read_mapping.cend) +
        set env(read_mapping.rstart) +
        set env(read_mapping.rend) +
        set env(read_mapping.polya) +
        set env(read_mapping.singleton) +
    } else {
        #Mapping
        gets $ft line
        gets $ft line
        set env(read_mapping.run) [lindex $line 0]
        set env(read_mapping.read) [lindex $line 1]
        set env(read_mapping.length) [lindex $line 2]
        set env(read_mapping.strand) [lindex $line 3]
        set env(read_mapping.cstart) [lindex $line 4]
        set env(read_mapping.cend) [lindex $line 5]
        set env(read_mapping.rstart) [lindex $line 6]
        set env(read_mapping.rend) [lindex $line 7]
        set env(read_mapping.polya) [lindex $line 8]
        set env(read_mapping.singleton) [lindex $line 9]
    }
    
    # Mapping
    set notebook .result.notebook2.nb
    set frame [$notebook insert end rm -text "Mapping" -raisecmd "catch {update_info_rm}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    radiobutton $frame.0.dist -text "distribution      " -variable mapping_rb -value "distribution" -command {pack forget .result.notebook2.nb.frm.1.panel; pack .result.notebook2.nb.frm.1.dist -side right -fill both -expand true}
    radiobutton $frame.0.panel -text "sequence" -variable mapping_rb -value "sequence" -command {pack forget .result.notebook2.nb.frm.1.dist; pack .result.notebook2.nb.frm.1.panel -side right -fill both -expand true}
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab rm"
    checkbutton $frame.0.map -text "Map" -variable readMap_mapCheck -command {if {$readMap_mapCheck eq 0} {destroy .readMap_map}}
    $frame.0.panel select
    #checkbutton $frame.0.multiple -text "multiple" -variable readMap_multipleCheck
    button $frame.0.run -text "Run" -command "readMapping_run"
    frame $frame.1
    frame $frame.1.tab
    frame $frame.1.tab.table
    scrollbar $frame.1.tab.y -orient vertical -command "$frame.1.tab.table.l yview"
    scrollbar $frame.1.tab.table.x -orient horizontal -command "$frame.1.tab.table.l xview"
    set nb2_tl_rm $frame.1.tab.table.l
    tablelist::tablelist $nb2_tl_rm \
            -width 24 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "Run" 0 "Read" 0 "length" 0 "strand" 0 "startC" 0 "endC" 0 "startR" 0 "endR" 0 "polyA" 0 "singleton" 0 "db"} \
            -labelcommand "$nb2_tl_rm finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -stretch {1 2} \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.tab.y set" \
            -xscrollcommand "$frame.1.tab.table.x set" \
            -background white
    $nb2_tl_rm columnconfigure 10 -hide yes
    text $frame.1.panel -background white -width 60 -height 1
    frame $frame.1.dist
    scrollbar $frame.1.dist.y -orient vertical -command "$frame.1.dist.table yview"
    set nb2_tl_rm_dist $frame.1.dist.table
    tablelist::tablelist $nb2_tl_rm_dist \
            -width 24 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "Reads" 0 "Run ID" 0 "%" 0 "% (normalized)" 0 "description" 0 "treatment"} \
            -labelcommand "$nb2_tl_rm_dist finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -stretch {1 2 3} \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.dist.y set" \
            -background white
    
    pack $frame.0.run $frame.0.label1 -side left -fill both -anchor w
    pack $frame.0.exit $frame.0.map $frame.0.dist $frame.0.panel -side right -fill both -anchor e
    pack $frame.1.tab.table.l -fill both -side top -expand true; pack $frame.1.tab.table.x -fill both -side bottom
    pack $frame.1.tab.table -fill both -side left -expand true; pack $frame.1.tab.y -fill both -side left
    pack $frame.1.dist.table -fill both -side left -expand true; pack $frame.1.dist.y -fill both -side left
    pack $frame.1.tab $frame.1.panel -fill both -side left -expand true
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    # Set up the tags
    .result.notebook2.nb.frm.1.panel tag configure bold12 -font {-family courier -size 12 -weight bold}
    .result.notebook2.nb.frm.1.panel tag configure bold11 -font {-family courier -size 11 -weight bold}
    .result.notebook2.nb.frm.1.panel tag configure bold11r -font {-family courier -size 11 -weight bold} -foreground red2
    .result.notebook2.nb.frm.1.panel tag configure bold_italics -font {-family courier -size 12 -weight bold -slant italic}
    .result.notebook2.nb.frm.1.panel tag configure hel -font {-family helvetica -size 16 -weight bold}
    .result.notebook2.nb.frm.1.panel tag configure helred -font {-family helvetica -size 16 -weight bold} -foreground red4
    .result.notebook2.nb.frm.1.panel tag configure color1 -foreground red
    .result.notebook2.nb.frm.1.panel tag configure smallBut -font {-family courier -size 6 -weight bold}
    .result.notebook2.nb.frm.1.panel tag configure sunken -relief sunken -borderwidth 1
    
    .result.notebook2.nb.frm.1.panel tag configure markedYellow -background yellow
    .result.notebook2.nb.frm.1.panel tag configure markedGreen -background green
    .result.notebook2.nb.frm.1.panel tag configure markedOrange -background orange
    .result.notebook2.nb.frm.1.panel tag configure markedRed -background red
    .result.notebook2.nb.frm.1.panel tag configure markedBlue -background blue
    .result.notebook2.nb.frm.1.panel tag configure unmarked -background white
    .result.notebook2.nb.frm.1.panel tag configure textGreen -foreground green
    
    #Read_mapping
    set tl .result.notebook2.nb.frm.1.tab.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 1\]
    rightmenu_rm rm rm \$id \$coord
    "
    #Read_mapping dist
    set tl .result.notebook2.nb.frm.1.dist.table
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 1\]
    rightmenu_rm rm_dist rm_dist \$id \$coord
    "
}

proc update_info_rm {} {
    global env
    .result.notebook2.nb.frm.0.label1 configure -text $env(contig.name)
}

proc update_info_readMapping {db name_hit mode blast} {
    global env
    global tabArr
    global oldTag
    global readMapping_stepx
    global readMapping_min
    global blastArr
    global map_canTagL
    global readMapping_seq
    
    catch {
        .readMapping_draw.bottom.c delete hit
        foreach tag $map_canTagL {
            .readMapping_draw.bottom.c delete $tag
        }
    }
    set map_canTagL ""
    if {$db ne "-"} {
        set seq_len "???"
        if {$tabArr(rm.exist)} {
            .result.notebook2.nb.frm.1.panel delete 1.0 end
            catch {.result.notebook2.nb.frm.1.panel tag remove markedGreen 1.0 1000.end}
        }
        if {$mode} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence, length FROM $db.sequences_read WHERE name = '$name_hit'"}}]]
            foreach sRes $sql_res {
                set sequence [string toupper [lindex $sRes 0]]
                set seq_len [lindex $sRes 1]
            }
            unset sql_res
            if {$blast} {
                set stop 1
                set s 0
                set level 0
                set readMapping_seq ""
                while {$stop} {
                    if {[lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 1] eq $name_hit} {
                        #set stop 0
                        set length [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 2]
                        set strand [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 3]
                        set seq_start [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 4]
                        set read_start [expr [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 6] - 1]
                        set read_end [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 7]
                        set r_start [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 6]
                        set r_end [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 7]
                        set r_startT $r_start
                        set r_endT $r_end
                        if {$strand eq "C"} {
                            set tmp ""
                            set sequence [string map {A T T A G C C G a t t a g c c g R Y Y R K M M K H D D H B V V B r y y r k m m k h d d h b v v b} $sequence]
                            for {set n [expr [string length $sequence] - 1]} {$n >= 0} {set n [expr $n - 1]} {
                                append tmp [string index $sequence $n]
                            }
                            set sequence $tmp
                            unset tmp
                            set r_startT [expr $length - $r_start + 1]
                            set r_endT [expr $length - $r_end + 1]
                        }
                        lappend readMapping_seq "$sequence"
                        foreach blastHit $blastArr(blastHitL) {
                            if {[lindex $blastHit 1] eq $name_hit && [lindex $blastHit 8] eq $r_startT && [lindex $blastHit 9] eq $r_endT} {
                                set seqQuery [lindex $blastHit 10]
                                set seqHit [lindex $blastHit 11]
                                break
                            }
                        }
                        set x [expr 5 + (-$readMapping_min + $seq_start - 1) * 12]
                        set insert 0
                        for {set i 0} {$i < [string length $sequence]} {incr i} {
                            if {$i < $read_start} {
                                .readMapping_draw.bottom.c create text $x [expr 30 + 11 * $level] -text [string index $sequence $i] -anchor w -tag hit -fill grey
                            } elseif {$i >= $read_end} {
                                .readMapping_draw.bottom.c create text $x [expr 30 + 11 * $level] -text [string index $sequence $i] -anchor w -tag hit -fill grey
                            } else {
                                for {set j 0} {$j < [string length $seqHit]} {incr j} {
                                    if {[string index $seqHit $j] eq [string index $seqQuery $j]} {
                                        .readMapping_draw.bottom.c create text [expr $x + ($readMapping_stepx / 2 - 6)] [expr 30 + 11 * $level] -text [string index $seqHit $j] -anchor w -tag hit -fill green
                                        set x [expr $x + $readMapping_stepx]
                                        incr i
                                    } elseif {[string index $seqQuery $j] eq "-"} {
                                        set insert [expr $insert - 1]
                                    } else {
                                        if {[string index $seqHit $j] eq "-"} {
                                            #incr insert
                                            .readMapping_draw.bottom.c create text [expr $x + ($readMapping_stepx / 2 - 6)] [expr 30 + 11 * $level] -text [string index $seqHit $j] -anchor w -tag hit -fill red
                                            set x [expr $x + $readMapping_stepx]
                                            #incr i
                                        } else {
                                            .readMapping_draw.bottom.c create text [expr $x + ($readMapping_stepx / 2 - 6)] [expr 30 + 11 * $level] -text [string index $seqHit $j] -anchor w -tag hit -fill red
                                            set x [expr $x + $readMapping_stepx]
                                            incr i
                                        }
                                    }
                                }
                                set i [expr $read_end - 1]
                                set x [expr $x - 12]
                            }
                            #set comm "readMapping_bind {base_[expr $seq_start - 1 + $i] [expr $seq_start - 1 + $i] $x}"
                            #.readMapping_draw.bottom.c bind hit_$i <ButtonRelease-1> $comm
                            #lappend map_canTagL hit_$i
                            set x [expr $x + 12]
                        }
                        if {$tabArr(rm.exist)} {
                            catch {
                                .result.notebook2.nb.frm.1.panel insert end ">$name_hit\tlength=$seq_len Level=$level\n" bold11
                                .result.notebook2.nb.frm.1.panel insert end "$sequence\n\n"
                                if {$r_start > $r_end} {
                                    .result.notebook2.nb.frm.1.panel tag add markedGreen [expr 2 + 3 * $level].[expr $r_end - 1] [expr 2 + 3 * $level].$r_start
                                } else  {
                                    .result.notebook2.nb.frm.1.panel tag add markedGreen [expr 2 + 3 * $level].[expr $r_start - 1] [expr 2 + 3 * $level].$r_end
                                }
                            }
                        }
                        incr level
                    } elseif {[lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 1] eq ""} {
                        set stop 0
                    }
                    incr s
                }
            } else {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence_gap, seq_start, read_start, read_end FROM $db.read_hits WHERE name_read = '$name_hit'"}}]]
                foreach sRes $sql_res {
                    if {[lindex $sRes 0] ne ""} {
                        set sequence [lindex $sRes 0]
                    }
                    set seq_start [lindex $sRes 1]
                    set read_start [expr [lindex $sRes 2] - 1]
                    set read_end [lindex $sRes 3]
                }
                unset sql_res
                catch {
                    set x [expr 5 + (-$readMapping_min + $seq_start - 1) * 12]
                    for {set i 0} {$i < [string length $sequence]} {incr i} {
                        if {$i < $read_start} {
                            .readMapping_draw.bottom.c create text $x 30 -text [string index $sequence $i] -anchor w -tag hit -fill grey
                        } elseif {$i > $read_end} {
                            .readMapping_draw.bottom.c create text $x 30 -text [string index $sequence $i] -anchor w -tag hit -fill grey
                        } elseif {[string index $sequence $i] ne "[.readMapping_draw.bottom.c itemcget base_[expr $seq_start - 1 + $i] -text]"} {
                            .readMapping_draw.bottom.c create text $x 30 -text [string index $sequence $i] -anchor w -tag hit -fill red
                        } else {
                            .readMapping_draw.bottom.c create text $x 30 -text [string index $sequence $i] -anchor w -tag hit -fill green
                        }
                        set x [expr $x + 12]
                    }
                }
                if {$tabArr(rm.exist)} {
                    .result.notebook2.nb.frm.1.panel insert end ">$name_hit\tlength=$seq_len\n" bold11
                    .result.notebook2.nb.frm.1.panel insert end "$sequence\n\n"
                    set r_start [expr [string length $sequence] - $read_start + 1]
                    set r_end [expr [string length $sequence] - $read_end + 1]
                    if {$r_start > $r_end} {
                        .result.notebook2.nb.frm.1.panel tag add markedGreen 2.[expr $r_end - 1] 2.$r_start
                    } else {
                        .result.notebook2.nb.frm.1.panel tag add markedGreen 2.[expr $r_start - 1] 2.$r_end
                    }
                }
            }
        } else {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence, length, numreads FROM $db.sequences_nucleotide WHERE name = '$name_hit'"}}]]
            foreach sRes $sql_res {
                set sequence [lindex $sRes 0]
                set seq_len [lindex $sRes 1]
                set numreads [lindex $sRes 2]
            }
            unset sql_res
            set stop 1
            set s 0
            set level 0
            set readMapping_seq ""
            while {$stop} {
                if {[lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 1] eq $name_hit} {
                    #set stop 0
                    set length [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 2]
                    set strand [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 3]
                    set seq_start [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 4]
                    set read_start [expr [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 6] - 1]
                    set read_end [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 7]
                    set r_start [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 6]
                    set r_end [lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 7]
                    set r_startT $r_start
                    set r_endT $r_end
                    if {$strand eq "C"} {
                        set tmp ""
                        set sequence [string map {A T T A G C C G a t t a g c c g R Y Y R K M M K H D D H B V V B r y y r k m m k h d d h b v v b} $sequence]
                        for {set n [expr [string length $sequence] - 1]} {$n >= 0} {set n [expr $n - 1]} {
                            append tmp [string index $sequence $n]
                        }
                        set sequence $tmp
                        unset tmp
                        set r_startT [expr $length - $r_start + 1]
                        set r_endT [expr $length - $r_end + 1]
                    }
                    lappend readMapping_seq "$sequence"
                    foreach blastHit $blastArr(blastHitL) {
                        if {[lindex $blastHit 1] eq $name_hit && [lindex $blastHit 8] eq $r_startT && [lindex $blastHit 9] eq $r_endT} {
                            set seqQuery [lindex $blastHit 10]
                            set seqHit [lindex $blastHit 11]
                            break
                        }
                    }
                    catch {
                        set x [expr 5 + (-$readMapping_min + $seq_start - 1) * 12]
                        set end 0
                        for {set i 0} {$i < [string length $sequence]} {incr i} {
                            if {$i < $read_start} {
                                .readMapping_draw.bottom.c create text $x [expr 30 + 11 * $level] -text [string index $sequence $i] -anchor w -tag hit -fill grey
                                set x [expr $x + 12]
                            } elseif {$end} {
                                .readMapping_draw.bottom.c create text $x [expr 30 + 11 * $level] -text [string index $sequence $i] -anchor w -tag hit -fill grey
                                set x [expr $x + 12]
                            } else {
                                set insertion 0
                                for {set j 0} {$j < [string length $seqHit]} {incr j} {
                                    if {[string index $seqHit $j] eq [string index $seqQuery $j]} {
                                        .readMapping_draw.bottom.c create text [expr $x + ($readMapping_stepx / 2 - 6)] [expr 30 + 11 * $level] -text [string index $seqHit $j] -anchor w -tag hit -fill green
                                        set x [expr $x + $readMapping_stepx]
                                        incr i
                                    } elseif {[string index $seqQuery $j] eq "-"} {
                                    } else {
                                        if {[string index $seqHit $j] eq "-"} {
                                            incr insertion
                                        }
                                        .readMapping_draw.bottom.c create text [expr $x + ($readMapping_stepx / 2 - 6)] [expr 30 + 11 * $level] -text [string index $seqHit $j] -anchor w -tag hit -fill red
                                        set x [expr $x + $readMapping_stepx]
                                        incr i
                                    }
                                }
                                set end 1
                                set i [expr $i - 1]
                            }
                        }
                    }
                    if {$tabArr(rm.exist)} {
                        .result.notebook2.nb.frm.1.panel insert end ">$name_hit\tlength=$seq_len\tnumreads=$numreads\tLevel=$level\n" bold11
                        .result.notebook2.nb.frm.1.panel insert end "$sequence\n\n"
                        if {$r_start > $r_end} {
                            .result.notebook2.nb.frm.1.panel tag add markedGreen [expr 2 + 3 * $level].[expr $r_end - 1] [expr 2 + 3 * $level].$r_start
                        } else  {
                            .result.notebook2.nb.frm.1.panel tag add markedGreen [expr 2 + 3 * $level].[expr $r_start - 1] [expr 2 + 3 * $level].$r_end
                        }
                    }
                    incr level
                } elseif {[lindex [.result.notebook2.nb.frm.1.tab.table.l get $s] 1] eq ""} {
                    set stop 0
                }
                incr s
            }
        }
        
        catch {.readMapping_draw.top.1.c itemconfigure [lindex $oldTag 0] -fill [lindex $oldTag 1]}
        catch {.readMapping_draw.top.1.c itemconfigure [lindex $oldTag 0]Complete -fill grey}
        catch {
            set oldTag "$name_hit [.readMapping_draw.top.1.c itemcget $name_hit -fill]"
            .readMapping_draw.top.1.c itemconfigure $name_hit -fill yellow
            append name_read "Complete"
            .readMapping_draw.top.1.c itemconfigure $name_hit -fill beige
        }
    }
}

proc readMapping_export_reads {dbName id_seq name} {
    global env
    set res ""
    if {$dbName eq "rm"} {
        set name $env(contig.name)
        set dbName $env(contig.dbName)
        set sql "SELECT name, id_run, length, sequence FROM $dbName.sequences_read WHERE name IN (SELECT name_read FROM $dbName.read_hits WHERE name_seq = '$name')"
    } elseif {$dbName eq "rm_dist"} {
        set name $env(contig.name)
        set dbName $env(contig.dbName)
        set sql "SELECT name, id_run, length, sequence FROM $dbName.sequences_read WHERE name IN (SELECT name_read FROM $dbName.read_hits WHERE name_seq = '$name') AND id_run = '$id_seq'"
    } else {
        if {$name eq 0} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name FROM $dbName.sequences_nucleotide WHERE id_seq = $id_seq"}}]]
            foreach sRes $sql_res {
                set name [lindex $sRes 0]
            }
            unset sql_res
        }
        set sql "SELECT name, id_run, length, sequence FROM $dbName.sequences_read WHERE name IN (SELECT name_read FROM $dbName.read_hits WHERE name_seq = '$name')"
    }
    
    set ofile [tk_getSaveFile -filetypes {{{Text Files} {.txt} } {{All Files} * }} -initialfile "${name}_reads.fasta" -initialdir $env(homeFolder)]
    
    if {$ofile ne ""} {
        set res ""
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "$sql"}}]]
        foreach sRes $sql_res {
            append res ">[lindex $sRes 0] run=[lindex $sRes 1] length=[lindex $sRes 2]\n[lindex $sRes 3]\n"
        }
        unset sql_res
        if {$res ne ""} {
            if {[catch {set fs [open $ofile w]} ]} {
                errorPopUp "Error" "Could not create file:\n$ofile."
            } else {
                puts -nonewline $fs $res
                close $fs
                unset res
            }
        } else  {
            errorPopUp "Error" "Could not extract reads for contig:\n"
        }
    }
}

proc readMapping_run {} {
    global env
    global blastArr
    global map_canTagL
    global readMap_alignCheck
    global readMapping_min
    global readMapping_max
    global readMapping_seqLen
    global readMapping_base_cover
    global readMapping_stepx
    
    .result.notebook2.nb.frm.0.run configure -state disabled
    .result.notebook1.nb.fblast.1.tab.table.l finishediting
    .result.notebook1.nb.fdb_info.1.table.l finishediting
    
    set readMap ""
    set program ""
    set runL ""
    set readMapping_base_cover ""
    set stop 1
    set i 0
    set color ""
    while {$stop} {
        set id_run [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3]
        if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq 1} {
            set color [string range [[.result.notebook1.nb.fdb_info.1.table.l windowpath $i,1] cget -image] 1 end]
            lappend runL "$id_run $color {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 4]} {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 5]} [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 7]"
        }
        if {$id_run eq ""} {
            set stop 0
        }
        incr i
    }
    unset color
    
    if {[.result.notebook1.nb raise] eq "blast"} {
        .result.notebook1.nb.fdb_info.1.table.l finishediting
        set program [lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]
        if {$program eq "tblastn"} {
            set readMapping_seqLen [expr 3 * [string length [lindex [lindex $blastArr(queryL) 0] 1]]]
            set readMapping_stepx 36
            set query [lindex $blastArr(queryL) 0]
        } else {
            set readMapping_seqLen [string length [lindex [lindex $blastArr(queryL) 0] 1]]
            set readMapping_stepx 12
            set query [lindex $blastArr(queryL) 0]
        }
        
        set tl ".result.notebook1.nb.fblast.1.tab.table.l"
        set stop 0
        set i 0
        set nameL ""
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend seqL "[lindex [$tl get $i] 2] [lrange [$tl get $i] 7 10]"
                append nameL ", '[lindex [$tl get $i] 2]'"
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
                set db [lindex [$tl get [expr $i - 1]] 12]
            }
            incr i
        }
        set nameL [string range $nameL 2 end]
        if {$nameL ne ""} {
            set readMapping_min 0
            set readMapping_max $readMapping_seqLen
            if {[lindex [split $db _] end] eq "reads"} {
                set update_mode 1
                set db [regsub -all "_reads" $db ""]
                if {[catch {
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, id_run, length, polya, singleton FROM $db.sequences_read WHERE name IN ($nameL)"}}]]
                        foreach sRes $sql_res {
                            set name [lindex $sRes 0]
                            set id_run [lindex $sRes 1]
                            set length [lindex $sRes 2]
                            set polya [lindex $sRes 3]
                            set singleton [lindex $sRes 4]
                            if {$polya eq ""} {
                                set polya "f"
                            }
                            foreach seq $seqL {
                                if {[lindex $seq 0] eq $name} {
                                    if {[lindex $seq 1] > [lindex $seq 2]} {
                                        if {$program eq "tblastn"} {
                                            set readMapping_stepx 36
                                            set qstart [expr ([lindex $seq 2] - 1) * 3]
                                        } else {
                                            set readMapping_stepx 12
                                            set qstart [lindex $seq 2]
                                        }
                                    } else {
                                        if {$program eq "tblastn"} {
                                            set readMapping_stepx 36
                                            set qstart [expr ([lindex $seq 1] - 1) * 3]
                                        } else {
                                            set readMapping_stepx 12
                                            set qstart [lindex $seq 1]
                                        }
                                    }
                                    if {[lindex $seq 3] > [lindex $seq 4]} {
                                        set start [expr $qstart - ($length - [lindex $seq 3])]
                                        set end [expr $start + $length - 1]
                                        if {$start < $readMapping_min} {
                                            set readMapping_min $start
                                        }
                                        if {$end > $readMapping_max} {
                                            set readMapping_max $end
                                        }
                                        lappend readMap "$start $end $name $id_run C $length [expr $length - [lindex $seq 3] + 1] [expr $length - [lindex $seq 4] + 1] $polya $singleton $db read"
                                    } else {
                                        set start [expr $qstart - [lindex $seq 3] + 1]
                                        set end [expr $start + $length - 2]
                                        if {$start < $readMapping_min} {
                                            set readMapping_min $start
                                        }
                                        if {$end > $readMapping_max} {
                                            set readMapping_max $end
                                        }
                                        lappend readMap "$start $end $name $id_run U $length [lindex $seq 3] [lindex $seq 4] $polya $singleton $db read"
                                    }
                                }
                            }
                        }
                        unset sql_res
                    }]} {
                    foreach hit $blastArr(blastHitL) {
                        if {[lindex $hit 0] eq $query} {
                            set i [lsearch -index 0 $seqL]
                            if {$i ne -1} {
                                if {[lindex $hit 6] > [lindex $hit 7]} {
                                    if {$program eq "tblastn"} {
                                        set readMapping_stepx 36
                                        set qstart [expr ([lindex $hit 7] - 1) * 3]
                                    } else {
                                        set readMapping_stepx 12
                                        set qstart [lindex $hit 7]
                                    }
                                } else {
                                    if {$program eq "tblastn"} {
                                        set readMapping_stepx 36
                                        set qstart [expr ([lindex $hit 6] - 1) * 3]
                                    } else {
                                        set readMapping_stepx 12
                                        set qstart [lindex $hit 6]
                                    }
                                }
                                if {[lindex $hit 8] > [lindex $hit 9]} {
                                    set start [expr $qstart - ([lindex $hit 14] - [lindex $hit 8])]
                                    set end [expr $start + [lindex $hit 14] - 1]
                                    if {$start < $readMapping_min} {
                                        set readMapping_min $start
                                    }
                                    if {$end > $readMapping_max} {
                                        set readMapping_max $end
                                    }
                                    lappend readMap "$start $end [lindex $hit 1] - C [lindex $hit 14] [expr [lindex $hit 14] - [lindex $hit 8] + 1] [expr [lindex $hit 14] - [lindex $hit 9] + 1] - - - -"
                                } else {
                                    set start [expr $qstart - [lindex $hit 8] + 1]
                                    set end [expr $start + [lindex $hit 14] - 2]
                                    if {$start < $readMapping_min} {
                                        set readMapping_min $start
                                    }
                                    if {$end > $readMapping_max} {
                                        set readMapping_max $end
                                    }
                                    lappend readMap "$start $end [lindex $hit 1] - U [lindex $hit 14] [lindex $hit 8] [lindex $hit 9] - - - -"
                                }
                            }
                        }
                    }
                }
            } else {
                set update_mode 0
                if {[catch {
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length FROM $db.sequences_nucleotide WHERE name IN ($nameL)"}}]]
                        foreach sRes $sql_res {
                            set name [lindex $sRes 0]
                            set length [lindex $sRes 1]
                            foreach seq $seqL {
                                if {[lindex $seq 0] eq $name} {
                                    if {[lindex $seq 1] > [lindex $seq 2]} {
                                        if {$program eq "tblastn"} {
                                            set readMapping_stepx 36
                                            set qstart [expr ([lindex $seq 2] - 1) * 3]
                                        } else {
                                            set readMapping_stepx 12
                                            set qstart [lindex $seq 2]
                                        }
                                    } else {
                                        if {$program eq "tblastn"} {
                                            set readMapping_stepx 36
                                            set qstart [expr ([lindex $seq 1] - 1) * 3]
                                        } else {
                                            set readMapping_stepx 12
                                            set qstart [lindex $seq 1]
                                        }
                                    }
                                    if {[lindex $seq 3] > [lindex $seq 4]} {
                                        set start [expr $qstart - ($length - [lindex $seq 3])]
                                        set end [expr $start + $length - 2]
                                        if {$start < $readMapping_min} {
                                            set readMapping_min $start
                                        }
                                        if {$end > $readMapping_max} {
                                            set readMapping_max $end
                                        }
                                        lappend readMap "$start $end $name - C $length [expr $length - [lindex $seq 3] + 1] [expr $length - [lindex $seq 4] + 1] - - $db contig"
                                    } else {
                                        set start [expr $qstart - [lindex $seq 3] + 1]
                                        set end [expr $start + $length - 1]
                                        if {$start < $readMapping_min} {
                                            set readMapping_min $start
                                        }
                                        if {$end > $readMapping_max} {
                                            set readMapping_max $end
                                        }
                                        lappend readMap "$start $end $name - U $length [lindex $seq 3] [lindex $seq 4] - - $db contig"
                                    }
                                }
                            }
                        }
                        unset sql_res
                    }]} {
                    foreach hit $blastArr(blastHitL) {
                        if {[lindex $hit 0] eq [lindex $query 0]} {
                            set i [lsearch -regexp $seqL [lindex $hit 1]]
                            if {$i ne -1} {
                                if {[lindex $hit 6] > [lindex $hit 7]} {
                                    if {$program eq "tblastn"} {
                                        set readMapping_stepx 36
                                        set qstart [expr ([lindex $hit 7] - 1) * 3]
                                    } else {
                                        set readMapping_stepx 12
                                        set qstart [lindex $hit 7]
                                    }
                                } else {
                                    if {$program eq "tblastn"} {
                                        set readMapping_stepx 36
                                        set qstart [expr ([lindex $hit 6] - 1) * 3]
                                    } else {
                                        set readMapping_stepx 12
                                        set qstart [lindex $hit 6]
                                    }
                                }
                                if {[lindex $hit 8] > [lindex $hit 9]} {
                                    set start [expr $qstart - ([lindex $hit 14] - [lindex $hit 8])]
                                    set end [expr $start + [lindex $hit 14] - 1]
                                    if {$start < $readMapping_min} {
                                        set readMapping_min $start
                                    }
                                    if {$end > $readMapping_max} {
                                        set readMapping_max $end
                                    }
                                    lappend readMap "$start $end [lindex $hit 1] - C [lindex $hit 14] [expr [lindex $hit 14] - [lindex $hit 8] + 1] [expr [lindex $hit 14] - [lindex $hit 9] + 1] - - - -"
                                } else {
                                    set start [expr $qstart - [lindex $hit 8] + 1]
                                    set end [expr $start + [lindex $hit 14] - 2]
                                    if {$start < $readMapping_min} {
                                        set readMapping_min $start
                                    }
                                    if {$end > $readMapping_max} {
                                        set readMapping_max $end
                                    }
                                    lappend readMap "$start $end [lindex $hit 1] - U [lindex $hit 14] [lindex $hit 8] [lindex $hit 9] - - - -"
                                }
                            }
                        }
                    }
                }
            }
        } else {
            errorPopUp "Error" "No legal blast results selected."
        }
    } else {
        set readMapping_stepx 12
        set update_mode 1
        
        if {[catch {
                if {$env(contig.numreads) ne 0} {
                    if {[string tolower $env(contig.dbName)] eq [string tolower $env(dbName)]} {
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence, sequence_gap, base_cover FROM $env(contig.dbName).sequences_nucleotide WHERE name = '$env(contig.name)'"}}]]
                        foreach sRes $sql_res {
                            if {[lindex $sRes 1] eq ""} {
                                set strS [lindex $sRes 0]
                            } else {
                                set strS [lindex $sRes 1]
                                set readMapping_base_cover [lindex $sRes 2]
                            }
                            set readMapping_seqLen [string length $strS]
                            set query "$env(contig.name) $strS"
                        }
                        unset sql_res
                        set readMapping_min 0
                        set readMapping_max $readMapping_seqLen
                        if {$runL ne ""} {
                            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $env(contig.dbName).read_hits.name_read AS name_read, $env(contig.dbName).sequences_read.id_run AS run, $env(contig.dbName).sequences_read.polya AS polya, $env(contig.dbName).read_hits.strand AS strand, $env(contig.dbName).read_hits.read_start AS read_start, $env(contig.dbName).read_hits.read_end AS read_end, $env(contig.dbName).read_hits.seq_start AS seq_start, $env(contig.dbName).read_hits.seq_start + char_length($env(contig.dbName).read_hits.sequence_gap) AS seq_end, char_length($env(contig.dbName).sequences_read.sequence) AS length FROM $env(contig.dbName).read_hits INNER JOIN $env(contig.dbName).sequences_read ON $env(contig.dbName).sequences_read.name = $env(contig.dbName).read_hits.name_read WHERE $env(contig.dbName).read_hits.name_seq = '$env(contig.name)' ORDER BY $env(contig.dbName).read_hits.seq_start"}}]]
                            foreach sRes $sql_res {
                                if {[lindex $sRes 6] < $readMapping_min} {
                                    set readMapping_min [lindex $sRes 6]
                                }
                                if {[lindex $sRes 7] > $readMapping_max} {
                                    set readMapping_max [lindex $sRes 7]
                                }
                                lappend readMap "[lindex $sRes 6] [lindex $sRes 7] [lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 3] [lindex $sRes 8] [lindex $sRes 4] [lindex $sRes 5] [lindex $sRes 2] f $env(contig.dbName) read"
                            }
                            unset sql_res
                        } else {
                            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name_read, strand, read_start, read_end, seq_start, seq_start + char_length(sequence_gap) AS seq_end, char_length(sequence_gap) AS length FROM $env(contig.dbName).read_hits WHERE name_seq = '$env(contig.name)' ORDER BY seq_start"}}]]
                            foreach sRes $sql_res {
                                if {[lindex $sRes 4] < $readMapping_min} {
                                    set readMapping_min [lindex $sRes 4]
                                }
                                if {[lindex $sRes 5] > $readMapping_max} {
                                    set readMapping_max [lindex $sRes 5]
                                }
                                lappend readMap "[lindex $sRes 4] [lindex $sRes 5] [lindex $sRes 0] - [lindex $sRes 1] [lindex $sRes 6] [lindex $sRes 2] [lindex $sRes 3] - f $env(contig.dbName) read"
                            }
                            unset sql_res
                        }
                    }
                } else {
                    errorPopUp "Error" "No read information available."
                }
            }]} {
            errorPopUp "Error" "No contig selected."
        }
    }
    if {$readMap ne ""} {
        set draw 0
        if {[llength $readMap] > 2000} {
            set draw [tk_dialog .dialog "Warning!" "There are [llength $readMap] reads to display,\nthis may take a while.\nAre you sure to proceed?" "" 1 "Yes" "No"]
        }
        if {$draw eq 0} {
            if {[.result.notebook1.nb raise] eq "blast"} {
                readMapping_draw $query $readMap "$runL" $update_mode 1
                unset readMap
            } else {
                readMapping_draw $query $readMap "$runL" $update_mode 0
                unset readMap
            }
        }
    }
    .result.notebook2.nb.frm.0.run configure -state normal
}

proc readMapping_draw {query readMap runL update_mode blast} {
    global map_canTagL
    #global readMap_multipleCheck
    global readMap_mapCheck
    global readMapping_width
    global readMapping_height
    global readMapping_posx
    global readMapping_stepx
    global readMapping_len
    global readMapping_min
    global readMapping_max
    global readMapping_seqLen
    global readMapping_base_cover
    global readMapping_yline
    
    if {$readMap_mapCheck} {
        set t .readMapping_draw
        set width 800; set height 608
        catch {set width [winfo width $t]; set height [winfo height $t]; destroy $t}
        toplevel $t
        wm title $t "[lindex $query 0]"
        wm minsize $t 800 608
        wm geometry $t "${width}x$height"
        
        frame $t.top
        frame $t.top.head
        label $t.top.head.l -text "Position: "
        label $t.top.head.pos -text ""
        frame $t.top.1
        canvas $t.top.1.c -height 490 -width 580 -background white -yscrollcommand "$t.top.1.y set"
        scrollbar $t.top.1.y -orient vertical -command "$t.top.1.c yview"
        frame $t.bottom
        label $t.bottom.l -text "Selected sequence:"
        canvas $t.bottom.c -height 62 -width 600 -background white -xscrollcommand "$t.bottom.x set"
        scrollbar $t.bottom.x -orient horizontal -command "$t.bottom.c xview"
        frame $t.buts -bd 2 -relief groove
        button $t.buts.cancel -text "Close" -command "destroy $t"
        
        pack $t.top.head.l $t.top.head.pos -side left
        pack $t.top.1.c -side left -fill both -expand true; pack $t.top.1.y -side left -fill both
        pack $t.top.head -side top -fill both; pack $t.top.1 -side top -fill both -expand true
        pack $t.bottom.l -side top -fill both; pack $t.bottom.c -expand true -side top -fill both; pack $t.bottom.x -side top -fill both
        pack $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.top $t.bottom -expand true -side top -fill both; pack $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
        
        .result.notebook2.nb.frm.1.panel delete 1.0 end
        
        set readMapping_len [expr $readMapping_max - $readMapping_min + 1]
        set readMapping_width [expr $width - 30]
        set readMapping_height [expr $height - 18]
        set readMapping_posx [expr $readMapping_width.0 / $readMapping_len.0]
        set contigSeq_start [expr 5 - int($readMapping_min.0 * $readMapping_posx)]
        set contigSeq_end [expr $contigSeq_start + int($readMapping_seqLen.0 * $readMapping_posx)]
        
        #draw query
        $t.top.1.c create rect $contigSeq_start 5 $contigSeq_end 12 -tag seq -fill yellow
        set x [expr 5 + (-$readMapping_min * 12)]
        for {set i 0} {$i < [string length [lindex $query 1]]} {incr i} {
            set base_sum 0
            set base_max 0
            if {$readMapping_base_cover ne ""} {
                foreach b [lindex $readMapping_base_cover $i] {
                    set base_sum [expr $base_sum + $b]
                    if {$b > $base_max} {
                        set base_max $b
                    }
                }
                if {$base_sum eq 0} {
                    set base_color blue
                } elseif {[expr $base_max.0 / $base_sum.0] > 0.9} {
                    set base_color green
                } elseif {[expr $base_max.0 / $base_sum.0] > 0.6} {
                    set base_color orange
                } else {
                    set base_color red
                }
                $t.bottom.c create rect [expr $x - 2] 0 [expr $x + 9] 8 -tag base -fill $base_color
            }
            
            $t.bottom.c create text $x 15 -text [string index [lindex $query 1] $i] -anchor w -tag base_$i
            set comm "readMapping_bind {base_$i $i $x}"
            $t.bottom.c bind base_$i <ButtonRelease-1> $comm
            set x [expr $x + $readMapping_stepx]
        }
        
        $t.bottom.c configure -scrollregion "0 0 [expr 5 + $readMapping_len * 12] 0"
        set space [expr int(13.0 / $readMapping_posx)]
        set rowStartL "{[lindex [lindex $readMap 0] 0] 0}"
        set lines 0
    }
    
    .result.notebook2.nb.frm.1.tab.table.l delete 0 end
    .result.notebook2.nb.frm.1.dist.table delete 0 end
    
    foreach run $runL {
        set runCountArr([lindex $run 0]) 0
    }
    foreach hit $readMap {
        incr runCountArr([lindex $hit 3])
        set draw 0
        if {$runL eq ""} {
            set draw 1
            set color green
        } else {
            foreach run $runL {
                if {[lindex $hit 3] eq "-"} {
                    set draw 1
                    set color green
                    break
                } elseif {[lindex $run 0] eq [lindex $hit 3]} {
                    set draw 1
                    set color [lindex $run 1]
                    break
                }
            }
        }
        if {$draw} {
            .result.notebook2.nb.frm.1.tab.table.l insert end "[lindex $hit 3] [lindex $hit 2] [lindex $hit 5] [lindex $hit 4] [lindex $hit 0] [lindex $hit 1] [lindex $hit 6] [lindex $hit 7] [lindex $hit 8] [lindex $hit 9] [lindex $hit 10]"
            if {[lindex $hit 8] eq "t"} {
                .result.notebook2.nb.frm.1.tab.table.l rowconfigure end -fg red
            }
            if {$readMap_mapCheck} {
                #draw hits
                set c_row -1
                set contig_start [lindex $hit 0]
                set contig_end [lindex $hit 1]
                for {set i 0} {$i < [llength $rowStartL]} {incr i} {
                    set row_start [lindex [lindex $rowStartL $i] 0]
                    set row_end [lindex [lindex $rowStartL $i] 1]
                    if {$contig_start > $row_end} {
                        set rowStartL [lreplace $rowStartL $i $i "[expr $row_start - $space] [expr $contig_end + $space]"]
                        set c_row $i
                        break
                    } elseif {$contig_end < $row_start} {
                        set rowStartL [lreplace $rowStartL $i $i "[expr $contig_start - $space] [expr $row_end + $space]"]
                        set c_row $i
                        break
                    }
                }
                if {$c_row eq -1} {
                    set c_row [llength $rowStartL]
                    lappend rowStartL "[expr [lindex $hit 0] - $space] [expr [lindex $hit 1] + $space]"
                }
                if {$c_row > $lines} {
                    set lines $c_row
                }
                set r_startComplete [lindex [split [expr 5 + $readMapping_posx * ($contig_start.0 - $readMapping_min.0)] .] 0]
                set r_endComplete [lindex [split [expr 5 + $readMapping_posx * ($contig_end.0 - $readMapping_min.0)] .] 0]
                set r_startContig [lindex [split [expr 5 + $readMapping_posx * ($contig_start.0 - $readMapping_min.0 + [lindex $hit 6].0 - 1.0)] .] 0]
                set r_endContig [lindex [split [expr 5 + $readMapping_posx * ($contig_end.0 - $readMapping_min.0 - ([lindex $hit 5].0 - [lindex $hit 7].0))] .] 0]
                if {[lindex $hit 4] eq "U"} {
                    $t.top.1.c create poly $r_endComplete [expr 13 + 7 * $c_row] $r_endComplete [expr 20 + 7 * $c_row] [expr $r_endComplete + 5] [expr 17 + 7 * $c_row] -fill black -tag hit
                } else {
                    $t.top.1.c create poly $r_startComplete [expr 13 + 7 * $c_row] $r_startComplete [expr 20 + 7 * $c_row] [expr $r_startComplete - 5] [expr 17 + 7 * $c_row] -fill black -tag hit
                }
                $t.top.1.c create rect $r_startComplete [expr 14 + 7 * $c_row] $r_endComplete [expr 19 + 7 * $c_row] -fill grey -tag "[lindex $hit 2]Complete"
                lappend map_canTagL "[lindex $hit 2]Complete"
                $t.top.1.c create rect $r_startContig [expr 14 + 7 * $c_row] $r_endContig [expr 19 + 7 * $c_row] -fill $color -tag "[lindex $hit 2]"
                lappend map_canTagL "[lindex $hit 2]"
                set comm "catch {update_info_readMapping [lindex $hit 10] [lindex $hit 2] $update_mode $blast}"
                catch {$t.top.1.c bind "[lindex $hit 2]" <Button-1> $comm}
                if {[lindex $hit 11] eq "contig"} {
                    set comm "rightmenu_rm readMapping [lindex $hit 10] [lindex $hit 2] 0"
                    catch {$t.top.1.c bind "[lindex $hit 2]" <ButtonPress-3> $comm}
                }
            }
        }
    }
    #seqTotal: the number of all reads of the selected runs which contribute to the contig
    set seqTotal 0
    foreach run $runL {
        if {$runCountArr([lindex $run 0]) ne 0} {
            set seqTotal [expr $seqTotal + [lindex $run 4]]
        }
    }
    #avgN: the sum
    set avgN 0
    set i 0
    foreach run $runL {
        if {$runCountArr([lindex $run 0]) ne 0} {
            set avgN [expr $avgN + ($seqTotal.0 * $runCountArr([lindex $run 0]).0 / [lindex $run 4].0)]
            incr i
        }
    }
    unset i
    foreach run $runL {
        if {$runCountArr([lindex $run 0]) ne 0} {
            set percent [split [expr 100.0 * $runCountArr([lindex $run 0]).0 / [llength $readMap].0] .]
            set percent "[lindex $percent 0],[string range [lindex $percent 1] 0 2]"
            if {[catch {set percentN [split [expr (100.0 * $seqTotal.0 * $runCountArr([lindex $run 0]).0) / ([lindex $run 4] * $avgN)] .]}]} {
                set percentN "N/A"
            } else {
                set percentN "[lindex $percentN 0],[string range [lindex $percentN 1] 0 2]"
            }
            .result.notebook2.nb.frm.1.dist.table insert end "$runCountArr([lindex $run 0]) [lindex $run 0] $percent $percentN {[lindex $run 2]} {[lindex $run 3]}"
        }
        unset runCountArr([lindex $run 0])
    }
    if {$readMap_mapCheck} {
        set readMapping_yline [expr 24 + 7 * $lines]
        $t.top.1.c configure -scrollregion "0 0 0 $readMapping_yline"
        bind $t.top.1.c <ButtonRelease-1> "readMapping_bind top"
        unset space
    }
    
    if {$blast} {
        if {$update_mode} {
            # Bindings.
            bind [.result.notebook2.nb.frm.1.tab.table.l bodypath] <Button-1> "
            set y \[.result.notebook2.nb.frm.1.tab.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
            set name_read \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 1\]
            set db \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 10\]
            update_info_readMapping \$db \$name_read 1 1
            "
        } else {
            # Bindings.
            bind [.result.notebook2.nb.frm.1.tab.table.l bodypath] <Button-1> "
            set y \[.result.notebook2.nb.frm.1.tab.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
            set name_read \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 1\]
            set db \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 10\]
            update_info_readMapping \$db \$name_read 0 1
            "
        }
    } else {
        if {$update_mode} {
            # Bindings.
            bind [.result.notebook2.nb.frm.1.tab.table.l bodypath] <Button-1> "
            set y \[.result.notebook2.nb.frm.1.tab.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
            set name_read \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 1\]
            set db \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 10\]
            update_info_readMapping \$db \$name_read 1 0
            "
        } else {
            # Bindings.
            bind [.result.notebook2.nb.frm.1.tab.table.l bodypath] <Button-1> "
            set y \[.result.notebook2.nb.frm.1.tab.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
            set name_read \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 1\]
            set db \[lindex \[.result.notebook2.nb.frm.1.tab.table.l get \$y\] 10\]
            update_info_readMapping \$db \$name_read 0 0
            "
        }
    }
    
    #bind .readMapping_draw.bottom.c <Button-1> "
    #set y \[.readMapping_draw.bottom.c canvasy \[expr {%y + \[winfo y %W\]}\]\]
    #set x \[.readMapping_draw.bottom.c canvasx \[expr {%x + \[winfo x %W\]}\]\]
    #.readMapping_draw.bottom.c addtag tmp closest \$x \$y
    #puts \[.readMapping_draw.bottom.c itemcget tmp -text\]
    #.readMapping_draw.bottom.c dtag tmp
    #"
}

proc readMapping_bind {mode} {
    global readMapping_width
    global readMapping_height
    global readMapping_posx
    global readMapping_len
    global readMapping_min
    global readMapping_max
    global readMapping_base
    global readMapping_base_cover
    global readMapping_yline
    
    if {$mode eq "top"} {
        #x position
        set x [expr [winfo pointerx .readMapping_draw.top.1.c] - [winfo rootx .readMapping_draw.top.1.c]]
        set i [expr int(($x.0 - 5.0) / $readMapping_posx)]
        if {$i < 1} {
            set i 1
        } elseif {$i >= $readMapping_len} {
            set i $readMapping_len
        }
        if {$x < 5} {
            set x 5
        } elseif {$x > [expr $readMapping_width + 5]} {
            set x [expr $readMapping_width + 5]
        }
        catch {.readMapping_draw.top.1.c delete line}
        if {$readMapping_base_cover eq ""} {
            catch {.readMapping_draw.top.head.pos configure -text "[expr $i + $readMapping_min + 1]"}
        } else {
            catch {.readMapping_draw.top.head.pos configure -text "[expr $i + $readMapping_min + 1]    (A: [lindex [lindex $readMapping_base_cover $i] 0];  T:[lindex [lindex $readMapping_base_cover $i] 1];  C: [lindex [lindex $readMapping_base_cover $i] 2];  G: [lindex [lindex $readMapping_base_cover $i] 3];  *: [lindex [lindex $readMapping_base_cover $i] 4])"}
        }
        .readMapping_draw.top.1.c create rect [expr $x - 1] 0 [expr $x + 1] $readMapping_yline -tag line -fill red
        set x [expr 5 + $i * 12]
        .readMapping_draw.bottom.c xview moveto [expr ($i.0 - 20) / $readMapping_len]
        
        #marking base
        catch {.readMapping_draw.bottom.c delete rect}
        catch {.readMapping_draw.bottom.c itemconfigure [lindex $readMapping_base 0] -fill black}
        catch {
            .readMapping_draw.bottom.c itemconfigure base_[expr $i + $readMapping_min] -fill red
            .readMapping_draw.bottom.c create rect [expr $x - 2] 9 [expr $x + 9] 23 -tag rect
        }
        set readMapping_base "base_[expr $i + $readMapping_min] $x"
    } else {
        catch {.readMapping_draw.bottom.c delete rect}
        catch {.readMapping_draw.top.1.c delete line}
        catch {.readMapping_draw.bottom.c itemconfigure [lindex $readMapping_base 0] -fill black}
        catch {
            .readMapping_draw.bottom.c itemconfigure [lindex $mode 0] -fill red
            .readMapping_draw.bottom.c create rect [expr [lindex $mode 2] - 2] 9 [expr [lindex $mode 2] + 9] 23 -tag rect
        }
        if {$readMapping_base_cover eq ""} {
            catch {.readMapping_draw.top.head.pos configure -text "[expr [lindex $mode 1] + 1]"}
        } else {
            catch {.readMapping_draw.top.head.pos configure -text "[expr [lindex $mode 1] + 1]    (A: [lindex [lindex $readMapping_base_cover [lindex $mode 1]] 0];  T:[lindex [lindex $readMapping_base_cover [lindex $mode 1]] 1];  C: [lindex [lindex $readMapping_base_cover [lindex $mode 1]] 2];  G: [lindex [lindex $readMapping_base_cover [lindex $mode 1]] 3];  *: [lindex [lindex $readMapping_base_cover [lindex $mode 1]] 4])"}
        }
        .readMapping_draw.top.1.c create rect [expr 4 + int([expr [lindex $mode 1] - $readMapping_min].0 * $readMapping_posx)] 0 [expr 6 + int([expr [lindex $mode 1] - $readMapping_min].0 * $readMapping_posx)] $readMapping_yline -tag line -fill red
        set readMapping_base "[lindex $mode 0] [lindex $mode 2]"
    }
}

proc mapping_config {} {
    global env
    
    set t .mapping_config
    toplevel $t
    wm title $t "Mapping Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.show
    
    frame $t.showColumn -bd 2 -relief groove
    label $t.showColumn.label -text "Columns displayed: "
    checkbutton $t.showColumn.contigEnd -text "contig end" -variable env(read_mapping.cend) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.contigStart -text "contig start" -variable env(read_mapping.cstart) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.length -text "length" -variable env(read_mapping.length) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.polya -text "poly-a" -variable env(read_mapping.polya) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.read -text "read" -variable env(read_mapping.read) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.readEnd -text "read end" -variable env(read_mapping.rend) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.readStart -text "read start" -variable env(read_mapping.rstart) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.run -text "run" -variable env(read_mapping.run) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.singleton -text "singleton" -variable env(read_mapping.singleton) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.strand -text "strand" -variable env(read_mapping.strand) -offvalue "-" -onvalue "+"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "mapping_changeConfig; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.showColumn.contigEnd $t.showColumn.contigStart $t.showColumn.length $t.showColumn.polya $t.showColumn.read \
            $t.showColumn.readEnd $t.showColumn.readStart $t.showColumn.run $t.showColumn.singleton $t.showColumn.strand -side top -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.showColumn $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc mapping_changeConfig {mode} {
    global env
    
    set out "[pwd]/conf/mapping_tace.conf"
    
    if {[catch {set ft [open $out w]} ]} {
    } else {
        puts $ft "Mapping"
        puts $ft "$env(read_mapping.run) \
                $env(read_mapping.read) \
                $env(read_mapping.length) \
                $env(read_mapping.strand) \
                $env(read_mapping.cstart) \
                $env(read_mapping.cend) \
                $env(read_mapping.rstart) \
                $env(read_mapping.rend) \
                $env(read_mapping.polya) \
                $env(read_mapping.singleton)"
        close $ft
    }
}

proc rightmenu_rm {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    if {$mode eq "rm"} {
        #Read_mapping
        .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.cend) contig end" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.cend 5"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.cstart) contig start" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.cstart 4"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.length) length" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.length 2"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.polya) polyA" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.polya 8"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.read) read" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.read 1"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.rend) read end" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.rend 7"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.rstart) read start" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.rstart 6"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.run) run" -command "table_col_sh  .result.notebook2.nb.frm.1.tab.table.l read_mapping.run 0"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.singleton) singleton" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.singleton 9"
        .rightmenu.hidemenuColumn add command -label "$env(read_mapping.strand) strand" -command "table_col_sh .result.notebook2.nb.frm.1.tab.table.l read_mapping.strand 3"
        .rightmenu add separator
        .rightmenu add command -label "Export reads" -command "readMapping_export_reads $feat $id 0"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.frm.1.tab.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.frm.1.tab.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.frm.1.tab.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.frm.1.tab.table.l}"
    } elseif {$mode eq "rm_dist"} {
        #Read_mapping dist
        .rightmenu add command -label "Export reads" -command "readMapping_export_reads $feat $id 0"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.frm.1.dist.table}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.frm.1.dist.table}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.frm.1.dist.table}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.frm.1.dist.table}"
    } elseif {$mode eq "readMapping"} {
        #Read_mapping
        global env
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $feat.sequences_nucleotide WHERE name = '$id'"}}]]
        foreach sRes $sql_res {
            set id [lindex $sRes 0]
        }
        unset sql_res
        if {[lsearch $env(loaded_modules) "sequence_edit_tace"] ne -1} {
            .rightmenu add command -label "Edit sequence" -command "catch {sequence_edit_window $feat $id}"
        }
        .rightmenu add command -label "New sequence" -command "catch {database_nucleotide_new_window $feat $id}"
    }
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}