proc read_distribution_init {} {
    global closeImg
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "Read distribution" -command "catch {create_tab rd}"
    
    # Read distribution
    set notebook .result.notebook2.nb  
    set frame [$notebook insert end rd -text "Read distribution" -raisecmd "catch {update_info_rd}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab rd"
    frame $frame.1
    frame $frame.1.tab
    frame $frame.1.tab.table
    scrollbar $frame.1.tab.y -orient vertical -command "$frame.1.tab.table.l yview"
    set nb2_tl_rd $frame.1.tab.table.l
    tablelist::tablelist $nb2_tl_rd \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue \
            -columns {0 "selected" 0 "Run" 0 "c/s" 0 "reads" 0 "description" 0 "treatment"} \
            -exportselection 0 \
            -stretch {4 5} \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.tab.y set" \
            -background white
    pack $frame.0.label1 -side left -fill both -anchor w
    pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.1.tab.table.l -fill both -side top -expand true
    pack $frame.1.tab.table -fill both -side left -expand true; pack $frame.1.tab.y -fill both -side left
    pack $frame.1.tab -fill both -side top -expand true
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    #Read_distribution
    set tl .result.notebook2.nb.frd.1.tab.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 1\]
    rightmenu_rd rd rd \$id \$coord
    "
}

proc read_distribution_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "Read distribution"
    .result.notebook2.nb delete rd
}

proc update_info_rd {} {
    global env
    global uncheckedImg
    global linkGreenImg
    global linkRedImg
    .result.notebook1.nb.fdb_info.1.table.l finishediting
    .result.notebook2.nb.frd.0.label1 configure -text $env(contig.name)
    
    set run_info ""
    set resL ""
    set stop 1
    set i 0
    while {$stop} {
        if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
            set stop 0
        } else {
            lappend run_info "[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3] [[.result.notebook1.nb.fdb_info.1.table.l windowpath $i,2] get] {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 4]} {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 5]} [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 7]"
        }
        incr i
    }
    foreach run $run_info {
        append sql ", runid_[string tolower [lindex $run 1]] AS runid_[string tolower [lindex $run 1]]"
    }
    append sql " FROM $env(dbName).read_distribution WHERE $env(dbName).read_distribution.id_seq = '$env(contig.id_seq)'"
    
    set sql "SELECT [string range $sql 2 end]"
    
    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "$sql"}}]]
    foreach sRes $sql_res {
        for {set i 0} {$i < [llength $run_info]} {incr i} {
            lappend resL "[lrange [lindex $run_info $i] 0 2] [lindex $sRes $i] [lrange [lindex $run_info $i] 3 end]"
        }
    }
    unset sql_res
    
    .result.notebook2.nb.frd.1.tab.table.l delete 0 end
    set resL [lsort -index 2 $resL]
    set resL [lsort -decreasing -index 0 $resL]
    foreach res $resL {
        .result.notebook2.nb.frd.1.tab.table.l insert end $res
        if {[lindex $res 0] eq 0} {
            .result.notebook2.nb.frd.1.tab.table.l cellconfigure end,0 -image $uncheckedImg -text ""
        } elseif {[lindex $res 0] eq 1} {
            if {[lindex $res 2] eq "B"} {
                .result.notebook2.nb.frd.1.tab.table.l cellconfigure end,0 -image $linkRedImg -text ""
            } else {
                .result.notebook2.nb.frd.1.tab.table.l cellconfigure end,0 -image $linkGreenImg -text ""
            }
            
        }
    }
    unset resL; unset sql; unset run_info
}

proc rightmenu_rd {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.frd.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.frd.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.frd.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.frd.1.tab.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}