proc run_compare_init {} {
    #Creating menu buttons
    .menubar.module.menu add command -label "Run compare" -command "runCompare"
}

proc run_compare_remove {} {
    #Remove menu buttons
    .menubar.module.menu delete -label "Run compare"
}

proc runCompare {} {
    global env
    global checkedImg
    global uncheckedImg
    
    global runCompareArr
    
    set stop 1
    set i 0
    set runL ""
    while {$stop} {
        if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
            set stop 0
        } else {
            lappend runL "0 [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3] {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 4]} {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 6]} {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 5]}"
        }
        incr i
    }
    set prjL ""
    foreach page [.result.notebook1.nb pages] {
        if {[lindex [split $page _] 0] eq "prj"} {
            set i 0
            set id_seqL ""
            while {[lindex [.result.notebook1.nb.f$page.1.table.l get $i] 0] ne ""} {
                if {[lindex [.result.notebook1.nb.f$page.1.table.l get $i] 24] eq $env(dbName)} {
                    lappend id_seqL [lindex [.result.notebook1.nb.f$page.1.table.l get $i] 23]
                }
                incr i
            }
            lappend prjL "0 $page [.result.notebook1.nb itemcget $page -text] N/A N/A {$id_seqL}"
        }
    }
    
    if {$env(dbName) ne " " && $runL ne ""} {
        set ::threadRunCompare [thread::create {
            package require BWidget
            package require tablelist
            proc runCompare_gui {db mtID phpID hf rl pl} {
                global runCompareArr
                global checkedImg
                global uncheckedImg
                global linkImg
                global linkRedImg
                global linkGreenImg
                global mainThreadID
                global phpThreadID
                global dbName
                global homeFolder
                global runL
                global prjL
                global max_pValue
                
                set dbName $db
                set homeFolder $hf
                set runL $rl
                set prjL $pl
                set mainThreadID $mtID
                set phpThreadID $phpID
                set max_pValue 0.05
                
                set checkedImg [image create photo -file "[pwd]/images/checked.gif"]
                set uncheckedImg [image create photo -file "[pwd]/images/unchecked.gif"]
                set linkRedImg [image create photo -file "[pwd]/images/link_red.ppm"]
                set linkGreenImg [image create photo -file "[pwd]/images/link_green.ppm"]
                set linkImg [image create photo -file "[pwd]/images/link.ppm"]
                
                set runCompareArr(ready) 0
                set runCompareArr(ready.go) 0
                set runCompareArr(ready.kegg) 0
                set runCompareArr(ready.domain.blastprodom) 0
                set runCompareArr(ready.domain.gene3d) 0
                set runCompareArr(ready.domain.interpro) 0
                set runCompareArr(ready.domain.panther) 0
                set runCompareArr(ready.domain.patternscan) 0
                set runCompareArr(ready.domain.pfam) 0
                set runCompareArr(ready.domain.pir) 0
                set runCompareArr(ready.domain.profilescan) 0
                set runCompareArr(ready.domain.smart) 0
                set runCompareArr(ready.domain.superfamily) 0
                set runCompareArr(ready.domain.tigr) 0
                set runCompareArr(cohortL) ""
                set runCompareArr(runs.references) ""
                set runCompareArr(prj.references) ""
                set runCompareArr(hideCol.domain.id) "+"
                set runCompareArr(hideCol.domain.name) "+"
                set runCompareArr(hideCol.domain.total) "+"
                set runCompareArr(hideCol.domain.found) "+"
                set runCompareArr(hideCol.domain.expected) "+"
                set runCompareArr(hideCol.domain.regulated) "+"
                set runCompareArr(hideCol.domain.pValLeft) "-"
                set runCompareArr(hideCol.domain.pValRight) "-"
                set runCompareArr(hideCol.domain.pValTwoTail) "+"
                set runCompareArr(hideCol.go.id) "+"
                set runCompareArr(hideCol.go.name) "+"
                set runCompareArr(hideCol.go.total) "+"
                set runCompareArr(hideCol.go.found) "+"
                set runCompareArr(hideCol.go.expected) "+"
                set runCompareArr(hideCol.go.regulated) "+"
                set runCompareArr(hideCol.go.pValLeft) "-"
                set runCompareArr(hideCol.go.pValRight) "-"
                set runCompareArr(hideCol.go.pValTwoTail) "+"
                set runCompareArr(hideCol.kegg.id) "+"
                set runCompareArr(hideCol.kegg.name) "+"
                set runCompareArr(hideCol.kegg.total) "+"
                set runCompareArr(hideCol.kegg.found) "+"
                set runCompareArr(hideCol.kegg.expected) "+"
                set runCompareArr(hideCol.kegg.regulated) "+"
                set runCompareArr(hideCol.kegg.pValLeft) "-"
                set runCompareArr(hideCol.kegg.pValRight) "-"
                set runCompareArr(hideCol.kegg.pValTwoTail) "+"
                
                wm title . "Run compare - $dbName"
                wm minsize . 800 450
                
                frame .runCompare
                set t .runCompare
                frame $t.menubar -relief raised -bd 2
                pack $t.menubar -fill x
                pack $t -side top -fill both -expand true
                ###FILE
                menubutton $t.menubar.file -text File -underline 0 -menu $t.menubar.file.menu; pack $t.menubar.file -side left
                menu $t.menubar.file.menu
                $t.menubar.file.menu add command -label Save -command "runCompare_save"
                $t.menubar.file.menu add command -label Load -command "runCompare_load"
                $t.menubar.file.menu add separator
                $t.menubar.file.menu add command -label Quit -command "destroy $t"
                ###EDIT
                menubutton $t.menubar.edit -text "Edit" -underline 0 -menu $t.menubar.edit.menu; pack $t.menubar.edit -side left
                menu $t.menubar.edit.menu
                
                ###Notebook
                frame $t.notebook1 -bd 2 -relief groove
                set notebook [NoteBook $t.notebook1.nb]
                
                ###Cohort manager
                set frame [$notebook insert end cohort -text "Cohort manager"]
                
                frame $frame.table
                scrollbar $frame.table.y -orient vertical -command "$frame.table.l yview"
                scrollbar $frame.x -orient horizontal -command "$frame.table.l xview"
                tablelist::tablelist $frame.table.l \
                        -width 100 -height 5 -showseparators 1 -stripebackground lightblue \
                        -columns {0 "" 0 "cohort" 0 "runs" 0 "id_cohort"} \
                        -labelcommand "$frame.table.l finishediting; tablelist::sortByColumn" \
                        -exportselection 0 \
                        -stretch {1 2} \
                        -selectmode single \
                        -editendcommand "editEndCmd" \
                        -yscrollcommand "$frame.table.y set" \
                        -xscrollcommand "$frame.x set" \
                        -background white
                $frame.table.l columnconfigure 0 \
                        -editable yes \
                        -editwindow checkbutton \
                        -formatcommand ::emptystr \
                        -labelimage [expr {0 ? $checkedImg : $uncheckedImg}] \
                        -labelcommand "table_selection"
                $frame.table.l columnconfigure 1 -sortmode dictionary -align left -editable yes
                $frame.table.l columnconfigure 2 -sortmode dictionary -align left -editable yes
                $frame.table.l columnconfigure 3 -hide yes
                
                frame $frame.buts
                button $frame.buts.add -text "New" -command "runCompare_addCohort_window"
                button $frame.buts.remove -text "Remove" -command "runCompare_removeCohort"
                button $frame.buts.save -text "Save" -command "runCompare_updateCohort save"
                button $frame.buts.update -text "Update" -command "runCompare_updateCohortStat"
                
                pack $frame.table.y -side left -expand false -fill both; pack $frame.table.l -side left -fill both -expand true
                pack $frame.buts.add $frame.buts.remove $frame.buts.save -side left -anchor w; pack $frame.buts.update -side right -anchor e
                pack $frame.table -side top -fill both -expand true; pack $frame.x $frame.buts -side top -expand false -fill both
                
                ###Cohort statistics
                set frame [$notebook insert end stat -text "Cohort statistics"]
                frame $frame.1
                frame $frame.1.results
                text $frame.1.results.panel -height 10 -background white
                
                pack $frame.1.results.panel -side top -fill both
                pack $frame.1.results -side left -fill both
                pack $frame.1 -side top -fill both
                
                ###GO statistics
                set frame [$notebook insert end go -text "GO"]
                
                frame $frame.mode
                button $frame.mode.compare -text "Compare" -command "runCompare_go"
                label $frame.mode.l -text "   Choose mode:"
                ComboBox $frame.mode.cb -width 15 -hottrack 1 -background white -text "all" -values {all {browse tree} level list} -modifycmd "runCompare_modify go"
                
                frame $frame.mode.pval
                label $frame.mode.pval.l -text "Max. pValue:"
                entry $frame.mode.pval.ent -width 7 -background white -textvariable max_pValue
                button $frame.mode.pval.but -text "Set" -command "runCompare_modify go"
                
                pack $frame.mode.pval.l $frame.mode.pval.ent $frame.mode.pval.but -side left -fill both
                
                frame $frame.0
                frame $frame.0.tab
                frame $frame.0.tab.table
                scrollbar $frame.0.tab.table.y -orient vertical -command "$frame.0.tab.table.l yview"
                scrollbar $frame.0.tab.x -orient horizontal -command "$frame.0.tab.table.l xview"
                tablelist::tablelist $frame.0.tab.table.l \
                        -width 100 -height 5 -showseparators 1 -stripebackground lightblue \
                        -columns {0 "" 0 "GO" 0 "name" 0 "total"} \
                        -labelcommand "$frame.0.tab.table.l finishediting; tablelist::sortByColumn" \
                        -exportselection 0 \
                        -selectmode single \
                        -editendcommand "editEndCmd" \
                        -yscrollcommand "$frame.0.tab.table.y set" \
                        -xscrollcommand "$frame.0.tab.x set" \
                        -background white
                
                frame $frame.0.mode
                #mode: browse tree
                frame $frame.0.mode.browse
                frame $frame.0.mode.browse.tree
                set tree [Tree $frame.0.mode.browse.tree.t -height 1 -width 40 -background white -selectbackground LightSkyBlue -opencmd "runCompare_go_tree_open .runCompare.notebook1.nb.fgo.0.mode.browse.tree.t" -closecmd "runCompare_go_tree_close .runCompare.notebook1.nb.fgo.0.mode.browse.tree.t" -yscrollcommand "$frame.0.mode.browse.y set" -xscrollcommand "$frame.0.mode.browse.tree.x set"]
                scrollbar $frame.0.mode.browse.tree.x -orient horizontal -command "$frame.0.mode.browse.tree.t xview"
                scrollbar $frame.0.mode.browse.y -orient vertical -command "$frame.0.mode.browse.tree.t yview"
                
                pack $frame.0.mode.browse.tree.t -fill both -side top -expand true; pack $frame.0.mode.browse.tree.x -fill both -side bottom
                pack $frame.0.mode.browse.y -fill both -side left; pack $frame.0.mode.browse.tree -fill both -side left -expand true
                
                runCompare_go_tree_create $frame.0.mode.browse.tree.t
                
                $tree bindText <Button-1> runCompare_go_browse
                $tree bindImage <Button-1> runCompare_go_browse
                $tree bindText <Button-3> runCompare_go_tree_show
                
                #mode: level
                set bp_max 0
                set cc_max 0
                set mf_max 0
                set bp 0
                set cc 0
                set mf 0
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT level_biological_process AS bp, level_cellular_component AS cc, level_molecular_function AS mf FROM refdb.gotree;"}}]]
                if {[lindex [lindex $sql_res end] end] ne "Fehler"} {
                    foreach sRes $sql_res {
                        set bp [split [lindex $sRes 0] |]
                        if {[llength $bp] ne 0 && $bp ne "0"} {
                            foreach level $bp {
                                if {$level > $bp_max} {
                                    set bp_max $level
                                }
                            }
                        }
                        set cc [split [lindex $sRes 1] |]
                        if {[llength $cc] ne 0 && $cc ne "0"} {
                            foreach level $cc {
                                if {$level > $cc_max} {
                                    set cc_max $level
                                }
                            }
                        }
                        set mf [split [lindex $sRes 2] |]
                        if {[llength $mf] ne 0 && $mf ne "0"} {
                            foreach level $mf {
                                if {$level > $mf_max} {
                                    set mf_max $level
                                }
                            }
                        }
                    }
                } else {
                    eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "[lrange [lindex $sql_res end] 2 end]"}}]
                }
                unset sql_res
                unset bp; unset mf; unset cc
                set values ""
                for {set i 1} {$i <= $bp_max} {incr i} {
                    lappend values $i
                }
                frame $frame.0.mode.level
                label $frame.0.mode.level.l1 -text "\nChoose type:"
                ComboBox $frame.0.mode.level.cbtype -width 15 -hottrack 1 -background white -text "Biological process" -values {{Biological process} {Cellular component} {Molecular function}} -modifycmd "runCompare_go_level_setLevels $bp_max $cc_max $mf_max"
                label $frame.0.mode.level.l2 -text "\nChoose level:"
                ComboBox $frame.0.mode.level.cblevel -width 15 -hottrack 1 -background white -text "1" -values "$values" -modifycmd runCompare_go_level
                unset values
                
                pack $frame.0.mode.level.l1 $frame.0.mode.level.cbtype $frame.0.mode.level.l2 $frame.0.mode.level.cblevel -fill both -side top -anchor w
                
                #mode: list
                frame $frame.0.mode.list
                button $frame.0.mode.list.load -text "Load File" -command "runCompare_list_load go"
                label $frame.0.mode.list.l2 -text "\n"
                text $frame.0.mode.list.panel -height 10 -width 15 -background white
                button $frame.0.mode.list.run -text "Run" -command "runCompare_go_list"
                
                pack $frame.0.mode.list.load $frame.0.mode.list.l2 $frame.0.mode.list.panel $frame.0.mode.list.run -side top -anchor w
                
                pack $frame.mode.compare $frame.mode.l $frame.mode.cb -side left -expand false -fill both -anchor w; pack $frame.mode.pval -side right -expand false -anchor e;
                pack $frame.0.tab.table.y -side left -expand false -fill both; pack $frame.0.tab.table.l -side left -fill both -expand true
                pack $frame.0.tab.table -side top -fill both -expand true; pack $frame.0.tab.x -side top -fill both
                pack $frame.0.mode -side left -fill both; pack $frame.0.tab -side right -fill both -expand true
                pack $frame.mode -side top -fill both; pack $frame.0 -side top -fill both -expand true
                
                ###KEGG
                set frame [$notebook insert end kegg -text "KEGG"]
                
                frame $frame.mode
                button $frame.mode.compare -text "Compare" -command "runCompare_kegg"
                label $frame.mode.l -text "   Choose mode:"
                ComboBox $frame.mode.cb -width 15 -hottrack 1 -background white -text "KO all" -values {{KO all} {KO by pathway} {KO list} pathways} -modifycmd "runCompare_modify kegg"
                
                frame $frame.mode.pval
                label $frame.mode.pval.l -text "Max. pValue:"
                entry $frame.mode.pval.ent -width 7 -background white -textvariable max_pValue
                button $frame.mode.pval.but -text "Set" -command "runCompare_modify kegg"
                
                pack $frame.mode.pval.l $frame.mode.pval.ent $frame.mode.pval.but -side left -fill both
                
                frame $frame.0
                frame $frame.0.tab
                frame $frame.0.tab.table
                scrollbar $frame.0.tab.table.y -orient vertical -command "$frame.0.tab.table.l yview"
                scrollbar $frame.0.tab.x -orient horizontal -command "$frame.0.tab.table.l xview"
                tablelist::tablelist $frame.0.tab.table.l \
                        -width 100 -height 5 -showseparators 1 -stripebackground lightblue \
                        -columns {0 "" 0 "KO" 0 "name" 0 "total"} \
                        -labelcommand "$frame.0.tab.table.l finishediting; tablelist::sortByColumn" \
                        -exportselection 0 \
                        -selectmode single \
                        -editendcommand "editEndCmd" \
                        -yscrollcommand "$frame.0.tab.table.y set" \
                        -xscrollcommand "$frame.0.tab.x set" \
                        -background white
                
                frame $frame.0.mode
                #mode: pathway
                set valueL ""
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name FROM refdb.kegg_maps ORDER BY name;"}}]]
                foreach sRes $sql_res {
                    lappend valueL [lindex $sRes 0]
                    
                }
                unset sql_res
                frame $frame.0.mode.path
                label $frame.0.mode.path.l1 -text "\nSelect pathway:"
                ComboBox $frame.0.mode.path.cb -width 15 -hottrack 1 -listboxwidth 400 -background white -text [lindex $valueL 0] -values $valueL -modifycmd "runCompare_kegg_pathway"
                unset valueL
                
                pack $frame.0.mode.path.l1 $frame.0.mode.path.cb -side top -anchor w
                
                #mode: list
                frame $frame.0.mode.list
                button $frame.0.mode.list.load -text "Load File" -command "runCompare_list_load kegg"
                label $frame.0.mode.list.l2 -text "\n"
                text $frame.0.mode.list.panel -height 10 -width 15 -background white
                button $frame.0.mode.list.run -text "Run" -command "runCompare_kegg_list"
                
                pack $frame.0.mode.list.load $frame.0.mode.list.l2 $frame.0.mode.list.panel $frame.0.mode.list.run -side top -anchor w
                
                pack $frame.mode.compare $frame.mode.l $frame.mode.cb -side left -expand false -fill both -anchor w; pack $frame.mode.pval -side right -expand false -anchor e;
                pack $frame.0.tab.table.y -side left -expand false -fill both; pack $frame.0.tab.table.l -side left -fill both -expand true
                pack $frame.0.tab.table -side top -fill both -expand true; pack $frame.0.tab.x -side top -fill both
                pack $frame.0.mode -side left -fill both; pack $frame.0.tab -side right -fill both -expand true
                pack $frame.mode -side top -fill both; pack $frame.0 -side top -fill both -expand true
                
                ###Domains
                set frame [$notebook insert end domain -text "Domains"]
                
                frame $frame.mode
                button $frame.mode.compare -text "Compare" -command "runCompare_domain"
                label $frame.mode.l -text "   Choose mode:"
                ComboBox $frame.mode.cb -width 15 -hottrack 1 -background white -text "all" -values {all list} -modifycmd "runCompare_modify domain"
                label $frame.mode.l2 -text "       Choose type:"
                ComboBox $frame.mode.domainCB -width 15 -hottrack 1 -background white -text "interpro" -values {blastprodom gene3d interpro panther patternscan pfam pir profilescan smart superfamily tigr}
                
                frame $frame.mode.pval
                label $frame.mode.pval.l -text "Max. pValue:"
                entry $frame.mode.pval.ent -width 7 -background white -textvariable max_pValue
                button $frame.mode.pval.but -text "Set" -command "runCompare_modify domain"
                
                pack $frame.mode.pval.l $frame.mode.pval.ent $frame.mode.pval.but -side left -fill both
                
                frame $frame.0
                frame $frame.0.tab
                frame $frame.0.tab.table
                scrollbar $frame.0.tab.table.y -orient vertical -command "$frame.0.tab.table.l yview"
                scrollbar $frame.0.tab.x -orient horizontal -command "$frame.0.tab.table.l xview"
                tablelist::tablelist $frame.0.tab.table.l \
                        -width 100 -height 5 -showseparators 1 -stripebackground lightblue \
                        -columns {0 "" 0 "ID" 0 "name" 0 "total"} \
                        -labelcommand "$frame.0.tab.table.l finishediting; tablelist::sortByColumn" \
                        -exportselection 0 \
                        -selectmode single \
                        -editendcommand "editEndCmd" \
                        -yscrollcommand "$frame.0.tab.table.y set" \
                        -xscrollcommand "$frame.0.tab.x set" \
                        -background white
                
                frame $frame.0.mode
                #mode: list
                frame $frame.0.mode.list
                button $frame.0.mode.list.load -text "Load File" -command "runCompare_list_load domain"
                label $frame.0.mode.list.l2 -text "\n"
                text $frame.0.mode.list.panel -height 10 -width 15 -background white
                button $frame.0.mode.list.run -text "Run" -command "runCompare_domain_list"
                
                pack $frame.0.mode.list.load $frame.0.mode.list.l2 $frame.0.mode.list.panel $frame.0.mode.list.run -side top -anchor w
                
                pack $frame.mode.compare $frame.mode.l $frame.mode.cb $frame.mode.l2 $frame.mode.domainCB -side left -expand false -fill both -anchor w; pack $frame.mode.pval -side right -expand false -anchor e;
                pack $frame.0.tab.table.y -side left -expand false -fill both; pack $frame.0.tab.table.l -side left -fill both -expand true
                pack $frame.0.tab.table -side top -fill both -expand true; pack $frame.0.tab.x -side top -fill both
                pack $frame.0.mode.list -side top -fill both
                pack $frame.0.tab -side right -fill both -expand true
                pack $frame.mode -side top -fill both; pack $frame.0 -side top -fill both -expand true
                
                #pack Notebook
                $notebook raise [$notebook page 0]
                pack $t.notebook1.nb -side top -fill both -expand true
                pack $t.notebook1 -side top -fill both -expand true
                               
                # Popup-Menu
                menu .rightmenu -tearoff false
                menu .rightmenu.hidemenuColumn
                menu .rightmenu.copymenu
                
                #compare_run_GO
                set tl .runCompare.notebook1.nb.fgo.0.tab.table.l
                bind [$tl bodypath] <Button-3> "
                set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
                catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
                set id \[lindex \[$tl get \$y\] 1\]
                rightmenu go tab \$id \$coord
                "
                #compare_run_KEGG
                set tl .runCompare.notebook1.nb.fkegg.0.tab.table.l
                bind [$tl bodypath] <Button-3> "
                set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
                catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
                set id \[lindex \[$tl get \$y\] 1\]
                rightmenu kegg tab \$id \$coord
                "
                
                #compare_run_Domain
                set tl .runCompare.notebook1.nb.fdomain.0.tab.table.l
                bind [$tl bodypath] <Button-3> "
                set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
                catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
                set id \[lindex \[$tl get \$y\] 1\]
                rightmenu domain tab \$id \$coord
                "
            }
            
            proc runCompare_modify {mode} {
                global max_pValue
                set max_pValue [regsub -all {[,]} $max_pValue "."]
                if {$mode eq "go"} {
                    set type [.runCompare.notebook1.nb.fgo.mode.cb get]
                    if {$type eq "all"} {
                        pack forget .runCompare.notebook1.nb.fgo.0.mode.browse; pack forget .runCompare.notebook1.nb.fgo.0.mode.level; pack forget .runCompare.notebook1.nb.fgo.0.mode.list; pack forget .runCompare.notebook1.nb.fgo.0.mode
                        runCompare_go_show all
                    } elseif {$type eq "browse tree"} {
                        pack forget .runCompare.notebook1.nb.fgo.0.mode.level; pack forget .runCompare.notebook1.nb.fgo.0.mode.list; pack .runCompare.notebook1.nb.fgo.0.mode.browse -side top -fill both -expand true; pack .runCompare.notebook1.nb.fgo.0.mode -side left -fill both
                        runCompare_go_show "browse tree"
                        runCompare_go_tree_raise .runCompare.notebook1.nb.fgo.0.mode.browse.tree.t
                    } elseif {$type eq "level"} {
                        pack forget .runCompare.notebook1.nb.fgo.0.mode.browse; pack forget .runCompare.notebook1.nb.fgo.0.mode.list; pack .runCompare.notebook1.nb.fgo.0.mode.level -side top -fill both; pack .runCompare.notebook1.nb.fgo.0.mode -side left -fill both
                        .runCompare.notebook1.nb.fgo.0.tab.table.l delete 0 end
                        runCompare_go_level
                        runCompare_go_show "level"
                    } elseif {$type eq "list"} {
                        pack forget .runCompare.notebook1.nb.fgo.0.mode.level; pack forget .runCompare.notebook1.nb.fgo.0.mode.browse; pack .runCompare.notebook1.nb.fgo.0.mode.list -side top -fill both; pack .runCompare.notebook1.nb.fgo.0.mode -side left -fill both
                        .runCompare.notebook1.nb.fgo.0.tab.table.l delete 0 end
                    }
                } elseif {$mode eq "kegg"} {
                    set type [.runCompare.notebook1.nb.fkegg.mode.cb get]
                    if {$type eq "KO all"} {
                        pack forget .runCompare.notebook1.nb.fkegg.0.mode.path; pack forget .runCompare.notebook1.nb.fkegg.0.mode.list; pack forget .runCompare.notebook1.nb.fkegg.0.mode
                        runCompare_kegg_show "KO all"
                    } elseif {$type eq "KO by pathway"} {
                        pack forget .runCompare.notebook1.nb.fkegg.0.mode.list; pack .runCompare.notebook1.nb.fkegg.0.mode.path -side top -fill both; pack .runCompare.notebook1.nb.fkegg.0.mode -side left -fill both
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l delete 0 end
                    } elseif {$type eq "KO list"} {
                        pack forget .runCompare.notebook1.nb.fkegg.0.mode.path; pack .runCompare.notebook1.nb.fkegg.0.mode.list -side top -fill both; pack .runCompare.notebook1.nb.fkegg.0.mode -side left -fill both
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l delete 0 end
                    } elseif {$type eq "pathways"} {
                        pack forget .runCompare.notebook1.nb.fkegg.0.mode.path; pack forget .runCompare.notebook1.nb.fkegg.0.mode.list; pack forget .runCompare.notebook1.nb.fkegg.0.mode
                        runCompare_kegg_show "pathways"
                    }
                } elseif {$mode eq "domain"} {
                    set type [.runCompare.notebook1.nb.fdomain.mode.cb get]
                    if {$type eq "all"} {
                        pack forget .runCompare.notebook1.nb.fdomain.0.mode
                        runCompare_domain_show all
                    } elseif {$type eq "list"} {
                        pack .runCompare.notebook1.nb.fdomain.0.mode -side left -fill both
                        .runCompare.notebook1.nb.fdomain.0.tab.table.l delete 0 end
                    }
                }
            }
            
            proc runCompare_list_load {mode} {
                global homefolder
                set f [tk_getOpenFile -filetypes {{{Text file} {.txt} } {{All Files} * }} -initialdir $homeFolder]
                if {$f != ""} {
                    if {$mode eq "go"} {
                        .runCompare.notebook1.nb.fgo.0.mode.list.panel delete 1.0 end
                        set fs [open $f r]
                        while {[gets $fs line] != -1} {
                            if {[string range $line 0 2] eq "GO:"} {
                                .runCompare.notebook1.nb.fgo.0.mode.list.panel insert end "$line\n"
                            }
                        }
                    } elseif {$mode eq "kegg"} {
                        .runCompare.notebook1.nb.fkegg.0.mode.list.panel delete 1.0 end
                        set fs [open $f r]
                        while {[gets $fs line] != -1} {
                            if {[string index $line 0] eq "K"} {
                                .runCompare.notebook1.nb.fkegg.0.mode.list.panel insert end "$line\n"
                            }
                        }
                    } elseif {$mode eq "domain"} {
                        .runCompare.notebook1.nb.fdomain.0.mode.list.panel delete 1.0 end
                        set fs [open $f r]
                        while {[gets $fs line] != -1} {
                            .runCompare.notebook1.nb.fdomain.0.mode.list.panel insert end "$line\n"
                        }
                    }
                    close $fs
                }
            }
            
            proc runCompare_load {} {
                global env
                global runCompareArr
                global checkedImg
                global uncheckedImg
                
                set ifile [tk_getOpenFile -filetypes {{{Run Compare} {.rc} } {{All Files} * }} -initialdir $env(homeFolder)]
                
                if {[catch {set ft [open $ifile r]} ]} {
                    #Cannot find File
                } else {
                    while {[gets $ft line] != -1} {
                        set runCompareArr([lindex $line 0]) [lrange $line 1 end]
                    }
                    close $ft
                }
                .runCompare.notebook1.nb.fcohort.table.l delete 0 end
                foreach cohort $runCompareArr(cohortL) {
                    .runCompare.notebook1.nb.fcohort.table.l insert end "0 {$runCompareArr(name.cohort.$cohort)} {$runCompareArr(runs.cohort.$cohort) $runCompareArr(prj.cohort.$cohort)} $cohort"
                    .runCompare.notebook1.nb.fcohort.table.l cellconfigure end,0 -image [expr {0 ? $checkedImg : $uncheckedImg}]
                }
                .runCompare.notebook1.nb.fstat.1.results.panel delete 1.0 end
                foreach cohort $runCompareArr(cohortL) {
                    .runCompare.notebook1.nb.fstat.1.results.panel insert end "$runCompareArr(name.cohort.$cohort) runs: $runCompareArr(runs.cohort.$cohort)\n"
                }
                .runCompare.notebook1.nb.fstat.1.results.panel insert end "\n"
                .runCompare.notebook1.nb.fstat.1.results.panel insert end "Contigs total: [llength $runCompareArr(contigL.references)]\n"
                foreach cohort $runCompareArr(cohortL) {
                    .runCompare.notebook1.nb.fstat.1.results.panel insert end "Contigs $runCompareArr(name.cohort.$cohort): [llength $runCompareArr(contigL.cohort.$cohort)]\n"
                }
            }
            
            proc runCompare_save {} {
                global env
                global runCompareArr
                set ofile [tk_getSaveFile -filetypes {{{Run Compare} {.rc} } {{All Files} * }} -initialfile $env(dbName)_runCompare.rc -initialdir $env(homeFolder)]
                
                if {[catch {set ft [open $ofile w]} ]} {
                    #Cannot find File
                } else {
                    set elemL [array names runCompareArr]
                    set out ""
                    set count 0
                    foreach elem [array names runCompareArr] {
                        append out "$elem\t$runCompareArr($elem)\n"
                        incr count
                        if {$count >= 5000} {
                            puts -nonewline $ft $out
                            set out ""
                            set count 0
                        }
                    }
                    if {$out ne ""} {
                        puts -nonewline $ft $out
                    }
                    unset out
                    unset count
                    close $ft
                }
            }
            
            proc runCompare_updateCohort {mode} {
                global runCompareArr
                global checkedImg
                global uncheckedImg
                
                if {$mode eq "save"} {
                    set stop 1
                    set i 0
                    .runCompare.notebook1.nb.fcohort.table.l finishediting
                    set refLr ""
                    set refLp ""
                    while {$stop} {
                        if {[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 0] eq ""} {
                            set stop 0
                        } else {
                            set runCompareArr(runs.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3]) ""
                            set runCompareArr(prj.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3]) ""
                            foreach ref [lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 2] {
                                if {[lindex [split $ref _] 0] eq "prj"} {
                                    lappend refLp $ref
                                    lappend runCompareArr(prj.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3]) $ref
                                } else {
                                    lappend refLr $ref
                                    lappend runCompareArr(runs.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3]) $ref
                                }
                            }
                            set runCompareArr(name.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3]) [lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 1]
                        }
                        incr i
                    }
                    set runCompareArr(runs.references) [lsort -unique $refLr]
                    set runCompareArr(prj.references) [lsort -unique $refLp]
                    unset refLr; unset refLp
                } else {
                    .runCompare.notebook1.nb.fcohort.table.l delete 0 end
                    foreach cohort $runCompareArr(cohortL) {
                        .runCompare.notebook1.nb.fcohort.table.l insert end "0 {$runCompareArr(name.cohort.$cohort)} {$runCompareArr(runs.cohort.$cohort) $runCompareArr(prj.cohort.$cohort)} $cohort"
                        .runCompare.notebook1.nb.fcohort.table.l cellconfigure end,0 -image [expr {0 ? $checkedImg : $uncheckedImg}]
                    }
                }
            }
            
            proc runCompare_updateCohortStat {} {
                global phpThreadID
                global dbName
                global runCompareArr
                global mainThreadID
                global prjL
                
                #runs
                set condition ""; set runs ""
                set runCompareArr(runs.references) [lsort -unique $runCompareArr(runs.references)]
                foreach run $runCompareArr(runs.references) {
                    append condition " OR runid_[string tolower $run] > 0"
                    append runs ", runid_[string tolower $run]"
                }
                
                set condition [string range $condition 4 end]
                if {$runs ne ""} {
                    catch {
                        foreach contig $runCompareArr(contigL.references) {
                            unset runCompareArr($contig.references)
                        }
                    }
                    set runCompareArr(contigL.references) ""
                    foreach cohort $runCompareArr(cohortL) {
                        catch {
                            foreach contig $runCompareArr(contigL.cohort.$cohort) {
                                unset runCompareArr($contig.cohort.$cohort)
                            }
                        }
                        set runCompareArr(contigL.cohort.$cohort) ""
                    }
                    
                    if {$runs ne ""} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq $runs FROM $dbName.read_distribution WHERE $condition ORDER BY id_seq"}}]]
                        if {[lindex [lindex $sql_res 0] 0] eq "Fehler:"} {
                            eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "Please update the read distribution."}}]
                        } else {
                            foreach sRes $sql_res {
                                set cReads 0
                                set i 1
                                foreach run $runCompareArr(runs.references) {
                                    set data(runid_[string tolower $run]) [lindex $sRes $i]
                                    incr i
                                    set cReads [expr $cReads + $data(runid_[string tolower $run])]
                                    set runCompareArr([lindex $sRes 0].$run) $data(runid_[string tolower $run])
                                }
                                unset i
                                set runCompareArr([lindex $sRes 0].references) $cReads
                                lappend runCompareArr(contigL.references) [lindex $sRes 0]
                                foreach cohort $runCompareArr(cohortL) {
                                    set cReads 0
                                    foreach run $runCompareArr(runs.cohort.$cohort) {
                                        set cReads [expr $cReads + $data(runid_[string tolower $run])]
                                    }
                                    set runCompareArr([lindex $sRes 0].cohort.$cohort) $cReads
                                    if {$cReads ne 0} {
                                        lappend runCompareArr(contigL.cohort.$cohort) [lindex $sRes 0]
                                    }
                                }
                            }
                            foreach run $runCompareArr(runs.references) {
                                unset data(runid_[string tolower $run])
                            }
                            unset sql_res
                            
                            #projects
                            foreach cohort $runCompareArr(cohortL) {
                                foreach prj $runCompareArr(prj.cohort.$cohort) {
                                    set i [lsearch -index 1 $prjL $prj]
                                    if {$i ne ""} {
                                        append runCompareArr(contigL.cohort.$cohort) " [lindex [lindex $prjL $i] end]"
                                        foreach id_seq [lindex [lindex $prjL $i] end] {
                                            set runCompareArr($id_seq.cohort.$cohort) N/A
                                        }
                                    }
                                }
                            }
                        }
                        
                        .runCompare.notebook1.nb.fstat.1.results.panel delete 1.0 end
                        foreach cohort $runCompareArr(cohortL) {
                            .runCompare.notebook1.nb.fstat.1.results.panel insert end "$runCompareArr(name.cohort.$cohort) runs/projects: $runCompareArr(runs.cohort.$cohort) $runCompareArr(prj.cohort.$cohort)\n"
                        }
                        .runCompare.notebook1.nb.fstat.1.results.panel insert end "\n"
                        .runCompare.notebook1.nb.fstat.1.results.panel insert end "Contigs total: [llength $runCompareArr(contigL.references)]\n"
                        foreach cohort $runCompareArr(cohortL) {
                            .runCompare.notebook1.nb.fstat.1.results.panel insert end "Contigs $runCompareArr(name.cohort.$cohort): [llength $runCompareArr(contigL.cohort.$cohort)]\n"
                        }
                        set runCompareArr(ready) 1
                    }
                } else {
                    eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "No run or project selected."}}]
                }
            }
### addCohort            
            proc runCompare_addCohort_window {} {
                global checkedImg
                global uncheckedImg
                global runCompareArr
                global runL
                global prjL
                
                variable cohortNum
                set cohortNum "Cohort_[expr [lindex $runCompareArr(cohortL) end] + 1]"
                
                set t .runCompare_addCohort_window
                catch {destroy $t}
                toplevel $t
                wm title $t "Select runs for cohort"
                wm attributes $t -topmost 1
                
                frame $t.head
                label $t.head.l -text "Cohort name: "
                entry $t.head.ent -width 30 -background white -textvariable cohortNum
                frame $t.table
                scrollbar $t.table.y -orient vertical -command "$t.table.l yview"
                scrollbar $t.x -orient horizontal -command "$t.table.l xview"
                tablelist::tablelist $t.table.l \
                        -width 100 -height 15 -showseparators 1 -stripebackground lightblue \
                        -columns {0 "" 0 "id" 0 "description" 0 "sequences" 0 "treatment" 0 "type"} \
                        -labelcommand "$t.table.l finishediting; tablelist::sortByColumn" \
                        -exportselection 0 \
                        -stretch {2 3 4} \
                        -selectmode single \
                        -editendcommand "editEndCmd" \
                        -yscrollcommand "$t.table.y set" \
                        -xscrollcommand "$t.x set" \
                        -background white
                $t.table.l columnconfigure 0 \
                        -editable yes \
                        -editwindow checkbutton \
                        -formatcommand ::emptystr \
                        -labelimage [expr {0 ? $checkedImg : $uncheckedImg}] \
                        -labelcommand "table_selection"
                        
                $t.table.l columnconfigure 2 -sortmode dictionary -align left
                $t.table.l columnconfigure 4 -sortmode dictionary -align left -editable yes
                $t.table.l columnconfigure 3 -sortmode real -align right -editable yes
                $t.table.l columnconfigure 5 -hide yes
                
                frame $t.buts
                button $t.buts.set -text "Add" -command "runCompare_addCohort"
                
                pack $t.head.l $t.head.ent -side left -anchor w
                pack $t.table.y -side left -expand false -fill both; pack $t.table.l -side left -fill both -expand true
                pack $t.buts.set -side left -anchor w
                pack $t.head -side top -fill both; pack $t.table -side top -fill both -expand true; pack $t.x $t.buts -side top -expand false -fill both
                
                set stop 1
                set i 0
                foreach run $runL {
                    $t.table.l insert end "$run run"
                    $t.table.l cellconfigure end,0 -image [expr {0 ? $checkedImg : $uncheckedImg}]
                    #$t.table.l.body.fk$i,0.w configure -bg white
                    #incr i
                }
                foreach prj $prjL {
                    $t.table.l insert end "$prj prj"
                    $t.table.l cellconfigure end,0 -image [expr {0 ? $checkedImg : $uncheckedImg}]
                    #$t.table.l.body.fk$i,0.w configure -bg white
                    #incr i
                }
                
                wm geometry $t +[expr [winfo rootx .runCompare]+[winfo width .runCompare]/2]+[expr [winfo rooty .runCompare]+[winfo height .runCompare]/2]
                raise $t
            }
            
            proc runCompare_addCohort {} {
                global runCompareArr
                global mainThreadID
                
                set stop 1
                set i 0
                set cohortNum [expr [lindex $runCompareArr(cohortL) end] + 1]
                set runCompareArr(runs.cohort.$cohortNum) ""
                set runCompareArr(prj.cohort.$cohortNum) ""
                .runCompare_addCohort_window.table.l finishediting
                set count 0
                while {$stop} {
                    if {[lindex [.runCompare_addCohort_window.table.l get $i] 0] eq ""} {
                        set stop 0
                    } else {
                        if {[lindex [.runCompare_addCohort_window.table.l get $i] 0] eq 1} {
                            incr count
                            if {[lindex [.runCompare_addCohort_window.table.l get $i] 5] eq "run"} {
                                lappend runCompareArr(runs.references) [lindex [.runCompare_addCohort_window.table.l get $i] 1]
                                lappend runCompareArr(runs.cohort.$cohortNum) [lindex [.runCompare_addCohort_window.table.l get $i] 1]
                            } else {
                                lappend runCompareArr(prj.references) [lindex [.runCompare_addCohort_window.table.l get $i] 1]
                                lappend runCompareArr(prj.cohort.$cohortNum) [lindex [.runCompare_addCohort_window.table.l get $i] 1]
                            }
                        }
                    }
                    incr i
                }
                if {$count eq 0} {
                    eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "Please select a run."}}]
                    set runCompareArr(runs.references) [lsort -unique $runCompareArr(runs.references)]
                    set runCompareArr(prj.references) [lsort -unique $runCompareArr(prj.references)]
                    unset runCompareArr(runs.cohort.$cohortNum)
                    unset runCompareArr(prj.cohort.$cohortNum)
                } else {
                    lappend runCompareArr(cohortL) "$cohortNum"
                    set runCompareArr(name.cohort.$cohortNum) "[.runCompare_addCohort_window.head.ent get]"
                    destroy .runCompare_addCohort_window
                    runCompare_updateCohort 0
                }
                unset count
                set runCompareArr(ready) 0
            }
### removeCohort            
            proc runCompare_removeCohort_window {} {
                
                set t .runCompare_removeCohort_window
                catch {destroy $t}
                toplevel $t
                wm title $t "Remove selected cohorts"
                wm resizable $t 0 0
                wm attributes $t -topmost 1
                
                set txt "Remove selected cohorts.\n\nAre you sure?"
                set comm "runCompare_removeCohort; destroy $t"
                
                frame $t.ptitle
                label $t.ptitle.label -height 5 -text $txt
                
                frame $t.buts -bd 2 -relief groove
                button $t.buts.ok -text "OK" -command $comm
                button $t.buts.cancel -text "Cancel" -command "destroy $t"
                
                pack $t.ptitle.label -side left -fill both
                pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
                pack $t.ptitle $t.buts -side top -fill both
                
                wm geometry $t +[expr [winfo rootx .runCompare]+[winfo width .runCompare]/2]+[expr [winfo rooty .runCompare]+[winfo height .runCompare]/2]
                raise $t
            }
            
            proc runCompare_removeCohort {} {
                global runCompareArr
                
                set stop 1
                set i 0
                .runCompare.notebook1.nb.fcohort.table.l finishediting
                while {$stop} {
                    if {[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 0] eq ""} {
                        set stop 0
                    } else {
                        if {[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 0] eq 1} {
                            unset runCompareArr(name.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3])
                            unset runCompareArr(runs.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3])
                            unset runCompareArr(prj.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3])
                            catch {
                                foreach contig $runCompareArr(contigL.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3]) {
                                    unset runCompareArr($contig.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3])
                                }
                                unset runCompareArr(contigL.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3])
                            }
                            catch {
                                foreach go $runCompareArr(goL) {
                                    unset runCompareArr($go.cohort.[lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3])
                                }
                            }
                            set cohortL ""
                            set refLr ""
                            set refLp ""
                            foreach cohort $runCompareArr(cohortL) {
                                if {$cohort ne [lindex [.runCompare.notebook1.nb.fcohort.table.l get $i] 3]} {
                                    append refLr " $runCompareArr(runs.cohort.$cohort)"
                                    append refLp " $runCompareArr(prj.cohort.$cohort)"
                                    lappend cohortL "$cohort"
                                }
                            }
                            set runCompareArr(runs.references) [lsort -unique $refLr]
                            set runCompareArr(prj.references) [lsort -unique $refLp]
                            set runCompareArr(cohortL) $cohortL
                            unset cohortL; unset refLr; unset refLp
                        }
                    }
                    incr i
                }
                runCompare_updateCohort 0
                set runCompareArr(ready) 0
            }
### GO            
            proc runCompare_go {} {
                global phpThreadID
                global dbName
                global runCompareArr
                
                if {$runCompareArr(ready)} {
                    set runCompareArr(goL) ""
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id, name FROM refdb.go"}}]]
                    foreach sRes $sql_res {
                        lappend runCompareArr(goL) "[lindex $sRes 0]"
                        set runCompareArr([lindex $sRes 0].name) "[lindex $sRes 1]"
                        set runCompareArr([lindex $sRes 0].references) 0
                        foreach cohort $runCompareArr(cohortL) {
                            set runCompareArr([lindex $sRes 0].cohort.$cohort) 0
                        }
                    }
                    unset sql_res
                    foreach nuc $runCompareArr(contigL.references) {
                        set ancestorL ""
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT member_of FROM refdb.gotree WHERE id IN (SELECT DISTINCT id FROM $dbName.go_hits WHERE id_seq = '$nuc');"}}]]
                        foreach sRes $sql_res {
                            append ancestorL " [lindex $sRes 0]"
                        }
                        unset sql_res
                        set ancestorL [lsort -unique $ancestorL]
                        if {$ancestorL ne ""} {
                            lappend runCompareArr(contigGOL.references) $nuc
                            foreach cohort $runCompareArr(cohortL) {
                                if {$runCompareArr($nuc.cohort.$cohort) ne 0} {
                                    lappend runCompareArr(contigGOL.cohort.$cohort) $nuc
                                }
                            }
                        }
                        foreach ancestor $ancestorL {
                            incr runCompareArr($ancestor.references)
                            foreach cohort $runCompareArr(cohortL) {
                                if {$runCompareArr($nuc.cohort.$cohort) ne 0} {
                                    incr runCompareArr($ancestor.cohort.$cohort)
                                }
                            }
                        }
                    }
                    foreach go $runCompareArr(goL) {
                        foreach cohort $runCompareArr(cohortL) {
                            if {$runCompareArr($go.references) eq 0} {
                                lappend runCompareArr($go.cohort.$cohort) 0
                                lappend runCompareArr($go.cohort.$cohort) "1 1 1"
                            } else {
                                lappend runCompareArr($go.cohort.$cohort) [expr int($runCompareArr($go.references).0 * [llength $runCompareArr(contigGOL.cohort.$cohort)].0 / [llength $runCompareArr(contigGOL.references)].0)]
                                #pValue 1_number_of_contigs_in_cohort 2_number_of_contigs_with_go_hits_in_cohort 3_number_of_contigs_in_reference 4_number_of_contigs_with_go_hits_in_reference
                                lappend runCompareArr($go.cohort.$cohort) [pValue [llength $runCompareArr(contigGOL.cohort.$cohort)] [lindex $runCompareArr($go.cohort.$cohort) 0] [llength $runCompareArr(contigGOL.references)] $runCompareArr($go.references)]
                            }
                        }
                    }
                    set runCompareArr(ready.go) 1
                    runCompare_go_show [.runCompare.notebook1.nb.fgo.mode.cb get]
                }
            }
            
            proc runCompare_go_tree_create {t} {
                global phpThreadID
                
                set parent_of ""
                catch {
                    $t insert end root categories -data "GO:0008150 GO:0005575 GO:0003674" -text categories -drawcross allways
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = 'GO:0008150'"}}]]
                    foreach sRes $sql_res {
                        set parent_of [lindex $sRes 0]
                    }
                    unset sql_res
                    $t insert end categories categories.GO:0008150 -data $parent_of -text "1: biological_process" -drawcross allways
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = 'GO:0005575'"}}]]
                    foreach sRes $sql_res {
                        set parent_of [lindex $sRes 0]
                    }
                    unset sql_res
                    $t insert end categories categories.GO:0005575 -data $parent_of -text "2: cellular_component" -drawcross allways
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = 'GO:0003674'"}}]]
                    foreach sRes $sql_res {
                        set parent_of [lindex $sRes 0]
                    }
                    unset sql_res
                    $t insert end categories categories.GO:0003674 -data $parent_of -text "3: molecular_function" -drawcross allways
                }
                unset parent_of
            }
            
            proc runCompare_go_tree_raise {t} {
                $t opentree categories 0
            }
            
            proc runCompare_go_tree_open {t node} {
                global phpThreadID
                
                set cL ""
                # Icon austauschen
                $t itemconfigure $node
                # alte Kinder-Knoten Löschen
                $t delete [$t nodes $node]
                
                # Verzeichnis aus Knoten
                set childs [$t itemcget $node -data]
                # Knoten für alle Kinder anlegen
                foreach child $childs {
                    set parent_of ""
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = '$child'"}}]]
                    foreach sRes $sql_res {
                        set parent_of [lindex $sRes 0]
                    }
                    unset sql_res
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name FROM refdb.go WHERE id = '$child'"}}]]
                    foreach sRes $sql_res {
                        set name [lindex $sRes 0]
                    }
                    unset sql_res
                    if {[llength $parent_of] > 0} {
                        set dc allways
                    } else {
                        set dc never
                    }
                    lappend cL "{$name} $child $dc {$parent_of}"
                }
                if {$cL ne ""} {
                    set cL [lsort $cL]
                    set i 1
                    foreach c $cL {
                        $t insert end $node $node.[lindex $c 1] -data [lindex $c 3] -text "$i: [lindex $c 0]" -drawcross [lindex $c 2]
                        incr i
                    }
                    unset parent_of; unset name
                }
            }
            
            proc runCompare_go_tree_show {node} {
                global mainThreadID
                rightmenu go tree [lindex [split $node .] end] -
            }
            
            proc runCompare_go_tree_close {t node} {
                $t itemconfigure $node
            }
            
            proc runCompare_go_show {mode} {
                global runCompareArr
                global mainThreadID
                global max_pValue
                global uncheckedImg
                global linkRedImg
                global linkGreenImg
                
                if {$runCompareArr(ready.go)} {
                    catch {.runCompare.notebook1.nb.fgo.0.tab.table.l deletecolumns 4 end}
                    foreach cohort $runCompareArr(cohortL) {
                        .runCompare.notebook1.nb.fgo.0.tab.table.l insertcolumns end 0 "$cohort: $runCompareArr(name.cohort.$cohort)" right
                        if {$runCompareArr(hideCol.go.found) eq "+"} {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode real
                        } else {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode real -hide yes
                        }
                        .runCompare.notebook1.nb.fgo.0.tab.table.l insertcolumns end 0 "$cohort: expected" right
                        if {$runCompareArr(hideCol.go.expected) eq "+"} {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode real
                        } else {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode real -hide yes
                        }
                        .runCompare.notebook1.nb.fgo.0.tab.table.l insertcolumns end 0 "$cohort" right
                        if {$runCompareArr(hideCol.go.regulated) eq "+"} {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode integer -width -15
                        } else {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode integer -width -15 -hide yes
                        }
                        .runCompare.notebook1.nb.fgo.0.tab.table.l insertcolumns end 0 "$cohort: two-tail pValue" right
                        if {$runCompareArr(hideCol.go.pValTwoTail) eq "+"} {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                        .runCompare.notebook1.nb.fgo.0.tab.table.l insertcolumns end 0 "$cohort: left pValue" right
                        if {$runCompareArr(hideCol.go.pValLeft) eq "+"} {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                        .runCompare.notebook1.nb.fgo.0.tab.table.l insertcolumns end 0 "$cohort: right pValue" right
                        if {$runCompareArr(hideCol.go.pValRight) eq "+"} {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                    }
                    .runCompare.notebook1.nb.fgo.0.tab.table.l delete 0 end
                    
                    set ent ""; set goL ""
                    if {$mode eq "all"} {
                        set goL $runCompareArr(goL)
                    } elseif {$mode eq "browse tree" || $mode eq "level"} {
                        set goL "GO:0008150 GO:0005575 GO:0003674"
                    } elseif {$mode ne "list"} {
                        set goL $mode
                    }
                    set termCount 0
                    if {$goL ne ""} {
                        set img ""
                        foreach go $goL {
                            if {$runCompareArr($go.references) ne 0} {
                                set ent "$go {$runCompareArr($go.name)} $runCompareArr($go.references)"
                                set pVal 0
                                foreach cohort $runCompareArr(cohortL) {
                                    lappend ent [lindex $runCompareArr($go.cohort.$cohort) 0]
                                    lappend ent [lindex $runCompareArr($go.cohort.$cohort) 1]
                                    set diff [expr [lindex $runCompareArr($go.cohort.$cohort) 1] - [lindex $runCompareArr($go.cohort.$cohort) 0]]
                                    if {[lindex [lindex $runCompareArr($go.cohort.$cohort) 2] 2] <= $max_pValue} {
                                        set pVal 1
                                    }
                                    if {[lindex [lindex $runCompareArr($go.cohort.$cohort) 2] 2] <= 0.05} {
                                        if {$diff > 0} {
                                            lappend ent -1
                                        } else {
                                            lappend ent 1
                                        }
                                    } else {
                                        lappend ent 0
                                    }
                                    lappend ent [lindex [lindex $runCompareArr($go.cohort.$cohort) 2] 2]
                                    lappend ent [lindex [lindex $runCompareArr($go.cohort.$cohort) 2] 0]
                                    lappend ent [lindex [lindex $runCompareArr($go.cohort.$cohort) 2] 1]
                                }
                                if {$pVal} {
                                    set ent_tmp "{}"
                                    foreach e $ent {
                                        lappend ent_tmp [regsub -all {[.]} $e ","]
                                    }
                                    .runCompare.notebook1.nb.fgo.0.tab.table.l insert end $ent_tmp
                                    unset ent_tmp
                                    for {set i 0} {$i < [llength $runCompareArr(cohortL)]} {incr i} {
                                        if {[lindex $ent [expr 5 + $i * 6]] eq 0} {
                                            set img $uncheckedImg
                                        } elseif {[lindex $ent [expr 5 + $i * 6]] eq 1} {
                                            set img $linkGreenImg
                                        } else {
                                            set img $linkRedImg
                                        }
                                        .runCompare.notebook1.nb.fgo.0.tab.table.l cellconfigure end,0 -window "fillTable_createButton link go"
                                        .runCompare.notebook1.nb.fgo.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -window "fillTable_createButton img {$img go [lindex $ent 0] $i}"
                                        #.runCompare.notebook1.nb.fgo.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -image $img
                                    }
                                    incr termCount
                                }
                            }
                        }
                        unset img
                    } else  {
                        eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "No GO terms selected."}}]
                    }
                    .runCompare.notebook1.nb.fgo.0.tab.table.l columnconfigure 1 -title "GO ($termCount of [llength $goL])"
                    
                    unset ent; unset goL; unset termCount
                }
            }
            
            proc runCompare_go_browse {node} {
                global phpThreadID
                global dbName
                
                .runCompare.notebook1.nb.fgo.0.mode.browse.tree.t selection set $node
                
                if {$dbName ne " "} {
                    set goL ""
                    if {$node eq "categories"} {
                        set sql_res "{{GO:0008150 GO:0005575 GO:0003674}}"
                    } else {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = '[lindex [split $node .] end]'"}}]]
                    }
                    foreach sRes $sql_res {
                        set goL [lindex $sRes 0]
                    }
                    unset sql_res
                    if {$goL ne ""} {
                        runCompare_go_show $goL
                    }
                    unset goL
                }
            }
            
            proc runCompare_go_level {} {
                global phpThreadID
                set root [.runCompare.notebook1.nb.fgo.0.mode.level.cbtype get]
                set level [.runCompare.notebook1.nb.fgo.0.mode.level.cblevel get]
                
                if {$root eq "Biological process"} {
                    set root "level_biological_process"
                } elseif {$root eq "Cellular component"} {
                    set root "level_cellular_component"
                } elseif {$root eq "Molecular function"} {
                    set root "level_molecular_function"
                }
                set goL ""
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id FROM refdb.gotree WHERE $root LIKE '%|$level|%';"}}]]
                foreach sRes $sql_res {
                    lappend goL [lindex $sRes 0]
                }
                unset sql_res
                if {$goL ne ""} {
                    runCompare_go_show $goL
                }
                unset goL
            }
            
            proc runCompare_go_level_setLevels {bp_max cc_max mf_max} {
                
                set root [.runCompare.notebook1.nb.fgo.0.mode.level.cbtype get]
                if {$root eq "Biological process"} {
                    set maxLevel $bp_max
                } elseif {$root eq "Cellular component"} {
                    set maxLevel $cc_max
                } elseif {$root eq "Molecular function"} {
                    set maxLevel $mf_max
                }
                set values ""
                for {set i 0} {$i <= $maxLevel} {incr i} {
                    lappend values $i
                }
                .runCompare.notebook1.nb.fgo.0.mode.level.cblevel configure -values "$values"
                unset values
            }
            
            proc runCompare_go_list {} {
                set goL [.runCompare.notebook1.nb.fgo.0.mode.list.panel get -displaychars 1.0 end]
                if {$goL ne ""} {
                    runCompare_go_show $goL
                }
                unset goL
            }
### KEGG
            proc runCompare_kegg {} {
                global phpThreadID
                global dbName
                global runCompareArr
                
                if {$runCompareArr(ready)} {
                    set runCompareArr(keggL) ""
                    set runCompareArr(keggL.pathway) ""
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id, description FROM refdb.kegg"}}]]
                    foreach sRes $sql_res {
                        lappend runCompareArr(keggL) "[lindex $sRes 0]"
                        set runCompareArr([lindex $sRes 0].name) "[lindex $sRes 1]"
                        set runCompareArr([lindex $sRes 0].pathwayL) " "
                        set runCompareArr([lindex $sRes 0].references) 0
                        foreach cohort $runCompareArr(cohortL) {
                            set runCompareArr([lindex $sRes 0].cohort.$cohort) 0
                        }
                    }
                    unset sql_res
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_map, id_ko, name FROM refdb.kegg_maps"}}]]
                    foreach sRes $sql_res {
                        lappend runCompareArr(keggL.pathway) "[lindex $sRes 0]"
                        set runCompareArr([lindex $sRes 0].pathway.name) "[lindex $sRes 2]"
                        set runCompareArr([lindex $sRes 0].pathway.koL) "[lindex $sRes 1]"
                        foreach ko [lindex $sRes 1] {
                            lappend runCompareArr($ko.pathwayL) [lindex $sRes 0]
                        }
                        set runCompareArr([lindex $sRes 0].pathway.references) 0
                        foreach cohort $runCompareArr(cohortL) {
                            set runCompareArr([lindex $sRes 0].pathway.cohort.$cohort) 0
                        }
                    }
                    foreach ko $runCompareArr(keggL) {
                        set runCompareArr($ko.pathwayL) [lsort -unique $runCompareArr($ko.pathwayL)]
                    }
                    unset sql_res
                    foreach nuc $runCompareArr(contigL.references) {
                        set keggL ""
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT id FROM $dbName.kegg_hits WHERE id_seq = '$nuc';"}}]]
                        foreach sRes $sql_res {
                            lappend keggL [lindex $sRes 0]
                        }
                        unset sql_res
                        if {$keggL ne ""} {
                            lappend runCompareArr(contigKEGGL.references) $nuc
                            foreach cohort $runCompareArr(cohortL) {
                                if {$runCompareArr($nuc.cohort.$cohort) ne 0} {
                                    lappend runCompareArr(contigKEGGL.cohort.$cohort) $nuc
                                }
                            }
                            set pathwayL ""
                            foreach kegg $keggL {
                                catch {append pathwayL " $runCompareArr($kegg.pathwayL)"}
                                incr runCompareArr($kegg.references)
                                foreach cohort $runCompareArr(cohortL) {
                                    if {$runCompareArr($nuc.cohort.$cohort) ne 0} {
                                        incr runCompareArr($kegg.cohort.$cohort)
                                    }
                                }
                            }
                            set pathwayL [lsort -unique $pathwayL]
                            foreach pathway $pathwayL {
                                incr runCompareArr($pathway.pathway.references)
                                foreach cohort $runCompareArr(cohortL) {
                                    if {$runCompareArr($nuc.cohort.$cohort) ne 0} {
                                        incr runCompareArr($pathway.pathway.cohort.$cohort)
                                    }
                                }
                            }
                        }
                    }
                    foreach kegg $runCompareArr(keggL) {
                        foreach cohort $runCompareArr(cohortL) {
                            if {$runCompareArr($kegg.references) eq 0} {
                                lappend runCompareArr($kegg.cohort.$cohort) 0
                                lappend runCompareArr($kegg.cohort.$cohort) "1 1 1"
                            } else {
                                lappend runCompareArr($kegg.cohort.$cohort) [expr int($runCompareArr($kegg.references).0 * [llength $runCompareArr(contigKEGGL.cohort.$cohort)].0 / [llength $runCompareArr(contigKEGGL.references)].0)]
                                lappend runCompareArr($kegg.cohort.$cohort) [pValue [llength $runCompareArr(contigKEGGL.cohort.$cohort)] [lindex $runCompareArr($kegg.cohort.$cohort) 0] [llength $runCompareArr(contigKEGGL.references)] $runCompareArr($kegg.references)]
                            }
                        }
                    }
                    foreach pathway $runCompareArr(keggL.pathway) {
                        foreach cohort $runCompareArr(cohortL) {
                            if {$runCompareArr($pathway.pathway.references) eq 0} {
                                lappend runCompareArr($pathway.pathway.cohort.$cohort) 0
                                lappend runCompareArr($pathway.pathway.cohort.$cohort) "1 1 1"
                            } else {
                                lappend runCompareArr($pathway.pathway.cohort.$cohort) [expr int($runCompareArr($pathway.pathway.references).0 * [llength $runCompareArr(contigKEGGL.cohort.$cohort)].0 / [llength $runCompareArr(contigKEGGL.references)].0)]
                                lappend runCompareArr($pathway.pathway.cohort.$cohort) [pValue [llength $runCompareArr(contigKEGGL.cohort.$cohort)] [lindex $runCompareArr($pathway.pathway.cohort.$cohort) 0] [llength $runCompareArr(contigKEGGL.references)] $runCompareArr($pathway.pathway.references)]
                            }
                        }
                    }
                    
                    set runCompareArr(ready.kegg) 1
                    runCompare_kegg_show [.runCompare.notebook1.nb.fkegg.mode.cb get]
                }
            }
    
            proc runCompare_kegg_show {mode} {
                global runCompareArr
                global max_pValue
                global mainThreadID
                global uncheckedImg
                global linkRedImg
                global linkGreenImg
                
                if {$runCompareArr(ready.kegg)} {
                    catch {.runCompare.notebook1.nb.fkegg.0.tab.table.l deletecolumns 4 end}
                    foreach cohort $runCompareArr(cohortL) {
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insertcolumns end 0 "$cohort: $runCompareArr(name.cohort.$cohort)" right
                        if {$runCompareArr(hideCol.kegg.found) eq "+"} {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode real
                        } else {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode real -hide yes
                        }
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insertcolumns end 0 "$cohort: expected" right
                        if {$runCompareArr(hideCol.kegg.expected) eq "+"} {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode real
                        } else {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode real -hide yes
                        }
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insertcolumns end 0 "$cohort" right
                        if {$runCompareArr(hideCol.kegg.regulated) eq "+"} {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode integer -width -15
                        } else {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode integer -width -15 -hide yes
                        }
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insertcolumns end 0 "$cohort: two-tail pValue" right
                        if {$runCompareArr(hideCol.kegg.pValTwoTail) eq "+"} {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insertcolumns end 0 "$cohort: left pValue" right
                        if {$runCompareArr(hideCol.kegg.pValLeft) eq "+"} {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insertcolumns end 0 "$cohort: right pValue" right
                        if {$runCompareArr(hideCol.kegg.pValRight) eq "+"} {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                    }
                    .runCompare.notebook1.nb.fkegg.0.tab.table.l delete 0 end
                    
                    set ent ""; set keggL ""
                    if {[lindex $mode end] eq "all"} {
                        set keggL $runCompareArr(keggL)
                    } elseif {[lindex $mode end] eq "pathway"} {
                        set keggL ""
                    } elseif {[lindex $mode end] eq "pathways"} {
                        set keggL "pathways"
                    } elseif {[lindex $mode end] ne "list"} {
                        set keggL $mode
                    }
                    set termCount 0
                    if {$keggL eq "pathways"} {
                        set keggL "$runCompareArr(keggL.pathway)"
                        foreach kegg $keggL {
                            catch {
                                if {$runCompareArr($kegg.pathway.references) ne 0} {
                                    set ent "$kegg {$runCompareArr($kegg.pathway.name)} $runCompareArr($kegg.pathway.references)"
                                    set pVal 0
                                    foreach cohort $runCompareArr(cohortL) {
                                        lappend ent [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 0]
                                        lappend ent [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 1]
                                        set diff [expr [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 1] - [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 0]]
                                        if {[lindex [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 2] 2] <= $max_pValue} {
                                            set pVal 1
                                        }
                                        if {[lindex [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 2] 2] <= 0.05} {
                                            if {$diff > 0} {
                                                lappend ent -1
                                            } else  {
                                                lappend ent 1
                                            }
                                        } else {
                                            lappend ent 0
                                        }
                                        lappend ent [lindex [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 2] 2]
                                        lappend ent [lindex [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 2] 0]
                                        lappend ent [lindex [lindex $runCompareArr($kegg.pathway.cohort.$cohort) 2] 1]
                                    }
                                    if {$pVal} {
                                        set ent_tmp "{}"
                                        foreach e $ent {
                                            lappend ent_tmp [regsub -all {[.]} $e ","]
                                        }
                                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insert end $ent_tmp
                                        unset ent_tmp
                                        for {set i 0} {$i < [llength $runCompareArr(cohortL)]} {incr i} {
                                            if {[lindex $ent [expr 5 + $i * 6]] eq 0} {
                                                set img $uncheckedImg
                                            } elseif {[lindex $ent [expr 5 + $i * 6]] eq 1} {
                                                set img $linkGreenImg
                                            } else {
                                                set img $linkRedImg
                                            }
                                            .runCompare.notebook1.nb.fkegg.0.tab.table.l cellconfigure end,0 -window "fillTable_createButton link kegg"
                                            .runCompare.notebook1.nb.fkegg.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -window "fillTable_createButton img {$img kegg_pathway [lindex $ent 0] $i}"
                                            #.runCompare.notebook1.nb.fkegg.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -image $img
                                        }
                                        incr termCount
                                    }
                                }
                            }
                        }
                    } elseif {$keggL ne ""} {
                        foreach kegg $keggL {
                            catch {
                                if {$runCompareArr($kegg.references) ne 0} {
                                    set ent "$kegg {$runCompareArr($kegg.name)} $runCompareArr($kegg.references)"
                                    set pVal 0
                                    foreach cohort $runCompareArr(cohortL) {
                                        lappend ent [lindex $runCompareArr($kegg.cohort.$cohort) 0]
                                        lappend ent [lindex $runCompareArr($kegg.cohort.$cohort) 1]
                                        set diff [expr [lindex $runCompareArr($kegg.cohort.$cohort) 1] - [lindex $runCompareArr($kegg.cohort.$cohort) 0]]
                                        if {[lindex [lindex $runCompareArr($kegg.cohort.$cohort) 2] 2] <= $max_pValue} {
                                            set pVal 1
                                        }
                                        if {[lindex [lindex $runCompareArr($kegg.cohort.$cohort) 2] 2] <= 0.05} {
                                            if {$diff > 0} {
                                                lappend ent 1
                                            } else  {
                                                lappend ent -1
                                            }
                                        } else {
                                            lappend ent 0
                                        }
                                        lappend ent [lindex [lindex $runCompareArr($kegg.cohort.$cohort) 2] 2]
                                        lappend ent [lindex [lindex $runCompareArr($kegg.cohort.$cohort) 2] 0]
                                        lappend ent [lindex [lindex $runCompareArr($kegg.cohort.$cohort) 2] 1]
                                    }
                                    if {$pVal} {
                                        set ent_tmp "{}"
                                        foreach e $ent {
                                            lappend ent_tmp [regsub -all {[.]} $e ","]
                                        }
                                        .runCompare.notebook1.nb.fkegg.0.tab.table.l insert end $ent_tmp
                                        for {set i 0} {$i < [llength $runCompareArr(cohortL)]} {incr i} {
                                            if {[lindex $ent [expr 5 + $i * 6]] eq 0} {
                                                set img $uncheckedImg
                                            } elseif {[lindex $ent [expr 5 + $i * 6]] eq 1} {
                                                set img $linkRedImg
                                            } else {
                                                set img $linkGreenImg
                                            }
                                            .runCompare.notebook1.nb.fkegg.0.tab.table.l cellconfigure end,0 -window "fillTable_createButton link kegg"
                                            .runCompare.notebook1.nb.fkegg.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -window "fillTable_createButton img {$img kegg [lindex $ent 0] $i}"
                                            #.runCompare.notebook1.nb.fkegg.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -image $img
                                        }
                                        incr termCount
                                    }
                                }
                            }
                        }
                    } else {
                        eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "No KEGG terms selected."}}]
                    }
                    .runCompare.notebook1.nb.fkegg.0.tab.table.l columnconfigure 1 -title "KEGG ($termCount of [llength $keggL])"
                    
                    unset ent; unset keggL; unset termCount
                }
            }
            
            proc runCompare_kegg_list {} {
                set keggL [.runCompare.notebook1.nb.fkegg.0.mode.list.panel get -displaychars 1.0 end]
                if {$keggL ne ""} {
                    runCompare_kegg_show $keggL
                }
                unset keggL
            }
            
            proc runCompare_kegg_pathway {} {
                global phpThreadID
                set kegg_map [.runCompare.notebook1.nb.fkegg.0.mode.path.cb get]
                set keggL ""
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_ko FROM refdb.kegg_maps WHERE name = '$kegg_map';"}}]]
                foreach sRes $sql_res {
                    set keggL [lindex $sRes 0]
                }
                unset sql_res
                if {$keggL ne ""} {
                    runCompare_kegg_show $keggL
                } else {
                    .runCompare.notebook1.nb.fkegg.0.mode.list.panel delete 1.0 end
                }
                unset keggL; unset kegg_map
            }
            
###Domains    
            proc runCompare_domain {} {
                global phpThreadID
                global dbName
                global runCompareArr
                
                if {$runCompareArr(ready)} {
                    set domain_type [.runCompare.notebook1.nb.fdomain.mode.domainCB get]
                    set runCompareArr(domainL.$domain_type) ""
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id, description FROM refdb.$domain_type"}}]]
                    foreach sRes $sql_res {
                        lappend runCompareArr(domainL.$domain_type) "[lindex $sRes 0]"
                        set runCompareArr([lindex $sRes 0].name) "[lindex $sRes 1]"
                        set runCompareArr([lindex $sRes 0].references) 0
                        foreach cohort $runCompareArr(cohortL) {
                            set runCompareArr([lindex $sRes 0].cohort.$cohort) 0
                        }
                    }
                    unset sql_res
                    set tab $domain_type; append tab "_hits"
                    foreach nuc $runCompareArr(contigL.references) {
                        set domainL ""
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT id FROM $dbName.$tab WHERE id_seq = '$nuc';"}}]]
                        foreach sRes $sql_res {
                            lappend domainL [lindex $sRes 0]
                        }
                        unset sql_res
                        if {$domainL ne ""} {
                            lappend runCompareArr(contigDomainL.$domain_type.references) $nuc
                            foreach cohort $runCompareArr(cohortL) {
                                if {$runCompareArr($nuc.cohort.$cohort) ne 0} {
                                    lappend runCompareArr(contigDomainL.$domain_type.cohort.$cohort) $nuc
                                }
                            }
                        }
                        foreach domain $domainL {
                            incr runCompareArr($domain.references)
                            foreach cohort $runCompareArr(cohortL) {
                                if {$runCompareArr($nuc.cohort.$cohort) ne 0} {
                                    incr runCompareArr($domain.cohort.$cohort)
                                }
                            }
                        }
                    }
                    unset tab
                    foreach domain $runCompareArr(domainL.$domain_type) {
                        foreach cohort $runCompareArr(cohortL) {
                            if {$runCompareArr($domain.references) eq 0} {
                                lappend runCompareArr($domain.cohort.$cohort) 0
                                lappend runCompareArr($domain.cohort.$cohort) "1 1 1"
                            } else {
                                lappend runCompareArr($domain.cohort.$cohort) [expr int($runCompareArr($domain.references).0 * [llength $runCompareArr(contigDomainL.$domain_type.cohort.$cohort)].0 / [llength $runCompareArr(contigDomainL.$domain_type.references)].0)]
                                lappend runCompareArr($domain.cohort.$cohort) [pValue [llength $runCompareArr(contigDomainL.$domain_type.cohort.$cohort)] [lindex $runCompareArr($domain.cohort.$cohort) 0] [llength $runCompareArr(contigDomainL.$domain_type.references)] $runCompareArr($domain.references)]
                            }
                        }
                    }
                    
                    set runCompareArr(ready.domain.$domain_type) 1
                    runCompare_domain_show [.runCompare.notebook1.nb.fdomain.mode.cb get]
                }
            }
            
            proc runCompare_domain_show {mode} {
                global runCompareArr
                global max_pValue
                global mainThreadID
                global uncheckedImg
                global linkRedImg
                global linkGreenImg
                
                set domain_type [.runCompare.notebook1.nb.fdomain.mode.domainCB get]
                if {$runCompareArr(ready.domain.$domain_type)} {
                    catch {.runCompare.notebook1.nb.fdomain.0.tab.table.l deletecolumns 4 end}
                    foreach cohort $runCompareArr(cohortL) {
                        .runCompare.notebook1.nb.fdomain.0.tab.table.l insertcolumns end 0 "$cohort: $runCompareArr(name.cohort.$cohort)" right
                        if {$runCompareArr(hideCol.domain.found) eq "+"} {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode real
                        } else {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode real -hide yes
                        }
                        .runCompare.notebook1.nb.fdomain.0.tab.table.l insertcolumns end 0 "$cohort: expected" right
                        if {$runCompareArr(hideCol.domain.expected) eq "+"} {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode real
                        } else {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode real -hide yes
                        }
                        .runCompare.notebook1.nb.fdomain.0.tab.table.l insertcolumns end 0 "$cohort" right
                        if {$runCompareArr(hideCol.domain.regulated) eq "+"} {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode integer -width -15
                        } else {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode integer -width -15 -hide yes
                        }
                        .runCompare.notebook1.nb.fdomain.0.tab.table.l insertcolumns end 0 "$cohort: two-tail pValue" right
                        if {$runCompareArr(hideCol.domain.pValTwoTail) eq "+"} {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                        .runCompare.notebook1.nb.fdomain.0.tab.table.l insertcolumns end 0 "$cohort: left pValue" right
                        if {$runCompareArr(hideCol.domain.pValLeft) eq "+"} {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                        .runCompare.notebook1.nb.fdomain.0.tab.table.l insertcolumns end 0 "$cohort: right pValue" right
                        if {$runCompareArr(hideCol.domain.pValRight) eq "+"} {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode dictionary
                        } else {
                            .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure end -sortmode dictionary -hide yes
                        }
                    }
                    .runCompare.notebook1.nb.fdomain.0.tab.table.l delete 0 end
                    
                    set ent ""; set domainL ""
                    if {$mode eq "all"} {
                        set domainL $runCompareArr(domainL.$domain_type)
                    } elseif {$mode ne "list"} {
                        set domainL $mode
                    }
                    set termCount 0
                    if {$domainL ne ""} {
                        foreach domain $domainL {
                            catch {
                                if {$runCompareArr($domain.references) ne 0} {
                                    set ent "$domain {$runCompareArr($domain.name)} $runCompareArr($domain.references)"
                                    set pVal 0
                                    foreach cohort $runCompareArr(cohortL) {
                                        lappend ent [lindex $runCompareArr($domain.cohort.$cohort) 0]
                                        lappend ent [lindex $runCompareArr($domain.cohort.$cohort) 1]
                                        set diff [expr [lindex $runCompareArr($domain.cohort.$cohort) 1] - [lindex $runCompareArr($domain.cohort.$cohort) 0]]
                                        if {[lindex [lindex $runCompareArr($domain.cohort.$cohort) 2] 2] <= $max_pValue} {
                                            set pVal 1
                                        }
                                        if {[lindex [lindex $runCompareArr($domain.cohort.$cohort) 2] 2] <= 0.05} {
                                            if {$diff > 0} {
                                                lappend ent -1
                                            } else  {
                                                lappend ent 1
                                            }
                                        } else {
                                            lappend ent 0
                                        }
                                        lappend ent [lindex [lindex $runCompareArr($domain.cohort.$cohort) 2] 2]
                                        lappend ent [lindex [lindex $runCompareArr($domain.cohort.$cohort) 2] 0]
                                        lappend ent [lindex [lindex $runCompareArr($domain.cohort.$cohort) 2] 1]
                                    }
                                    if {$pVal} {
                                        set ent_tmp "{}"
                                        foreach e $ent {
                                            lappend ent_tmp [regsub -all {[.]} $e ","]
                                        }
                                        .runCompare.notebook1.nb.fdomain.0.tab.table.l insert end $ent_tmp
                                        unset ent_tmp
                                        for {set i 0} {$i < [llength $runCompareArr(cohortL)]} {incr i} {
                                            if {[lindex $ent [expr 5 + $i * 6]] eq 0} {
                                                set img $uncheckedImg
                                            } elseif {[lindex $ent [expr 5 + $i * 6]] eq 1} {
                                                set img $linkGreenImg
                                            } else {
                                                set img $linkRedImg
                                            }
                                            .runCompare.notebook1.nb.fdomain.0.tab.table.l cellconfigure end,0 -window "fillTable_createButton link $domain_type"
                                            .runCompare.notebook1.nb.fdomain.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -window "fillTable_createButton img {$img $domain_type [lindex $ent 0] $i}"
                                            #.runCompare.notebook1.nb.fdomain.0.tab.table.l cellconfigure end,[expr 6 + $i * 6] -image $img
                                        }
                                        incr termCount
                                    }
                                }
                            }
                        }
                    } else  {
                        eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "No $domain terms selected."}}]
                    }
                    .runCompare.notebook1.nb.fdomain.0.tab.table.l columnconfigure 1 -title "$domain_type ($termCount of [llength $domainL])"
                    
                    unset ent; unset domainL; unset termCount
                }
            }
            
            proc runCompare_domain_list {} {
                set domainL [.runCompare.notebook1.nb.fdomain.0.mode.list.panel get -displaychars 1.0 end]
                if {$domainL ne ""} {
                    runCompare_domain_show $domainL
                }
                unset domainL
            }
            
            proc runCompare_showContigs {type id cohort} {
                global runCompareArr
                global phpThreadID
                global dbName
                global runCompareArr
                global mainThreadID
                global prjL
                
                set tmpString ""
                set cohort [lindex $runCompareArr(cohortL) $cohort]
                foreach contig $runCompareArr(contigL.cohort.$cohort) {
                    append tmpString ", '$contig'"
                }
                set tmpString [string range $tmpString 2 end]
                if {$type eq "go"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT members FROM refdb.gotree WHERE id = '$id'"}}]]
                    foreach sRes $sql_res {
                        foreach go [lindex $sRes 0] {
                            append memberL ", '$go'"
                        }
                    }
                    set memberL [string range $memberL 2 end]
                    unset sql_res
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT id_seq FROM $dbName.${type}_hits WHERE id IN ($memberL) and id_seq IN ($tmpString) ORDER BY id_seq"}}]]
                    unset memberL
                } elseif {$type eq "kegg_pathway"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_ko FROM refdb.kegg_maps WHERE name = '$kegg_map';"}}]]
                    foreach sRes $sql_res {
                        set keggL ", '[lindex $sRes 0]'"
                    }
                    set keggL [string range $keggL 2 end]
                    unset sql_res
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT id_seq FROM $dbName.kegg_hits WHERE id IN ($keggL) and id_seq IN ($tmpString) ORDER BY id_seq"}}]]
                    unset keggL
                } else {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT id_seq FROM $dbName.${type}_hits WHERE id = '$id' and id_seq IN ($tmpString) ORDER BY id_seq"}}]]
                }
                
                set id_seqL ""
                if {[lindex [lindex $sql_res 0] 0] eq "Fehler:"} {
                    eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "Could not get contigs to display."}}]
                } else {
                    foreach sRes $sql_res {
                        lappend id_seqL [lindex $sRes 0]
                    }
                }
                unset sql_res; unset tmpString
                
                eval [subst {thread::send -async $mainThreadID {::search_right id_seqL "{$type cohort$cohort $id} {$id_seqL}"}}]
                unset id_seqL
            }
            
### Table + Rightmenu            
            proc editEndCmd {tbl row col text} {
                global checkedImg
                global uncheckedImg
                
                if {$col eq 0} {
                    set img [expr {$text ? $checkedImg : $uncheckedImg}]
                    $tbl cellconfigure $row,$col -image $img
                } elseif {$col eq 5} {
                    $tbl cellconfigure $row,$col -text $text
                }
                return $text
            }
            
            proc emptystr {args} { return "" }
            
            proc fillTable_createButton {type linkRef tl row col w} {
                global linkImg
                global mainThreadID
                
                if {$type eq "link"} {
                    set linkID [lindex [$tl get $row] 1]
                    set comm "eval [subst {thread::send -async $mainThreadID {\"execLink $linkID $linkRef\"}}]"
                    button $w -image $linkImg -highlightthickness 0 -takefocus 0 -command $comm
                } else {
                    set comm "runCompare_showContigs [lindex $linkRef 1] [lindex $linkRef 2] [lindex $linkRef 3]"
                    button $w -image [lindex $linkRef 0] -highlightthickness 0 -takefocus 0 -command $comm
                }
            }
            
            proc rightmenu {mode feat id coord} {
                global mainThreadID
                global runCompareArr
                
                .rightmenu delete 0 end
                .rightmenu.hidemenuColumn delete 0 end
                .rightmenu.copymenu delete 0 end
                if {$mode eq "go"} {
                    #GO_tree
                    if {$feat eq "tree"} {
                        set cmd "eval \[subst {thread::send -async $mainThreadID {::search_right go_stat $id}}\]"
                        .rightmenu add command -label "Show all hits" -command $cmd
                    } elseif {$feat eq "tab"} {
                        set cmd "eval \[subst {thread::send -async $mainThreadID {::search_right go $id}}\]"
                        .rightmenu add command -label "Show all hits" -command $cmd
                        .rightmenu add separator
                        .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.id) id" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.id 0"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.name) name" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.name 1"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.total) total" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.total 2"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.found) found" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.found 3"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.expected) expected" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.expected 4"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.regulated) regulated" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.regulated 5"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.pValLeft) left pValue" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.pValLeft 8"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.pValRight) right pValue" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.pValRight 7"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.go.pValTwoTail) two-tail pValue" -command "table_col_sh .runCompare.notebook1.nb.fgo.0.tab.table.l hideCol.go.pValTwoTail 6"
                        .rightmenu add separator
                        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
                        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .runCompare.notebook1.nb.fgo.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .runCompare.notebook1.nb.fgo.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .runCompare.notebook1.nb.fgo.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .runCompare.notebook1.nb.fgo.0.tab.table.l}"
                    }
                } elseif {$mode eq "kegg"} {
                    #KEGG
                    if {$feat eq "tab"} {
                        set cmd "eval \[subst {thread::send -async $mainThreadID {::search_right keggM $id}}\]"
                        .rightmenu add command -label "Show all hits" -command $cmd
                        .rightmenu add separator
                        .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.id) id" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.id 0"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.name) name" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.name 1"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.total) total" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.total 2"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.found) found" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.found 3"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.expected) expected" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.expected 4"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.regulated) regulated" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.regulated 5"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.pValLeft) left pValue" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.pValLeft 8"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.pValRight) right pValue" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.pValRight 7"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.kegg.pValTwoTail) two-tail pValue" -command "table_col_sh .runCompare.notebook1.nb.fkegg.0.tab.table.l hideCol.kegg.pValTwoTail 6"
                        .rightmenu add separator
                        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
                        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .runCompare.notebook1.nb.fkegg.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .runCompare.notebook1.nb.fkegg.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .runCompare.notebook1.nb.fkegg.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .runCompare.notebook1.nb.fkegg.0.tab.table.l}"
                    }
                } elseif {$mode eq "domain"} {
                    #Domain
                    if {$feat eq "tab"} {
                        set cmd "eval \[subst {thread::send -async $mainThreadID {::search_right [.runCompare.notebook1.nb.fdomain.mode.domainCB get] $id}}\]"
                        .rightmenu add command -label "Show all hits" -command $cmd
                        .rightmenu add separator
                        .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.id) id" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.id 0"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.name) name" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.name 1"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.total) total" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.total 2"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.found) found" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.found 3"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.expected) expected" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.expected 4"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.regulated) regulated" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.regulated 5"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.pValLeft) left pValue" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.pValLeft 8"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.pValRight) right pValue" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.pValRight 7"
                        .rightmenu.hidemenuColumn add command -label "$runCompareArr(hideCol.domain.pValTwoTail) two-tail pValue" -command "table_col_sh .runCompare.notebook1.nb.fdomain.0.tab.table.l hideCol.domain.pValTwoTail 6"
                        .rightmenu add separator
                        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
                        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .runCompare.notebook1.nb.fdomain.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .runCompare.notebook1.nb.fdomain.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .runCompare.notebook1.nb.fdomain.0.tab.table.l}"
                        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .runCompare.notebook1.nb.fdomain.0.tab.table.l}"
                    }
                }
                tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
            }
            
            proc table_copy {mode t} {
                global env
                set i 0
                set tab ""
                if {$mode eq "all"} {
                    set colNum [$t columncount]
                    for {set i 0} {$i < $colNum} {incr i} {
                        if {[$t columncget $i -hide] ne 1} {
                            lappend colL $i
                            append tab "[$t columncget $i -title]\t"
                        }
                    }
                    append tab "\n"
                    set entL [$t getcolumns $colL]
                    set colNum [llength $entL]
                    set i 0
                    while {[lindex [lindex $entL 1] $i] ne ""} {
                        foreach e $entL {
                            append tab "[lindex $e $i]\t"
                        }
                        append tab "\n"
                        incr i
                    }
                    unset entL; unset colNum; unset colL
                } elseif {[lindex $mode 0] eq "column"} {
                    append tab "[$t columncget [$t containingcolumn [lindex $mode 1]] -title]\n"
                    foreach e [$t getcolumns [$t containingcolumn [lindex $mode 1]]] {
                        append tab "$e\n"
                    }
                } elseif {[lindex $mode 0] eq "row"} {
                    set ent [$t get [$t nearest [lindex $mode 1]]]
                    set colNum [$t columncount]
                    for {set i 0} {$i < $colNum} {incr i} {
                        if {[$t columncget $i -hide] ne 1} {
                            append header "[$t columncget $i -title]\t"
                            append tab "[lindex $ent $i]\t"
                        }
                    }
                    set tab "$header\n$tab"
                    unset header; unset ent; unset colNum
                } elseif {[lindex $mode 0] eq "cell"} {
                    set tab [$t cellcget [$t containingcell [lindex $mode 1] [lindex $mode 2]] -text]
                } elseif {[lindex $mode 0] eq "sequence"} {
                    if {$env(sequence_type) eq "nucleotide"} {
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM [lindex $mode 2].sequences_nucleotide WHERE id_seq = '[lindex $mode 1]'"}}]]
                        foreach ent $sql_res {
                            set tab ">[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]\n[lindex $ent 3]"
                        }
                        unset sql_res
                    } else {
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, frame, orf, sequence FROM [lindex $mode 2].sequences_protein WHERE id_prot = '[lindex $mode 1]'"}}]]
                        foreach ent $sql_res {
                            set tab ">[lindex $ent 0] length=[lindex $ent 1] frame=[lindex $ent 2] orf=[lindex $ent 3]\n[lindex $ent 4]"
                        }
                        unset sql_res
                    }
                }
                
                clipboard clear; clipboard append "$tab"
                unset tab; unset i
            }
            
            proc table_col_sh {t tab col} {
                global runCompareArr
                if {$runCompareArr($tab) eq "+"} {
                    if {$col ne "-"} {
                        if {$col > 2} {
                            for {set i 0} {$i < [llength $runCompareArr(cohortL)]} {incr i} {
                                $t columnconfigure [expr $col + $i * 6] -hide yes
                            }
                        } else {
                            $t columnconfigure $col -hide yes
                        }
                    }
                    set runCompareArr($tab) -
                } else {
                    if {$col ne "-"} {
                        if {$col > 2} {
                            for {set i 0} {$i < [llength $runCompareArr(cohortL)]} {incr i} {
                                $t columnconfigure [expr $col + $i * 6] -hide no
                            }
                        } else {
                            $t columnconfigure $col -hide no
                        }
                    }
                    set runCompareArr($tab) +
                }
            }
            
            proc table_selection {tl col} {
                global checkedImg
                global uncheckedImg
                
                $tl finishediting
                if {[$tl columncget $col -labelimage] eq "image1"} {
                    set use 0
                } else {
                    set use 1
                }
                
                $tl columnconfigure $col -labelimage [expr {$use ? $checkedImg : $uncheckedImg}]
                set rows [$tl index end]
                for {set i 0} {$i < $rows} {incr i} {
                    $tl cellconfigure $i,$col -text $use -image [expr {$use ? $checkedImg : $uncheckedImg}]
                }
            }
### P-Value            
            proc pValue {n1 n11 n n_1} {
                set n1 $n1.0
                set n11 $n11.0
                set n $n.0
                set n_1 $n_1.0
                set n12 [expr $n1 - $n11]
                set n21 [expr $n_1 - $n11]
                set n22 [expr $n - $n1 - $n21]
                set tmp [exact $n11 $n1 $n_1 $n]
                #set prob [human_readable [lindex $tmp 0]]
                set left [human_readable [lindex $tmp 1]]
                set right [human_readable [lindex $tmp 2]]
                set twotail [expr [lindex $tmp 3] + [lindex $tmp 4]]
                if {$twotail > 1} {set twotail 1}
                set twotail [human_readable $twotail]
                
                
                return "$left $right $twotail"
            }
            
            proc human_readable {p} {
                set p [regsub -all {[\.e]} $p " "]
                if {[llength $p] eq 2} {
                    if {[lindex $p 0] eq 0} {
                        set count 1
                        set n 0
                        for {set j 0} {$j < [string length [lindex $p 1]]} {incr j} {
                            if {[string index [lindex $p 1] $j] eq 0} {
                                incr count
                            } else {
                                set n [string index [lindex $p 1] $j]
                                break
                            }
                        }
                        if {$count > 3} {
                            incr j
                            set p "$n.[string range [lindex $p 1] $j [expr $j + 3]]e-$count"
                        } else {
                            set p "[lindex $p 0].[string range [lindex $p 1] 0 4]"
                        }
                    } else {
                        set p "[lindex $p 0].[string range [lindex $p 1] 0 2]"
                    }
                } elseif {[llength $p] eq 3} {
                    set p "[lindex $p 0].[string range [lindex $p 1] 0 2]e[lindex $p 2]"
                }
                return $p
            }
            
            proc exact {n11 n1 n_1 n} {
                set max $n1
                if {$n_1 < $max} {set max $n_1}
                set min [expr $n1 + $n_1 - $n]
                if {$min < 0} {set min 0}
                if {$min == $max && $min == 0} {
                    set sless 1
                    set sright 1
                    set sleft 1
                    set slarg 1
                    return "1 1 1 1 1"
                }
                set prob [hyper $n11 $n1 $n_1 $n]
                set sleft 0
                set p [hyper $min 0 0 0]
                for {set i [expr int($min) + 1]} {$p < [expr 0.99999999 * $prob]} {incr i} {
                    set sleft [expr $sleft + $p]
                    set p [hyper $i 0 0 0]
                }
                set i [expr $i - 1]
                if {$p < [expr 1.00000001 * $prob]} {
                    set sleft [expr $sleft + $p]
                } else {
                    set i [expr $i - 1]
                }
                set sright 0
                set p [hyper $max 0 0 0]
                for {set j [expr int($max) - 1]} {$p < [expr 0.99999999 * $prob]} {set j [expr $j - 1]} {
                    set sright [expr $sright + $p]
                    set p [hyper $j 0 0 0]
                }
                incr j
                if {$p < [expr 1.00000001 * $prob]} {
                    set sright [expr $sright + $p]
                } else {
                    incr j
                }
                if {[expr abs(($i - $n11))] < [expr abs(($j - $n11))]} {
                    set sless $sleft
                    set slarg [expr 1 - $sleft + $prob]
                } else {
                    set sless [expr 1 - $sright + $prob]
                    set slarg $sright
                }
                return "$prob $sless $slarg $sleft $sright"
            }
            
            proc lngamm {z} {
                set x 0
                set x [expr $x + 0.1659470187408462e-06 / ($z + 7) + 0.9934937113930748e-05 / ($z + 6) - 0.1385710331296526 / ($z + 5) + 12.50734324009056 / ($z + 4) - 176.6150291498386 / ($z + 3) + 771.3234287757674 / ($z + 2) - 1259.139216722289 / ($z + 1) + 676.5203681218835 / $z + 0.9999999999995183]
                return [expr log($x) - 5.58106146679532777 - $z + ($z - 0.5) * log(($z + 6.5))]
            }
            
            proc lnfact {n} {
                if {$n <= 1} {return 0}
                return [lngamm [expr $n + 1]]
            }
            
            proc lnbico {n k} {
                return [expr [lnfact $n] - [lnfact $k] - [lnfact [expr $n - $k]]]
            }
            
            proc hyper_323 {n11 n1_ n_1 n} {
                return [expr exp(([lnbico $n1_ $n11] + [lnbico [expr $n - $n1_] [expr $n_1 - $n11]] - [lnbico $n $n_1]))]
            }
            
            proc hyper {n11i n1_i n_1i ni} {
                global sn11
                global sn1_
                global sn_1
                global sn
                global sprob
                if {$n1_i == 0 && $n_1i == 0 && $ni == 0} {
                    if {[expr fmod($n11i,10)] != 0} {
                        if {$n11i == [expr $sn11 + 1]} {
                            set sprob  [expr $sprob * (($sn1_ - $sn11) / $n11i) * (($sn_1 - $sn11) / ($n11i + $sn - $sn1_ - $sn_1))]
                            set sn11 $n11i
                            return $sprob
                        }
                        if {$n11i == [expr $sn11 - 1]} {
                            set sprob  [expr $sprob * ($sn11 / ($sn1_ - $n11i)) * (($sn11 + $sn - $sn1_ - $sn_1) / ($sn_1 - $n11i))]
                            set sn11 $n11i
                            return $sprob
                        }
                    }
                    set sn11 $n11i
                } else {
                    set sn11 $n11i
                    set sn1_ $n1_i
                    set sn_1 $n_1i
                    set sn $ni
                }
                set sprob [hyper_323 $sn11 $sn1_ $sn_1 $sn]
                return $sprob
            }
            
            thread::wait
        }]
        eval [subst {thread::send -async $::threadRunCompare {runCompare_gui $env(dbName) $env(mainThreadID) $env(phpThreadID) "$env(homeFolder)" "$runL" "$prjL"} result}]
    } else {
        if {$runL eq ""} {
            ::errorPopUp "Error" "No runs available."
        } else {
            ::errorPopUp "Error" "No database selected."
        }
        
    }
}