proc toolTip_init {} {
    if {[catch {set ft [open [pwd]/conf/toolTip_tace.conf r]} ]} {
    } else {
        while {[gets $ft line] != -1} {
            if {[string index $line 0] ne "#" && $line ne ""} {
                set line "{[regsub -all {\t} $line "\} \{"]}"
                toolTip [lindex $line 0] "[lindex $line 1]"
            }
        }
        close $ft
    }
}

proc toolTip {t help} {
    bind $t <Any-Enter> "after 1000 [list toolTip_show %W \"$help\"]"
    bind $t <Any-Leave> "destroy %W.balloon"
}

proc toolTip_show {t arg} {
    if {[eval winfo containing  [winfo pointerxy .]]!=$t} {return}
    set top $t.balloon
    catch {destroy $top}
    toplevel $top -bd 1 -bg black
    wm overrideredirect $top 1
    if {[string equal [tk windowingsystem] aqua]}  {
        ::tk::unsupported::MacWindowStyle style $top help none
    }
    pack [message $top.txt -aspect 10000 -bg lightyellow \
            -font fixed -text $arg]
    set wmx [winfo rootx $t]
    set wmy [expr [winfo rooty $t]+[winfo height $t]]
    wm geometry $top \
            [winfo reqwidth $top.txt]x[winfo reqheight $top.txt]+$wmx+$wmy
    raise $top
}