package require http
package require BWidget
package require tablelist
package require Thread 2.6.5

global env
if {$tcl_platform(platform) == "windows"} {
    set env(platform) windows
} elseif {$tcl_platform(platform) == "unix"} {
    set env(platform) unix
}

#loads the configuration file and builds the interface
proc init {} {  
    auto_mkindex [pwd]/modules *.tcl
    global auto_path
    lappend auto_path [pwd]/modules
        
    global env
    set env(loaded_modules) " "
    set env(mainThreadID) [thread::id]
    set env(phpThreadID) $::threadPHP
    set env(dbName) " "
    set env(processL) " "
    set env(contig.dbName) " "
    set env(contig.dbType) "nucleotide"
    set env(blastRefDBL) " "
    set env(dbbCBL) " "
    set env(sequence_type) "nucleotide"
    
    set env(translateTableProt) " "
    set env(translateTableProtPath) " "
    set env(dbL) " "
    
    set env(connections) " "
    set env(currentConnection) " "
    set env(host) " "
    set env(port) " "
    set env(user) " "
    set env(parentDB) " "
    set env(folderServer) " "
    set env(password) " "
    set env(userServer) " "
    set env(passwdServer) " "
    
    global blastRefDBL
    global projectL
    global min_contig_size
    global checkedImg
    global uncheckedImg
    global linkImg
    global linkRedImg
    global linkGreenImg
    global closeImg
    global tabArr
    global tabL
    global seq_info
    global seq_all
    global database_browser_showSeq
    global database_browser_search
    global database_browser_goto
    global database_browser_idOrderCheck
    global database_browser_lengthOrderCheck
    global database_browser_numreadsOrderCheck
    global database_browser_goOrderCheck
    global database_browser_interproOrderCheck
    global readMap_mapCheck
    #global readMap_multipleCheck
    global readMap_alignCheck
    global map_canTagL
    global searchFeatArr
    global execLinkArr
    
    variable listboxCB
    
    foreach item {blast blastprodom gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr} {
        set searchFeatArr($item) 1
    }
    
    set seq_info ""
    set seq_all ""
    set projectL ""
    set min_contig_size 100
    set map_canTagL ""
    set readMap_mapCheck 1
    set readMap_multipleCheck 0
    set readMap_alignCheck 0
    #HomeFolder
    set env(homeFolder) [pwd]
    #BrowserPath
    set env(browserPath) " "
    #ProteinTranslationTable
    set env(translateTableProtPath) "[pwd]/gcodes/code_1.txt"

    event add <<MarkAll>> <Control-a>
    
    if {[catch {set ft [open [pwd]/conf/T-ACE.conf r]} ]} {
        #Database_browser
        set database_browser_showSeq 50
        set env(database_browser.nr) +
        set env(database_browser.length) +
        set env(database_browser.numreads) +
        set env(database_browser.description) +
        set env(database_browser.proteins) +
        set env(database_browser.blast) +
        set env(database_browser.blastprodom) +
        set env(database_browser.coil) +
        set env(database_browser.gene3d) +
        set env(database_browser.go) +
        set env(database_browser.interpro) +
        set env(database_browser.kegg) +
        set env(database_browser.panther) +
        set env(database_browser.pfam) +
        set env(database_browser.pir) +
        set env(database_browser.patternscan) +
        set env(database_browser.profilescan) +
        set env(database_browser.smart) +
        set env(database_browser.superfamily) +
        set env(database_browser.tigr) +
        set env(database_browser.coverage) +
        set database_browser_idOrderCheck 1
        set database_browser_lengthOrderCheck 1
        set database_browser_numreadsOrderCheck 0
        set database_browser_goOrderCheck 0
        set database_browser_interproOrderCheck 0
        #Database_info
        set env(db_info.assembled) +
        set env(db_info.comment) +
        set env(db_info.data) +
        set env(db_info.dateIn) +
        set env(db_info.dateOut) +
        set env(db_info.description) +
        set env(db_info.id_run) +
        set env(db_info.runs) +
        set env(db_info.sequencer) +
        set env(db_info.sequences) +
        set env(db_info.singletons) +
        set env(db_info.treatment) +
        set env(db_info.type) +
    } else {
        #Database_browser
        gets $ft line
        gets $ft line
        set database_browser_showSeq [lindex $line 0]
        set env(database_browser.nr) [lindex $line 1]
        set env(database_browser.length) [lindex $line 2]
        set env(database_browser.description) [lindex $line 3]
        set env(database_browser.proteins) [lindex $line 4]
        set env(database_browser.blast) [lindex $line 5]
        set env(database_browser.blastprodom) [lindex $line 6]
        set env(database_browser.coil) [lindex $line 7]
        set env(database_browser.gene3d) [lindex $line 8]
        set env(database_browser.go) [lindex $line 9]
        set env(database_browser.interpro) [lindex $line 10]
        set env(database_browser.kegg) [lindex $line 11]
        set env(database_browser.panther) [lindex $line 12]
        set env(database_browser.pfam) [lindex $line 13]
        set env(database_browser.pir) [lindex $line 14]
        set env(database_browser.patternscan) [lindex $line 15]
        set env(database_browser.profilescan) [lindex $line 16]
        set env(database_browser.smart) [lindex $line 17]
        set env(database_browser.superfamily) [lindex $line 18]
        set env(database_browser.tigr) [lindex $line 19]
        set env(database_browser.numreads) [lindex $line 20]
        set env(database_browser.coverage) [lindex $line 21]
        gets $ft line
        set database_browser_idOrderCheck [lindex $line 0]
        set database_browser_lengthOrderCheck [lindex $line 1]
        set database_browser_numreadsOrderCheck [lindex $line 2]
        set database_browser_goOrderCheck [lindex $line 3]
        set database_browser_interproOrderCheck [lindex $line 4]
        #Database_info
        gets $ft line
        gets $ft line
        set env(db_info.assembled) [lindex $line 0]
        set env(db_info.comment) [lindex $line 1]
        set env(db_info.data) [lindex $line 2]
        set env(db_info.dateIn) [lindex $line 3]
        set env(db_info.dateOut) [lindex $line 4]
        set env(db_info.description) [lindex $line 5]
        set env(db_info.id_run) [lindex $line 6]
        set env(db_info.runs) [lindex $line 7]
        set env(db_info.sequencer) [lindex $line 8]
        set env(db_info.sequences) [lindex $line 9]
        set env(db_info.singletons) [lindex $line 10]
        set env(db_info.treatment) [lindex $line 11]
        set env(db_info.type) [lindex $line 12]
        #HomeFolder
        gets $ft line
        gets $ft line
        set env(homeFolder) $line
        if {$env(homeFolder) eq ""} {
            set env(homeFolder) [pwd]
        }
        #BrowserPath
        gets $ft line
        gets $ft line
        if {$line ne ""} {
            set env(browserPath) $line
        }
        #ProteinTranslationTable
        gets $ft line
        gets $ft line
        if {$line ne ""} {
            set env(translateTableProtPath) $line
        }
    }
    set env(currentFolder) $env(homeFolder)
    
    if {[catch {set ft [open [pwd]/conf/links_tace.conf r]} ]} {
        #Links
        set execLinkArr(protein) "http://www.ncbi.nlm.nih.gov/Structure/cdd/wrpsb.cgi?DATALIB=oasis_sap&INPUT_TYPE=access&FILTER=T&SMODE=0&NHITS=50&GRAPH=2&PAIR=2&EXPECT=0.1&SEQUENCE=\$linkID"
        set execLinkArr(blastprodom) "http://prodom.prabi.fr/prodom/current/cgi-bin/request.pl?question=DBEN&query=\$linkID"
        set execLinkArr(gene3d) "http://www.cathdb.info/cgi-bin/GotoCath.pl?cath=\$linkID"
        set execLinkArr(go) "http://amigo.geneontology.org/cgi-bin/amigo/go.cgi?view=details&search_constraint=terms&depth=0&query=\$linkID"
        set execLinkArr(panther) "http://www.pantherdb.org/panther/family.do?clsAccession=\$linkID"
        set execLinkArr(pfam) "http://pfam.sanger.ac.uk/family?entry=\$linkID"
        set execLinkArr(pir) "http://pir.georgetown.edu/cgi-bin/ipcSF?id=\$linkID"
        set execLinkArr(smart) "http://smart.embl-heidelberg.de/smart/do_annotation.pl?BLAST=DUMMY&DOMAIN=\$linkID"
        set execLinkArr(interpro) "http://www.ebi.ac.uk/interpro/IEntry?ac=\$linkID"
        set execLinkArr(kegg) "http://www.genome.jp/dbget-bin/www_bget?\$linkID"
        set execLinkArr(patternscan) "http://expasy.org/prosite/\$linkID"
        set execLinkArr(profilescan) "http://expasy.org/prosite/\$linkID"
        set execLinkArr(superfamily) "http://supfam.cs.bris.ac.uk/SUPERFAMILY/cgi-bin/scop.cgi?sunid=\$linkID"
        set execLinkArr(tigr) "http://cmr.jcvi.org/cgi-bin/CMR/HmmReport.cgi?hmm_acc=\$linkID"
        set execLinkArr(uniref100) "http://www.uniprot.org/uniref/Uniref100_\$linkID"
        set execLinkArr(uniref50) "http://www.uniprot.org/uniref/Uniref50_\$linkID"
        set execLinkArr(nr) "http://www.ncbi.nlm.nih.gov/entrez/viewer.fcgi?db=nuccore&id=\$linkID"
        set execLinkArr(nt) "http://www.ncbi.nlm.nih.gov/entrez/viewer.fcgi?db=nuccore&id=\$linkID"
        set execLinkArr(uniprot_sprot) "http://www.uniprot.org/uniref/Uniref100_\$linkID"
    } else {
        while {[gets $ft line] ne -1} {
            set execLinkArr([lindex $line 0]) [lindex $line 1]
        }
    }
    
    if {[catch {set ft [open "$env(translateTableProtPath)" r]} ]} {
        lappend env(translateTableProt) "A gct"
        lappend env(translateTableProt) "A gcc"
        lappend env(translateTableProt) "A gca"
        lappend env(translateTableProt) "A gcg"
        lappend env(translateTableProt) "R cgt"
        lappend env(translateTableProt) "R cgc"
        lappend env(translateTableProt) "R cga"
        lappend env(translateTableProt) "R aga"
        lappend env(translateTableProt) "R agg"
        lappend env(translateTableProt) "R cgg"
        lappend env(translateTableProt) "N aat"
        lappend env(translateTableProt) "N aac"
        lappend env(translateTableProt) "D gat"
        lappend env(translateTableProt) "D gac"
        lappend env(translateTableProt) "C tgt"
        lappend env(translateTableProt) "C tgc"
        lappend env(translateTableProt) "Q caa"
        lappend env(translateTableProt) "Q cag"
        lappend env(translateTableProt) "E gaa"
        lappend env(translateTableProt) "E gag"
        lappend env(translateTableProt) "G ggt"
        lappend env(translateTableProt) "G ggc"
        lappend env(translateTableProt) "G gga"
        lappend env(translateTableProt) "G ggg"
        lappend env(translateTableProt) "H cat"
        lappend env(translateTableProt) "H cac"
        lappend env(translateTableProt) "I att"
        lappend env(translateTableProt) "I atc"
        lappend env(translateTableProt) "I ata"
        lappend env(translateTableProt) "M atg Start"
        lappend env(translateTableProt) "L tta"
        lappend env(translateTableProt) "L ttg"
        lappend env(translateTableProt) "L ctt"
        lappend env(translateTableProt) "L ctc"
        lappend env(translateTableProt) "L cta"
        lappend env(translateTableProt) "L ctg"
        lappend env(translateTableProt) "K aaa"
        lappend env(translateTableProt) "K aag"
        lappend env(translateTableProt) "F ttc"
        lappend env(translateTableProt) "F ttt"
        lappend env(translateTableProt) "P cct"
        lappend env(translateTableProt) "P cca"
        lappend env(translateTableProt) "P ccc"
        lappend env(translateTableProt) "P ccg"
        lappend env(translateTableProt) "S tct"
        lappend env(translateTableProt) "S tcc"
        lappend env(translateTableProt) "S tca"
        lappend env(translateTableProt) "S tcg"
        lappend env(translateTableProt) "S agt"
        lappend env(translateTableProt) "S agc"
        lappend env(translateTableProt) "T act"
        lappend env(translateTableProt) "T acc"
        lappend env(translateTableProt) "T aca"
        lappend env(translateTableProt) "T acg"
        lappend env(translateTableProt) "W tgg"
        lappend env(translateTableProt) "Y tat"
        lappend env(translateTableProt) "Y tac"
        lappend env(translateTableProt) "V gtt"
        lappend env(translateTableProt) "V gtc"
        lappend env(translateTableProt) "V gta"
        lappend env(translateTableProt) "V gtg"
        lappend env(translateTableProt) "* tag"
        lappend env(translateTableProt) "* tga"
        lappend env(translateTableProt) "* taa"
    } else {
        while {[gets $ft line] ne -1} {
            set line "{[regsub -all {\t} $line "\} \{"]}"
            if {[llength $line] > 1} {
                foreach ent $line {
                    lappend env(translateTableProt) $ent
                }
            }
        }
    }
    
    set checkedImg [image create photo -file "[pwd]/images/checked.gif"]
    set uncheckedImg [image create photo -file "[pwd]/images/unchecked.gif"]
    set linkImg [image create photo -file "[pwd]/images/link.ppm"]
    set linkRedImg [image create photo -file "[pwd]/images/link_red.ppm"]
    set linkGreenImg [image create photo -file "[pwd]/images/link_green.ppm"]
    set closeImg [image create photo -file "[pwd]/images/close.ppm"]
    
    wm title . "T-ACE"
    wm minsize . 800 650
    wm protocol . WM_DELETE_WINDOW "areYouSurePopUp {Close T-ACE} {Are you sure you want to close?} {exit}"
    
    frame .menubar -relief raised -bd 2
    pack .menubar -fill x
    
    frame .result
    #Notebook 1
    frame .result.notebook1 -bd 2 -relief groove
    set notebook [NoteBook .result.notebook1.nb]
    # Database Info
    set frame [$notebook insert end db_info -text "Database info"]
    scrollbar $frame.y -orient vertical -command "$frame.panel yview"
    text $frame.panel -height 1 -background white -yscrollcommand "$frame.y set"
    frame $frame.1
    frame $frame.1.table
    
    scrollbar $frame.1.table.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.1.x -orient horizontal -command "$frame.1.table.l xview"
    frame $frame.1.buts
    button $frame.1.buts.add -text "Add Run" -command "db_info_run_add_window"
    button $frame.1.buts.change -text "Save changes" -command "db_info_run_change"
    button $frame.1.buts.coverage -text "Coverage" -command "db_info_run_coverage"
    button $frame.1.buts.delete -text "Delete selected" -command "db_info_run_delete_window"
    set nb1_tl_database_info $frame.1.table.l
    tablelist::tablelist $nb1_tl_database_info \
        -width 60 -height 1 -showseparators 1 -stripebackground lightblue \
        -columns {
            0 "" 0 "color" 0 "A/B" \
            0 "run id" 0 "description" 0 "treatment" 0 "sequences" 0 "assembled" 0 "singletons" 0 "sequencer" \
            0 "type" 0 "runs" 0 "date in" 0 "date out" 0 "data" 0 "comment"} \
        -labelcommand "$nb1_tl_database_info finishediting; tablelist::sortByColumn" \
        -exportselection 0 \
        -stretch {3 4 6 12} \
        -selectmode single \
        -editendcommand editEndCmd \
        -yscrollcommand "$frame.1.table.y set" \
        -xscrollcommand "$frame.1.x set" \
        -background white
    $nb1_tl_database_info columnconfigure 0 \
        -editable yes \
        -editwindow checkbutton \
        -formatcommand emptystr \
        -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
        -labelcommand "table_selection"
    $nb1_tl_database_info columnconfigure 3 -sortmode dictionary -align left
    $nb1_tl_database_info columnconfigure 4 -sortmode dictionary -align left -editable yes
    $nb1_tl_database_info columnconfigure 5 -sortmode dictionary -align left -editable yes
    $nb1_tl_database_info columnconfigure 6 -sortmode real -align right -editable yes
    $nb1_tl_database_info columnconfigure 7 -sortmode real -align right -editable yes
    $nb1_tl_database_info columnconfigure 8 -sortmode real -align right -editable yes
    for {set c 9} {$c <= 15} {incr c} {
        $nb1_tl_database_info columnconfigure $c -sortmode dictionary -editable yes -align left
    }
    
    if {$env(db_info.assembled) eq "+"} {
        $nb1_tl_database_info columnconfigure 7 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 7 -hide yes
    }
    if {$env(db_info.data) eq "+"} {
        $nb1_tl_database_info columnconfigure 15 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 15 -hide yes
    }
    if {$env(db_info.comment) eq "+"} {
        $nb1_tl_database_info columnconfigure 14 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 14 -hide yes
    }
    if {$env(db_info.dateIn) eq "+"} {
        $nb1_tl_database_info columnconfigure 12 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 12 -hide yes
    }
    if {$env(db_info.dateOut) eq "+"} {
        $nb1_tl_database_info columnconfigure 13 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 13 -hide yes
    }
    if {$env(db_info.description) eq "+"} {
        $nb1_tl_database_info columnconfigure 4 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 4 -hide yes
    }
    if {$env(db_info.id_run) eq "+"} {
        $nb1_tl_database_info columnconfigure 3 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 3 -hide yes
    }
    if {$env(db_info.runs) eq "+"} {
        $nb1_tl_database_info columnconfigure 11 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 11 -hide yes
    }
    if {$env(db_info.sequencer) eq "+"} {
        $nb1_tl_database_info columnconfigure 9 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 9 -hide yes
    }
    if {$env(db_info.sequences) eq "+"} {
        $nb1_tl_database_info columnconfigure 6 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 6 -hide yes
    }
    if {$env(db_info.singletons) eq "+"} {
        $nb1_tl_database_info columnconfigure 8 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 8 -hide yes
    }
    if {$env(db_info.treatment) eq "+"} {
        $nb1_tl_database_info columnconfigure 5 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 5 -hide yes
    }
    if {$env(db_info.type) eq "+"} {
        $nb1_tl_database_info columnconfigure 10 -hide no
    } else {
        $nb1_tl_database_info columnconfigure 10 -hide yes
    }
    
    pack $frame.1.buts.add $frame.1.buts.change $frame.1.buts.delete -side left; pack $frame.1.buts.coverage -side right
    pack $frame.1.table.y -side left -fill both; pack $frame.1.table.l -side right -fill both -expand true
    pack $frame.1.table -side top -fill both -expand true; pack $frame.1.buts $frame.1.x -side bottom -fill both
    pack $frame.y -side left -fill both; pack $frame.panel $frame.1 -side left -fill both -expand true
    
    # Database Browser  
    set frame [$notebook insert end dbb -text "Database browser"]
    frame $frame.0
    ComboBox $frame.0.feat -modifycmd {getRefs .result.notebook1.nb.fdbb.0.feat} -width 15 -hottrack 1 -background white -text "all" -values {{all} {with hits} {without hits} {with comment}} -state normal
    label $frame.0.label0 -text "    "
    button $frame.0.first -text "<<" -command "database_browser_showSeq 0"
    button $frame.0.prev -text "<"  -command "database_browser_showSeq 2"
    label $frame.0.label1 -text ""
    label $frame.0.label2 -text " to "
    label $frame.0.label3 -text ""
    label $frame.0.label4 -text ""
    button $frame.0.next -text ">" -command "database_browser_showSeq 3"
    button $frame.0.last -text ">>" -command "database_browser_showSeq 1"
    frame $frame.0.goto -bd 2 -relief groove
    label $frame.0.goto.label -text "Entry: "
    entry $frame.0.goto.ent  -width 6 -background white -textvariable database_browser_goto
    button $frame.0.goto.but -text "Go" -command "database_browser_showSeq 4"
    frame $frame.0.size -bd 2 -relief groove
    label $frame.0.size.label -text "Min. size: "
    entry $frame.0.size.ent -width 6 -background white -textvariable min_contig_size
    button $frame.0.size.but -text "Set" -command "contig_size_confirm; fillTable .result.notebook1.nb.fdbb.1.table.l 0 $database_browser_showSeq"
    frame $frame.0.search -bd 2 -relief groove
    entry $frame.0.search.ent  -width 26 -background white -textvariable database_browser_search
    button $frame.0.search.but -text "Search" -command "search_quick 0"
    
    frame $frame.1
    frame $frame.1.table
    
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb1_tl_database_browser $frame.1.table.l
    tablelist::tablelist $nb1_tl_database_browser \
            -width 110 -height 1 -showseparators 1 -stripebackground lightblue \
            -columns {
                0 "" 0 "nr" \
                        0 "seq name" 0 "length" 0 "reads" 0 "description" 0 "proteins" 0 "blast" \
                        0 "prodom" 0 "coil" 0 "gene3d" 0 "go" 0 "interpro" 0 "kegg" 0 "panther" 0 "patternscan" \
                        0 "pfam" 0 "pir" 0 "profilescan" 0 "smart" 0 "superfamily" 0 "tigr" 0 "coverage" 0 "id_seq" 0 "dbName"} \
            -labelcommand "$nb1_tl_database_browser finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch 2 \
            -stretch 5 \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb1_tl_database_browser columnconfigure 0 \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
            
    $nb1_tl_database_browser columnconfigure 1 -sortmode real -align right
    $nb1_tl_database_browser columnconfigure 2 -sortmode dictionary
    $nb1_tl_database_browser columnconfigure 3 -sortmode real -align right
    $nb1_tl_database_browser columnconfigure 4 -sortmode real -align right
    $nb1_tl_database_browser columnconfigure 5 -sortmode dictionary -align left
    $nb1_tl_database_browser columnconfigure 23 -hide yes
    $nb1_tl_database_browser columnconfigure 24 -hide yes
    
    for {set c 6} {$c <= 22} {incr c} {
        $nb1_tl_database_browser columnconfigure $c -align right -sortmode real
    }     
    if {$env(database_browser.nr) eq "-"} {
        $nb1_tl_database_browser columnconfigure 1 -hide yes
    }
    if {$env(database_browser.length) eq "-"} {
        $nb1_tl_database_browser columnconfigure 3 -hide yes
    }
    if {$env(database_browser.numreads) eq "-"} {
        $nb1_tl_database_browser columnconfigure 4 -hide yes
    }
    if {$env(database_browser.description) eq "-"} {
        $nb1_tl_database_browser columnconfigure 5 -hide yes
    }
    if {$env(database_browser.proteins) eq "-"} {
        $nb1_tl_database_browser columnconfigure 6 -hide yes
    }
    if {$env(database_browser.blast) eq "-"} {
        $nb1_tl_database_browser columnconfigure 7 -hide yes
    }
    if {$env(database_browser.blastprodom) eq "-"} {
        $nb1_tl_database_browser columnconfigure 8 -hide yes
    }
    if {$env(database_browser.coil) eq "-"} {
        $nb1_tl_database_browser columnconfigure 9 -hide yes
    }
    if {$env(database_browser.gene3d) eq "-"} {
        $nb1_tl_database_browser columnconfigure 10 -hide yes
    }
    if {$env(database_browser.go) eq "-"} {
        $nb1_tl_database_browser columnconfigure 11 -hide yes
    }
    if {$env(database_browser.interpro) eq "-"} {
        $nb1_tl_database_browser columnconfigure 12 -hide yes
    }
    if {$env(database_browser.kegg) eq "-"} {
        $nb1_tl_database_browser columnconfigure 13 -hide yes
    }
    if {$env(database_browser.panther) eq "-"} {
        $nb1_tl_database_browser columnconfigure 14 -hide yes
    }
    if {$env(database_browser.pfam) eq "-"} {
        $nb1_tl_database_browser columnconfigure 15 -hide yes
    }
    if {$env(database_browser.pir) eq "-"} {
        $nb1_tl_database_browser columnconfigure 16 -hide yes
    }
    if {$env(database_browser.patternscan) eq "-"} {
        $nb1_tl_database_browser columnconfigure 17 -hide yes
    }
    if {$env(database_browser.profilescan) eq "-"} {
        $nb1_tl_database_browser columnconfigure 18 -hide yes
    }
    if {$env(database_browser.smart) eq "-"} {
        $nb1_tl_database_browser columnconfigure 19 -hide yes
    }
    if {$env(database_browser.superfamily) eq "-"} {
        $nb1_tl_database_browser columnconfigure 20 -hide yes
    }
    if {$env(database_browser.tigr) eq "-"} {
        $nb1_tl_database_browser columnconfigure 21 -hide yes
    }
    if {$env(database_browser.coverage) eq "-"} {
        $nb1_tl_database_browser columnconfigure 22 -hide yes
    }
    
    pack $frame.0.size.label $frame.0.size.ent $frame.0.size.but -side left -fill both
    pack $frame.0.goto.label $frame.0.goto.ent $frame.0.goto.but -side left -fill both
    pack $frame.0.feat $frame.0.label0 $frame.0.first $frame.0.prev $frame.0.label1 $frame.0.label2 $frame.0.label3 \
         $frame.0.label4 $frame.0.next $frame.0.last $frame.0.goto $frame.0.size -side left -fill both
    pack $frame.0.search.ent $frame.0.search.but -side left -fill both -anchor e
    pack $frame.0.search -side right -fill both -anchor e
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0 -side top -fill both
    pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    # Process tab
    set frame [$notebook insert end process -text "Process"]
    frame $frame.0
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command ".result.notebook1.nb raise dbb; close_tab process"
    frame $frame.1
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    set nb1_tl_process $frame.1.table.l
    tablelist::tablelist $nb1_tl_process \
            -width 60 -height 10 -showseparators 1 -stripebackground lightblue \
            -columns {0 "ProcessID" 0 "Status" 0 "Process" 0 "Start" 0 "End" 0 "Database" 0 "result"} \
            -labelcommand "$nb1_tl_process finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch 2 \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -background white
    $nb1_tl_process columnconfigure 6 -hide yes
    frame $frame.2
    text $frame.2.panel -background white -width 100 -height 1
    
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.2.panel -side left -fill both -expand true
    pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 $frame.2 -side top -fill both -expand true
    
    $notebook raise [$notebook page 2]
    pack $notebook -side top -fill both -expand true
    
    # Notebook 2
    frame .result.notebook2 -bd 2 -relief groove
    set notebook [NoteBook .result.notebook2.nb]
    
    #packing Notebooks    
    frame .result.notebook3 -bd 2 -relief groove
    
    pack $notebook -side top -fill both -expand true
    Separator .result.separator -relief ridge
    pack .result -side top -fill both -expand true
    grid .result.notebook1 -sticky news
    grid .result.separator -sticky news
    grid .result.notebook2 -sticky news
    
    grid rowconfigure .result 0 -weight 50
    grid rowconfigure .result 1 -weight 1
    grid rowconfigure .result 2 -weight 50
    
    grid columnconfigure .result 0 -weight 1
    
    #The Buttons
    frame .buts
    frame .status -bd 1 -relief sunken
    label .status.lab -text ""
    label .status.lab2 -text "Mode: nucleotide"
    pack .status.lab -side left -fill both; pack .status.lab2 -side right -anchor e
    pack .status -side top -fill both
    
    # Set up the tags
    .result.notebook1.nb.fdb_info.panel tag configure bold12 -font {-family courier -size 12 -weight bold}
    .result.notebook1.nb.fdb_info.panel tag configure bold11 -font {-family courier -size 11 -weight bold}
    .result.notebook1.nb.fdb_info.panel tag configure bold11r -font {-family courier -size 11 -weight bold} -foreground red2
    .result.notebook1.nb.fdb_info.panel tag configure bold_italics -font {-family courier -size 12 -weight bold -slant italic}
    .result.notebook1.nb.fdb_info.panel tag configure hel -font {-family helvetica -size 16 -weight bold}
    .result.notebook1.nb.fdb_info.panel tag configure helred -font {-family helvetica -size 16 -weight bold} -foreground red4
    .result.notebook1.nb.fdb_info.panel tag configure color1 -foreground red
    .result.notebook1.nb.fdb_info.panel tag configure smallBut -font {-family courier -size 6 -weight bold}
    .result.notebook1.nb.fdb_info.panel tag configure sunken -relief sunken -borderwidth 1
    
    #scaling event: notebooks
    bind .result.separator <ButtonRelease-1> "
    scale_widgets horizontal .result .result.notebook1 .result.notebook2
    "
    bind .result.separator <Enter> "
    .result configure -cursor arrow
    "
    bind .result.separator <Leave> "
    .result configure -cursor \"\"
    "
    
    menu .sequence_edit_rightmenu -tearoff false
    menu .sequence_edit_rightmenu.insert
    menu .sequence_edit_rightmenu.replace

    #Loading Modules
    menu_load_modules ""
    
    #Loading Tab Configuration
    if {[catch {set ft [open [pwd]/conf/tabs_tace.conf r]} ]} {
    } else {
        while {[gets $ft line] != -1} {
            lappend tabL [lindex $line 1]
            set tabArr([lindex $line 1].name) [lindex $line 0]
            set tabArr([lindex $line 1].notebook) [lindex $line 2]
            set tabArr([lindex $line 1].exist) [lindex $line 3]
        }
        foreach tab $tabL {
            if {$tabArr($tab.exist) eq 0} {
                catch {.result.$tabArr($tab.notebook).nb delete $tab 0}
            }
        }
    }
    
    #raising database browser
    .result.notebook1.nb raise dbb
    
    tkwait visibility .
    
    if {[catch {set ft [open [pwd]/conf/db_connections.conf r]} ]} {
        errorPopUp "Error" "Could not read database connections file,\nplease add new database conncetion."
    } else {
        set connections 0
        while {[gets $ft line] ne -1} {
            if {[lindex $line 0] ne ""} {
                lappend env(connections) [lindex $line 0]
                set env(host_[lindex $line 0]) [lindex $line 1]
                set env(port_[lindex $line 0]) [lindex $line 2]
                set env(parentDB_[lindex $line 0]) [lindex $line 3]
                if {[lindex $line 4] ne ""} {
                    set env(folderServer_[lindex $line 0]) [lindex $line 4]
                } else {
                    set env(folderServer_[lindex $line 0]) " "
                }
                if {[lindex $line 5] ne ""} {
                    set env(userServer_[lindex $line 0]) [lindex $line 5]
                } else {
                    set env(userServer_[lindex $line 0]) " "
                }
                if {[lindex $line 6] ne ""} {
                    set env(passwdServer_[lindex $line 0]) [lindex $line 6]
                } else {
                    set env(passwdServer_[lindex $line 0]) " "
                }
                set connections 1
            }
        }
        close $ft
        set env(connections) [lsort -unique $env(connections)]
        
        if {$connections} {
            if {[catch {set ft [open [pwd]/conf/login.conf r]} ]} {
                set env(currentConnection) [lindex $env(connections) 0]
            } else {
                gets $ft line
                set env(user) [lindex $line 0]
                set env(currentConnection) [lindex $line 1]
            }
            if {[catch {
                    set env(host) $env(host_$env(currentConnection))
                }]} {
                set env(currentConnection) [lindex $env(connections) 0]
                set env(host) $env(host_$env(currentConnection))
            }
            set env(port) $env(port_$env(currentConnection))
            set env(parentDB) $env(parentDB_$env(currentConnection))
            set env(folderServer) $env(folderServer_$env(currentConnection))
            set env(userServer) $env(userServer_$env(currentConnection))
            set env(passwdServer) $env(passwdServer_$env(currentConnection))
            #Login
            database_login_window
        } else {
            set env(connections) " "
            errorPopUp "Error" "No connections in database connections file,\nplease add new database conncetion."
        }
    }
}

proc scale_widgets {orientation wRoot w1 w2} {
    global w_end
    
    if {$orientation eq "vertical"} {
        set w_start [winfo rootx $wRoot]
        set w_end [expr [winfo pointerx $wRoot.separator] - $w_start]
        set w_width [winfo width $wRoot]
        set w1_width [winfo width $w1]
        set w2_width [winfo width $w2]
        set space [expr 100.0 / ($w1_width.0 + $w2_width.0)]
        set w1 [lindex [split [expr $space * $w_end] .] 0]
        set w2 [lindex [split [expr $space * [expr $w_width - $w_end]] .] 0]
        if {$w1 < 0} {
            set w1 0
        } elseif {$w2 < 0} {
            set w2 0
        }
        grid columnconfigure $wRoot 0 -weight $w1
        grid columnconfigure $wRoot 2 -weight $w2
    } else {
        set w_start [winfo rooty $wRoot]
        set w_end [expr [winfo pointery $wRoot.separator] - $w_start]
        set w_height [winfo height $wRoot]
        set w1_height [winfo height $w1]
        set w2_height [winfo height $w2]
        set space [expr 100.0 / ($w1_height.0 + $w2_height.0)]
        set w1 [lindex [split [expr $space * $w_end] .] 0]
        set w2 [lindex [split [expr $space * [expr $w_height - $w_end]] .] 0]
        if {$w1 < 0} {
            set w1 0
        } elseif {$w2 < 0} {
            set w2 0
        }
        grid rowconfigure $wRoot 0 -weight $w1
        grid rowconfigure $wRoot 2 -weight $w2
    }
}

proc sequences_add {page} {
    global env
    global checkedImg
    global uncheckedImg
       
    set page2 [.result.notebook1.nb raise]
    if {[lindex [split $page2 _] 0] eq "prj" || $page2 eq "blast" || $page2 eq "dbb" || $page2 eq "sb"} {
        set tl1 ".result.notebook1.nb.f$page.1.table.l"
        if {$page2 eq "blast"} {
            set tl2 ".result.notebook1.nb.f[.result.notebook1.nb raise].1.tab.table.l"
        } else {
            set tl2 ".result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l"
        }
        
        $tl1 finishediting
        $tl2 finishediting
        if {[$tl1 columncget 0 -labelimage] eq "image1"} {
            set use 1
        } else {
            set use 0
        }
        if {[lindex [$tl1 get end] 1] ne ""} {
            set num [lindex [$tl1 get end] 1]
        } else {
            set num 0
        }
        if {$tl2 eq ".result.notebook1.nb.fdbb.1.table.l"} {
            set i 0
            while {[$tl2 get $i] ne ""} {
                if {[lindex [$tl2 get $i] 0] eq 1} {
                    incr num
                    set ent [lrange [$tl2 get $i] 2 end]
                    $tl1 insert end "$use $num $ent"
                    $tl1 cellconfigure end,0 -image [expr {$use ? $checkedImg : $uncheckedImg}]
                }
                incr i
            }
        } elseif {$tl2 eq ".result.notebook1.nb.fsb.1.table.l"} {
            set i 0
            while {[$tl2 get $i] ne ""} {
                if {[lindex [$tl2 get $i] 0] eq 1} {
                    set nr [lindex [$tl2 get $i] 1]
                    set j 0
                    while {[.result.notebook1.nb.fdbb.1.table.l get $j] ne ""} {
                        if {$nr eq [lindex [$tl2 get $j] 1]} {
                            incr num
                            set ent [lrange [.result.notebook1.nb.fdbb.1.table.l get $j] 2 end]
                            break
                        }
                        incr j
                    }
                    $tl1 insert end "$use $num $ent"
                    $tl1 cellconfigure end,0 -image [expr {$use ? $checkedImg : $uncheckedImg}]
                }
                incr i
            }
        } elseif {$tl2 eq ".result.notebook1.nb.fblast.1.tab.table.l"} {
            set i 0
            while {[$tl2 get $i] ne ""} {
                if {[lindex [$tl2 get $i] 0] eq 1} {
                    lappend nameL "[lindex [$tl2 get $i] 2] [lindex [$tl2 get $i] 12]"
                }
                incr i
            }
            unset i
            set nameL [lsort -unique $nameL]
            set db [lindex [lindex $nameL 0] 1]
            set tmpString ""
            set num 0
            foreach name $nameL {
                if {$db eq [lindex $name 1]} {
                    append tmpString ", '[lindex $name 0]'"
                } else {
                    set tmpString [string range $tmpString 2 end]
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage, id_seq FROM $db.seq_info WHERE name IN ($tmpString)"}}]]
                    set tmpString ""; set inf ""
                    foreach ent $sql_res {
                        incr num
                        $tl1 insert end "$use $num [lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A {[lindex $ent 4]} [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $db"
                        $tl1 cellconfigure end,0 -image [expr {$use ? $checkedImg : $uncheckedImg}]
                    }
                    set db [lindex $name 1]
                    append tmpString ", '[lindex $name 0]'"
                }
            }
            set tmpString [string range $tmpString 2 end]
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage, id_seq FROM $db.seq_info WHERE name IN ($tmpString)"}}]]
            set tmpString ""; set inf ""
            foreach ent $sql_res {
                incr num
                $tl1 insert end "$use $num [lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A {[lindex $ent 4]} [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $db"
                $tl1 cellconfigure end,0 -image [expr {$use ? $checkedImg : $uncheckedImg}]
            }
            unset sql_res; unset inf; unset tmpString; unset num
        } else {
            set i 0
            set inf ""
            while {[$tl2 get $i] ne ""} {
                if {[lindex [$tl2 get $i] 0] eq 1} {
                    incr num
                    set inf [lrange [$tl2 get $i] 2 end]
                    $tl1 insert end "$use $num $inf $env(dbName)"
                    $tl1 cellconfigure end,0 -image [expr {$use ? $checkedImg : $uncheckedImg}]
                }
                incr i
            }
            unset inf; unset i; unset num
        }
        # Bindings.
        bind [$tl1 bodypath] <Button-1> "
        set y \[$tl1 nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl1 get \$y\] 2\]
        set env(contig.dbName) \[lindex \[$tl1 get \$y\] end\]
        update_info_get_name \$name name
        "
    } else  {
        errorPopUp "Error" "Cannot add sequences from this tab.\nPlease raise the 'Database browser', 'Sequence browser',\n'Blast'-tab or a project tab."
    }
}

proc sequences_remove {} {
    set page [.result.notebook1.nb raise]
    
    if {[lindex [split $page _] 0] eq "prj"} {
        set tl ".result.notebook1.nb.f$page.1.table.l"
        $tl finishediting
        set i 0
        set stop 1
        while {$stop} {
            if {[lindex [$tl get $i] 0] ne ""} {
                if {[lindex [$tl get $i] 0] eq 1} {
                    $tl delete $i
                } else {
                    incr i
                }
            } else {
                set stop 0
            }
        }
        set i 0
        set stop 1
        while {$stop} {
            if {[lindex [$tl get $i] 0] ne ""} {
                $tl cellconfigure $i,1 -text [expr $i + 1]
                incr i
            } else {
                set stop 0
            }
        }
        unset i; unset stop; unset tl; unset page
    } else {
        errorPopUp "Error" "Cannot remove entries from this tab.\nPlease raise a project tab."
    }
}

proc sequences_save {ofile type idL mode descriptionCheck} {
    global env
    global checkOrder
    
    set output ""
    if {$ofile eq 0} {
        if {$mode eq "sequences"} {
            set ofile [browse save {{{Fasta Files} {.fa .fas .fna .fasta .txt} } {{All Files} * }} "$env(dbName)_sequences.fasta"]
        } else {
            set ofile [browse save {{{Text Files} {.txt} } {{All Files} * }} "$env(dbName)_$mode.txt"]
        }
    }
    if {$ofile ne ""} {
        if {$type eq 1} {
            set output [.sequences_show.1.panel get -displaychars 1.0 end]
            set out [open "$ofile" w]
            puts $out $output
            close $out
        } else {
            if {$mode eq "hits"} {
                set page [.result.notebook2.nb raise]
                set t .result.notebook2.nb.f$page.1.table.l
                catch {$t finishediting}
                set i 0
                set idL ""
                if {$page eq "br"} {
                    set query [.result.notebook2.nb.f$page.0.label1 cget -text]
                    set header "\tDB\tID\torganism\tproduct\tdescription\tcoverage\tperf\tstart\tend\tlength\teval\tscore\n"
                    while {[lindex [$t get $i] 0] ne ""} {
                        if {[lindex [$t get $i] 0] eq 1} {
                            lappend idL "[lrange [$t get $i] 1 12]"
                        }
                        incr i
                    }
                } elseif {$page eq "ips"} {
                    set query [.result.notebook2.nb.f$page.0.label1 cget -text]
                    set header "\tprot name\tfeature\tID\tdescription\tstart\tend\tlength\teval\n"
                    while {[lindex [$t get $i] 0] ne ""} {
                        if {[lindex [$t get $i] 0] eq 1} {
                            lappend idL "[lrange [$t get $i] 1 8]"
                        }
                        incr i
                    }
                } elseif {$page eq "go"} {
                    set query [.result.notebook2.nb.f$page.0.label1 cget -text]
                    set header "\tprot name\tID\tcategory\tname\tdescription\n"
                    while {[lindex [$t get $i] 0] ne ""} {
                        if {[lindex [$t get $i] 0] eq 1} {
                            lappend idL "[lrange [$t get $i] 1 5]"
                        }
                        incr i
                    }
                } elseif {$page eq "kegg"} {
                    set query [.result.notebook2.nb.f$page.0.label1 cget -text]
                    set header "\tID\tname\tdescription\n"
                    while {[lindex [$t2 get $i] 0] ne ""} {
                        if {[lindex [$t2 get $i] 0] eq 1} {
                            lappend idL "[lrange [$t2 get $i] 1 3]"
                        }
                        incr i
                    }
                } elseif {$page eq "primer"} {
                    set query [.result.notebook2.nb.f$page.0.label1 cget -text]
                    set header "\tpenalty\tF penalty\tR penalty\tForward primer\tReverse primer\tprod. size\tF len\tR len\tF pos\tR pos\topt. Ta\tprod Tm\tTm diff. (prod. vs oligo)\tF Tm\tR Tm\tF GC\tR GC\tpair compl.\tpair compl. end\tF self align\tR self align\tF self align end\tR self align end\tF end stability\tR end stability\t salt conc. (mM)\toligo conc. ()\n"
                    while {[lindex [$t2 get $i] 0] ne ""} {
                        if {[lindex [$t2 get $i] 0] eq 1} {
                            lappend idL "[lrange [$t2 get $i] 1 27"
                        }
                        incr i
                    }
                } elseif {$page eq "repeats"} {
                    set query [.result.notebook2.nb.f$page.0.label1 cget -text]
                    set header "\tunit length\tunit\tstart\tend\tlength\tscore\tperfection\tmismatches\tinsertions\tdeletions\n"
                    while {[lindex [$t2 get $i] 0] ne ""} {
                        if {[lindex [$t2 get $i] 0] eq 1} {
                            lappend idL "[lrange [$t2 get $i] 1 10"
                        }
                        incr i
                    }
                } else {
                    errorPopUp "Error" "Cannot save any\nhits from selected tab."
                }
                if {$idL ne ""} {
                    set output ""
                    append output "$query\n$header"
                    foreach id $idL {
                        set hit ""
                        foreach i $id {append hit "\t$i"}
                        append output "$hit\n"
                    }
                    unset hit
                    if {$output ne ""} {
                        set out [open $ofile w]
                        puts $out $output
                        close $out
                        unset output
                    }
                }
            } else {
                set page [.result.notebook1.nb raise]
                if {$page eq "db_info" && $mode eq "sequences"} {
                    if {$idL eq "all"} {
                        set queL ""
                        if {$type eq "nuc"} {
                            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide $checkOrder"}}]]
                            foreach ent $sql_res {
                                lappend queL "{[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]} [lindex $ent 3]"
                            }
                            unset sql_res
                        } elseif {$type eq "prot"} {
                            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, frame, orf, length, sequence FROM $env(dbName).sequences_protein $checkOrder"}}]]
                            foreach ent $sql_res {
                                lappend queL "{[lindex $ent 0] frame=[lindex $ent 1] orf=[lindex $ent 2] length=[lindex $ent 3]} [lindex $ent 4]"
                            }
                            unset sql_res
                        } elseif {$type eq "read"} {
                            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, id_run, length, sequence FROM $env(dbName).sequences_read $checkOrder"}}]]
                            foreach ent $sql_res {
                                lappend queL "{[lindex $ent 0] run=[lindex $ent 1] length=[lindex $ent 2]} [lindex $ent 3]"
                            }
                            unset sql_res
                        }
                    } else {
                        set queL ""
                        if {$type eq "nuc"} {
                            if {$descriptionCheck ne "" && $descriptionCheck ne "with hits" && $descriptionCheck ne "without hits" && $descriptionCheck ne "selected runs"} {
                                set name ""
                                if {[lindex $descriptionCheck 0] eq "blast"} {
                                    set descriptionCheckHits "[lindex $descriptionCheck 0]_hits"
                                    if {[lindex $descriptionCheck 2] ne ""} {
                                        set descriptionCheck [lindex $descriptionCheck 2]
                                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $env(dbName).sequences_nucleotide.name AS name, $env(dbName).sequences_nucleotide.length AS length, $env(dbName).sequences_nucleotide.numreads AS numreads, A1.id AS id, A1.description AS des, $env(dbName).sequences_nucleotide.sequence AS sequence FROM $env(dbName).sequences_nucleotide INNER JOIN (SELECT $env(dbName).$descriptionCheckHits.id_seq AS id_seq, refdb.$descriptionCheck.id AS id, refdb.$descriptionCheck.description AS description FROM refdb.$descriptionCheck INNER JOIN $env(dbName).$descriptionCheckHits ON refdb.$descriptionCheck.id = $env(dbName).$descriptionCheckHits.id) A1 ON A1.id_seq = $env(dbName).sequences_nucleotide.id_seq"}}]]
                                        foreach ent $sql_res {
                                            if {[lindex $ent 0] ne $name} {
                                                lappend queL "{[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]; [lindex $ent 3] [lindex $ent 4]} [lindex $ent 5]"
                                                set name [lindex $ent 0]
                                            }
                                        }
                                    } else {
                                        #hier noch einfügen
                                    }
                                } else {
                                    set descriptionCheckHits "${descriptionCheck}_hits"
                                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $env(dbName).sequences_nucleotide.name AS name, $env(dbName).sequences_nucleotide.length AS length, $env(dbName).sequences_nucleotide.numreads AS numreads, A1.id AS id, A1.description AS des, $env(dbName).sequences_nucleotide.sequence AS sequence FROM $env(dbName).sequences_nucleotide INNER JOIN (SELECT $env(dbName).$descriptionCheckHits.id_seq AS id_seq, refdb.$descriptionCheck.id AS id, refdb.$descriptionCheck.description AS description FROM refdb.$descriptionCheck INNER JOIN $env(dbName).$descriptionCheckHits ON refdb.$descriptionCheck.id = $env(dbName).$descriptionCheckHits.id) A1 ON A1.id_seq = $env(dbName).sequences_nucleotide.id_seq"}}]]
                                    foreach ent $sql_res {
                                        if {[lindex $ent 0] ne $name} {
                                            lappend queL "{[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]; [lindex $ent 3] [lindex $ent 4]} [lindex $ent 5]"
                                            set name [lindex $ent 0]
                                        }
                                    }
                                }
                                unset sql_res; unset name
                            } else {
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE id_seq IN ($idL) $checkOrder"}}]]
                                foreach ent $sql_res {
                                    lappend queL "{[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]} [lindex $ent 3]"
                                }
                                unset sql_res
                            }
                        } elseif {$type eq "prot"} {
                            if {$descriptionCheck ne "" && $descriptionCheck ne "with hits" && $descriptionCheck ne "without hits"} {
                                set descriptionCheckHits "${descriptionCheck}_hits"
                                set name ""
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $env(dbName).sequences_protein.name AS name, $env(dbName).sequences_protein.frame AS frame, $env(dbName).sequences_protein.orf AS orf, $env(dbName).sequences_protein.length AS length, A1.id AS id, A1.description AS des, $env(dbName).sequences_protein.sequence AS sequence FROM $env(dbName).sequences_protein INNER JOIN (SELECT $env(dbName).$descriptionCheckHits.id_prot AS id_prot, refdb.$descriptionCheck.id AS id, refdb.$descriptionCheck.description AS description FROM refdb.$descriptionCheck INNER JOIN $env(dbName).$descriptionCheckHits ON refdb.$descriptionCheck.id = $env(dbName).$descriptionCheckHits.id) A1 ON A1.id_prot = $env(dbName).sequences_protein.id_prot"}}]]
                                foreach ent $sql_res {
                                    if {$data(name) ne $name} {
                                        lappend queL "{[lindex $ent 0] frame=[lindex $ent 1] orf=[lindex $ent 2] length=[lindex $ent 3]; [lindex $ent 4] [lindex $ent 5]} [lindex $ent 6]"
                                        set name [lindex $ent 0]
                                    }
                                }
                                unset sql_res; unset name
                            } else {
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, frame, orf, length, sequence FROM $env(dbName).sequences_protein WHERE id_seq IN ($idL) $checkOrder"}}]]
                                foreach ent $sql_res {
                                    lappend queL "{[lindex $ent 0] frame=[lindex $ent 1] orf=[lindex $ent 2] length=[lindex $ent 3]} [lindex $ent 4]"
                                }
                                unset sql_res
                            }                       
                        } elseif {$type eq "reads"} {
                            if {$idL eq "assembled"} {
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, id_run, length, sequence FROM $env(dbName).sequences_read WHERE singleton = FALSE $checkOrder"}}]]
                                foreach ent $sql_res {
                                    lappend queL "{[lindex $ent 0] run=[lindex $ent 1] length=[lindex $ent 2]} [lindex $ent 3]"
                                }
                                unset sql_res
                            } elseif {$idL eq "singletons"} {
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, id_run, length, sequence FROM $env(dbName).sequences_read WHERE singleton = TRUE $checkOrder"}}]]
                                foreach ent $sql_res {
                                    lappend queL "{[lindex $ent 0] run=[lindex $ent 1] length=[lindex $ent 2]} [lindex $ent 3]"
                                }
                                unset sql_res
                            } else {
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, id_run, length, sequence FROM $env(dbName).sequences_read WHERE id_run = '$idL' $checkOrder"}}]]
                                foreach ent $sql_res {
                                    lappend queL "{[lindex $ent 0] run=[lindex $ent 1] length=[lindex $ent 2]} [lindex $ent 3]"
                                }
                                unset sql_res
                            }
                        }
                    }
                    
                    if {[catch {set fs [open $ofile w]} ]} {
                        .top.search.result.panel insert end "\n\nError while creation of blast sequence list."
                    } else {
                        set start 0
                        foreach que $queL {
                            if {$start} {
                                append res "\n>[lindex $que 0]\n[lindex $que 1]"
                            } else {
                                set start 1
                                append res ">[lindex $que 0]\n[lindex $que 1]"
                            }
                        }
                        puts -nonewline $fs $res
                        unset res
                        close $fs
                        unset queL
                    }
                } elseif {$page eq "blast"} {
                    set t .result.notebook1.nb.fblast.1.tab.table.l
                    $t finishediting
                    set output ""
                    if {$mode eq "sequences"} {
                        set db [lindex [$t get end] 12]
                        set end [lindex [$t get end] 2]
                        set stop 1
                        set i 0
                        set idL ""
                        while {$stop} {
                            set id_seq [lindex [$t get $i] 2]
                            if {[lindex [$t get $i] 0] eq 1} {
                                lappend idL $id_seq
                            }
                            if {$id_seq eq $end} {
                                set stop 0
                            }
                            incr i
                        }
                        if {[lindex [split $db _] end] eq "reads"} {
                            if {$idL ne ""} {
                                foreach id $idL {append tmpString ", '$id'"}
                                set tmpString [string range $tmpString 2 end]
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, sequence FROM $env(dbName).sequences_read WHERE name IN ($tmpString)"}}]]
                                foreach ent $sql_res {
                                    append output ">[lindex $ent 0]\tlength=[lindex $ent 1]\n[lindex $ent 2]\n"
                                }
                                unset sql_res
                            }
                        } else {
                            if {$idL ne ""} {
                                foreach id $idL {append tmpString ", '$id'"}
                                set tmpString [string range $tmpString 2 end]
                                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE name IN ($tmpString)"}}]]
                                foreach ent $sql_res {
                                    append output ">[lindex $ent 0]\tlength=[lindex $ent 1]\tnumreads=[lindex $ent 2]\n[lindex $ent 3]\n"
                                }
                                unset sql_res
                            }
                        }
                    } elseif {$mode eq "blast_results"} {
                        set i 0
                        set idL ""
                        while {[lindex [$t get $i] 0] ne ""} {
                            if {[lindex [$t get $i] 0] eq 1} {
                                lappend idL "{[lindex [$t get $i] 1]} {[lrange [$t get $i] 2 10]}"
                            }
                            incr i
                        }
                        if {$idL ne ""} {
                            set query ""
                            foreach id $idL {
                                if {[lindex $id 0] ne $query} {
                                    set query [lindex $id 0]
                                    append output "$query\n"
                                    set hit ""
                                    foreach i [lindex $id 1] {append hit "\t$i"}
                                    append output "\tHit\tperf\tlength\teval\tscore\tqStart\tqEnd\thStart\thEnd\n$hit\n"
                                } else {
                                    set hit ""
                                    foreach i [lindex $id 1] {append hit "\t$i"}
                                    append output "$hit\n"
                                }
                            }
                            unset hit
                        }
                    }
                    if {$output ne ""} {
                        set out [open $ofile w]
                        puts $out $output
                        close $out
                        unset output
                    }
                } elseif {[lindex [split $page _] 0] eq "prj" || $page eq "dbb" && $mode eq "sequences"} {
                    set t .result.notebook1.nb.f$page.1.table.l
                    $t finishediting
                    set stop 1
                    set i 0
                    set id_seq ""
                    set dbName ""
                    set dbNameL ""
                    while {$stop} {
                        set id_seq [lindex [$t get $i] 23]
                        set dbName [lindex [$t get $i] 24]
                        if {[lindex [$t get $i] 0] eq 1} {
                            lappend dbNameL $dbName
                            lappend idArr($dbName) $id_seq
                        } elseif {$id_seq eq ""} {
                            set stop 0
                        }
                        incr i
                    }
                    unset id_seq; unset dbName
                    set dbNameL [lsort -unique $dbNameL]
                    if {$dbNameL ne ""} {
                        foreach dbName $dbNameL {
                            set tmpString ""
                            foreach id $idArr($dbName) {append tmpString ", '$id'"}
                            set tmpString [string range $tmpString 2 end]
                            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE id_seq IN ($tmpString)"}}]]
                            foreach ent $sql_res {
                                append output ">[lindex $ent 0]\tlength=[lindex $ent 1]\tnumreads=[lindex $ent 2]\n[lindex $ent 3]\n"
                            }
                            unset sql_res; unset idArr($dbName); unset tmpString
                        }
                    }
                    unset dbNameL; unset dbName
                    set out [open $ofile w]
                    puts -nonewline $out $output
                    close $out
                } else {
                    if {$mode eq "sequences"} {
                        errorPopUp "Error" "Cannot save any\nsequences from selected tab."
                    } elseif {$mode eq "blast_results"} {
                        errorPopUp "Error" "Please select the 'Blast'-tab results\nbefore running this option."
                    }
                }
            }
        }
    }   
}

proc sequences_show {mode} {
    global env
    
    set t .sequences_show
    catch {
        toplevel $t
        wm title $t "Selected sequences"
        wm minsize $t 800 400
        
        frame $t.1
        text $t.1.panel -height 15 -background white -width 70 -yscrollcommand "$t.1.y set"
        scrollbar $t.1.y -orient vertical -command "$t.1.panel yview"
        frame $t.buts
        set comm "sequences_save 0 1 0 $mode 0"
        button $t.buts.save -text "Save" -command $comm
        button $t.buts.close -text "Close" -command "destroy $t"
        
        pack $t.1.panel -fill both -side left -expand true; pack $t.1.y -fill both -side left
        pack $t.buts.save $t.buts.close -side left -expand 1 -anchor c
        pack $t.1 -side top -fill both -expand true
        pack $t.buts -side top -fill both
    }
    if {$mode eq "hits"} {
        set page [.result.notebook2.nb raise]
        set t2 .result.notebook2.nb.f$page.1.table.l
        catch {$t2 finishediting}
        set i 0
        set idL ""
        if {$page eq "br"} {
            set query [.result.notebook2.nb.f$page.0.label1 cget -text]
            set header "\tDB\tID\torganism\tproduct\tdescription\tcoverage\tperf\tstart\tend\tlength\teval\tscore\n"
            while {[lindex [$t2 get $i] 0] ne ""} {
                if {[lindex [$t2 get $i] 0] eq 1} {
                    lappend idL "[lrange [$t2 get $i] 1 12]"
                }
                incr i
            }
        } elseif {$page eq "ips"} {
            set query [.result.notebook2.nb.f$page.0.label1 cget -text]
            set header "\tprot name\tfeature\tID\tdescription\tstart\tend\tlength\teval\n"
            while {[lindex [$t2 get $i] 0] ne ""} {
                if {[lindex [$t2 get $i] 0] eq 1} {
                    lappend idL "[lrange [$t2 get $i] 1 8]"
                }
                incr i
            }
        } elseif {$page eq "go"} {
            set query [.result.notebook2.nb.f$page.0.label1 cget -text]
            set header "\tprot name\tID\tcategory\tname\tdescription\n"
            while {[lindex [$t2 get $i] 0] ne ""} {
                if {[lindex [$t2 get $i] 0] eq 1} {
                    lappend idL "[lrange [$t2 get $i] 1 5]"
                }
                incr i
            }
        } elseif {$page eq "kegg"} {
            set query [.result.notebook2.nb.f$page.0.label1 cget -text]
            set header "\tID\tname\tdescription\n"
            while {[lindex [$t2 get $i] 0] ne ""} {
                if {[lindex [$t2 get $i] 0] eq 1} {
                    lappend idL "[lrange [$t2 get $i] 1 3]"
                }
                incr i
            }
        } elseif {$page eq "primer"} {
            set query [.result.notebook2.nb.f$page.0.label1 cget -text]
            set header "\tpenalty\tF penalty\tR penalty\tForward primer\tReverse primer\tprod. size\tF len\tR len\tF pos\tR pos\topt. Ta\tprod Tm\tTm diff. (prod. vs oligo)\tF Tm\tR Tm\tF GC\tR GC\tpair compl.\tpair compl. end\tF self align\tR self align\tF self align end\tR self align end\tF end stability\tR end stability\t salt conc. (mM)\toligo conc. ()\n"
            while {[lindex [$t2 get $i] 0] ne ""} {
                if {[lindex [$t2 get $i] 0] eq 1} {
                    lappend idL "[lrange [$t2 get $i] 1 27"
                }
                incr i
            }
        } elseif {$page eq "repeats"} {
            set query [.result.notebook2.nb.f$page.0.label1 cget -text]
            set header "\tunit length\tunit\tstart\tend\tlength\tscore\tperfection\tmismatches\tinsertions\tdeletions\n"
            while {[lindex [$t2 get $i] 0] ne ""} {
                if {[lindex [$t2 get $i] 0] eq 1} {
                    lappend idL "[lrange [$t2 get $i] 1 10"
                }
                incr i
            }
        } else {
            destroy $t
            errorPopUp "Error" "Cannot display any\nhits from selected tab."
        }
        if {$idL ne ""} {
            $t.1.panel insert end "$query\n$header"
            foreach id $idL {
                set hit ""
                foreach i $id {append hit "\t$i"}
                $t.1.panel insert end "$hit\n"
            }
            unset hit
        }
    } else {
        set page [.result.notebook1.nb raise]
        if {([lindex [split $page _] 0] eq "prj" || $page eq "dbb") && $mode eq "sequences"} {
            set t2 .result.notebook1.nb.f$page.1.table.l
            $t2 finishediting
            set stop 1
            set i 0
            set dbNameL ""
            while {$stop} {
                set id_seq [lindex [$t2 get $i] 23]
                set dbName [lindex [$t2 get $i] 24]
                if {[lindex [$t2 get $i] 0] eq 1} {
                    lappend dbNameL $dbName
                    lappend idArr($dbName) $id_seq
                } elseif {$id_seq eq ""} {
                    set stop 0
                }
                incr i
            }
            unset id_seq; unset dbName
            set dbNameL [lsort -unique $dbNameL]
            if {$dbNameL ne ""} {
                foreach dbName $dbNameL {
                    set tmpString ""
                    foreach id $idArr($dbName) {append tmpString ", '$id'"}
                    set tmpString [string range $tmpString 2 end]
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE id_seq IN ($tmpString)"}}]]
                    foreach ent $sql_res {
                        $t.1.panel insert end ">[lindex $ent 0]\tlength=[lindex $ent 1]\tnumreads=[lindex $ent 2]\n[lindex $ent 3]\n"
                    }
                    unset sql_res; unset idArr($dbName); unset tmpString
                }
            }
            unset dbNameL
        } elseif {$page eq "blast"} {
            set t2 .result.notebook1.nb.fblast.1.tab.table.l
            $t2 finishediting
            
            if {$mode eq "sequences"} {
                set db [lindex [$t2 get end] 12]
                set end [lindex [$t2 get end] 2]
                set stop 1
                set i 0
                set idL ""
                while {$stop} {
                    set id_seq [lindex [$t2 get $i] 2]
                    if {[lindex [$t2 get $i] 0] eq 1} {
                        lappend idL $id_seq
                    }
                    if {$id_seq eq $end} {
                        set stop 0
                    }
                    incr i
                }
                if {[lindex [split $db _] end] eq "reads"} {
                    if {$idL ne ""} {
                        foreach id $idL {append tmpString ", '$id'"}
                        set tmpString [string range $tmpString 2 end]
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, sequence FROM $env(dbName).sequences_read WHERE name IN ($tmpString)"}}]]
                        foreach ent $sql_res {
                            $t.1.panel insert end ">[lindex $ent 0]\tlength=[lindex $ent 1]\n[lindex $ent 2]\n"
                        }
                        unset sql_res; unset tmpString
                    }
                } else {
                    if {$idL ne ""} {
                        foreach id $idL {append tmpString ", '$id'"}
                        set tmpString [string range $tmpString 2 end]
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE name IN ($tmpString)"}}]]
                        foreach ent $sql_res {
                            $t.1.panel insert end ">[lindex $ent 0]\tlength=[lindex $ent 1]\tnumreads=[lindex $ent 2]\n[lindex $ent 3]\n"
                        }
                        unset sql_res; unset tmpString
                    }
                }
            } elseif {$mode eq "blast_results"} {
                set end [lindex [$t2 get end] 2]
                set stop 1
                set i 0
                set idL ""
                while {$stop} {
                    if {[lindex [$t2 get $i] 0] eq 1} {
                        lappend idL "{[lindex [$t2 get $i] 1]} {[lrange [$t2 get $i] 2 10]}"
                    }
                    if {[lindex [$t2 get $i] 2] eq $end} {
                        set stop 0
                    }
                    incr i
                }
                if {$idL ne ""} {
                    set query ""
                    foreach id $idL {
                        set hit ""
                        if {[lindex $id 0] ne $query} {
                            set query [lindex $id 0]
                            $t.1.panel insert end "$query\n"
                            foreach i [lindex $id 1] {append hit "\t$i"}
                            set hit [regsub -all {\.} "$hit" ","]
                            $t.1.panel insert end "\tHit\tperf\tlength\teval\tscore\tqStart\tqEnd\thStart\thEnd\n$hit\n"
                        } else {
                            foreach i [lindex $id 1] {append hit "\t$i"}
                            set hit [regsub -all {\.} "$hit" ","]
                            $t.1.panel insert end "$hit\n"
                        }
                    }
                    unset hit
                }
            } else {
                destroy $t
                errorPopUp "Error" "Cannot display any\nhits from selected tab."
            }
        } else {
            destroy $t
            errorPopUp "Error" "Please select the 'Blast'-tab results\nbefore running this option."
        }
    } 
}

proc selection_invert {} {
    global checkedImg
    global uncheckedImg
    
    set page [.result.notebook1.nb raise]
    
    if {$page eq "db_info"} {
        set tl ".result.notebook1.nb.f$page.1.table.l"
    } elseif {$page eq "blast"}  {
        set tl ".result.notebook1.nb.f$page.1.tab.table.l"
    } else {
        set tl ".result.notebook1.nb.f$page.1.table.l"
    }
    
    $tl finishediting
    set i 0
    while {[$tl get $i] ne ""} {
        catch {
            if {[lindex [$tl get $i] 0] eq 1} {
                $tl cellconfigure $i,0 -text 0 -image [expr {0 ? $checkedImg : $uncheckedImg}]
            } else {
                $tl cellconfigure $i,0 -text 1 -image [expr {1 ? $checkedImg : $uncheckedImg}]
            }
        }
        incr i
    }
}

proc database_comment_change_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set t .database_comment
        catch {destroy $t}
        toplevel $t
        wm title $t "Change database comment"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.comment
        label $t.comment.label -text "Comment:"
        text $t.comment.panel -height 10 -width 80 -background white
        
        catch {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT comment FROM $env(dbName).db_comment"}}]]
            foreach sRes $sql_res {
                $t.comment.panel insert end [regsub -all {#zub#} [lindex $sRes 0] "\n"]
            }
            unset sql_res
        }
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "Set" -command "database_comment_change; destroy $t"
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.comment.label $t.comment.panel -side top -fill both
        pack $t.buts.ok $t.buts.cancel -side left -fill both
        pack $t.comment $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    }  
}

proc database_comment_change {} {
    global env
    
    set comment [string trim [.database_comment.comment.panel get -displaychars 1.0 end]]
    set comment [regsub -all {\n} $comment "#zub#"]
    eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.dbcomment('$env(dbName)', '$comment')"}}]
    dbEvnt $env(dbName) 0
    unset comment
}

proc database_blastResult_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{Blast Result Files} {.out} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addBlastResult
            catch {destroy $t}
            toplevel $t
            wm title $t "Add Blast results"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.type
            label $t.type.label -text "Sequence type: "
            ComboBox $t.type.cb -width 10 -hottrack 1 -background white -text "nucleotide" -values {nucleotide protein}
            
            frame $t.db
            label $t.db.label -text "Database identifier: "
            ComboBox $t.db.cb -width 10 -hottrack 1 -background white -text "nt" -values {nr nt uniprot_sprot uniref100}
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Add Blast results from\n$f\nto $env(dbName)\n\nAre you sure?"
            
            set comm "database_blastResult_add \"$f\" getFromWindow; destroy $t"
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.type.label $t.type.cb -side left -fill both
            pack $t.db.label $t.db.cb -side left -fill both
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.type $t.db $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    }
}

proc database_blastResult_add {blastResult_file dbID} {
    global env
    
    if {$dbID eq "getFromWindow"} {
        set dbID [.addBlastResult.db.cb get]
        set type [.addBlastResult.type.cb get]
    }
    
    set ::threadBlastResultAdd [thread::create {
        proc blastResult_add {dbName dbID type blastResult_file processID mainThreadID phpThreadID} {
            set nameL ""
            set blastHitL ""
            set bResL ""
            set num 0
            
            if {$type eq "nucleotide"} {
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, id_seq FROM $dbName.sequences_nucleotide"}}]]
                foreach ent $sql_res {
                    lappend nameL "[lindex [lindex $ent 0] 0] [lindex $ent 1]"
                }
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT $dbName.sequences_nucleotide.name AS name, $dbName.blast_hits.id AS id FROM $dbName.sequences_nucleotide INNER JOIN $dbName.blast_hits ON $dbName.sequences_nucleotide.id_seq = $dbName.blast_hits.id_seq WHERE $dbName.blast_hits.db = '$dbID'"}}]]
                foreach ent $sql_res {
                    lappend blastHitL "[lindex $ent 0] [lindex $ent 1]"
                }
            } else {
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, id_prot FROM $dbName.sequences_protein"}}]]
                foreach ent $sql_res {
                    lappend nameL "[lindex [lindex $ent 0] 0] [lindex $ent 1]"
                }
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT $dbName.sequences_protein.name AS name, $dbName.blast_hits.id AS id FROM $dbName.sequences_protein INNER JOIN $dbName.blast_hits ON $dbName.sequences_protein.id_prot = $dbName.blast_hits.id_prot WHERE $dbName.blast_hits.db = '$dbID'"}}]]
                foreach ent $sql_res {
                    lappend blastHitL "[lindex $ent 0] [lindex $ent 1]"
                }
            }
            unset sql_res
            
            if {[catch {set fs [open $blastResult_file r]}]} {
                puts "can't find $blastResult_file."
            } else {
                returnResult $processID running "getting blast hits..." $dbName 0 $mainThreadID
                flush stdout
                set seq_id ""
                set id ""
                while {[gets $fs line] != -1} {
                    if {$seq_id ne [lindex $line 0]} {
                        set count 0
                        set seq_id [lindex $line 0]
                    }
                    if {[string range [lindex $line 1] 0 5] eq "length"} {
                        if {$dbID eq "uniref100" || $dbID eq "uniref50"} {
                            set tmp [split [lindex $line 2] _]
                            set tmpID [lindex $tmp 1]
                        } else {
                            set tmp [split [lindex $line 2] |]
                            set tmpID [lindex $tmp 1]
                        }
                        if {$id ne $tmpID && $count < 10} {
                            set id $tmpID
                            incr count
                            set in [lsearch $blastHitL "$seq_id $id"]
                            if {$in eq -1} {
                                lappend bResLtmp "$seq_id $id [lindex $line 7] [lindex $line 8] [lindex $line 4] [lindex $line 11] [lindex $line 12] [lindex $line 3]"
                            }
                        }
                    } else {
                        if {$dbID eq "uniref100" || $dbID eq "uniref50"} {
                            set tmp [split [lindex $line 1] _]
                            set tmpID [lindex $tmp 1]
                        } else {
                            set tmp [split [lindex $line 1] |]
                            set tmpID [lindex $tmp 1]
                        }
                        if {$id ne $tmpID && $count < 10} {
                            set id $tmpID
                            incr count
                            set in [lsearch $blastHitL "$seq_id $id"]
                            if {$in eq -1} {
                                lappend bResLtmp "$seq_id $id [lindex $line 6] [lindex $line 7] [lindex $line 3] [lindex $line 10] [lindex $line 11] [lindex $line 2]"
                            }
                        }
                    }
                }
                close $fs
            }
            set bResLtmp [lsort -index 0 $bResLtmp]
            set nameL [lsort -index 0 $nameL]
            foreach ent $bResLtmp {
                foreach name $nameL {
                    if {[lindex $name 0] eq [lindex $ent 0]} {
                        if {$type eq "nucleotide"} {
                            lappend bResL "[lindex $name 1]\t-1\t[lindex $ent 1]\t$dbID\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $ent 4]\t[lindex $ent 5]\t[lindex $ent 6]\t[lindex $ent 7]"
                        } else {
                            lappend bResL "-1\t[lindex $name 1]\t[lindex $ent 1]\t$dbID\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $ent 4]\t[lindex $ent 5]\t[lindex $ent 6]\t[lindex $ent 7]"
                        }
                        lappend seq_idL [lindex $name 1]
                        break
                    } else {
                        set nameL [lreplace $nameL 0 0]
                    }
                }
            }
            set num [llength $bResL]
            unset bResLtmp
            unset blastHitL; unset nameL
            if {$num ne 0} {
                set input ""
                set start 0
                set count 0
                set sum 0
                returnResult $processID running "writing blast hits..." $dbName 0 $mainThreadID
                foreach ent $bResL {
                    incr count
                    if {$start eq 0} {
                        set start 1
                        append input "$ent"
                    } else {
                        append input "\n$ent"
                    }
                    if {$count >= 1500} {
                        set sum [expr $sum + $count]
                        returnResult $processID running "writing blast hits...$sum of $num" $dbName 0 $mainThreadID
                        set sql_res ""
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getDBupload [string tolower $dbName].blast_hits "$input"}}]]
                        set count 0
                        set input ""
                        set start 0
                        if {$sql_res eq "1"} {
                            returnResult $processID running "writing blast hits..." $dbName 1 $mainThreadID
                        } else {
                            returnResult $processID error "$num $dbID blast hits. $sql_res" $dbName "$sql_res" $mainThreadID
                            break
                        }
                        unset sql_res
                    }
                }
                if {$input ne ""} {
                    set sql_res ""
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getDBupload [string tolower $dbName].blast_hits "$input"}}]]
                    if {$sql_res eq "1"} {
                        returnResult $processID finished "$num $dbID blast hits added." $dbName 1 $mainThreadID
                        eval [subst {thread::send -async $mainThreadID {::database_update dbInfo 0}}]
                        if {$type eq "nucleotide"} {
                            eval [subst {thread::send -async $mainThreadID {::database_update seqInfo {$seq_idL}}}]
                        } else {
                            eval [subst {thread::send -async $mainThreadID {::database_update protInfo {$seq_idL}}}]
                        }
                    } else {
                        returnResult $processID error "$num $dbID blast hits. $sql_res" $dbName "$sql_res" $mainThreadID
                    }
                    unset sql_res
                }
            } else {
                returnResult $processID error "$num $dbID blast hits added. No matching results." $dbName 0 $mainThreadID
            }
            unset bResL
        }
        proc returnResult {processID status process dbName result mainThreadID} {
            eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
        }
        thread::wait
    }]
    set processID [llength $env(processL)]
    process_update $processID running "Adding $dbID blast results" $env(dbName) 0
    eval [subst {thread::send -async $::threadBlastResultAdd {blastResult_add $env(dbName) "$dbID" $type "$blastResult_file" $processID $env(mainThreadID) $env(phpThreadID)} result}]
}

proc database_GOTerms_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{GO-terms Files (Blast2GO formats)} {.annot .txt} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addGOTerms
            catch {destroy $t}
            toplevel $t
            wm title $t "Add GO terms"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.type
            label $t.type.label -text "Sequence type: "
            ComboBox $t.type.cb -width 10 -hottrack 1 -background white -text "nucleotide" -values {nucleotide protein}
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Add GO-terms from\n$f\nto $env(dbName)\n\nAre you sure?"
            
            set comm "database_GOTerms_add \"$f\"; destroy $t"
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"

            pack $t.type.label $t.type.cb -side left -fill both
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.type $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    }
}

proc database_GOTerms_add {goTerms_file} {
    global env
    
    set type [.addGOTerms.type.cb get]
    set fileFormat [lindex [split $goTerms_file .] end]
    if {$fileFormat eq "annot" || $fileFormat eq "txt"} {
        set ::threadGOTermsAdd [thread::create {
            proc goTerms_add {dbName type goTerms_file fileFormat processID mainThreadID phpThreadID} {
                set nameL ""
                set goTermL ""
                set goResL ""
                set num 0
                
                if {$type eq "nucleotide"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, id_seq FROM $dbName.sequences_nucleotide"}}]]
                    foreach ent $sql_res {
                        lappend nameL "[lindex [lindex $ent 0] 0] [lindex $ent 1]"
                    }
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT $dbName.sequences_nucleotide.name AS name, $dbName.go_hits.id AS id FROM $dbName.sequences_nucleotide INNER JOIN $dbName.go_hits ON $dbName.sequences_nucleotide.id_seq = $dbName.go_hits.id_seq"}}]]
                    foreach ent $sql_res {
                        lappend blastHitL "[lindex $ent 0] [lindex $ent 1]"
                    }
                } else {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, id_seq, id_prot FROM $dbName.sequences_protein"}}]]
                    foreach ent $sql_res {
                        lappend nameL "[lindex [lindex $ent 0] 0] [lindex $ent 1] [lindex $ent 2]"
                    }
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT $dbName.sequences_protein.name AS name, $dbName.go_hits.id AS id FROM $dbName.sequences_protein INNER JOIN $dbName.go_hits ON $dbName.sequences_protein.id_prot = $dbName.go_hits.id_prot"}}]]
                    foreach ent $sql_res {
                        lappend blastHitL "[lindex $ent 0] [lindex $ent 1]"
                    }
                }
                unset sql_res
                
                if {[catch {set fs [open $goTerms_file r]}]} {
                    puts "can't find $goTerms_file."
                } else {
                    returnResult $processID running "getting GO-terms..." $dbName 0 $mainThreadID
                    flush stdout
                    set seq_id ""
                    set id ""
                    if {$fileFormat eq "annot"} {
                        while {[gets $fs line] != -1} {
                            if {[string range [lindex $line 1] 0 1] eq "GO"} {
                                lappend goResLtmp "[lindex $line 0] [lindex $line 1]"
                            }
                        }
                    } elseif {$fileFormat eq "txt"} {
                        [gets $fs line]
                        set line "\{[regsub -all {\t} $line "\} \{"]\}"
                        if {[lindex $line 0] eq "SeqName" && [lindex $line 3] eq "GO-ID"} {
                            while {[gets $fs line] != -1} {
                                set line "\{[regsub -all {\t} $line "\} \{"]\}"
                                if {[string range [lindex $line 3] 0 1] eq "GO"} {
                                    lappend goResLtmp "[lindex $line 0] [lindex $line 3]"
                                }
                            }
                        } elseif {[string range [lindex $line 2] 0 1] eq "GO"} {
                            lappend goResLtmp "[lindex $line 0] [lindex $line 2]"
                            while {[gets $fs line] != -1} {
                                set line "\{[regsub -all {\t} $line "\} \{"]\}"
                                if {[string range [lindex $line 2] 0 1] eq "GO"} {
                                    lappend goResLtmp "[lindex $line 0] [lindex $line 2]"
                                }
                            }
                        }
                    }
                    close $fs
                }
                set goResLtmp [lsort -index 0 $goResLtmp]
                set nameL [lsort -index 0 $nameL]
                foreach ent $goResLtmp {
                    foreach name $nameL {
                        if {[lindex $name 0] eq [lindex $ent 0]} {
                            if {$type eq "nucleotide"} {
                                lappend goResL "[lindex $name 1]\t-1\t[lindex $ent 1]"
                            } else {
                                lappend goResL "[lindex $name 1]\t[lindex $name 2]\t[lindex $ent 1]"
                            }
                            lappend seq_idL [lindex $name 1]
                            break
                        } else {
                            set nameL [lreplace $nameL 0 0]
                        }
                    }
                }
                set num [llength $goResL]
                unset goResLtmp
                unset goTermL; unset nameL
                if {$num ne 0} {
                    set input ""
                    set start 0
                    set count 0
                    set sum 0
                    returnResult $processID running "writing GO-terms..." $dbName 0 $mainThreadID
                    foreach ent $goResL {
                        incr count
                        if {$start eq 0} {
                            set start 1
                            append input "$ent"
                        } else {
                            append input "\n$ent"
                        }
                        if {$count >= 1500} {
                            set sum [expr $sum + $count]
                            returnResult $processID running "writing GO-terms...$sum of $num" $dbName 0 $mainThreadID
                            set sql_res ""
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getDBupload [string tolower $dbName].go_hits "$input"}}]]
                            set count 0
                            set input ""
                            set start 0
                            if {$sql_res eq "1"} {
                                returnResult $processID running "writing GO-terms..." $dbName 1 $mainThreadID
                            } else {
                                returnResult $processID error "$num GO-terms. $sql_res" $dbName "$sql_res" $mainThreadID
                                break
                            }
                            unset sql_res
                        }
                    }
                    if {$input ne ""} {
                        set sql_res ""
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getDBupload [string tolower $dbName].go_hits "$input"}}]]
                        if {$sql_res eq "1"} {
                            returnResult $processID finished "$num GO-terms added." $dbName 1 $mainThreadID
                            eval [subst {thread::send -async $mainThreadID {::database_update dbInfo 0}}]
                            if {$type eq "nucleotide"} {
                                eval [subst {thread::send -async $mainThreadID {::database_update seqInfo {$seq_idL}}}]
                            } else {
                                eval [subst {thread::send -async $mainThreadID {::database_update protInfo {$seq_idL}}}]
                            }
                        } else {
                            returnResult $processID error "$num GO-terms. $sql_res" $dbName "$sql_res" $mainThreadID
                        }
                        unset sql_res
                    }
                } else {
                    returnResult $processID error "$num GO-terms added. No matching results." $dbName 0 $mainThreadID
                }
                unset goResL
            }
            proc returnResult {processID status process dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        process_update $processID running "Adding GO-terms" $env(dbName) 0
        eval [subst {thread::send -async $::threadGOTermsAdd {goTerms_add $env(dbName) $type "$goTerms_file" "$fileFormat" $processID $env(mainThreadID) $env(phpThreadID)} result}]
    } else {
        errorPopUp "Error" "Unknown file format of GO-term input."   
    } 
}

proc database_create_window {} {
    variable dbn
    set dbn "New_Database"
    set t .newDatabase
    catch {destroy $t}
    toplevel $t
    wm title $t "New_Database"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.ptitle
    label $t.ptitle.label -text "Database title: "
    entry $t.ptitle.ent -textvariable dbn -width 20 -background white
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "OK" -command "database_create; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.ptitle.label $t.ptitle.ent -side left -fill both
    pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
    pack $t.ptitle $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc database_create {} {
    global env
    
    set database [.newDatabase.ptitle.ent get]
    set err [regexp -all {\.} $database]
    if {$err > 0} {
        errorPopUp "Error" "Illegel character in database name."
    } else {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.cdb('$database','$env(user)') AS out"}}]]
        foreach ent $sql_res {
            set out [lindex $ent 0]
        }
        unset sql_res
        if {[string range $out 0 7] ne "Database"} {
            errorPopUp "Error" "$out"
        } else {
            .menubar.file.menu.fmenu delete 0 end
            set dbLtmp [getDBs]
            set env(dbL) " "
            foreach db $dbLtmp {
                lappend env(dbL) $db
            }
            set env(dbL) [lsort $env(dbL)]
            foreach db $env(dbL) {
                set comm "dbEvnt [lindex $db 0] 1; dbEvnt_config [lindex $db 1]"
                .menubar.file.menu.fmenu add command -label "[lindex $db 0]" -command $comm
            }
            dbEvnt $database 1
            dbEvnt_config owner
            catch {blast_dbL}
        }
    }
}
        
proc database_delete_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set t .deleteDatabase
        catch {destroy $t}
        toplevel $t
        wm title $t "Delete Database"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        if {$env(dbName) eq ""} {
            set txt "No database selected"
            set comm "destroy $t"
        } else {
            set txt "Delete: $env(dbName).\n\nAre you sure?"
            set comm "database_delete; destroy $t"
        }
        
        frame $t.ptitle
        label $t.ptitle.label -height 5 -text $txt
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command $comm
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.ptitle.label -side left -fill both
        pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
        pack $t.ptitle $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    }
}

proc database_delete {} {
    global env
    
    set out ""
    set err ""
    catch {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.deldb('$env(dbName)') AS out"}}]]
        foreach ent $sql_res {
            set out $ent
        }
        unset sql_res
    } err
    if {[lindex $out end] ne 1} {
        errorPopUp "Error" "Could not delete database:\n\n$out\n$err"
    } else {
        .menubar.file.menu.fmenu delete 0 end
        set dbLtmp [getDBs]
        set env(dbL) ""
        foreach db $dbLtmp {
            if {$db ne "refdb"} {
                lappend env(dbL) $db
                set env(dbL) [lsort $env(dbL)]
            }
        }
        foreach db $env(dbL) {
            set comm "dbEvnt [lindex $db 0] 1; dbEvnt_config [lindex $db 1]"
            .menubar.file.menu.fmenu add command -label "[lindex $db 0]" -command $comm
        }
        catch {blast_dbL}
        wm title . "T-ACE"
        .result.notebook1.nb.fdb_info.1.table.l delete 0 end
        .result.notebook1.nb.fdb_info.panel delete 1.0 end
        .result.notebook1.nb.fdbb.1.table.l delete 0 end
        catch {
            .result.notebook1.nb.fsb.1.table.l delete 0 end
            .result.notebook2.nb.fips.1.table.l delete 0 end
            .result.notebook1.nb.fgo.1.table.l delete 0 end
            .result.notebook1.nb.fkeggM.1.1.1.table.l delete 0 end
            .result.notebook1.nb.fkeggM.1.2.1.table.l delete 0 end
        }
        set env(dbName) " "
    }
    unset out   
}

proc database_contig_delete_window {} {
    global env
    
    if {$env(dbName) ne " " && [.result.notebook1.nb raise] eq "dbb"} {
        set t .deleteContigs
        catch {destroy $t}
        toplevel $t
        wm title $t "Delete contigs from $env(dbName)"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        set txt "Delete selected contigs.\n\nAre you sure?"
        set comm "database_contig_delete dbb; destroy $t"
        
        frame $t.ptitle
        label $t.ptitle.label -height 5 -text $txt
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command $comm
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.ptitle.label -side left -fill both
        pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
        pack $t.ptitle $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        errorPopUp "Error" "Select in database_browser to delete contigs."
    }
}

proc database_contig_delete {mode} {
    global env
    
    set tl ".result.notebook1.nb.f$mode.1.table.l"
    $tl finishediting
    
    set rowL ""
    set delL ""
    set tmpString ""
    set stop 0
    set i 0
    
    while {$stop ne 1} {
        if {[lindex [$tl get $i] 0] eq 1} {
            lappend delL [lindex [$tl get $i] 23]
            set rowL [linsert $rowL 0 "$i"]
        } elseif {[lindex [$tl get $i] 0] eq ""} {
            set stop 1
        }
        incr i
    }
    
    foreach row $rowL {
        $tl delete $row
    }
    unset rowL; unset tl
    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.delContigs('$env(dbName)', '$delL') AS out"}}]]
    if {[lindex $sql_res end] eq "Fehler"} {
        puts "error: $sql_res"
    }
    unset sql_res
    database_update dbInfo 0
    unset delL
}

proc database_copy_window {} {
    global env
    
    variable newDB
    
    set t .copyDB
    catch {destroy $t}
    toplevel $t
    wm title $t "Create copy of $env(dbName)"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    set txt "Create copy of database?\n\n$env(dbName)\n"
    set comm "database_copy $env(dbName); destroy $t"
    
    frame $t.ptitle
    label $t.ptitle.label -text $txt
    set newDB "${env(dbName)}_copy"
    entry $t.ptitle.ent -background white -textvariable newDB -width 30
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "OK" -command $comm
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.ptitle.label $t.ptitle.ent -side top -fill both
    pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
    pack $t.ptitle $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc database_copy {dbName} {
    global env
    
    set newDB [.copyDB.ptitle.ent get]
    catch {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.cdb('$newDB','$env(user)') AS out"}}]]
        foreach ent $sql_res {
            set out [lindex $ent 0]
        }
    } out
    .menubar.file.menu.fmenu delete 0 end
    set dbLtmp [getDBs]
    set env(dbL) ""
    foreach db $dbLtmp {
        lappend env(dbL) $db
    }
    set env(dbL) [lsort $env(dbL)]
    foreach db $env(dbL) {
        set comm "dbEvnt [lindex $db 0] 1; dbEvnt_config [lindex $db 1]"
        .menubar.file.menu.fmenu add command -label "[lindex $db 0]" -command $comm
    }
    catch {blast_dbL}
    
    eval [subst {thread::send $::threadPHP {::php_getSQLresults }}]

    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_nucleotide (id_seq, name, numreads, length, sequence, sequence_gap, base_cover) SELECT id_seq, name, numreads, length, sequence, sequence_gap, base_cover FROM $dbName.sequences_nucleotide"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_read (id_read, id_run, name, length, polya, singleton, sequence) SELECT id_read, id_run, name, length, polya, singleton, sequence FROM $dbName.sequences_read"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_protein (id_seq, id_prot, \"name\", frame, orf, length, \"sequence\") SELECT id_seq, id_prot, \"name\", frame, orf, length, \"sequence\" FROM $dbName.sequences_protein"}}]}
            catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_nucleotide_description (id_seq, blast, \
                blastprodom, gene3d, go, interpro, panther, patternscan, \
                pfam, pir, profilescan, smart, superfamily, tigr, comment) SELECT id_seq, blast, \
                blastprodom, gene3d, go, interpro, panther, patternscan, \
                pfam, pir, profilescan, smart, superfamily, tigr, comment FROM $dbName.sequences_nucleotide_description"}}]}
            catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_protein_description (id_prot, blast, \
                blastprodom, gene3d, go, interpro, panther, patternscan, \
                pfam, pir, profilescan, smart, superfamily, tigr, comment) SELECT id_seq, blast, \
                blastprodom, gene3d, go, interpro, panther, patternscan, \
                pfam, pir, profilescan, smart, superfamily, tigr, comment FROM $dbName.sequences_protein_description"}}]}
            catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_protein_description (id_prot, blast, \
                blastprodom, gene3d, go, interpro, panther, patternscan, \
                pfam, pir, profilescan, smart, superfamily, tigr, comment) SELECT id_prot, blast, \
                blastprodom, gene3d, go, interpro, panther, patternscan, \
                pfam, pir, profilescan, smart, superfamily, tigr, comment FROM $dbName.sequences_protein_description"}}]}
            catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.seq_info (id_seq, name, length, numreads, id_prot, prot, blast, \
                blastprodom, coil, gene3d, go, panther, pfam, pir, smart, interpro, patternscan, profilescan, superfamily, \
                tigr, gothits, coverage) SELECT id_seq, name, length, numreads, id_prot, prot, blast, \
                blastprodom, coil, gene3d, go, panther, pfam, pir, smart, \
                interpro, patternscan, profilescan, superfamily, tigr, gothits, coverage FROM $dbName.seq_info"}}]}
            catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.seq_info (id_prot, name, length, blast, \
                blastprodom, coil, gene3d, go, panther, pfam, pir, smart, interpro, patternscan, profilescan, superfamily, \
                tigr, gothits) SELECT id_prot, name, length, blast, \
                blastprodom, coil, gene3d, go, panther, pfam, pir, smart, \
                interpro, patternscan, profilescan, superfamily, tigr, gothits FROM $dbName.prot_info"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.prot_info (id_prot, name, length, blast, \
                blastprodom, coil, gene3d, go, panther, pfam, pir, smart, interpro, patternscan, profilescan, superfamily, \
                tigr, gothits) SELECT id_prot, name, length, blast, \
                blastprodom, coil, gene3d, go, panther, pfam, pir, smart, \
                interpro, patternscan, profilescan, superfamily, tigr, gothits FROM $dbName.prot_info"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.run_info (id_run, description, runs, sequencer, type, datein, dateout, data, sequences, \
                assembled, singleton, treatment, comment, color, a_b) SELECT id_run, description, runs, sequencer, type, datein, dateout, data, sequences, \
                assembled, singleton, treatment, comment, color, a_b FROM $dbName.run_info"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.db_comment (comment) SELECT comment FROM $dbName.db_comment"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.blast_hits (id_seq, id, db, \
                \"start\", \"end\", length, evalue, score, perfection) SELECT id_seq, id, db, \
                \"start\", \"end\", length, evalue, score, perfection FROM $dbName.blast_hits"}}]}
    foreach tab {blastprodom_hits coil_hits gene3d_hits panther_hits patternscan_hits pfam_hits pir_hits profilescan_hits smart_hits superfamily_hits tigr_hits} {
        catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.$tab (id_seq, id_prot, id, \
                    \"start\", \"end\", length, evalue) SELECT id_seq, id_prot, id, \
                    \"start\", \"end\", length, evalue FROM $dbName.$tab"}}]}
    }
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.go_hits (id_seq, id_prot, id) SELECT id_seq, id_prot, id FROM  $dbName.go_hits"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.interpro_hits (id_seq, id_prot, id) SELECT id_seq, id_prot, id FROM  $dbName.interpro_hits"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.kegg_hits (id_seq, id) SELECT id_seq, id FROM  $dbName.kegg_hits"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.kegg_stat (id, ko_num, ko_hits, id_seql) SELECT id, ko_num, ko_hits, id_seql FROM $dbName.kegg_stat"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.read_hits (name_read, name_seq, strand, \
                seq_start, read_start, read_end, sequence_gap) SELECT name_read, name_seq, strand, \
                seq_start, read_start, read_end, sequence_gap FROM $dbName.read_hits"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.go_stat (id, hits) SELECT id, hits FROM  $dbName.go_stat"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_nucleotide_primer (id_seq, primer_forward_sequence, primer_reverse_sequence, \
                primer_pair_penalty, primer_forward_penalty, primer_reverse_penalty, \
                primer_forward_pos, primer_reverse_pos, primer_forward_len, primer_reverse_len, \
                primer_forward_tm, primer_reverse_tm, primer_forward_gc, primer_reverse_gc, \
                primer_forward_self_any, primer_reverse_self_any, primer_forward_self_end, \      
                primer_reverse_self_end, primer_forward_end_stability, primer_reverse_end_stability, \
                primer_pair_compl_any, primer_pair_compl_end, primer_product_size, \
                primer_product_tm, primer_product_tm_oligo_tm_diff, primer_pair_t_opt_a, \
                primer_salt_con, primer_dna_con) SELECT id_seq, primer_forward_sequence, primer_reverse_sequence, \
                primer_pair_penalty, primer_forward_penalty, primer_reverse_penalty, \
                primer_forward_pos, primer_reverse_pos, primer_forward_len, primer_reverse_len, \
                primer_forward_tm, primer_reverse_tm, primer_forward_gc, primer_reverse_gc, \
                primer_forward_self_any, primer_reverse_self_any, primer_forward_self_end, \
                primer_reverse_self_end, primer_forward_end_stability, primer_reverse_end_stability, \
                primer_pair_compl_any, primer_pair_compl_end, primer_product_size, \
                primer_product_tm, primer_product_tm_oligo_tm_diff, primer_pair_t_opt_a, \
                primer_salt_con, primer_dna_con FROM $dbName.sequences_nucleotide_primer"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "INSERT INTO $newDB.sequences_nucleotide_repeat (id_seq, unit_length, unit, \"start\", \"end\", length, score, \
                perfection, mismatches, insertions, deletions, num_of_ns) SELECT id_seq, unit_length, unit, \"start\", \"end\", length, score, \
                perfection, mismatches, insertions, deletions, num_of_ns FROM $dbName.sequences_nucleotide_repeat"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.dbInfo('$newDB')"}}]}
    
    dbEvnt $newDB 1
}

proc database_hits_delete_window {} {
    global env
    
    set txt ""
    set t .deleteHits
    if {[.result.notebook2.nb raise] eq "br"} {
        set txt "Delete selected Blast results.\n\nAre you sure?"
        set comm "database_hits_delete br; destroy $t"
    } elseif {[.result.notebook2.nb raise] eq "ips"} {
        set txt "Delete selected InterPro results.\n\nAre you sure?"
        set comm "database_hits_delete ips; destroy $t"
    } elseif {[.result.notebook2.nb raise] eq "primer"} {
        set txt "Delete selected primer entries.\n\nAre you sure?"
        set comm "database_hits_delete primer; destroy $t"
    } elseif {[.result.notebook2.nb raise] eq "repeat"} {
        set txt "Delete selected repeat entries.\n\nAre you sure?"
        set comm "database_hits_delete repeat; destroy $t"
    } elseif {[.result.notebook2.nb raise] eq "kegg"} {
        set txt "Delete selected KEGG hits.\n\nAre you sure?"
        set comm "database_hits_delete kegg; destroy $t"
    } elseif {[.result.notebook2.nb raise] eq "go"} {
        set txt "Delete selected GO hits.\n\nAre you sure?"
        set comm "database_hits_delete go; destroy $t"
    }
    
    if {$env(contig.dbName) ne "" && $txt ne ""} {
        catch {destroy $t}
        toplevel $t
        wm title $t "Delete hits from $env(contig.dbName)"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.ptitle
        label $t.ptitle.label -height 5 -text $txt
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command $comm
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.ptitle.label -side left -fill both
        pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
        pack $t.ptitle $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        errorPopUp "Error" "Cannot delete hits from this tab."
    }
}

proc database_hits_delete {mode} {
    global env
    
    set tl ".result.notebook2.nb.f$mode.1.table.l"
    $tl finishediting
    
    set rowL ""
    set delL ""
    set tmpString ""
    set stop 0
    set i 0
    
    if {$mode eq "ips"} {
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend delL "[lindex [$tl get $i] 2]_hits $env(contig.id_seq) [lindex [$tl get $i] 9] [lindex [$tl get $i] 3]"
                set rowL [linsert $rowL 0 "$i"]
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
    } elseif {$mode eq "primer"} {
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend delL "sequences_nucleotide_primer [lindex [$tl get $i] 28] [lindex [$tl get $i] 4] [lindex [$tl get $i] 5] [lindex [$tl get $i] 6]"
                set rowL [linsert $rowL 0 "$i"]
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
    } elseif {$mode eq "repeat"} {
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend delL "sequences_nucleotide_repeat [lindex [$tl get $i] 12] [lindex [$tl get $i] 1] [lindex [$tl get $i] 2] [lindex [$tl get $i] 3]"
                set rowL [linsert $rowL 0 "$i"]
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
    } elseif {$mode eq "br"} {
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend delL "blast_hits [lindex [$tl get $i] 13] [lindex [$tl get $i] 1] [lindex [$tl get $i] 2]"
                set rowL [linsert $rowL 0 "$i"]
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
    } elseif {$mode eq "go"} {
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend delL "go_hits $env(contig.id_seq) [lindex [$tl get $i] 6] [lindex [$tl get $i] 2]"
                set rowL [linsert $rowL 0 "$i"]
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
    } elseif {$mode eq "kegg"} {
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend delL "kegg_hits $env(contig.id_seq) [lindex [$tl get $i] 1]"
                set rowL [linsert $rowL 0 "$i"]
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
    }
    
    set delL [lsort $delL]
    foreach row $rowL {
        $tl delete $row
    }
    unset rowL; unset tl
    
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.delHits('$env(contig.dbName)', '$delL')"}}]}
    catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.seqInfo('$env(contig.dbName)', '$env(contig.id_seq)')"}}]}
    unset tmpString; unset delL
}

proc database_interproRes_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{InterPro Files} {.raw .txt .out} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addInterpro
            catch {destroy $t}
            toplevel $t
            wm title $t "Add InterProScan results"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.type
            label $t.type.label -text "Sequence type: "
            ComboBox $t.type.cb -width 10 -hottrack 1 -background white -text "protein" -values {nucleotide protein}
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Add InterProScan results from\n$f\nto $env(dbName)\n\nAre you sure?"
            
            set comm "database_interproRes_add \"$f\"; destroy $t"
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.type.label $t.type.cb -side left -fill both
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.type $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_interproRes_add {f} {
    global env

    if {[catch {set fs [open $f r]}]} {
        errorPopUp "Error" "Cannot find file: $f."
    } else {
        set count 0
        set refL ""
        set hitL ""
        
        set type [.addInterpro.type.cb get]
        
        if {[lindex [split $f .] end] eq "raw"} {
            gets $fs line
            set line [regsub -all {\[} [regsub -all {\]} [regsub -all {["\\]} $line ""] ")"] "("]
            set line "\{[regsub -all {\t} $line "\} \{"]\}"
            if {[llength $line] eq 5 || [llength $line] eq 6} {
                if {[lindex $line 2] ne "noIPR"} {
                    lappend hitL "interpro_hits {[lindex $line 0] [lindex $line 2]}"
                    lappend refL "interpro {[lindex $line 2] {[lindex $line 3]}}"
                    if {[string range [lindex $line 5] 0 1] eq "GO"} {
                        lappend hitL "go_hits {[lindex $line 0] [lindex $line 5]}"
                    }
                }
                while {[gets $fs line] != -1} {
                    set line [regsub -all {\[} [regsub -all {\]} [regsub -all {["\\]} $line ""] ")"] "("]
                    set line "\{[regsub -all {\t} $line "\} \{"]\}"
                    if {[lindex $line 2] ne "noIPR"} {
                        lappend hitL "interpro_hits {[lindex $line 0] [lindex $line 2]}"
                        lappend refL "interpro {[lindex $line 2] {[lindex $line 3]}}"
                        if {[string range [lindex $line 5] 0 1] eq "GO"} {
                            lappend hitL "go_hits {[lindex $line 0] [lindex $line 5]}"
                        }
                    }
                }
                set hitL [lsort -unique $hitL]
                set refL [lsort -unique $refL]
            } elseif {[llength $line] eq 13 || [llength $line] eq 14} {
                if {[lindex $line 4] ne "Seg"} {
                    if {[lindex $line 3] eq "HMMPfam"} {
                        set feat pfam
                    } elseif {[lindex $line 3] eq "HMMPIR"} {
                        set feat pir
                    } elseif {[lindex $line 3] eq "HMMPanther"} {
                        set feat panther
                    } elseif {[lindex $line 3] eq "HMMSmart"} {
                        set feat smart
                    } elseif {[lindex $line 3] eq "HMMTigr"} {
                        set feat tigr
                    } else {
                        set feat [string tolower [lindex $line 3]]
                    }
                    if {$feat ne ""} {
                        set feat_hits "${feat}_hits"
                        if {[catch {
                                incr count
                                lappend hitL "$feat_hits {[lindex $line 0] [lindex $line 4] [lindex $line 6] [lindex $line 7] [lindex $line 8]}"
                                lappend refL "$feat {[lindex $line 4] {[lindex $line 5]}}"
                                if {[lindex $line 11] ne "NULL"} {
                                    lappend hitL "interpro_hits {[lindex $line 0] [lindex $line 11]}"
                                    lappend refL "interpro {[lindex $line 11] {[lindex $line 12]}}"
                                    if {[lindex $line 13] ne ""} {
                                        set goL "\{[regsub -all {\),} [string range [lindex $line 13] 0 [expr [string length [lindex $line 13]] - 2]] "\}~\{"]\}"
                                        set goL [split $goL ~]
                                        foreach go $goL {
                                            set go "[regsub -all {: } $go "\} \{"]"
                                            set go "[regsub -all {\(GO:} $go "\} \{GO:"]"
                                            set goNum [string trimleft [string trimright [lindex $go 2]]]
                                            lappend hitL "go_hits {[lindex $line 0] $goNum}"
                                        }
                                    }
                                }
                            }]} {
                            errorPopUp "Error" "Cannot read domain hits.\nSome unrecognised character after line $count."
                        }
                    }
                }
                while {[gets $fs line] != -1} {
                    set line [regsub -all {\[} [regsub -all {\]} [regsub -all {["\\]} $line ""] ")"] "("]
                    set line "\{[regsub -all {\t} $line "\} \{"]\}"
                    if {[lindex $line 4] ne "Seg"} {
                        if {[lindex $line 3] eq "HMMPfam"} {
                            set feat pfam
                        } elseif {[lindex $line 3] eq "HMMPIR"} {
                            set feat pir
                        } elseif {[lindex $line 3] eq "HMMPanther"} {
                            set feat panther
                        } elseif {[lindex $line 3] eq "HMMSmart"} {
                            set feat smart
                        } elseif {[lindex $line 3] eq "HMMTigr"} {
                            set feat tigr
                        } else {
                            set feat [string tolower [lindex $line 3]]
                        }
                        if {$feat ne ""} {
                            set feat_hits "${feat}_hits"
                            if {[catch {
                                    incr count
                                    lappend hitL "$feat_hits {[lindex $line 0] [lindex $line 4] [lindex $line 6] [lindex $line 7] [lindex $line 8]}"
                                    lappend refL "$feat {[lindex $line 4] {[lindex $line 5]}}"
                                    if {[lindex $line 11] ne "NULL"} {
                                        lappend hitL "interpro_hits {[lindex $line 0] [lindex $line 11]}"
                                        lappend refL "interpro {[lindex $line 11] {[lindex $line 12]}}"
                                        if {[lindex $line 13] ne ""} {
                                            set goL "\{[regsub -all {\),} [string range [lindex $line 13] 0 [expr [string length [lindex $line 13]] - 2]] "\}~\{"]\}"
                                            set goL [split $goL ~]
                                            foreach go $goL {
                                                set go "[regsub -all {: } $go "\} \{"]"
                                                set go "[regsub -all {\(GO:} $go "\} \{GO:"]"
                                                set goNum [string trimleft [string trimright [lindex $go 2]]]
                                                lappend hitL "go_hits {[lindex $line 0] $goNum}"
                                            }
                                        }
                                    }
                                }]} {
                                errorPopUp "Error" "Cannot read domain hits.\nSome unrecognised character after line $count."
                            }
                        }
                    }
                }
            } else {
                errorPopUp "Error" "Input file seems to be in the wrong format."
            }
        } else {
            gets $fs line
            set line [regsub -all {\[} [regsub -all {\]} [regsub -all {["\\]} $line ""] ")"] "("]
            if {[lindex $line 1] eq "hmmscan"} {
                set ref ""
                set contig ""
                set domain ""
                set min_contig 0
                set max_contig 0
                set description ""
                set evalue ""
                set score ""
                while {[gets $fs line] != -1} {
                    set line [regsub -all {\[} [regsub -all {\]} [regsub -all {["\\]} $line ""] ")"] "("]
                    if {$ref ne ""} {
                        if {[lindex $line 0] eq "//"} {
                            if {$contig ne "" && $domain ne ""} {
                                lappend hitL "${ref}_hits {$contig $domain $min_contig $max_contig $evalue}"
                                lappend refL "$ref {$domain {$description}}"
                            }
                            set contig ""
                            set domain ""
                            set min_contig 0
                            set max_contig 0
                            set evalue ""
                            set Score ""
                            set description ""
                        } elseif {[lindex $line 0] eq "Query:"} {
                            if {$contig ne "" && $domain ne ""} {
                                lappend hitL "${ref}_hits {$contig $domain $min_contig $max_contig $evalue}"
                                lappend refL "$ref {$domain {$description}}"
                            }
                            set min_contig 0
                            set max_contig 0
                            set evalue ""
                            set score ""
                            set description ""
                            set contig [lindex $line 1]
                        } elseif {[lindex $line 0] eq ">>"} {
                            if {$contig ne "" && $domain ne ""} {
                                lappend hitL "${ref}_hits {$contig $domain $min_contig $max_contig $evalue}"
                                lappend refL "$ref {$domain {$description}}"
                            }
                            set min_contig 0
                            set max_contig 0
                            set evalue ""
                            set score ""
                            set domain [lindex $line 1]
                            set description [lrange $line 1 end]
                        } elseif {[lindex $line 0] eq "=="} {
                            if {$contig ne "" && $domain ne "" && $evalue ne ""} {
                                lappend hitL "${ref}_hits {$contig $domain $min_contig $max_contig $evalue}"
                                lappend refL "$ref {$domain {$description}}"
                            }
                            set min_contig 0
                            set max_contig 0
                            set description ""
                            set evalue [lindex $line end]
                            set score [lindex $line 4]
                        } elseif {[lindex $line 0] eq $contig} {
                            if {$min_contig eq 0} {
                                set min_contig [lindex $line 1]
                            }
                            set max_contig [lindex $line end]
                            
                        }
                    } elseif {[lrange $line 1 3] eq "target HMM database:"} {
                        if {[lindex $line 4] eq "Pfam-A.hmm"} {
                            set ref pfam
                        }
                    }
                }
            } else {
                errorPopUp "Error" "Input file seems to be in the wrong format."
            }
        }

        unset count
        close $fs
        set refL [lsort -unique $refL]
        set hitL [lsort -unique $hitL]     
        
        if {$hitL eq "" && $refL eq ""} {
            set inL ""
        } else {
            set inL "$f {$refL} {$hitL}"
        }
        unset hitL; unset refL
        
        set ::threadInterproResAdd [thread::create {
            proc interproRes_add {dbName inL type processID mainThreadID phpThreadID} {
                foreach ent [lindex $inL 1] {
                    eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO refdb.[lindex $ent 0] VALUES ('[lindex [lindex $ent 1] 0]', '[lindex [lindex $ent 1] 1]')"}}]
                }
                set hitNum 0
                set goNum 0
                set iprNum 0
                set go_hitL ""
                set ips_hitL ""
                foreach ent [lindex $inL 2] {
                    set id_seq ""
                    if {$type eq "protein"} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, id_prot FROM $dbName.sequences_protein WHERE name = '[lindex [lindex $ent 1] 0]'"}}]]
                    } elseif {$type eq "nucleotide"} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, '-1' as id_prot FROM $dbName.sequences_nucleotide WHERE name = '[lindex [lindex $ent 1] 0]'"}}]]
                    }
                    foreach sRes $sql_res {
                        set id_seq [lindex $sRes 0]
                        set id_prot [lindex $sRes 1]
                    }
                    unset sql_res
                    if {$id_seq ne ""} {
                        if {[lindex $ent 0] eq "go_hits"} {
                            append go_hitL ",('$id_seq', '$id_prot', '[lindex [lindex $ent 1] 1]')"
                            incr goNum
                        } elseif {[lindex $ent 0] eq "interpro_hits"} {
                            append ips_hitL ",('$id_seq', '$id_prot', '[lindex [lindex $ent 1] 1]')"
                            incr iprNum
                        } else {
                            set len [expr [lindex [lindex $ent 1] 3] - [lindex [lindex $ent 1] 2] + 1]
                            eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.[lindex $ent 0] VALUES ('$id_seq', '$id_prot', '[lindex [lindex $ent 1] 1]', '[lindex [lindex $ent 1] 2]', '[lindex [lindex $ent 1] 3]', '$len', '[lindex [lindex $ent 1] 4]')"}}] 
                            incr hitNum
                        }
                    }
                }
                if {$go_hitL ne ""} {
                    set go_hitL [string range $go_hitL 1 end]
                    eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.go_hits VALUES $go_hitL"}}]
                }
                if {$ips_hitL ne ""} {
                    set ips_hitL [string range $ips_hitL 1 end]
                    eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.interpro_hits VALUES $ips_hitL"}}]
                }
                unset go_hitL
                unset ips_hitL
                
                eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}]
                returnResult $processID finished "$hitNum domain hits added." $dbName "Input file: [lindex $inL 0]\n\nGO: $goNum entries\nInterPro: $iprNum entries\nDomains: $hitNum" $mainThreadID
                unset inL
            }
            proc returnResult {processID status process dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
                eval [subst {thread::send -async $mainThreadID {::dbEvnt $dbName 0}}]
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        process_update $processID running "Adding domain hits" $env(dbName) 0
        if {$inL eq ""} {
            process_update $processID finished "0 domain hits added." $env(dbName) "No domain entries found in file: $f"
        } else {
            eval [subst {thread::send -async $::threadInterproResAdd {interproRes_add $env(dbName) {$inL} $type $processID $env(mainThreadID) $env(phpThreadID)} result}]
        }
        unset f; unset inL
    }
}

proc database_login_window_old {} {
    global env
    
    if {[string trim $env(user)] ne ""} {
        PasswdDlg .passwd -logintext "$env(user)" -type okcancel -command database_login -parent .
    } else {
        PasswdDlg .passwd -logintext "" -type okcancel -command database_login -parent .
    }
}

proc database_login_server_change {} {
    global env
    
    set env(currentConnection) [.database_login_window.db.cb get]
    
    set env(host) $env(host_$env(currentConnection))
    set env(port) $env(port_$env(currentConnection))
    set env(parentDB) $env(parentDB_$env(currentConnection))
    set env(folderServer) $env(folderServer_$env(currentConnection))
    set env(userServer) $env(userServer_$env(currentConnection))
    set env(passwdServer) $env(passwdServer_$env(currentConnection))
}

proc database_login_window {} {
    global env
    
    set t .database_login_window
    catch {destroy $t}
    toplevel $t
    wm title $t "Login"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    variable user
    set user [string trim $env(user)]
    
    frame $t.db
    label $t.db.l -text "Server:"
    ComboBox $t.db.cb -modifycmd {database_login_server_change; focus .database_login_window.passwd.ent} -width 20 -hottrack 1 -background white -text $env(currentConnection) -values $env(connections) -state normal
    
    label $t.l -text ""
    label $t.l2 -text ""
    
    frame $t.user
    label $t.user.l -text "User:"
    entry $t.user.ent -background white -textvariable user -width 20
    
    frame $t.passwd
    label $t.passwd.l -text "Password:            "
    entry $t.passwd.ent -background white -show "*" -textvariable "" -width 20
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "OK" -command database_login
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.db.l -side left -fill both -anchor w; pack $t.db.cb -side right -fill both -anchor w
    pack $t.user.l -side left -fill both -anchor w; pack $t.user.ent -side right -fill both -anchor w
    pack $t.passwd.l -side left -fill both -anchor w; pack $t.passwd.ent -side right -fill both -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c -expand 1
    pack $t.db $t.l $t.user $t.passwd $t.l2 $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
    
    if {$user eq ""} {
        focus $t.user.ent
    } else {
        focus $t.passwd.ent
    }
    
    bind $t.passwd.ent <Return> "database_login"
    bind $t.buts.ok <Return> "database_login"
    bind $t.user.ent <Return> "focus $t.passwd.ent"
}

proc database_login {} {
    global env
    
    set env(user) [.database_login_window.user.ent get]
    set env(password) [.database_login_window.passwd.ent get]
    destroy .database_login_window
    
    .menubar.file.menu.fmenu delete 0 end
    
    set check 0
    set err ""
    catch {set check [eval [subst {thread::send $::threadPHP {::php_checkConncetion}}]]} err
    if {$err ne ""} {
        if {$err eq "can't read \"env(password)\": no such variable"} {
            set check "Empty passwords are not allowed."
        }
    }
    
    if {$check eq 0} {
        errorPopUp "Error - Login" "Incorrect username or password."
    } elseif {$check eq 1} {
        #execute after login
        set dbLtmp [getDBs]
        set env(dbL) " "
        foreach db $dbLtmp {
            lappend env(dbL) $db
        }
        unset dbLtmp
        catch {
            set env(dbL) [lsort -unique $env(dbL)]
            foreach db $env(dbL) {
                set comm "dbEvnt [lindex $db 0] 1; dbEvnt_config [lindex $db 1]"
                .menubar.file.menu.fmenu add command -label "[lindex $db 0]" -command $comm
            }
        }
        catch {database_login_save}
        catch {database_login_menu_change}
        catch {go_tree_create .result.notebook2.nb.fgo_stat.1.tree.t}
        catch {blast_dbL}
    } else {
        errorPopUp "Error - Login" "Could not reach database server.\n\n$check"
    }
}

proc database_login_save {} {
    global env
    if {[catch {set ft [open [pwd]/conf/login.conf w]} ]} {
    } else {
        puts $ft "$env(user)\t\{$env(currentConnection)\}"
        close $ft
    }
}

proc database_login_menu_change {} {
    global env
    
    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT usecreatedb FROM pg_user where usename = '$env(user)'"}}]]
    foreach ent $sql_res {
        if {[lindex $ent 0]} {
            .menubar.file.menu entryconfigure "New DB..." -state normal
            .menubar.file.menu entryconfigure "Import..." -state normal
        } else {
            .menubar.file.menu entryconfigure "New DB..." -state disabled
            .menubar.file.menu entryconfigure "Import..." -state disabled
        }
    }
    unset sql_res
}

proc database_getNum {dbh dbName} {
    global env
    
    if {$dbh eq "sequences_nucleotide"} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT MAX(id_seq) AS n FROM $dbName.$dbh"}}]]
        foreach ent $sql_res {
            set num [lindex $ent 0]
        }
        unset sql_res
    } elseif {$dbh eq "sequences_protein"} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT MAX(id_prot) AS n FROM $dbName.$dbh"}}]]
        foreach ent $sql_res {
            set num [lindex $ent 0]
        }
        unset sql_res
    } elseif {$dbh eq "sequences_read"} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT MAX(id_read) AS n FROM $dbName.$dbh"}}]]
        foreach ent $sql_res {
            set num [lindex $ent 0]
        }
        unset sql_res
    } else {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT COUNT(id_seq) AS n FROM $dbName.$dbh"}}]]
        foreach ent $sql_res {
            set num [lindex $ent 0]
        }
        unset sql_res
    }
    if {$num eq ""} {
        return 0
    } else {
        return $num
    }
}

proc database_export_window {mode} {
    global env
    
    if {$env(dbName) ne " "} {
        if {$mode eq "ace"} {
            set f [browse save {{{ACE Files} {.ace} } {{All Files} * }} "$env(dbName).ace"]
        } elseif {$mode eq "db"} {
            set f [browse save {{{DB Files} {.db} } {{All Files} * }} "$env(dbName).db"]
        }
        if {$f ne ""} {
            set t .exportDB
            catch {destroy $t}
            toplevel $t
            wm title $t "Export $env(dbName) to file"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Export database $env(dbName) to\n\n$f\n\nAre you sure?"
            
            set comm "database_export {$f} $mode"
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_export {f mode} {
    global env
    destroy .exportDB
    
    set ::threadExportDB [thread::create {
        proc exportDB {host port user password parentDB dbName mode f processID mainThreadID phpThreadID} {
            set out ""
            set res ""
            if {[catch {set fs [open "$f" w]}]} {
                puts "cant find $f."
            } else {
                if {$mode eq "ace"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, length, numreads, sequence_gap FROM $dbName.sequences_nucleotide ORDER BY name"}}]]
                    foreach sRes $sql_res {
                        lappend contigL "[lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3]"
                    }
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT COUNT(name_read) AS numreads FROM $dbName.read_hits"}}]]
                    foreach sRes $sql_res {
                        set numReads [lindex $sRes 0]
                        
                    }
                    unset sql_res
                    puts $fs "AS [llength $contigL] $numReads\n"
                    unset numReads
                    foreach contig $contigL {
                        append out "CO [lindex [split [lindex $contig 0] _] end] [string length [lindex $contig 3]] [lindex $contig 2] [lindex $contig 2] U\n"
                        set i 0
                        while {$i < [string length [lindex $contig 3]]} {
                            append out "[string range [lindex $contig 3] $i [expr $i + 49]]\n"
                            set i [expr $i + 49]
                        }
                        append out "\nBQ\n"
                        set j 0
                        for {set i 0} {$i < [lindex $contig 1]} {incr i} {
                            append out " 60"
                            incr j
                            if {$j eq 50} {
                                set j 0
                                append out "\n"
                            }
                        }
                        append out "\n"
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name_read, strand, seq_start, read_start, read_end, sequence_gap FROM $dbName.read_hits WHERE name_seq = '[lindex $contig 0]' ORDER BY seq_start"}}]]
                        foreach sRes $sql_res {
                            lappend readL "[lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] [lindex $sRes 4] [lindex $sRes 5]"
                        }
                        unset sql_res
                        append out "\n"
                        foreach r $readL {
                            append out "AF [lindex $r 0] [lindex $r 1] [lindex $r 2]\n"
                        }
                        append out "\n"
                        foreach r $readL {
                            append out "RD [lindex $r 0] [string length [lindex $r 5]] 0 0\n"
                            set i 0
                            while {$i < [string length [lindex $r 5]]} {
                                append out "[string range [lindex $r 5] $i [expr $i + 49]]\n"
                                set i [expr $i + 49]
                            }
                            append out "\nQA [lindex $r 3] [lindex $r 4] [lindex $r 3] [lindex $r 4]\nDS\n"
                        }
                        puts $fs $out
                        flush $fs
                        set out ""
                        unset readL
                    }
                    unset contigL
                } elseif {$mode eq "db"} {
                    catch {
                        set num 0
                        set out "# db_info"
                        append res "db_info..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT nucseq, protseq, readseq, blast, blastprodom, coil, gene3d, go, panther, pfam, pir, smart, interpro, kegg, patternscan, profilescan, superfamily, tigr, minnuc, avgnuc, maxnuc, minprot, avgprot, maxprot, minread, avgread, maxread, rassembled, rsingletons, n50, gc_content, at_gc_ratio FROM $dbName.db_info"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t[lindex $sRes 15]\t[lindex $sRes 16]\t[lindex $sRes 17]\t[lindex $sRes 18]\t[lindex $sRes 19]\t[lindex $sRes 20]\t[lindex $sRes 21]\t[lindex $sRes 22]\t[lindex $sRes 23]\t[lindex $sRes 24]\t[lindex $sRes 25]\t[lindex $sRes 26]\t[lindex $sRes 27]\t[lindex $sRes 28]\t[lindex $sRes 29]\t[lindex $sRes 30]\t[lindex $sRes 31]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# sequences_nucleotide"
                        append res "done\nsequences_nucleotide..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, numreads, length, sequence, sequence_gap, base_cover FROM (SELECT id_seq, name, numreads, length, sequence, sequence_gap, base_cover, ROW_NUMBER() OVER (ORDER BY id_seq) AS RowNumber FROM $dbName.sequences_nucleotide) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# sequences_protein"
                        append res "done\nsequences_protein..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, id_prot, name, frame, orf, length, sequence FROM (SELECT id_seq, id_prot, name, frame, orf, length, sequence, ROW_NUMBER() OVER (ORDER BY id_prot) AS RowNumber FROM $dbName.sequences_protein) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# sequences_read"
                        append res "done\nsequences_read..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_read, id_run, name, length, polya, singleton, sequence FROM (SELECT id_read, id_run, name, length, polya, singleton, sequence, ROW_NUMBER() OVER (ORDER BY id_read) AS RowNumber FROM $dbName.sequences_read) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# sequences_nucleotide_description"
                        append res "done\nsequences_nucleotide_description..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, blast, blastprodom, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg FROM (SELECT id_seq, blast, blastprodom, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg, ROW_NUMBER() OVER (ORDER BY id_seq) AS RowNumber FROM $dbName.sequences_nucleotide_description) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# sequences_protein_description"
                        append res "done\nsequences_protein_description..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_prot, blast, blastprodom, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg FROM (SELECT  id_prot, blast, blastprodom, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg, ROW_NUMBER() OVER (ORDER BY id_prot) AS RowNumber FROM $dbName.sequences_protein_description) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set out "# sequences_nucleotide_primer"
                        append res "done\nsequences_nucleotide_primer..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, primer_forward_sequence, primer_reverse_sequence, primer_pair_penalty, primer_forward_penalty, primer_reverse_penalty, primer_forward_pos, primer_reverse_pos, primer_forward_len, primer_reverse_len, primer_forward_tm, primer_reverse_tm, primer_forward_gc, primer_reverse_gc, primer_forward_self_any, primer_reverse_self_any, primer_forward_self_end, primer_reverse_self_end, primer_forward_end_stability, primer_reverse_end_stability, primer_pair_compl_any, primer_pair_compl_end, primer_product_size, primer_product_tm, primer_product_tm_oligo_tm_diff, primer_pair_t_opt_a, primer_salt_con, primer_dna_con FROM $dbName.sequences_nucleotide_primer"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t[lindex $sRes 15]\t[lindex $sRes 16]\t[lindex $sRes 17]\t[lindex $sRes 18]\t[lindex $sRes 19]\t[lindex $sRes 20]\t[lindex $sRes 21]\t[lindex $sRes 22]\t[lindex $sRes 23]\t[lindex $sRes 24]\t[lindex $sRes 25]\t[lindex $sRes 26]\t[lindex $sRes 27]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set out "# sequences_nucleotide_repeat"
                        append res "done\nsequences_nucleotide_repeat..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, unit_length, unit, start, \\\"end\\\", length, score, perfection, mismatches, insertions, deletions, num_of_ns FROM $dbName.sequences_nucleotide_repeat"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set out "# db_comment"
                        append res "done\ndb_comment..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT \"comment\" FROM $dbName.db_comment"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# seq_info"
                        append res "done\nseq_info..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg, gothits, coverage FROM (SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg, gothits, coverage, ROW_NUMBER() OVER (ORDER BY id_seq) AS RowNumber FROM $dbName.seq_info) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t[lindex $sRes 15]\t[lindex $sRes 16]\t[lindex $sRes 17]\t[lindex $sRes 18]\t[lindex $sRes 19]\t[lindex $sRes 20]\t[lindex $sRes 21]\t[lindex $sRes 22]"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t[lindex $sRes 15]\t[lindex $sRes 16]\t[lindex $sRes 17]\t[lindex $sRes 18]\t[lindex $sRes 19]\t[lindex $sRes 20]\t[lindex $sRes 21]\t[lindex $sRes 22]"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# prot_info"
                        append res "done\nprot_info..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg, gothits FROM (SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, kegg, gothits, ROW_NUMBER() OVER (ORDER BY id_prot) AS RowNumber FROM $dbName.prot_info) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t[lindex $sRes 15]\t[lindex $sRes 16]\t[lindex $sRes 17]\t[lindex $sRes 18]"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]\t[lindex $sRes 15]\t[lindex $sRes 16]\t[lindex $sRes 17]\t[lindex $sRes 18]"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set out "# run_info"
                        append res "done\nrun_info..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_run, description, runs, sequencer, type, datein, dateout, data, sequences, assembled, singleton, treatment, \\\"comment\\\", color, a_b FROM $dbName.run_info"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]\t[lindex $sRes 10]\t[lindex $sRes 11]\t[lindex $sRes 12]\t[lindex $sRes 13]\t[lindex $sRes 14]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set out "# go_stat"
                        append res "done\ngo_stat..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id, hits FROM $dbName.go_stat"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set out "# kegg_stat"
                        append res "done\nkegg_stat..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id, ko_num, ko_hits, id_seql FROM $dbName.kegg_stat"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# read_hits"
                        append res "done\nread_hits..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name_read, name_seq, strand, seq_start, read_start, read_end, sequence_gap FROM (SELECT name_read, name_seq, strand, seq_start, read_start, read_end, sequence_gap, ROW_NUMBER() OVER (ORDER BY name_read) AS RowNumber FROM $dbName.read_hits) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set start 0
                        set end 20000
                        set stop 1
                        set s 1
                        set out "# blast_hits"
                        append res "done\nblast_hits..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        while {$stop} {
                            set num 0
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, id_prot, id, db, start, \\\"end\\\", length, evalue, score, perfection FROM (SELECT id_seq, id_prot, id, db, start, \\\"end\\\", length, evalue, score, perfection, ROW_NUMBER() OVER (ORDER BY id_seq) AS RowNumber FROM $dbName.blast_hits) A WHERE RowNumber BETWEEN $start AND $end"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    if {$s} {
                                        append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]"
                                    } else {
                                        append out "[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]\t[lindex $sRes 7]\t[lindex $sRes 8]\t[lindex $sRes 9]"
                                        set s 1
                                    }
                                    incr num
                                    if {$num >= 20000} {
                                        puts -nonewline $fs $out
                                        flush $fs
                                        set out ""
                                        set s 0
                                    }
                                }
                            }
                            unset sql_res
                            set start [expr $end + 1]
                            set end [expr $end + 20000]
                            if {$num < 20000} {
                                set stop 0
                            }
                            puts $fs $out
                            flush $fs
                        }
                    }
                    foreach ref {blastprodom_hits coil_hits gene3d_hits panther_hits patternscan_hits pfam_hits pir_hits profilescan_hits smart_hits superfamily_hits tigr_hits} {
                        catch {
                            set out "# $ref"
                            append res "done\n$ref..."
                            returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, id_prot, id, start, \\\"end\\\", length, evalue FROM $dbName.$ref"}}]]
                            if {[lindex $sql_res end] ne "Fehler"} {
                                foreach sRes $sql_res {
                                    append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 6]"
                                }
                            }
                            unset sql_res
                            puts $fs $out
                            flush $fs
                        }
                    }
                    catch {
                        set out "# go_hits"
                        append res "done\ngo_hits..."
                        returnResult $processID finished "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, id_prot, id FROM $dbName.go_hits"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set out "# interpro_hits"
                        append res "done\ninterpro_hits..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, id_prot, id FROM $dbName.interpro_hits"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    catch {
                        set out "# kegg_hits"
                        append res "done\nkegg_hits..."
                        returnResult $processID running "Exporting database to $f" $dbName "$res" $mainThreadID
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, id FROM $dbName.kegg_hits"}}]]
                        if {[lindex $sql_res end] ne "Fehler"} {
                            foreach sRes $sql_res {
                                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]"
                            }
                        }
                        unset sql_res
                        puts $fs $out
                        flush $fs
                    }
                    unset out
                }
                close $fs
            }
            append res "done"
            returnResult $processID finished "Exporting database to $f" $dbName "$res" $mainThreadID
        }
        proc returnResult {processID status process dbName result mainThreadID} {
            eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
        }
        thread::wait
    }]
    set processID [llength $env(processL)]
    process_update $processID running "Exporting database to $f" $env(dbName) 0
    eval [subst {thread::send -async $::threadExportDB {exportDB $env(host) $env(port) $env(user) $env(password) $env(parentDB) $env(dbName) $mode "$f" $processID $env(mainThreadID) $env(phpThreadID)} result}]
}

proc database_import_window {mode} {
    global env
    
    if {$mode eq "ace"} {
        set f [browse open {{{ACE Files} {.ace} } {{All Files} * }} -]
    } elseif {$mode eq "db"} {
        set f [browse open {{{DB Files} {.db} } {{All Files} * }} -]
    }
    if {$f ne ""} {
        set t .importDB
        catch {destroy $t}
        toplevel $t
        wm title $t "Import new database from file"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.db
        label $t.db.label -text "Database name: "
        entry $t.db.ent -width 36 -background white -text ""
        frame $t.ptitle
        label $t.ptitle.label -height 7 -text "\n\nImport database from\n\n$f\n\nAre you sure?"
        
        set comm "database_import $f $mode"
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command $comm
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.db.label $t.db.ent -side left -fill both
        pack $t.ptitle.label -side left -fill both
        pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.db $t.ptitle $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    }
}

proc database_import {f mode} {
    global env
    
    set database [.importDB.db.ent get]
    destroy .importDB
    set err [regexp -all {\.} $database]
    if {$err > 0} {
        errorPopUp "Error" "Illegel character in database name."
    } else {
        set ::threadImportDB [thread::create {
            proc importDB {dbName mode f processID mainThreadID phpThreadID} {
                set in ""
                if {[catch {set fs [open $f r]}]} {
                    puts "cant find $f."
                } else {
                    if {$mode eq "ace"} {
                        
                    } elseif {$mode eq "db"} {
                        set start 0
                        set i 0
                        set res ""
                        while {[gets $fs line] != -1} {
                            if {[lindex $line 0] eq "#"} {
                                if {$in ne ""} {
                                    eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.$tab "$in"}}]
                                    set in ""
                                    set start 0
                                    append res "done\n"
                                }
                                incr i
                                set tab [lindex $line 1]
                                append res "$tab..."
                                returnResult $processID running "Importing database from $f; $i of 20" $dbName "$res" $mainThreadID
                            } elseif {$line ne ""} {
                                incr num
                                if {$start eq 0} {
                                    set start 1
                                    append in "$line"
                                } else {
                                    append in "\n$line"
                                }
                                if {$num >= 5000} {
                                    set num 0
                                    eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.$tab "$in"}}]
                                    set in ""
                                    set start 0
                                    append res "."
                                }
                            }
                        }
                        if {$in ne ""} {
                            eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.$tab "$in"}}]
                            unset in; unset start
                        }
                    }
                    close $fs
                    eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.readdistribution('$dbName') AS out"}}]]
                    eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}] 
                }
                returnResult $processID finished "Importing database from $f" $dbName "$res" $mainThreadID
            }
            proc returnResult {processID status process dbName result mainThreadID} {
                if {[catch {eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]} err]} {
                    errorPopUp "Error" "$err"
                }
            }
            thread::wait
        }]

        if {$database ne ""} {
            catch {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.cdb('$database','$env(user)') AS out"}}]]
                foreach sRes $sql_res {
                    set out [lindex $sRes 0]
                }
                unset sql_res
            } err
            if {[lindex $out 0] ne "Database"} {
                errorPopUp "Error" "$err"
            } else {
                .menubar.file.menu.fmenu delete 0 end
                set dbLtmp [getDBs]
                set env(dbL) ""
                foreach db $dbLtmp {
                    lappend env(dbL) $db
               }
                set env(dbL) [lsort $env(dbL)]
                foreach db $env(dbL) {
                    set comm "dbEvnt [lindex $db 0] 1; dbEvnt_config [lindex $db 1]"
                    .menubar.file.menu.fmenu add command -label "[lindex $db 0]" -command $comm
                }
                dbEvnt $database 1
                catch {blast_dbL}
                set processID [llength $env(processL)]
                process_update $processID running "Importing database from $f" $database 0
                eval [subst {thread::send -async $::threadImportDB {importDB $database $mode "$f" $processID $env(mainThreadID) $env(phpThreadID)} result}]
            }
        } else {
            errorPopUp "Error" "No database name."
        }
    }
}

proc database_nuc2prot_window {} {
    global env
    global nuc2prot_translationStart
    global nuc2prot_translationLongestCheck
    
    variable nuc2prot_minLen
    set nuc2prot_minLen 50
    
    if {$env(dbName) ne " "} {
        set t .nuc2prot
        catch {destroy $t}
        toplevel $t
        wm title $t "Contigs to protein"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.ptitle
        label $t.ptitle.label -height 7 -text "Translate contig sequences of $env(dbName)\n\nAre you sure?"
        
        frame $t.length
        label $t.length.label -text "Min. protein length (AA): "
        entry $t.length.ent -background white -textvariable nuc2prot_minLen -width 5
        frame $t.translate
        checkbutton $t.translate.longest -text "Only longest ORF, if ORF >95% of transcript" -variable nuc2prot_translationLongestCheck
        radiobutton $t.translate.start -text "Start translation only at start codons" -variable nuc2prot_translationStart -value "start"
        radiobutton $t.translate.stop -text "Start translation after stop codons" -variable nuc2prot_translationStart -value "stop"
        $t.translate.stop select
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command "database_nuc2prot"
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.ptitle.label -side left -fill both
        pack $t.length.label $t.length.ent -side left -anchor w
        pack $t.translate.longest $t.translate.start $t.translate.stop -side top -anchor w
        pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.ptitle $t.length $t.translate $t.buts -side top -fill both
       
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_nuc2prot {} {
    global env
    global nuc2prot_translationStart
    global nuc2prot_translationLongestCheck
    
    set nuc2prot_minLen [.nuc2prot.length.ent get]
    catch {destroy .nuc2prot}
    
    set ::threadNuc2Prot [thread::create {
        proc nuc2prot {dbName nuc2prot_minLen nuc2prot_translationStart nuc2prot_translationLongestCheck translateTableProt mainThreadID phpThreadID processID} {
            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, length, sequence FROM $dbName.sequences_nucleotide"}}]]
            foreach ent $sql_res {
                lappend seqL "[lindex $ent 0] {[lindex $ent 1]} [lindex $ent 3] [expr int([lindex $ent 2].0 * 0.95 / 3.0)]"
            }
            unset sql_res
            
            set all [llength $seqL]
            set num 0
            set count 0
            foreach seq $seqL {
                set proteinL ""
                set prot95L ""
                for {set fr 1} {$fr <= 6} {incr fr} {
                    set protL ""
                    set result ""
                    if {$nuc2prot_translationStart eq "start"} {
                        set protL [nuc2prot_translateNuc [lindex $seq 2] $fr T $translateTableProt]
                    } else {
                        set protL [split [nuc2prot_translateNuc [lindex $seq 2] $fr A $translateTableProt] *]
                    }
                    set orf 1
                    foreach prot $protL {
                        if {[string length $prot] >= $nuc2prot_minLen} {
                            if {[string length $prot] >= [lindex $seq end]} {
                                lappend prot95L "{[lindex $seq 1]_${fr}_ORF$orf [lindex $seq 1] $fr $orf} $prot"
                            }
                            lappend proteinL "{[lindex $seq 1]_${fr}_ORF$orf [lindex $seq 1] $fr $orf} $prot"
                            incr orf
                        }
                    }
                }
                if {$nuc2prot_translationLongestCheck && $prot95L ne ""} {
                    set proteinL $prot95L
                }
                unset prot95L
                foreach prot $proteinL {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.addProt('$dbName', '$prot', '1') AS out"}}]]
                    foreach sRes $sql_res {
                        set result "[lindex $sRes 0]"
                    }
                    unset sql_res
                }
                if {$count >= 500} {
                    if {[lindex $result 0] eq "ERROR:"} {
                        returnResult $processID error "Error while translating contigs to protein sequences." $dbName $result $mainThreadID
                    } else {
                        returnResult $processID running "$num of $all contigs translated; min. Protein length: $nuc2prot_minLen AA" $dbName $result $mainThreadID
                    }
                    set count 0
                }
                
                unset proteinL
                incr num
                incr count
                
            }
            if {[lindex $result 0] eq "ERROR:"} {
                returnResult $processID error "Error while translating contigs to protein sequences." $dbName $result $mainThreadID
            } else {
                returnResult $processID finished "$num of $all contigs translated; min. Protein length: $nuc2prot_minLen AA" $dbName $result $mainThreadID
            }
            #eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}]
        }
        
        proc nuc2prot_translateNuc {nuc frame mode translateTableProt} {
            set end [string length $nuc]
            switch $frame {
                + {set h 0; set i 0}
                - {set h 1; set i 0}
                1 {set h 0; set i 0}
                2 {set h 0; set i 1}
                3 {set h 0; set i 2}
                4 {set h 1; set i 0}
                5 {set h 1; set i 1}
                6 {set h 1; set i 2}
            }
            set tries 1
            if {$h} {
                set tmp ""
                set nuc [string map {A T T A G C C G a t t a g c c g R Y Y R K M M K H D D H B V V B r y y r k m m k h d d h b v v b} $nuc]
                for {set n [expr [string length $nuc] - 1]} {$n >= 0} {set n [expr $n - 1]} {
                    append tmp [string index $nuc $n]
                }
                set nuc $tmp
                unset tmp
                set tries 3
            }
            
            set gaps [regexp -all {[*:]} [string range $nuc 0 $i]]
            set i [expr $i + $gaps]
            while {$tries > 0} {
                set j $i
                set prot ""
                set prot2 ""
                set orf 1
                set yes 1
                while {$end > $i} {
                    set window 1
                    set ok 0
                    while {$ok ne 2} {
                        incr window
                        set gaps [regexp -all {[*:]} [string range $nuc $i [expr $i + $window]]]
                        set ok [expr $window - $gaps]
                    }
                    set triplet [string tolower [regsub -all {\*} [string range $nuc $i [expr $i + $window]] ""]]
                    set p [lindex $translateTableProt [lsearch -regexp $translateTableProt $triplet]]
                    if {$p ne ""} {
                        if {[lindex $p 0] eq "*" || [lindex $p 0] eq ":"} {
                            if {$yes} {
                                lappend protL $prot
                            }
                            set yes 0; append prot2 *; set prot ""
                        } elseif {[lindex $p 2] eq "Start"} {
                            append prot [lindex $p 0]; append prot2 [lindex $p 0]; set yes 1
                        } else {
                            if {$yes} {append prot [lindex $p 0]}; append prot2 [lindex $p 0]
                        }
                    } else {
                        if {$yes} {append prot x}
                    }
                    
                    set i [expr $i + 1 + $window]
                }
                if {$yes} {
                    lappend protL $prot
                }
                if {$mode eq "T"} {
                    unset prot2; unset protein; unset nuc
                    return "$protL"
                } elseif {$mode eq "A"} {
                    return $prot2
                }
            }
        }
        
        proc returnResult {processID status process dbName result mainThreadID} {
            eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
        }
        thread::wait
    }]
    set processID [llength $env(processL)]
    process_update $processID running "Translating contigs to protein sequences; min. Protein length: $nuc2prot_minLen AA" $env(dbName) 0
    eval [subst {thread::send -async $::threadNuc2Prot {nuc2prot $env(dbName) $nuc2prot_minLen $nuc2prot_translationStart $nuc2prot_translationLongestCheck {$env(translateTableProt)} $env(mainThreadID) $env(phpThreadID) $processID}}]
}

proc database_ACE_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{ACE Files} {.ace} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addACE
            catch {destroy $t}
            toplevel $t
            wm title $t "Add ACE file"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Add contigs/reads from\n$f\nto $env(dbName)\n\nAre you sure?"
            
            set comm "database_ACE_add \"$f\""
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_ACE_add {ace_file} {
    global env
    
    destroy .addACE
    if {$env(dbName) ne " "} {
        set ::threadACEAdd [thread::create {
            proc ace_add {dbName ace_file processID mainThreadID phpThreadID contig_num} {
                if {[catch {set fs [open $ace_file r]}]} {
                    puts "cant find $f."
                } else {
                    puts "reading ACE file..."
                    if {$contig_num eq 0} {
                        set mode 0
                    } else {
                        set mode 1
                    }
                    set maxContigLen 0
                    set readL ""
                    set contig_qual ""
                    set contig_sequence_gap ""
                    set contig_reads 0
                    set readSeqL ""
                    set q 0
                    set sC 0
                    set sR 0
                    set err 0
                    catch {
                        while {[gets $fs line] != -1} {
                            if {[lindex $line 0] eq "CO"} {
                                if {$contig_reads ne 0} {
                                    set contig_sequence_gap [string trim $contig_sequence_gap]
                                    set base_cover ""
                                    if {[string length $contig_sequence_gap] > $maxContigLen} {
                                        set maxContigLen [string length $contig_sequence_gap]
                                    }
                                    for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                                        set base_coverArr(a_$i) 0
                                        set base_coverArr(t_$i) 0
                                        set base_coverArr(c_$i) 0
                                        set base_coverArr(g_$i) 0
                                        set base_coverArr(gap_$i) 0
                                    }
                                    set input ""
                                    set start 0
                                    set count 0
                                    foreach r $readL {
                                        set r_seq [lindex $r 5]
                                        for {set i [expr [lindex $r 3] - 1]} {$i < [lindex $r 4]} {incr i} {
                                            set base [string toupper [string index $r_seq $i]]
                                            catch {
                                                set ind [expr [lindex $r 2] + $i - 1]
                                                if {$base eq "A"} {
                                                    incr base_coverArr(a_$ind)
                                                } elseif {$base eq "T"} {
                                                    incr base_coverArr(t_$ind)
                                                } elseif {$base eq "C"} {
                                                    incr base_coverArr(c_$ind)
                                                } elseif {$base eq "G"} {
                                                    incr base_coverArr(g_$ind)
                                                } elseif {$base eq "*"} {
                                                    incr base_coverArr(gap_$ind)
                                                }
                                            }
                                        }
                                        if {$mode} {
                                            set exists 0
                                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name_read FROM $dbName.read_hits WHERE name_read = '[lindex $r 0]' AND name_seq = '$contig_name'"}}]]
                                            foreach sRes $sql_res {
                                                set exists 1
                                                puts "[lindex $r 0]...exists"
                                            }
                                            unset sql_res
                                            if {$exists} {
                                                eval [subst {thread::send $phpThreadID {::php_getSQLresults "UPDATE $dbName.read_hits SET strand='[lindex $r 1]', seq_start='[lindex $r 2]', read_start='[lindex $r 3]', read_end='[lindex $r 4]', sequence_gap='[lindex $r 5]' WHERE name_read = '[lindex $r 0]' AND name_seq='$contig_name';"}}]
                                            } else {
                                                if {$start eq 0} {
                                                    set start 1
                                                    append input "[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                                } else {
                                                    append input "\n[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                                }
                                                incr count
                                                #eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.read_hits VALUES ('[lindex $r 0]', '$contig_name', '[lindex $r 1]', '[lindex $r 2]', '[lindex $r 3]', '[lindex $r 4]', '[lindex $r 5]')"}}]
                                            }
                                        } else {
                                            if {$start eq 0} {
                                                set start 1
                                                append input "[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                            } else {
                                                append input "\n[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                            }
                                            incr count
                                            
                                        }
                                        if {$count >= 100} {
                                            eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.read_hits "$input"}}]
                                            set input ""
                                            set start 0
                                            set count 0
                                        }
                                    }
                                    if {$input ne ""} {
                                        eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.read_hits "$input"}}]
                                        unset input
                                        set count 0
                                    }
                                    for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                                        lappend base_cover "$base_coverArr(a_$i) $base_coverArr(t_$i) $base_coverArr(c_$i) $base_coverArr(g_$i) $base_coverArr(gap_$i)"
                                    }
                                    if {$mode} {
                                        set exists 0
                                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name FROM $dbName.sequences_nucleotide WHERE name = '$contig_name'"}}]]
                                        foreach sRes $sql_res {
                                            set exists 1
                                        }
                                        unset sql_res
                                        if {$exists} {
                                            eval [subst {thread::send $phpThreadID {::php_getSQLresults "UPDATE $dbName.sequences_nucleotide SET sequence_gap='$contig_sequence_gap', base_cover='$base_cover' WHERE name='$contig_name';"}}]
                                        } else {
                                            set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                                            set contig_length [string length $contig_sequence]
                                            incr contig_num
                                            eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover');INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0.0')"}}]
                                        }
                                    } else {
                                        set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                                        set contig_length [string length $contig_sequence]
                                        incr contig_num
                                        eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover');INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0.0')"}}]
                                    }
                                    if {[catch {puts ">$contig_name length=$contig_length numreads=$contig_reads...done."}]} {puts ">$contig_name ...updated."}
                                    set base_cover ""
                                    set contig_reads 0
                                    set contig_sequence_gap ""
                                    set contig_qual ""
                                    set readSeqL ""
                                    set readL ""
                                }
                                set sC 1
                                set contig_name "${dbName}_[lindex $line 1]"
                            } elseif {[lindex $line 0] eq "BQ"} {
                                set q 1
                                set sC 0
                            } elseif {$sC eq 1} {
                                append contig_sequence_gap "$line"
                            } elseif {[lindex $line 0] eq "AF"} {
                                set q 0
                                lappend readStartL "[lindex [split [lindex $line 1] .] 0] [lindex $line 2] [lindex $line 3]"
                            } elseif {$q eq 1} {
                                append contig_qual "$line "
                            } elseif {[lindex $line 0] eq "RD"} {
                                set readStartNum 0
                                set sR 1
                                set read_sequence_gap ""
                                set seqName [lindex [split [lindex $line 1] .] 0]
                                foreach readStart $readStartL {
                                    if {[lindex [split [lindex $line 1] .] 0] eq [lindex $readStart 0]} {
                                        set readTmp "[lindex [split [lindex $line 1] .] 0] [lindex $readStart 1] [lindex $readStart 2]"
                                        set readStartL [lreplace $readStartL $readStartNum $readStartNum]
                                        break
                                    }
                                    incr readStartNum
                                }
                            } elseif {[lindex $line 0] eq "QA"} {
                                if {$seqName eq [lindex $readTmp 0]} {
                                    lappend readSeqL "$read_sequence_gap [lindex $readTmp 2]"
                                }
                                set sR 0
                                append readTmp " [lindex $line 1] [lindex $line 2] $read_sequence_gap"
                                lappend readL $readTmp
                            } elseif {$sR eq 1} {
                                append read_sequence_gap "$line"
                            } elseif {[lindex $line 0] eq "DS"} {
                                set numreads [split [lindex $line 2] =]
                                if {[lindex $numreads 0] eq "numreads"} {
                                    set contig_reads [expr $contig_reads + [lindex $numreads 1]]
                                } else {
                                    incr contig_reads
                                }
                            }
                        }
                        if {$contig_reads ne 0} {
                            set contig_sequence_gap [string trim $contig_sequence_gap]
                            set base_cover ""
                            if {[string length $contig_sequence_gap] > $maxContigLen} {
                                set maxContigLen [string length $contig_sequence_gap]
                            }
                            for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                                set base_coverArr(a_$i) 0
                                set base_coverArr(t_$i) 0
                                set base_coverArr(c_$i) 0
                                set base_coverArr(g_$i) 0
                                set base_coverArr(gap_$i) 0
                            }
                            set input ""
                            set start 0
                            set count 0
                            foreach r $readL {
                                set r_seq [lindex $r 5]
                                for {set i [expr [lindex $r 3] - 1]} {$i < [lindex $r 4]} {incr i} {
                                    set base [string toupper [string index $r_seq $i]]
                                    catch {
                                        set ind [expr [lindex $r 2] + $i - 1]
                                        if {$base eq "A"} {
                                            incr base_coverArr(a_$ind)
                                        } elseif {$base eq "T"} {
                                            incr base_coverArr(t_$ind)
                                        } elseif {$base eq "C"} {
                                            incr base_coverArr(c_$ind)
                                        } elseif {$base eq "G"} {
                                            incr base_coverArr(g_$ind)
                                        } elseif {$base eq "*"} {
                                            incr base_coverArr(gap_$ind)
                                        }
                                    }
                                }
                                if {$mode} {
                                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name_read FROM $dbName.read_hits WHERE name_read = '[lindex $r 0]' AND name_seq='$contig_name'"}}]]
                                    foreach sRes $sql_res {
                                        set exists 1
                                        puts "[lindex $r 0]...exists"
                                    }
                                    unset sql_res
                                    if {$exists} {
                                        eval [subst {thread::send $phpThreadID {::php_getSQLresults "UPDATE $dbName.read_hits SET strand='[lindex $r 1]', seq_start='[lindex $r 2]', read_start='[lindex $r 3]', read_end='[lindex $r 4]', sequence_gap='[lindex $r 5]' WHERE name_read = '[lindex $r 0]' AND name_seq='$contig_name';"}}]
                                    } else {
                                        if {$start eq 0} {
                                            set start 1
                                            append input "[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                        } else {
                                            append input "\n[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                        }
                                        incr count
                                        #eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.read_hits VALUES ('[lindex $r 0]', '$contig_name', '[lindex $r 1]', '[lindex $r 2]', '[lindex $r 3]', '[lindex $r 4]', '[lindex $r 5]')"}}]
                                    }
                                } else {
                                    if {$start eq 0} {
                                        set start 1
                                        append input "[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                    } else {
                                        append input "\n[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[lindex $r 2]\t[lindex $r 3]\t[lindex $r 4]\t[lindex $r 5]"
                                    }
                                    incr count
                                }
                                if {$count >= 100} {
                                    eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.read_hits "$input"}}]
                                    set input ""
                                    set start 0
                                    set count 0
                                }
                            }
                            if {$input ne ""} {
                                eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.read_hits "$input"}}]
                                unset input
                                set count 0
                            }
                            
                            for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                                lappend base_cover "$base_coverArr(a_$i) $base_coverArr(t_$i) $base_coverArr(c_$i) $base_coverArr(g_$i) $base_coverArr(gap_$i)"
                            }
                            if {$mode} {
                                set exists 0
                                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name FROM $dbName.sequences_nucleotide WHERE name = '$contig_name'"}}]]
                                foreach sRes $sql_res {
                                    set exists 1
                                }
                                unset sql_res
                                if {$exists} {
                                    eval [subst {thread::send $phpThreadID {::php_getSQLresults "UPDATE $dbName.sequences_nucleotide SET sequence_gap='$contig_sequence_gap', base_cover='$base_cover' WHERE name='$contig_name';"}}]
                                } else {
                                    set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                                    set contig_length [string length $contig_sequence]
                                    incr contig_num
                                    eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover');INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0.0')"}}]
                                }
                            } else {
                                set contig_sequence [regsub -all {\*} $contig_sequence_gap ""]
                                set contig_length [string length $contig_sequence]
                                incr contig_num
                                eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO $dbName.sequences_nucleotide VALUES ('$contig_num', '$contig_name', '$contig_reads', '$contig_length', '$contig_sequence', '$contig_sequence_gap', '$base_cover');INSERT INTO $dbName.seq_info VALUES ('$contig_num', '$contig_name', '$contig_length', '$contig_reads', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0.0')"}}]
                            }
                            if {[catch {puts ">$contig_name length=$contig_length numreads=$contig_reads...done."}]} {puts ">$contig_name ...updated."}
                            unset base_cover
                            unset contig_reads
                            unset contig_sequence_gap
                            unset contig_qual
                            unset readL
                            for {set i 0} {$i < $maxContigLen} {incr i} {
                                unset base_coverArr(a_$i)
                                unset base_coverArr(t_$i)
                                unset base_coverArr(c_$i)
                                unset base_coverArr(g_$i)
                                unset base_coverArr(gap_$i)
                            }
                            unset maxContigLen
                        }
                    } err
                    puts "Exit code: $err"
                    close $fs
                }
                returnResult $processID finished "Adding sequences from ACE file...done" $dbName 1 $mainThreadID
            }
            proc returnResult {processID status process dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName 1}}]
                eval [subst {thread::send -async $mainThreadID {::database_update dbInfo 0}}]
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        set contig_num [database_getNum sequences_nucleotide $env(dbName)]
        process_update $processID running "Adding sequences from ACE file: $ace_file" $env(dbName) 0
        eval [subst {thread::send -async $::threadACEAdd {ace_add $env(dbName) {$ace_file} $processID $env(mainThreadID) $env(phpThreadID) $contig_num} result}]
    }   
}

proc database_SAM_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{SAM Files} {.sam} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addSAM
            catch {destroy $t}
            toplevel $t
            wm title $t "Add SAM file"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Add reads from\n$f\nto $env(dbName).\n(Reference contigs must be present in the database)\n\nAre you sure?"
            
            set comm "database_SAM_add \"$f\""
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_SAM_add {sam_file} {
    global env
    
    destroy .addSAM
    if {$env(dbName) ne " "} {
        set ::threadSAMAdd [thread::create {
            proc sam_add {dbName sam_file processID mainThreadID phpThreadID} {
                global contig_name
                global contig_numreads
                global contig_sequence_gap
                global contig_baseCover
                global contig_readL
                
                if {[catch {set fs [open $sam_file r]}]} {
                    puts "cant find $f."
                } else {
                    puts "reading SAM file..."
                    set contig_name ""
                    set contig_sequence ""
                    set contig_numreads 0
                    set contig_sequence_gap ""
                    set contig_baseCover ""
                    set contig_readL ""
                    set contig_currentReads ""
                    set old_gaps 0
                    set old_pos 0
                    set count_contig 0

                    catch {
                        while {[gets $fs line] != -1} {
                            if {[lindex $line 2] ne $contig_name} {
                                if {$contig_name ne "" && $contig_readL ne ""} {
                                    returnResult $processID finished "Adding sequences from SAM file: $sam_file" $dbName "$count_contig contigs finished.\nAdding reads of contig: $contig_name..." $mainThreadID
                                    finish_contig $dbName $phpThreadID
                                    incr count_contig
                                    set contig_name ""
                                    set contig_sequence ""
                                    set contig_numreads 0
                                    set contig_sequence_gap ""
                                    set contig_baseCover ""
                                    set contig_readL ""
                                    set contig_currentReads ""
                                }
                                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, sequence, sequence_gap, base_cover FROM $dbName.sequences_nucleotide WHERE name = '[lindex $line 2]'"}}]]
                                if {$sql_res eq ""} {
                                    set contig_name ""
                                    set contig_sequence ""
                                    set contig_numreads 0
                                    set contig_sequence_gap ""
                                    set contig_baseCover ""
                                    set contig_readL ""
                                    set contig_currentReads ""
                                } else {
                                    foreach sRes $sql_res {
                                        set contig_name [lindex $sRes 0]
                                        set contig_sequence [lindex $sRes 1]
                                        set contig_baseCover [lindex $sRes 3]
                                        if {[string length [string trim [lindex $sRes 2]]] eq 0} {
                                            set contig_sequence_gap [lindex $sRes 1]
                                        } else {
                                            set contig_sequence_gap [lindex $sRes 2]
                                        }
                                        if {$contig_baseCover eq ""} {
                                            for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                                                lappend contig_baseCover "0 0 0 0 0"
                                            }
                                        }
                                    }
                                }
                                unset sql_res
                                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name_read FROM $dbName.read_hits WHERE name_seq = '[lindex $line 2]'"}}]]
                                foreach sRes $sql_res {
                                    lappend contig_currentReads [lindex $sRes 0]
                                }
                                unset sql_res
                                set contig_numreads [llength $contig_currentReads]
                            }
                            if {$contig_name ne ""} {                                
                                set k [lsearch $contig_currentReads [lindex $line 0]]
                                if {$k eq -1} {
                                    set readName [lindex $line 0]
                                    
                                    set flag [int2bits [lindex $line 1]]
                                    if {[llength $flag] <= 4} {
                                        set strand "U"
                                    } elseif {[llength $flag] >= 5} {
                                        if {[lindex $flag [expr [llength $flag] - 5]] eq 0} {
                                            set strand "U"
                                        } else {
                                            set strand "C"
                                        }
                                    }
                                    
                                    set seq_start [lindex $line 3]
                                    set cigar [lindex $line 5]
                                    set read_seq [lindex $line 9]
                                    set read_seqIns $read_seq
                                    set read_start 0
                                    set read_end 0
                                    set r_start 1
                                    set bases ""
                                    set basesOld 0
                                    set gaps 0
                                    set new_gaps 0
                                    
                                    if {$old_pos eq [expr $seq_start + $old_gaps - 1]} {
                                        set gaps $old_gaps
                                    } elseif {$old_pos < [expr $seq_start - 1]} {
                                        set gaps $old_gaps
                                        for {set i $old_pos} {$i < [expr $seq_start + $gaps]} {incr i} {
                                            if {[string index $contig_sequence_gap $i] eq "*"} {
                                                incr gaps
                                            }
                                        }
                                        set old_pos $i
                                        set old_gaps $gaps
                                    } else {
                                        set gaps 0
                                        for {set i 0} {$i < [expr $seq_start + $gaps]} {incr i} {
                                            if {[string index $contig_sequence_gap $i] eq "*"} {
                                                incr gaps
                                            }
                                        }
                                        set old_pos $i
                                        set old_gaps $gaps
                                    }

                                    set read_pos [expr $seq_start + $gaps]
                                    
                                    #parsing cigar
                                    for {set i 0} {$i < [string length $cigar]} {incr i} {
                                        switch [string index $cigar $i] {
                                            "H" {
                                                if {$r_start} {
                                                    #set read_end [expr $read_end + $bases]
                                                    #set read_start [expr $read_Start + $bases]
                                                    set read_start 1
                                                    set bases ""
                                                }
                                            }
                                            "S" {
                                                if {$r_start} {
                                                    #set read_end [expr $read_end + $bases]
                                                    #set read_start [expr $read_Start + $bases]
                                                    set read_start 1
                                                    set bases ""
                                                }
                                            }
                                            "M" {
                                                set read_end [expr $read_end + $bases]
                                                set r_start 0
                                                if {$read_start eq 0} {
                                                    set read_start 1
                                                }
                                                set bases ""
                                            }
                                            "N" {
                                                set skip_seq ""
                                                for {set j 0} {$j < $bases} {incr j} {
                                                    set skip_seq "_$skip_seq"
                                                }
                                                set read_seq "[string range $read_seq 0 [expr $read_end - $read_start]]$skip_seq[string range $read_seq [expr $read_end - $read_start + 1] end]"
                                                set read_end [expr $read_end + $bases]
                                                set bases ""
                                                
                                                set read_end [expr $read_end + $bases]
                                                set bases ""
                                            }
                                            "P" {
                                                set read_end [expr $read_end + $bases]
                                                set bases ""
                                            }
                                            "I" {
                                                set gapStr ""
                                                
                                                set gapsTMP $gaps
                                                for {set j $read_pos} {$j < [expr $seq_start + $gapsTMP + $read_end - 1]} {incr j} {
                                                    if {[string index $contig_sequence_gap $j] eq "*"} {
                                                        incr gaps
                                                    }
                                                }
                                                set gaps [expr $gaps - $basesOld]
                                                
                                                for {set j 0} {$j < $bases} {incr j} {
                                                    if {[string index $contig_sequence_gap [expr $seq_start + $read_end - 1 + $j + $gaps]] ne "*"} {
                                                        incr new_gaps
                                                        set contig_sequence_gap "[string range $contig_sequence_gap 0 [expr $seq_start + $read_end - 2 + $j + $gaps]]*[string range $contig_sequence_gap [expr $seq_start + $read_end - 1 + $j + $gaps] end]"
                                                        set contig_baseCover [linsert $contig_baseCover [expr $seq_start + $read_end - 1 + $j + $gaps] "0 0 0 0 0"]
                                                    }
                                                    set gapStr "*$gapStr"
                                                }
                                                
                                                set read_seqIns "[string range $read_seqIns 0 [expr $read_end - 1]]$gapStr[string range $read_seqIns [expr $read_end + $bases] end]"
                                                
                                                set read_pos [expr $seq_start + $gaps + $read_end - 1]
                                                set read_end [expr $read_end + $bases]
                                                
                                                set basesOld $bases
                                                set bases ""
                                            }
                                            "D" {
                                                set deletion_seq ""
                                                for {set j 0} {$j < $bases} {incr j} {
                                                    set deletion_seq "*$deletion_seq"
                                                }
                                                set read_seq "[string range $read_seq 0 [expr $read_end - $read_start]]$deletion_seq[string range $read_seq [expr $read_end - $read_start + 1] end]"
                                                set read_end [expr $read_end + $bases]
                                                set bases ""
                                            }
                                            "=" {
                                                set read_end [expr $read_end + $bases]
                                                set r_start 0
                                                if {$read_start = 0} {
                                                    set read_start 1
                                                }
                                                set bases ""
                                            }
                                            "X" {
                                                set read_end [expr $read_end + $bases]
                                                set r_start 0
                                                if {$read_start = 0} {
                                                    set read_start 1
                                                }
                                                set bases ""
                                            }
                                            default {
                                                set bases "$bases[string index $cigar $i]"
                                            }
                                        }
                                    }
                                    incr contig_numreads
                                    lappend contig_readL "$readName $strand $seq_start $read_start $read_end $read_seq $read_seqIns"
                                }
                            }
                        }
                        if {$contig_name ne "" && $contig_readL ne ""} {
                            returnResult $processID finished "Adding sequences from SAM file: $sam_file" $dbName "$count_contig contigs finished.\nAdding reads of contig: $contig_name..." $mainThreadID
                            finish_contig $dbName $phpThreadID
                            incr count_contig
                            unset contig_name
                            unset contig_sequence
                            unset contig_numreads
                            unset contig_sequence_gap
                            unset contig_baseCover
                            unset contig_readL
                        }
                    } err
                    puts "Exit code: $err"
                    close $fs
                }
                returnResult $processID finished "Adding sequences from SAM file...done" $dbName "$count_contig contigs finished." $mainThreadID
            }
            proc finish_contig {dbName phpThreadID} {
                global contig_name
                global contig_numreads
                global contig_sequence_gap
                global contig_baseCover
                global contig_readL
                
                for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                    set base_coverArr(a_$i) [lindex [lindex $contig_baseCover $i] 0]
                    set base_coverArr(t_$i) [lindex [lindex $contig_baseCover $i] 1]
                    set base_coverArr(c_$i) [lindex [lindex $contig_baseCover $i] 2]
                    set base_coverArr(g_$i) [lindex [lindex $contig_baseCover $i] 3]
                    set base_coverArr(gap_$i) [lindex [lindex $contig_baseCover $i] 4]
                }
                set contig_baseCover ""
                
                set start 0
                set count 0
                set input ""
                
                foreach r $contig_readL {
                    set gaps 0
                    set addedGaps 0
                    set startGaps ""
                    set read_seq [lindex $r 5]
                    set read_seqIns [lindex $r 6]
                    set seq_start [expr [lindex $r 2] - 1]
                    set seq_end [expr [lindex $r 2] + [lindex $r 4] - 1]
                    for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                        if {$i > [expr $seq_end + $gaps]} {
                            break
                        }
                        if {$i >= [expr $seq_start + $gaps]} {
                            if {$startGaps eq ""} {
                                set startGaps $gaps
                            }
                            if {[string index $contig_sequence_gap $i] eq "*" && [string index $read_seqIns [expr $i - $seq_start - $gaps]] ne "*"} {
                                set read_seq "[string range $read_seq 0 [expr $i - $seq_start - $gaps - 1 + $addedGaps]]*[string range $read_seq [expr $i - $seq_start - $gaps + $addedGaps] end]"
                                incr addedGaps
                            }
                        }
                        if {[string index $contig_sequence_gap $i] eq "*"} {
                            if {[string index $read_seqIns [expr $i - $seq_start - $gaps]] ne "*"} {
                                incr gaps
                            }
                        }
                    }
                    for {set i 0} {$i < [string length $read_seq]} {incr i} {
                        set base [string toupper [string index $read_seq $i]]
                        catch {
                            set ind [expr $seq_start + $startGaps + $i]
                            if {$base eq "A"} {
                                incr base_coverArr(a_$ind)
                            } elseif {$base eq "T"} {
                                incr base_coverArr(t_$ind)
                            } elseif {$base eq "C"} {
                                incr base_coverArr(c_$ind)
                            } elseif {$base eq "G"} {
                                incr base_coverArr(g_$ind)
                            } elseif {$base eq "*"} {
                                incr base_coverArr(gap_$ind)
                            }
                        }
                    }
                    
                    if {$start} {
                        append input "\n[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[expr [lindex $r 2] + $startGaps]\t[lindex $r 3]\t[expr [lindex $r 4] + $addedGaps]\t$read_seq"
                    } else {
                        set start 1
                        append input "[lindex $r 0]\t$contig_name\t[lindex $r 1]\t[expr [lindex $r 2] + $startGaps]\t[lindex $r 3]\t[expr [lindex $r 4] + $addedGaps]\t$read_seq"
                    }
                    incr count
                    if {$count >= 100} {
                        eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.read_hits "$input"}}]
                        set input ""
                        set start 0
                        set count 0
                    }
                }
                if {$input ne ""} {
                    eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.read_hits "$input"}}]
                    unset input
                    set count 0
                }

                for {set i 0} {$i < [string length $contig_sequence_gap]} {incr i} {
                    lappend contig_baseCover "$base_coverArr(a_$i) $base_coverArr(t_$i) $base_coverArr(c_$i) $base_coverArr(g_$i) $base_coverArr(gap_$i)"
                }
                
                eval [subst {thread::send $phpThreadID {::php_getSQLresults "UPDATE $dbName.sequences_nucleotide SET numreads = '$contig_numreads', sequence_gap = '$contig_sequence_gap', base_cover = '$contig_baseCover' WHERE name = '$contig_name'; UPDATE $dbName.seq_info SET numreads = '$contig_numreads' WHERE name = '$contig_name'"}}]
                unset read_seq
                unset read_seqIns           
            }
            
            proc returnResult {processID status process dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
                eval [subst {thread::send -async $mainThreadID {::database_update dbInfo 0}}]
            }
            
            proc int2bits {i} {
                #returns a bitslist, e.g. int2bits 10 => {1 0 1 0}
                set res ""
                while {$i>0} {
                    set res [expr {$i%2}]$res
                    set i [expr {$i/2}]
                }
                if {$res==""} {set res 0}
                split $res ""
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        process_update $processID running "Adding sequences from SAM file: $sam_file" $env(dbName) 0
        eval [subst {thread::send -async $::threadSAMAdd {sam_add $env(dbName) {$sam_file} $processID $env(mainThreadID) $env(phpThreadID)} result}]
    }
}

proc database_nucleotide_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{Fasta Files} {.fa .fas .fna .fasta .txt} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addNuc
            catch {destroy $t}
            toplevel $t
            wm title $t "Add nucleotide sequences"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Add sequences from\n$f\nto $env(dbName)\n\nAre you sure?"
            
            set comm "database_nucleotide_add \"$f\""
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_nucleotide_add {f} {
    global env
    
    destroy .addNuc
    set nucL ""
    if {[catch {set fs [open $f r]}]} {
    } else {
        set strH ""
        set strS ""
        while {[gets $fs line] != -1} {
            if {[string index $line 0] eq ">"} {
                if {$strS ne ""} {
                    if {[lindex $strH 2] eq "?"} {
                        set strH [lreplace $strH 2 2 [string length $strS]]
                    }
                    lappend nucL "{$strH} {$strS}"
                    set name [string range [lindex $line 0] 1 end]
                    set numreads 0
                    set length ?
                    for {set i 1} {$i < [llength $line]} {incr i} {
                        if {[lindex [split [lindex $line $i] =] 0] eq "numreads"} {
                            set numreads [regsub -all {[;,.]} [lindex [split [lindex $line $i] =] 1] ""]
                        } elseif {[lindex [split [lindex $line $i] =] 0] eq "length"} {
                            set length [regsub -all {[;,.]} [lindex [split [lindex $line $i] =] 1] ""]
                        } else {
                            append name "_[lindex $line $i]"
                        }
                    }
                    set strH [regsub -all {'} "{$name} $numreads $length" `]
                    set strS ""
                } else {
                    set name [string range [lindex $line 0] 1 end]
                    set numreads 0
                    set length ?
                    for {set i 1} {$i < [llength $line]} {incr i} {
                        if {[lindex [split [lindex $line $i] =] 0] eq "numreads"} {
                            set numreads [regsub -all {[;,.]} [lindex [split [lindex $line $i] =] 1] ""]
                        } elseif {[lindex [split [lindex $line $i] =] 0] eq "length"} {
                            set length [regsub -all {[;,.]} [lindex [split [lindex $line $i] =] 1] ""]
                        } else {
                            append name "_[lindex $line $i]"
                        }
                    }
                    set strH [regsub -all {'} "{$name} $numreads $length" `]
                }
            } else {
                append strS "$line"
            }
        }
        if {[lindex $strH 2] eq "?"} {
            set strH [lreplace $strH 2 2 [string length $strS]]
        }
        lappend nucL "{$strH} {$strS}"
        close $fs
    }
    
    if {$nucL eq "{} {}"} {
        set nucL ""
    }
    if {$nucL ne ""} {
        set ::threadNucleotideAdd [thread::create {
            proc nucleotide_add {dbName nucL num processID mainThreadID phpThreadID} {
                set all [llength $nucL]
                set result 1
                set count 0
                set start 0
                set input ""
                set start_num $num
                foreach nuc $nucL {
                    if {$start eq 0} {
                        set start 1
                        append input "$num\t[lindex [lindex $nuc 0] 0]\t[lindex [lindex $nuc 0] 1]\t[lindex [lindex $nuc 0] 2]\t[lindex $nuc 1]\t\t"
                    } else {
                        append input "\n$num\t[lindex [lindex $nuc 0] 0]\t[lindex [lindex $nuc 0] 1]\t[lindex [lindex $nuc 0] 2]\t[lindex $nuc 1]\t\t"
                    }
                    incr num
                    incr count
                    if {$count >= 100} {
                        eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.sequences_nucleotide "$input"}}]
                        set input ""
                        set start 0
                        set count 0
                    }
                }
                if {$input ne ""} {
                    eval [subst {thread::send $phpThreadID {::php_getDBupload $dbName.sequences_nucleotide "$input"}}]
                    unset input
                    unset start 
                    unset count 
                }
                unset nucL
                
                eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}]
                returnResult $processID finished "[expr $num - $start_num] of $all sequences added." $dbName "$result" $mainThreadID
            }
            proc returnResult {processID status process dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
                eval [subst {thread::send -async $mainThreadID {::dbEvnt $dbName 0}}]
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        process_update $processID running "Adding nucleotide sequences" $env(dbName) 0
        set contig_num [database_getNum sequences_nucleotide $env(dbName)]
        eval [subst {thread::send -async $::threadNucleotideAdd {nucleotide_add $env(dbName) {$nucL} $contig_num $processID $env(mainThreadID) $env(phpThreadID)} result}]
    }
}

proc database_nucleotide_new_window {db id_seq} {
    global env
    
    if {$env(dbName) ne " "} {
        set t .newNuc
        catch {destroy $t}
        toplevel $t
        wm title $t "New nucleotide sequence entry"
        wm attributes $t -topmost 1
        wm minsize $t 400 400
        variable head
        set head "${env(dbName)}_x"
        
        frame $t.seq
        label $t.seq.labelH -text "Header:"
        entry $t.seq.entH -width 80 -textvariable head -background white
        label $t.seq.labelS -text "Sequence:"
        text $t.seq.seqPanel -height 5 -width 80 -background white
        label $t.seq.label2 -text "Add comment:"
        frame $t.bottom
        text $t.bottom.commentPanel -height 9 -background white
        frame $t.bottom.frames
        radiobutton $t.bottom.frames.0 -text "None" -variable goview_rb -value "0" -command {database_nucleotide_new_show_frame 0}
        radiobutton $t.bottom.frames.1 -text "Frame 1" -variable goview_rb -value "1" -command {database_nucleotide_new_show_frame 1}
        radiobutton $t.bottom.frames.2 -text "Frame 2" -variable goview_rb -value "2" -command {database_nucleotide_new_show_frame 2}
        radiobutton $t.bottom.frames.3 -text "Frame 3" -variable goview_rb -value "3" -command {database_nucleotide_new_show_frame 3}
        radiobutton $t.bottom.frames.4 -text "Frame 4" -variable goview_rb -value "4" -command {database_nucleotide_new_show_frame 4}
        radiobutton $t.bottom.frames.5 -text "Frame 5" -variable goview_rb -value "5" -command {database_nucleotide_new_show_frame 5}
        radiobutton $t.bottom.frames.6 -text "Frame 6" -variable goview_rb -value "6" -command {database_nucleotide_new_show_frame 6}
        $t.bottom.frames.0 select
        
        set comm "database_nucleotide_new; destroy $t"
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command "areYouSurePopUp {Add sequence} {Adding sequence to database:\n\n$env(dbName)\n\nAre you sure?} {$comm}"
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.bottom.frames.0 $t.bottom.frames.1 $t.bottom.frames.2 $t.bottom.frames.3 $t.bottom.frames.4 $t.bottom.frames.5 $t.bottom.frames.6 -side top -fill both
        pack $t.bottom.frames -side left; pack $t.bottom.commentPanel -side left -expand true -fill both
        pack $t.seq.labelH $t.seq.entH $t.seq.labelS -side top -fill both
        pack $t.seq.seqPanel -expand true -side top -fill both; pack $t.seq.label2 -side top -fill both
        pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.seq -expand true -side top -fill both
        pack $t.bottom $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
        
        $t.seq.seqPanel tag configure markedYellow -background yellow
        $t.seq.seqPanel tag configure markedGreen -background green
        $t.seq.seqPanel tag configure markedRed -background red
        
        if {$db eq "sequence_edit"} {
            $t.seq.seqPanel insert 1.end $id_seq
        } else {
            if {$id_seq ne "-"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence FROM [string tolower $db].sequences_nucleotide WHERE id_seq = '$id_seq'"}}]]
                foreach sRes $sql_res {
                    set seq [lindex $sRes 0]
                    
                }
                unset sql_res
                $t.seq.seqPanel insert 1.end $seq
            }
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_nucleotide_new {} {
    global env
    
    set comment [regsub -all {\n} [.newNuc.bottom.commentPanel get -displaychars 1.0 end] "\\\n"]
    set seq [string trim [regsub -all {\n} [.newNuc.seq.seqPanel get -displaychars 1.0 end] ""]]
    set len [string length $seq]
    set tmp [.newNuc.seq.entH get]
    set head [lindex $tmp 0]
    set tmp [regsub -all {=} $tmp " "]
    set i 0
    set numreads 0
    foreach t $tmp {
        incr i
        if {$t eq "numreads"} {
            set numreads [lindex $tmp $i]
            break
        }
    }
    unset tmp
    
    if {$head ne ""} {
        set ::threadNucNew [thread::create {
            proc nuc_new {phpThreadID dbName nuc comment} {
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.newNuc('$dbName', '$nuc', '$comment') AS out"}}]]
                eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}]
                if {[lindex $sql_res end] eq "Fehler"} {
                    puts "error: $sql_res"
                }
                unset sql_res
            }
            thread::wait
        }]
        eval [subst {thread::send -async $::threadNucNew {nuc_new $env(phpThreadID) $env(dbName) {$head $numreads $len $seq} {$comment}}}]
    }
}

proc database_nucleotide_new_show_frame {fr} {
    set nuc [string trim [.newNuc.seq.seqPanel get -displaychars 1.0 end]]
    if {$nuc ne ""} {
        catch {.newNuc.seq.seqPanel tag remove markedRed 1.0 end}
        catch {.newNuc.seq.seqPanel tag remove markedGreen 1.0 end}
        catch {.newNuc.seq.seqPanel tag remove markedYellow 1.0 end}
        
        switch $fr {
            + {set h 0; set i 0}
            - {set h 1; set i 0}
            1 {set h 0; set i 0}
            2 {set h 0; set i 1}
            3 {set h 0; set i 2}
            4 {set h 1; set i 2}
            5 {set h 1; set i 1}
            6 {set h 1; set i 0}
        }
        
        if {$fr eq 0} {
        } elseif {$h} {
            set pos [translateNuc $nuc 0 $fr]
            if {[lindex $pos 1] ne ""} {
                .newNuc.seq.seqPanel tag add markedYellow 1.[lindex [lindex $pos 1] 0] 1.[expr [string length $nuc] - $i]
            } else {
                .newNuc.seq.seqPanel tag add markedYellow 1.0 1.[expr [string length $nuc] - $i]
            }
            foreach s [lindex $pos 0] {
                foreach e "[lindex $pos 1] 0" {
                    if {$e < $s} {
                        .newNuc.seq.seqPanel tag add markedYellow 1.$e 1.$s
                        break
                    }
                }
                .newNuc.seq.seqPanel tag add markedGreen 1.[expr ($s - 3)] 1.$s
            }
            foreach s [lindex $pos 1] {
                .newNuc.seq.seqPanel tag add markedRed 1.[expr ($s - 3)] 1.$s
            }
        } else {
            set pos [translateNuc $nuc 0 $fr]
            if {[lindex $pos 1] ne ""} {
                .newNuc.seq.seqPanel tag add markedYellow 1.$i 1.[lindex [lindex $pos 1] 0]
            } else {
                .newNuc.seq.seqPanel tag add markedYellow 1.$i 1.end
            }
            
            foreach s [lindex $pos 0] {
                foreach e "[lindex $pos 1] [string length $nuc]" {
                    if {$e > $s} {
                        .newNuc.seq.seqPanel tag add markedYellow 1.$s 1.$e
                        break
                    }
                }
                .newNuc.seq.seqPanel tag add markedGreen 1.$s 1.[expr $s + 3]
            }
            foreach s [lindex $pos 1] {
                .newNuc.seq.seqPanel tag add markedRed 1.$s 1.[expr $s + 3]
            }
        }
    } else {
        errorPopUp "Error" "No sequence in panel."
    }
}

proc database_password_change_window {} {
    set t .database_password_change
    catch {destroy $t}
    toplevel $t
    wm title $t "Database: Change password"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.db
    frame $t.db.o
    label $t.db.o.label -text "Old password:"
    entry $t.db.o.ent  -width 15 -background white -foreground white
    frame $t.db.n
    label $t.db.n.label -text "New password:"
    entry $t.db.n.ent  -width 15 -background white -foreground white
    frame $t.db.c
    label $t.db.c.label -text "Confirm:"
    entry $t.db.c.ent  -width 15 -background white -foreground white
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "database_password_change; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.db.o.label -side left -fill both; pack $t.db.o.ent -side right -fill both
    pack $t.db.n.label -side left -fill both; pack $t.db.n.ent -side right -fill both
    pack $t.db.c.label -side left -fill both; pack $t.db.c.ent -side right -fill both
    pack $t.db.o $t.db.n $t.db.c -side top -fill both
    
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.db $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc database_password_change {} {
    global env
    
    set pwdO [.database_password_change.db.o.ent get]
    set pwdN [.database_password_change.db.n.ent get]
    set pwdC [.database_password_change.db.c.ent get]
    
    set err 0
    if {$pwdN eq $pwdC} {
        catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "ALTER ROLE $env(user) ENCRYPTED PASSWORD '$pwdN';"}}]} err
    } else {
        errorPopUp "" "Could not confirm new password."
    }
    if {$err eq ""} {
        errorPopUp "" "Password changed."
    } else {
        errorPopUp "" "Password not changed."
    }
}

proc database_polyA_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{Text file} {.txt} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addPolyA
            catch {destroy $t}
            toplevel $t
            wm title $t "Add polyA information"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "Add polyA information from\n$f\nto $env(dbName)\n\nAre you sure?"
            
            set comm "database_polyA_add \"$f\"; destroy $t"
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_polyA_add {f} {
    global env
    
    set polyAL ""
    if {[catch {set ft [open $f r]} ]} {
    } else {
        while {[gets $ft line] != -1} {
            lappend polyAL $line
        }
        close $ft
    }
    if {$polyAL ne ""} {
        set ::threadPolyAdd [thread::create {
            proc polyA_add {dbName polyAL mainThreadID phpThreadID processID} {
                set all [llength $polyAL]
                set inL ""
                for {set i 0} {$i < $all} {incr i} {
                    append inL ", '[lindex $polyAL $i]'"
                }
                if {$inL ne ""} {
                    set inL [string range $inL 2 end]
                    catch {
                        eval [subst {thread::send $phpThreadID {::php_getSQLresults "UPDATE $dbName.sequences_read SET polya='TRUE' WHERE name IN ($inL);"}}]
                    } result
                    if {[lindex $result 0] eq "ERROR:"} {
                        returnResult $processID error "Error while adding polyA information." $dbName $result $mainThreadID
                    } else {
                        returnResult $processID finished "$all reads set to polyA." $dbName $result $mainThreadID
                    }
                    unset inL; unset all
                }
            }
            proc returnResult {processID status process dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
                eval [subst {thread::send -async $mainThreadID {::dbEvnt $dbName 0}}]
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        process_update $processID running "Adding polyA information" $env(dbName) 0
        eval [subst {thread::send -async $::threadPolyAdd {polyA_add $env(dbName) {$polyAL} $env(mainThreadID) $env(phpThreadID) $processID} result}]
    }
}

proc database_protein_add_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set f [browse open {{{Fasta Files} {.fasta .input .pep} } {{All Files} * }} -]
        if {$f ne ""} {
            set t .addProt
            catch {destroy $t}
            toplevel $t
            wm title $t "Add protein sequences"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            ComboBox $t.cb -width 30 -hottrack 1 -background white -text "nucleotide entry necessary" -values {{nucleotide entry necessary} {without nucleotide entry}}
            frame $t.ptitle
            label $t.ptitle.label -height 7 -text "\nAdd sequences from\n$f\nto $env(dbName)\n\nAre you sure?"
            
            set comm "database_protein_add \"$f\" window; destroy $t"
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command $comm
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.ptitle.label -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.cb $t.ptitle $t.buts -side top -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc database_protein_add {f mode} {
    global env
    
    if {$mode eq "window"} {
        set mode [lindex [.addProt.cb get] 0]
        if {$mode eq "nucleotide"} {
            set mode 1
        } else {
            set mode 0
        }
    }    
    
    if {[catch {set ft [open $f r]} ]} {
    } else {
        set strH ""
        set strS ""
        if {$mode} {
            if {[lindex [split $f .] end] eq "input"} {
                while {[gets $ft line] != -1} {
                    if {[string index $line 0] eq ">"} {
                        if {$strS ne ""} {
                            lappend proteinL "{$strH} $strS"
                            set strH "[string range [lindex $line 0] 1 end] [lindex $line 3] [string index [lindex $line 6] 0] [string range [lindex $line 8] 0 [expr [string length [lindex $line 8]] - 2]]"
                            set strS ""
                        } else {
                            set strH "[string range [lindex $line 0] 1 end] [lindex $line 3] [string index [lindex $line 6] 0] [string range [lindex $line 8] 0 [expr [string length [lindex $line 8]] - 2]]"
                        }
                    } else {
                        append strS "$line"
                    }
                }
            } elseif {[lindex [split $f .] end] eq "pep"} {
                while {[gets $ft line] != -1} {
                    if {[string index $line 0] eq ">"} {
                        if {$strS ne ""} {
                            lappend proteinL "{$strH} $strS"
                            foreach ent $line {
                                set fr +
                                if {$ent eq "minus"} {
                                    set fr "-"
                                }
                            }
                            set strH "[string range [lindex $line 0] 1 end]_ESTscan [string range [lindex $line 0] 1 end] $fr 1"
                            set strS ""
                        } else {
                            foreach ent $line {
                                set fr +
                                if {$ent eq "minus"} {
                                    set fr "-"
                                }
                            }
                            set strH "[string range [lindex $line 0] 1 end]_ESTscan [string range [lindex $line 0] 1 end] $fr 1"
                        }
                    } else {
                        append strS "$line"
                    }
                }
            }
        } else {
            while {[gets $ft line] != -1} {
                if {[string index $line 0] eq ">"} {
                    if {$strS ne ""} {
                        lappend proteinL "{$strH} $strS"
                        set strH "[string range [lindex $line 0] 1 end]"
                        set strS ""
                    } else {
                        set strH "[string range [lindex $line 0] 1 end]"
                    }
                } else {
                    append strS "$line"
                }
            }
        }
        lappend proteinL "{$strH} $strS"
        close $ft
    }
    if {$proteinL ne ""} {
        set ::threadProteinAdd [thread::create {
            proc protein_add {dbName proteinL mainThreadID phpThreadID processID mode} {
                set num 0
                set result ""
                set all [llength $proteinL]
                foreach prot $proteinL {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.addProt('$dbName', '$prot', '$mode') AS out"}}]]
                    foreach sRes $sql_res {
                        set result "[lindex $sRes 0]\n"
                    }
                    unset sql_res
                    incr num
                }
                eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}]
                if {[lindex $result 0] eq "ERROR:"} {
                    returnResult $processID error "Error while adding protein sequences." $dbName $result $mainThreadID
                } else {
                    returnResult $processID finished "$num of $all protein sequences added." $dbName $result $mainThreadID
                }
            }
            proc returnResult {processID status process dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
                eval [subst {thread::send -async $mainThreadID {::dbEvnt $dbName 0}}]
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        process_update $processID running "Adding protein sequences" $env(dbName) 0
        eval [subst {thread::send -async $::threadProteinAdd {protein_add $env(dbName) {$proteinL} $env(mainThreadID) $env(phpThreadID) $processID $mode} result}]
    }
}

proc db_info_run_add_window {} {
    global env
    global database_run_add_file
    
    if {$env(dbName) ne " "} {
        set t .addRun
        catch {destroy $t}
        toplevel $t
        wm title $t "Add Run"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        variable database_run_add_file
        
        frame $t.file
        label $t.file.label -text "Fasta file:"
        entry $t.file.ent -textvariable database_run_add_file -width 15 -background white
        button $t.file.browse -text "Browse" -command "database_run_add_get_file"
        frame $t.id
        label $t.id.label -text "ID:"
        entry $t.id.ent -textvariable id -width 15 -background white
        frame $t.description
        label $t.description.label -text "Description:"
        entry $t.description.ent -textvariable description -width 15 -background white
        frame $t.treatment
        label $t.treatment.label -text "Treatment:"
        entry $t.treatment.ent -textvariable treatment -width 15 -background white
        frame $t.sequencer
        label $t.sequencer.label -text "Sequencer:"
        entry $t.sequencer.ent -textvariable seqeuncer -width 15 -background white
        frame $t.type
        label $t.type.label -text "Type:"
        entry $t.type.ent -textvariable type -width 15 -background white
        frame $t.runs
        label $t.runs.label -text "Runs:"
        entry $t.runs.ent -textvariable runs -width 15 -background white
        frame $t.dateIn
        label $t.dateIn.label -text "Date in:"
        entry $t.dateIn.ent -textvariable dateIn -width 15 -background white
        frame $t.dateOut
        label $t.dateOut.label -text "Date out:"
        entry $t.dateOut.ent -textvariable dateOut -width 15 -background white
        frame $t.data
        label $t.data.label -text "Data:"
        entry $t.data.ent -textvariable data -width 15 -background white
        frame $t.comment
        label $t.comment.label -text "Comment:"
        entry $t.comment.ent -textvariable comment -width 15 -background white
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command "database_run_add new"
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.file.label -side left -fill both; pack $t.file.browse $t.file.ent -side right -fill both
        pack $t.id.label -side left -fill both; pack $t.id.ent -side right -fill both
        pack $t.description.label -side left -fill both; pack $t.description.ent -side right -fill both
        pack $t.treatment.label -side left -fill both; pack $t.treatment.ent -side right -fill both
        pack $t.sequencer.label -side left -fill both; pack $t.sequencer.ent -side right -fill both
        pack $t.type.label -side left -fill both; pack $t.type.ent -side right -fill both
        pack $t.runs.label -side left -fill both; pack $t.runs.ent -side right -fill both
        pack $t.dateIn.label -side left -fill both; pack $t.dateIn.ent -side right -fill both
        pack $t.dateOut.label -side left -fill both; pack $t.dateOut.ent -side right -fill both
        pack $t.data.label -side left -fill both; pack $t.data.ent -side right -fill both
        pack $t.comment.label -side left -fill both; pack $t.comment.ent -side right -fill both
        pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
        pack $t.file $t.id $t.description $t.treatment $t.sequencer $t.type $t.runs \
                $t.dateIn $t.dateOut $t.data $t.comment $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        errorPopUp "Error" "Please select a database."
    }  
}

proc database_run_add_exists_window {run} {
    global env
    
    set txt ""
    set t .database_run_add_exists
    
    catch {destroy $t}
    toplevel $t
    wm title $t "Update Run"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.ptitle
    label $t.ptitle.label -height 5 -text "Run '$run' already exists.\n\nUpdate run information?"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "OK" -command "destroy $t; db_info_run_add add"
    button $t.buts.cancel -text "Cancel" -command "catch {destroy .addRun}; destroy $t"
    
    pack $t.ptitle.label -side left -fill both
    pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
    pack $t.ptitle $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc db_info_run_add_get_file {} {
    global database_run_add_file
    set database_run_add_file [browse open {{{Fasta Files} {.fasta .fas .fna .fa} } {{All Files} * }} -]
}

proc db_info_run_add {mode} {
    global env
     
    set run_file [.addRun.file.ent get]
    set run_info "[.addRun.id.ent get]"
    set sequences 0
    set stop 1
    set i 0
    if {$mode eq "new"} {
        set ok 1
        while {$stop} {
            if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
                set stop 0
            } else {
                if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3] eq $run_info} {
                    set ok 0
                    break
                }
            }
            incr i
        }
        unset stop; unset i
        if {$ok eq 0} {
            database_run_add_exists_window $run_info
        } else {
            database_run_add run
        }
    } else {
        if {$run_file ne ""} {
            if {[catch {set fs [open $run_file r]}]} {
                errorPopUp "Error" "cant find read sequence file: $run_file"
            } else {
                set strH ""
                set strS ""
                while {[gets $fs line] != -1} {
                    if {[string index $line 0] eq ">"} {
                        if {$strS ne ""} {
                            lappend readSeqs "$strH [string length $strS] $polyA TRUE $strS"
                            set strS ""
                            set strH [string range [lindex $line 0] 1 end]
                            if {[lindex $line 1] eq "polyA"} {
                                set polyA TRUE
                            } else {
                                set polyA FALSE
                            }
                        } else {
                            set strH [string range [lindex $line 0] 1 end]
                            if {[lindex $line 1] eq "polyA"} {
                                set polyA TRUE
                            } else {
                                set polyA FALSE
                            }
                        }
                    } else {
                        append strS "$line"
                    }
                }
                lappend readSeqs "$strH [string length $strS] $polyA TRUE $strS"
                close $fs
                
                # Write to the database:
                set input ""
                set start 0
                set num [database_getNum sequences_read $env(dbName)]
                set count 0
                foreach ent $readSeqs {
                    if {$start eq 0} {
                        set start 1
                        append input "$num\t[lindex $run_info 0]\t[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $ent 4]"
                    } else {
                        append input "\n$num\t[lindex $run_info 0]\t[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $ent 4]"
                    }
                    incr num
                    incr count
                    if {$count >= 100} {
                        eval [subst {thread::send $::threadPHP {::php_getDBupload $env(dbName).sequences_read "$input"}}]
                        set input ""
                        set start 0
                        set count 0
                    }
                    
                }
                unset readSeqs
                if {$input ne ""} {
                    eval [subst {thread::send $::threadPHP {::php_getDBupload $env(dbName).sequences_read "$input"}}]
                }
                unset input
            }
            set mode run
        }
        if {$mode eq "run"} {
            lappend run_info [.addRun.description.ent get]
            lappend run_info [.addRun.runs.ent get]
            lappend run_info [.addRun.sequencer.ent get]
            lappend run_info [.addRun.type.ent get]
            lappend run_info [.addRun.dateIn.ent get]
            lappend run_info [.addRun.dateOut.ent get]
            lappend run_info [.addRun.data.ent get]
            lappend run_info [lindex [lindex [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT COUNT(id_run) AS out FROM $env(dbName).sequences_read WHERE id_run = '[lindex $run_info 0]'"}}]] 0] 0]
            lappend run_info -1
            lappend run_info -1
            lappend run_info [.addRun.treatment.ent get]
            lappend run_info [.addRun.comment.ent get]
            lappend run_info "blue"
            if {[.addRun.treatment.ent get] eq ""} {
                lappend run_info "A"
            } else {
                lappend run_info "B"
            }
            set out ""
            catch {
                set f [lindex [split $run_file /] end]
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.addRun('$env(dbName)', '$run_info') AS out"}}]]
                foreach sRes $sql_res {
                    set out [lindex $sRes 0]
                }
                unset sql_res
            }
            if {$out ne "1"} {
                errorPopUp "Error" "$out"
            }
            database_update dbInfo 0
            dbEvnt $env(dbName) 0
            unset run_info
        }
        catch {destroy .addRun}
    }   
}

proc db_info_run_change {} {
    global env
    
    .result.notebook1.nb.fdb_info.1.table.l finishediting
    
    set runL ""
    set stop 0
    set i 0
    while {$stop ne 1} {
        if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq 1} {
            lappend runL "[lrange [.result.notebook1.nb.fdb_info.1.table.l get $i] 3 end] [string range [[.result.notebook1.nb.fdb_info.1.table.l windowpath $i,1] cget -image] 1 end] [[.result.notebook1.nb.fdb_info.1.table.l windowpath $i,2] cget -text]"
        } elseif {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
            set stop 1
        }
        incr i
    }
    if {$runL ne ""} {
        catch {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.changeRun('$env(dbName)', '$runL') AS out"}}]]
            foreach sRes $sql_res {
                set out [lindex $sRes 0]
            }
            unset sql_res
        } out
        dbEvnt $env(dbName) 0
    }
    unset runL
}

proc db_info_run_delete_window {} {
    global env
    
    if {$env(dbName) ne " "} {
        set t .deleteRun
        catch {destroy $t}
        toplevel $t
        wm title $t "Delete Runs"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        set txt "Delete selected runs.\n\nAre you sure?"
        set comm "database_run_delete; destroy $t"
        
        frame $t.ptitle
        label $t.ptitle.label -height 5 -text $txt
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command $comm
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.ptitle.label -side left -fill both
        pack $t.buts.ok $t.buts.cancel -side left -fill both -anchor c
        pack $t.ptitle $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc db_info_run_delete {} {
    global env
    
    .result.notebook1.nb.fdb_info.1.table.l finishediting
    
    set runL ""
    set stop 0
    set i 0
    while {$stop ne 1} {
        if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq 1} {
            lappend runL [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3]
        } elseif {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
            set stop 1
        }
        incr i
    }
    
    if {$runL ne ""} {
        catch {eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.delrun('$env(dbName)', '$runL')"}}]} out
    }
    unset runL
    dbEvnt $env(dbName) 0
}

proc database_update {mode param} {
    global env

    if {$env(dbName) ne " "} {
        set ::threadUpdate [thread::create {
            proc update_run {dbName mode param processID mainThreadID phpThreadID} {
                set result 0
                set err ""
                if {$mode eq "seqInfo"} {
                    if {$param eq 0} {
                        catch {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.seqinfo('$dbName', 'all') AS out"}}]]
                            foreach ent $sql_res {
                                set result [lindex $ent 0]
                            }
                            unset sql_res
                        } err
                        catch {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName') AS out"}}]]
                            foreach ent $sql_res {
                                set result [lindex $ent 0]
                            }
                        } err
                    } else {
                        catch {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.seqinfo('$dbName', '$param') AS out"}}]]
                            foreach ent $sql_res {
                                set result [lindex $ent 0]
                            }
                            unset sql_res
                        } err
                    }
                } elseif {$mode eq "protInfo"} {
                    if {$param eq 0} {
                        catch {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.protinfo('$dbName', 'all') AS out"}}]]
                            foreach ent $sql_res {
                                set result [lindex $ent 0]
                            }
                            unset sql_res
                        } err
                    } else {
                        catch {
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.protinfo('$dbName', '$param') AS out"}}]]
                            foreach ent $sql_res {
                                set result [lindex $ent 0]
                            }
                            unset sql_res
                        } err
                    }
                } elseif {$mode eq "description_seq"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.getdes('$dbName', '$param', 'id_seq') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "description_prot"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.getdes('$dbName', '$param', 'id_prot') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "gostat"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.gostat('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "kegg"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.kegg('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "coverage"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.coverage('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "dbInfo"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "blast2interpro"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.blast2interpro('$dbName', '$param') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}]
                    } err
                } elseif {$mode eq "domain2interpro"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.domain2interpro('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.dbInfo('$dbName')"}}]
                    } err
                } elseif {$mode eq "readDistribution"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.readdistribution('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "readStatus"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.readstatus('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                } elseif {$mode eq "general"} {
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.readdistribution('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.coverage('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.kegg('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.domain2interpro('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.gostat('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.protinfo('$dbName', 'all') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.seqinfo('$dbName', '$param') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.getdes('$dbName', '$param', 'id_prot') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.getdes('$dbName', '$param', 'id_seq') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                    catch {
                        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT functions.dbInfo('$dbName') AS out"}}]]
                        foreach ent $sql_res {
                            set result [lindex $ent 0]
                        }
                        unset sql_res
                    } err
                }
                if {$result eq "1" || $err eq "1"} {
                    returnResult $processID finished $dbName 1 $mainThreadID 
                } else {
                    set result "[lindex [split [regsub -all {\"} $result "'"] \n] 0]"
                    set err "[regsub -all {\$} [regsub -all {\}} [regsub -all {\{} [regsub -all {\]} [regsub -all {\[} [regsub -all {\"} $err "'"] "\\\["] "\\\]"] "("] ")"] "\\\$"]"
                    returnResult $processID error $dbName "$result\n\nError:\n$err" $mainThreadID
                }
            }
            proc returnResult {processID status dbName result mainThreadID} {
                eval [subst {thread::send -async $mainThreadID {::process_update $processID $status - $dbName "$result"}}]
                eval [subst {thread::send -async $mainThreadID {::dbEvnt $dbName 0}}]
            }
            thread::wait
        }]
        set processID [llength $env(processL)]
        if {$mode eq "seqInfo"} {
            process_update $processID running "updating sequence hit information" $env(dbName) 0
        } elseif {$mode eq "protInfo"} {
            process_update $processID running "updating protein hit information" $env(dbName) 0
        } elseif {$mode eq "description_seq"} {
            process_update $processID running "updating blast/domain descriptions for contig sequences" $env(dbName) 0
        } elseif {$mode eq "description_prot"} {
            process_update $processID running "updating blast/domain descriptions for protein sequences" $env(dbName) 0
        } elseif {$mode eq "gostat"} {
            process_update $processID running "updating GO statistics" $env(dbName) 0
        } elseif {$mode eq "coverage"} {
            process_update $processID running "updating sequence coverage" $env(dbName) 0
        } elseif {$mode eq "dbInfo"} {
            process_update $processID running "updating database information" $env(dbName) 0
        } elseif {$mode eq "blast2interpro"} {
            process_update $processID running "getting new domain hits for $param entries" $env(dbName) 0
        } elseif {$mode eq "kegg"} {
            process_update $processID running "updating kegg information" $env(dbName) 0
        } elseif {$mode eq "domain2interpro"} {
            process_update $processID running "getting new InterPro/GO hits from domain entries" $env(dbName) 0
        } elseif {$mode eq "readDistribution"} {
            process_update $processID running "updating read distribution" $env(dbName) 0
        } elseif {$mode eq "readStatus"} {
            process_update $processID running "updating read status" $env(dbName) 0
        } elseif {$mode eq "general"} {
            process_update $processID running "updating database tables" $env(dbName) 0
        }
        
        eval [subst {thread::send -async $::threadUpdate {update_run $env(dbName) $mode {$param} $processID $env(mainThreadID) $env(phpThreadID)}}]
    } else {
        errorPopUp "Error - Update" "Cannot execute update, no database selected."
    }   
}

proc database_update_window {mode} {
    global env
    
    if {$env(dbName) ne " "} {
        set t .update_window
        catch {destroy $t}
        toplevel $t
        wm title $t "Database update"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        if {$mode eq "blast2interpro"} {
            frame $t.db
            label $t.db.label -text "Database identifier: "
            ComboBox $t.db.cb -width 15 -hottrack 1 -background white -text [lindex $env(blastRefDBL) 0] -values $env(blastRefDBL)
            
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command "database_update_params blast2interpro; destroy $t"
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.db.label $t.db.cb -side left -fill both
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.db $t.buts -side top -fill both
        } elseif {$mode eq "description_seq" || $mode eq "description_prot"} {
            global database_update_description_allCheck
            global database_update_description_blastCheck
            global database_update_description_blastprodomCheck
            global database_update_description_gene3dCheck
            global database_update_description_goCheck
            global database_update_description_interproCheck
            global database_update_description_keggCheck
            global database_update_description_pantherCheck
            global database_update_description_patternscanCheck
            global database_update_description_pfamCheck
            global database_update_description_pirCheck
            global database_update_description_profilescanCheck
            global database_update_description_smartCheck
            global database_update_description_superfamilyCheck
            global database_update_description_tigrCheck
            
            set database_update_description_allCheck 1
            set database_update_description_blastCheck 0
            set database_update_description_blastprodomCheck 0
            set database_update_description_gene3dCheck 0
            set database_update_description_goCheck 0
            set database_update_description_interproCheck 0
            set database_update_description_keggCheck 0
            set database_update_description_pantherCheck 0
            set database_update_description_patternscanCheck 0
            set database_update_description_pfamCheck 0
            set database_update_description_pirCheck 0
            set database_update_description_profilescanCheck 0
            set database_update_description_smartCheck 0
            set database_update_description_superfamilyCheck 0
            set database_update_description_tigrCheck 0
            
            frame $t.ptitle
            label $t.ptitle.label -text "Run update for:"
            
            frame $t.showFeat
            checkbutton $t.showFeat.all -text "all" -variable database_update_description_allCheck
            checkbutton $t.showFeat.blast -text "blast" -variable database_update_description_blastCheck
            checkbutton $t.showFeat.blastprodom -text "blastprodom" -variable database_update_description_blastprodomCheck
            checkbutton $t.showFeat.gene3d -text "gene3d" -variable database_update_description_gene3dCheck
            checkbutton $t.showFeat.go -text "go" -variable database_update_description_goCheck
            checkbutton $t.showFeat.interpro -text "interpro" -variable database_update_description_interproCheck
            checkbutton $t.showFeat.kegg -text "kegg" -variable database_update_description_keggCheck
            checkbutton $t.showFeat.panther -text "panther" -variable database_update_description_pantherCheck
            checkbutton $t.showFeat.patternscan -text "patternscan" -variable database_update_description_patternscanCheck
            checkbutton $t.showFeat.pfam -text "pfam" -variable database_update_description_pfamCheck
            checkbutton $t.showFeat.pir -text "pir" -variable database_update_description_pirCheck
            checkbutton $t.showFeat.profilescan -text "profilescan" -variable database_update_description_profilescanCheck
            checkbutton $t.showFeat.smart -text "smart" -variable database_update_description_smartCheck
            checkbutton $t.showFeat.superfamily -text "superfamily" -variable database_update_description_superfamilyCheck
            checkbutton $t.showFeat.tigr -text "tigr" -variable database_update_description_tigrCheck
            
            frame $t.buts -bd 2 -relief groove
            button $t.buts.ok -text "OK" -command "database_update_params $mode; destroy $t"
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            
            pack $t.ptitle.label -side left
            pack $t.showFeat.all $t.showFeat.blast \
                    $t.showFeat.blastprodom $t.showFeat.gene3d $t.showFeat.go $t.showFeat.kegg \
                    $t.showFeat.interpro $t.showFeat.panther $t.showFeat.patternscan $t.showFeat.pfam $t.showFeat.pir \
                    $t.showFeat.profilescan $t.showFeat.smart $t.showFeat.superfamily $t.showFeat.tigr \
                    -side top -anchor w
            pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
            pack $t.ptitle $t.showFeat $t.buts -side top
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        }
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc process_update {processID status process dbName result} {
    global env
    global tabArr
    set date [lrange [clock format [clock seconds]] 0 3]
    set err ""
    if {[catch {
        if {[lindex $result 0] eq "+"} {
            if {$status eq "running" && $processID eq [llength $env(processL)]} {
                set result [lindex $result 1]
            } else {
                set result "[lindex [lindex $env(processL) $processID] end]\n[lindex $result 1]"
            }
        }
        
        if {$status eq "running" && $processID eq [llength $env(processL)]} {
            lappend env(processL) "$processID $status {$process} {$date} {-} $dbName {$result}"
        } else {
            if {$process ne "-"} {
                if {$status ne "error" && $status ne "finished"} {
                    set env(processL) [lreplace $env(processL) $processID $processID "$processID $status {$process} {[lindex [lindex $env(processL) $processID] 3]} {-} $dbName {$result}"]
                } else {
                    set env(processL) [lreplace $env(processL) $processID $processID "$processID $status {$process} {[lindex [lindex $env(processL) $processID] 3]} {$date} $dbName {$result}"]
                }
            } else {
                if {$status ne "error" && $status ne "finished"} {
                    set env(processL) [lreplace $env(processL) $processID $processID "$processID $status {[lindex [lindex $env(processL) $processID] 2]} {[lindex [lindex $env(processL) $processID] 3]} {-} $dbName {$result}"]
                } else {
                    set env(processL) [lreplace $env(processL) $processID $processID "$processID $status {[lindex [lindex $env(processL) $processID] 2]} {[lindex [lindex $env(processL) $processID] 3]} {$date} $dbName {$result}"]
                }
                
            }
        }
        
        if {$tabArr(process.exist)} {
            .result.notebook1.nb.fprocess.1.table.l delete 0 end
            for {set i [expr [llength $env(processL)] - 1]} {$i >= 0} {set i [expr $i - 1]} {
                .result.notebook1.nb.fprocess.1.table.l insert end [lindex $env(processL) $i]
            }
            
            bind [.result.notebook1.nb.fprocess.1.table.l bodypath] <Button-1> "
            catch {
                set y \[.result.notebook1.nb.fprocess.1.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
                .result.notebook1.nb.fprocess.2.panel delete 1.0 end
                .result.notebook1.nb.fprocess.2.panel insert end \[lindex \[.result.notebook1.nb.fprocess.1.table.l get \$y\] 6\]
            }
            "
        }
    } err]} {
        errorPopUp "Error" "Error while process update:\n\n$err"
    } 
}

proc database_update_params {mode} {
    if {$mode eq "blast2interpro"} {
        set blastdb [.update_window.db.cb get]
        database_update blast2interpro "$blastdb"
    } elseif {$mode eq "description_seq" || $mode eq "description_prot"}  {
        global database_update_description_allCheck
        global database_update_description_blastCheck
        global database_update_description_blastprodomCheck
        global database_update_description_gene3dCheck
        global database_update_description_goCheck
        global database_update_description_interproCheck
        global database_update_description_keggCheck
        global database_update_description_pantherCheck
        global database_update_description_patternscanCheck
        global database_update_description_pfamCheck
        global database_update_description_pirCheck
        global database_update_description_profilescanCheck
        global database_update_description_smartCheck
        global database_update_description_superfamilyCheck
        global database_update_description_tigrCheck
        
        if {$database_update_description_allCheck} {
            set featL "blastprodom gene3d go panther pfam pir interpro kegg patternscan profilescan smart superfamily tigr blast"
        } else {
            set featL ""
            if {$database_update_description_blastprodomCheck} {
                lappend featL blastprodom
            }
            if {$database_update_description_gene3dCheck} {
                lappend featL gene3d
            }
            if {$database_update_description_goCheck} {
                lappend featL go
            }
            if {$database_update_description_interproCheck} {
                lappend featL interpro
            }
            if {$database_update_description_keggCheck && $mode eq "description_seq"} {
                lappend featL kegg
            }
            if {$database_update_description_pantherCheck} {
                lappend featL panther
            }
            if {$database_update_description_patternscanCheck} {
                lappend featL patternscan
            }
            if {$database_update_description_pfamCheck} {
                lappend featL pfam
            }
            if {$database_update_description_pirCheck} {
                lappend featL pir
            }
            if {$database_update_description_profilescanCheck} {
                lappend featL profilescan
            }
            if {$database_update_description_smartCheck} {
                lappend featL smart
            }
            if {$database_update_description_superfamilyCheck} {
                lappend featL superfamily
            }
            if {$database_update_description_tigrCheck} {
                lappend featL tigr
            }
            if {$database_update_description_blastCheck && $mode eq "description_seq"} {
                lappend featL blast
            }
        }
        if {$featL ne ""} {
            database_update $mode "$featL"
        }
    }   
}

proc db_info_run_coverage {} {
    global env
    
    if {$env(dbName) ne " "} {
        .result.notebook1.nb.fdb_info.1.buts.coverage configure -state disabled
        .result.notebook1.nb.fdb_info.1.table.l finishediting
        set run_info ""
        set stop 1
        set i 0
        while {$stop} {
            if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
                set stop 0
            } elseif {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq "1"} {
                #Text from ComboBox
                set type [[.result.notebook1.nb.fdb_info.1.table.l windowpath $i,2] get]
                lappend run_info "[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3]"
            }
            incr i
        }
        if {$run_info ne ""} {
            set ::threadRunCoverage [thread::create {
                proc run_coverage {dbName processID mainThreadID phpThreadID run_info} {
                    global env
                    
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT SUM(length) AS len, COUNT(id_seq) AS cnum FROM $env(dbName).sequences_nucleotide"}}]]
                    foreach sRes $sql_res {
                        set transcriptome_length [lindex $sRes 0]
                        set cNum [lindex $sRes 1]
                    }
                    unset sql_res
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT SUM(length) AS len, COUNT(id_read) AS rAnum FROM $env(dbName).sequences_read WHERE singleton = FALSE"}}]]
                    foreach sRes $sql_res {
                        set readAssembled_bases [lindex $sRes 0]
                        set readAssembled_num [lindex $sRes 1]
                    }
                    unset sql_res
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT SUM(length) AS len, COUNT(id_read) AS rAnum FROM $env(dbName).sequences_read WHERE singleton = TRUE"}}]]
                    foreach sRes $sql_res {
                        set readSingleton_bases [lindex $sRes 0]
                        set readSingleton_num [lindex $sRes 1]
                    }
                    unset sql_res
                    
                    set cL ""
                    set cNameL ""
                    foreach run $run_info {
                        append tmp ", '$run'"
                    }
                    set tmp [string range $tmp 2 end]
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT $env(dbName).read_hits.name_seq AS name, $env(dbName).read_hits.seq_start AS seq_start, $env(dbName).read_hits.read_start AS read_start, $env(dbName).read_hits.read_end AS read_end FROM $env(dbName).read_hits INNER JOIN $env(dbName).sequences_read ON $env(dbName).read_hits.name_read = $env(dbName).sequences_read.name WHERE $env(dbName).sequences_read.id_run IN ($tmp) ORDER BY $env(dbName).read_hits.name_seq, $env(dbName).read_hits.seq_start"}}]]
                    foreach sRes $sql_res {
                        lappend cL "[lindex $sRes 0] [expr [lindex $sRes 1] + [lindex $sRes 2] - 1] [expr [lindex $sRes 1] + [lindex $sRes 3]]"
                        lappend cNameL "[lindex $sRes 0]"
                    }
                    unset sql_res
                    
                    set cNameL [llength [lsort -unique $cNameL]]
                    set contig ""
                    set covered 0
                    foreach ent $cL {
                        if {[lindex $ent 0] eq $contig} {
                            if {[lindex $ent 1] > $end} {
                                set start [lindex $ent 1]
                            } else {
                                set start $end
                            }
                            if {[lindex $ent 2] > $end} {
                                set end [lindex $ent 2]
                                set covered [expr $covered + ($end - $start)]
                            }
                        } else {
                            set contig [lindex $ent 0]
                            set start [lindex $ent 1]
                            set end [lindex $ent 2]
                            set covered [expr $covered + ($end - $start)]
                        }
                    }
                    
                    set coverP [split [expr ($covered.0 / $transcriptome_length.0) * 100.0] .]
                    set coverP "[lindex $coverP 0].[string range [lindex $coverP 1] 0 1]"
                    set conP [split [expr ($cNameL.0 / $cNum.0) * 100.0] .]
                    set conP "[lindex $conP 0].[string range [lindex $conP 1] 0 1]"
                    set readAP [expr ($readAssembled_num.0 / ($readAssembled_num.0 + $readSingleton_num.0)) * 100.0]
                    set readSP [split [expr 100.0 - $readAP] .]
                    set readAP [split $readAP .]
                    set readSP "[lindex $readSP 0].[string range [lindex $readSP 1] 0 1]"
                    set readAP "[lindex $readAP 0].[string range [lindex $readAP 1] 0 1]"
                    
                    set res "$transcriptome_length $covered $coverP $cNum $cNameL $conP $readAssembled_num $readAssembled_bases $readAP $readSingleton_num $readSingleton_bases $readSP"
                    unset cL transcriptome_length covered coverP cNum cNameL conP readAssembled_num readAssembled_bases readSingleton_num readSingleton_bases readAP readSP
                    eval [subst {thread::send -async $mainThreadID {::db_info_run_coverage_window "$run_info" "$res"}}]
                    unset res
                    returnResult $processID finished $dbName $mainThreadID
                }
                proc returnResult {processID status dbName mainThreadID} {
                    eval [subst {thread::send -async $mainThreadID {::process_update $processID $status - $dbName 1}}]
                }
                thread::wait
            }]
            
            set processID [llength $env(processL)]
            process_update $processID running "Running Run-Coverage" $env(dbName) 0
            eval [subst {thread::send -async $::threadRunCoverage {::run_coverage $env(dbName) $processID $env(mainThreadID) $env(phpThreadID) "$run_info"}}]
        }
    }
}

proc db_info_run_coverage_window {run_info res} {
    .result.notebook1.nb.fdb_info.1.buts.coverage configure -state normal
    set t .run_coverage
    catch {
        toplevel $t
        wm title $t "Transcriptome Coverage"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        text $t.panel
        pack $t.panel -side top -fill both -expand true
    }
    $t.panel insert end "Selected Runs:\n"
    foreach run $run_info {
        $t.panel insert end "$run; "
    }
    $t.panel insert end "\n\nTranscriptome length:\t[lindex $res 0]\tbp"
    $t.panel insert end "\nCovered length:\t[lindex $res 1]\tbp"
    
    $t.panel insert end "\nCovered:\t[lindex $res 2]\t%\n"
    $t.panel insert end "\n\nContigs in transcriptome:\t[lindex $res 3]"
    $t.panel insert end "\nContigs (partially) covered:\t[lindex $res 4]\t([lindex $res 5] %)\n"
    $t.panel insert end "\nAssembled reads:\t[lindex $res 6]\t([lindex $res 8] %); [lindex $res 7] bp"
    $t.panel insert end "\nSingleton reads:\t[lindex $res 9]\t([lindex $res 11] %); [lindex $res 10] bp"
}

proc db_info_change_ab {mode} {
    .result.notebook1.nb.fdb_info.1.table.l finishediting
    set i 0
    if {$mode eq "A"} {
        while {[.result.notebook1.nb.fdb_info.1.table.l get $i] ne ""} {
            catch {
                [.result.notebook1.nb.fdb_info.1.table.l windowpath $i,2] configure -text A
            }
            incr i
        }
    } elseif {$mode eq "B"} {
        while {[.result.notebook1.nb.fdb_info.1.table.l get $i] ne ""} {
            catch {
                [.result.notebook1.nb.fdb_info.1.table.l windowpath $i,2] configure -text B
            }
            incr i
        }
    }
}

proc db_info_export_readDistribution {mode} {
    global env
    
    .result.notebook1.nb.fdb_info.1.table.l finishediting
    set i 0
    set runL ""
    set runs ""
    while {[.result.notebook1.nb.fdb_info.1.table.l get $i] ne ""} {
        if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq 1} {
            lappend runL [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3]
            append runs ", A.runid_[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3] AS runid_[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3]"
        }
        incr i
    }
    
    if {$runs ne ""} {
        set ofile ""
        set ofile [browse save {{{Text Files} {.txt} } {{All Files} * }} "$env(dbName)_readDistribution.txt"]
        if {$ofile ne ""} {
            set runs [string range $runs 2 end]
            set num [expr [llength $runL] + 1]
            set out "Name\ttotal reads"
            foreach run $runL {
                append out "\t$run"
            }
            set sql "SELECT B.name AS name, B.numreads AS numreads, $runs FROM $env(dbName).read_distribution AS A INNER JOIN $env(dbName).seq_info AS B ON A.id_seq = B.id_seq"
            if {$mode eq "keggM2"} {
                set i 0
                set tmpString ""
                while {[.result.notebook2.nb.fkeggM.1.2.1.table.l get $i] ne ""} {
                    if {[lindex [.result.notebook2.nb.fkeggM.1.2.1.table.l get $i] 0] eq 1} {
                        append tmpString ", '[lindex [.result.notebook2.nb.fkeggM.1.2.1.table.l get $i] 5]'"
                    }
                    incr i
                }
                set tmpString [string range $tmpString 2 end]
                append sql " WHERE A.id_seq IN ($tmpString)"
            } elseif {$mode ne 0} {
                set i 0
                set tmpString ""
                while {[.result.notebook1.nb.f$mode.1.table.l get $i] ne ""} {
                    if {[lindex [.result.notebook1.nb.f$mode.1.table.l get $i] 0] eq 1} {
                        append tmpString ", '[lindex [.result.notebook1.nb.f$mode.1.table.l get $i] 23]'"
                    }
                    incr i
                }
                set tmpString [string range $tmpString 2 end]
                append sql " WHERE A.id_seq IN ($tmpString)"
            }
            append sql " ORDER BY A.id_seq"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "$sql"}}]]
            foreach sRes $sql_res {
                append out "\n[lindex $sRes 0]\t[lindex $sRes 1]"
                for {set i 2} {$i <= $num} {incr i} {
                    append out "\t[lindex $sRes $i]"
                }
            }
            unset sql_res
            if {[catch {set fs [open "$ofile" w]}]} {
                errorPopUp "Error" "Could not create selected file:\n$ofile."
            } else {
                puts -nonewline $fs $out
                close $fs
            }
            unset num; unset out
        }
    } else  {
        errorPopUp "Error" "No runs selected."
    }
    unset runL; unset runs
}

proc project_create {} {
    global page_counter
    incr page_counter
    
    variable pn
    set pn "New Project"
    set t .newProject
    catch {destroy $t}
    toplevel $t
    wm title $t "New project"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.ptitle
    label $t.ptitle.label -text "Project title: "
    entry $t.ptitle.ent -textvariable pn -width 20 -background white
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "OK" -command "create_project_tab prj_$page_counter 0; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.ptitle.label $t.ptitle.ent -side left -fill both
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.ptitle $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc project_save {ofile} {
    set page [.result.notebook1.nb raise]
    if {[lindex [split $page _] 0] eq "prj"} {
        set tl1 ".result.notebook1.nb.f$page.1.table.l"
        if {$ofile eq 0} {
            set ofile [browse save {{{Project Files} {.prj} } {{All Files} * }} "[.result.notebook1.nb itemcget $page -text].prj"]
        }
        if {$ofile ne ""} {
            $tl1 finishediting
            set output ""
            set indx [lindex [$tl1 get end] 1]
            set i 0
            while {$i ne -1} {
                if {[lindex [$tl1 get $i] 0] eq 1} {
                    set ent [lrange [$tl1 get $i] 2 end]
                    append output "[lindex $ent 0]\t[lindex $ent 1]\t[lindex $ent 2]\t\
                            [lindex $ent 3]\t[lindex $ent 4]\t[lindex $ent 5]\t\
                            [lindex $ent 6]\t[lindex $ent 7]\t[lindex $ent 8]\t\
                            [lindex $ent 9]\t[lindex $ent 10]\t[lindex $ent 11]\t\
                            [lindex $ent 12]\t[lindex $ent 13]\t[lindex $ent 14]\t\
                            [lindex $ent 15]\t[lindex $ent 16]\t[lindex $ent 17]\t\
                            [lindex $ent 18]\t[lindex $ent 19]\t[lindex $ent 20]\t[lindex $ent 21]\t[lindex $ent 22]\n"
                } elseif {[lindex [$tl1 get $i] 0] eq ""} {
                    set i -2
                }
                incr i
            }
            if {$output eq ""} {
                errorPopUp "Error" "No rows selected."
            } else {
                set out [open "$ofile" w]
                puts $out "seq name\tlength\treads\tdescription\tproteins\tblast\tprodom\tcoil\tgene3d\tgo\tinterpro\tkegg\tpanther\tpatternscan\tpfam\tpir\tprofilescan\tsmart\tsuperfamily\ttigr\tcoverage\tid_seq\tdbName\n"
                puts $out $output
                unset output
                close $out
            }
        }
    } else {
        errorPopUp "Error" "No project selected."    
    }
}

proc project_open {} {
    global checkedImg
    global uncheckedImg
    global page_counter
    incr page_counter
    
    set projectF [browse open {{{Project Files} {.prj} } {{All Files} * }} -]
    if {[catch {set in [open "$projectF" r]} ]} {
    } else {
        set entL ""
        while {[gets $in line] != -1} {
            if {$line ne ""} {
                lappend entL "\{[regsub -all {\t} $line "\} \{"]\}"
            }
        }
        close $in
        if {[llength [lindex $entL 0]] eq 23} {
            create_project_tab prj_$page_counter [regsub -all { } [lindex [split [lindex [split $projectF /] end] .] 0] ""]
            set tl1 ".result.notebook1.nb.fprj_$page_counter.1.table.l"
            set num -1
            foreach ent $entL {
                if {[lindex $ent 0] ne "seq name"} {
                    incr num
                    $tl1 insert end "1 $num $ent"
                    $tl1 cellconfigure end,0 -image [expr {1 ? $checkedImg : $uncheckedImg}]
                }
            }
            .result.notebook1.nb raise prj_$page_counter
        } else {
            errorPopUp "Error" "File in wrong format or empty."
        }
        
        # Bindings.
        bind [$tl1 bodypath] <Button-1> "
        set y \[$tl1 nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl1 get \$y\] 2\]
        set env(contig.dbName) \[lindex \[$tl1 get \$y\] end\]
        update_info_get_name \$name name
        "
    }   
}

proc project_change_description {w} {
    global env
    
    set t .result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l
    $t finishediting
    set refName [$w get]
    set stop 1
    set i 0
    while {$stop} {
        if {[lindex [$t get $i] 0] eq 1} {
            set id_seq [lindex [$t get $i] 23]
            set db [lindex [$t get $i] 24]
            if {[lindex $refName 0] eq "blast"} {
                if {[lindex $refName 2] ne ""} {
                    set desO [string trim [lindex [split [.result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l cellcget $i,5 -text] ###] end]]
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT blast AS description FROM $db.sequences_nucleotide_description WHERE id_seq = '$id_seq'"}}]]
                    foreach ent $sql_res {
                        set des ""; set desc ""
                        foreach desc [lindex $ent 0] {
                            if {[lindex $desc 0] eq [lindex $refName 2]} {
                                set des [lindex $desc 1]
                                break
                            }
                        }
                        if {$des eq "" || $des eq "\"\""} {
                            set des "N/A"
                        }
                        .result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l cellconfigure $i,5 -text "$des"
                        unset desc; unset des
                    }
                    unset sql_res; unset desO
                } else {
                    set desO [string trim [lindex [split [.result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l cellcget $i,5 -text] ###] end]]
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT blast AS description FROM $db.sequences_nucleotide_description WHERE id_seq = '$id_seq'"}}]]
                    foreach ent $sql_res {
                        set des [lindex [lindex [lindex $ent 0] 0] 1]
                        if {$des eq "" || $des eq "\"\""} {
                            set des "N/A"
                        }
                        .result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l cellconfigure $i,5 -text "$des"
                        unset des
                    }
                    unset sql_res; unset desO
                }
            } elseif {$refName eq "empty" || $refName eq ""} {
                .result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l cellconfigure $i,5 -text ""
            } else {
                set desO [string trim [lindex [split [.result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l cellcget $i,5 -text] ###] end]]
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $refName AS description FROM $db.sequences_nucleotide_description WHERE id_seq = '$id_seq'"}}]]
                foreach ent $sql_res {
                    set des [lindex $ent 0]
                    if {$des eq "" || $des eq "\"\""} {
                        set des "N/A"
                    }
                    .result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l cellconfigure $i,5 -text "$des"
                    unset des
                }
                unset sql_res; unset desO
            }
        } elseif {[lindex [$t get $i] 0] eq ""} {
            set stop 0
        }
        incr i
    }
}

proc project_insert_contig_list_window {page} {
    global env
    global project_insert_contig_list_inputFile
    
    if {[string trim $env(dbName)] ne ""} {
        set project_insert_contig_list_inputFile ""
        
        set t .project_insert_contig_list_window
        catch {destroy $t}
        toplevel $t
        wm title $t "Insert contig list"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.1
        frame $t.1.panel
        text $t.1.panel.p -width 15 -height 20 -background white -yscrollcommand "$t.1.panel.y set"
        scrollbar $t.1.panel.y -orient vertical -command "$t.1.panel.p yview"
        frame $t.1.f
        label $t.1.f.lab -text "Input File: "
        entry $t.1.f.input -width 25 -background white -textvariable project_insert_contig_list_inputFile
        button $t.1.f.browse -text "Browse" -command "project_insert_contig_list_inputFile"
        button $t.1.ok -text "OK" -command "project_insert_contig_list $page"
        
        pack $t.1.panel.p -side left -fill both -expand true; pack $t.1.panel.y -side left -fill both
        pack $t.1.f.lab $t.1.f.input $t.1.f.browse -side left -fill both -anchor w
        pack $t.1.f -side top -fill both; pack $t.1.panel -side top -fill both -expand true
        pack $t.1.ok -side top -anchor w
        
        pack $t.1 -side top -fill both -expand true
    } else {
        errorPopUp "Error" "Please select a database."
    }
}

proc project_insert_contig_list_inputFile {} {
    global project_insert_contig_list_inputFile
    
    set project_insert_contig_list_inputFile [browse open {{{Text Files} {.txt} } {{All Files} * }} -]
}

proc project_insert_contig_list {page} {
    global env
    global search_results
    set contigL ""
    
    set input [string trimright [.project_insert_contig_list_window.1.panel.p get -displaychars 1.0 end]]
    if {$input ne ""} {
        set input "{[regsub -all {\n} $input "\} \{"]}"
        foreach line $input {
            foreach elem $line {
                append contigL ", '$elem'"
            }
        }
    } else {
        if {[catch {set ft [open [.project_insert_contig_list_window.1.f.input get] r]} ]} {
        } else {
            while {[gets $ft line] != -1} {
                foreach elem $line {
                    append contigL ", '$elem'"
                }
            }
            close $ft
        }
    }
    unset input
    set contigL [string range $contigL 2 end]
    
    catch {destroy .project_insert_contig_list_window}
    
    if {$contigL ne ""} {
        set sql_res [eval [subst {thread::send $env(phpThreadID) {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE $env(dbName).seq_info.name IN ($contigL)"}}]]
        foreach ent $sql_res {
            lappend search_results "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} N/A {[regsub -all {\}} [regsub -all {\{} [lindex $ent 5] "("] ")"]} [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $env(dbName)"
        }
        unset sql_res
        fillTable .result.notebook1.nb.f$page.1.table.l 0 [llength $search_results]
    }
}

proc create_project_tab {page mode} {
    global env
    global checkedImg
    global uncheckedImg
    global closeImg
    global database_browser_goto
    global projectL
    
    if {$mode eq 0} {
        set mode [.newProject.ptitle.ent get]
    }
    for {set i 0} {$i < [llength $mode]} {incr i} {
        if {$i ne 0} {
            append name "_[lindex $mode $i]"
        } else {
            append name "[lindex $mode $i]"
        }
    }
    
    set frame [.result.notebook1.nb insert end $page -text $name]
    set comm "sequences_add $page"
    .menubar.edit.menu.asmenu add command -label "$name" -command $comm
    
    frame $frame.0
    set comm "project_change_description .result.notebook1.nb.f$page.0.feat"
    set cbL "{}"
    foreach ref $env(dbbCBL) {
        if {$ref ne "all" && $ref ne "with hits" && $ref ne "without hits" && $ref ne "with comment"} {
            lappend cbL "$ref"
        }
    }
    lappend cbL "empty"
    ComboBox $frame.0.feat -modifycmd $comm -width 15 -hottrack 1 -background white -text "" -values $cbL
    unset cbL
    set comm ".menubar.edit.menu.asmenu delete [lindex [split $page _] end]; .result.notebook1.nb raise [.result.notebook1.nb page 0]; .result.notebook1.nb delete $page 1"
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command $comm
    frame $frame.1
    frame $frame.1.table
    
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb1_tl_database_browser $frame.1.table.l   
    tablelist::tablelist $nb1_tl_database_browser \
            -width 110 -height 5 -showseparators 1 -stripebackground lightblue \
            -columns {
                0 "" 0 "nr" \
                        0 "seq name" 0 "length" 0 "reads" 0 "description" 0 "proteins" 0 "blast" \
                        0 "prodom" 0 "coil" 0 "gene3d" 0 "go" 0 "interpro" 0 "kegg" 0 "panther" 0 "patternscan" \
                        0 "pfam" 0 "pir" 0 "profilescan" 0 "smart" 0 "superfamily" 0 "tigr" 0 "coverage" 0 "id_seq" 0 "dbName"} \
            -labelcommand "$nb1_tl_database_browser finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch 2 \
            -stretch 5\
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb1_tl_database_browser columnconfigure 0 \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    $nb1_tl_database_browser columnconfigure 5 \
            -editable yes
    $nb1_tl_database_browser columnconfigure 1 -sortmode real -align right
    $nb1_tl_database_browser columnconfigure 2 -sortmode dictionary
    $nb1_tl_database_browser columnconfigure 3 -sortmode real -align right
    $nb1_tl_database_browser columnconfigure 4 -sortmode real -align right
    $nb1_tl_database_browser columnconfigure 5 -sortmode dictionary -align left
    $nb1_tl_database_browser columnconfigure 23 -hide yes
    $nb1_tl_database_browser columnconfigure 24 -hide yes
    
    for {set c 6} {$c <= 22} {incr c} {
        $nb1_tl_database_browser columnconfigure $c -align right -sortmode real
    }     
    if {$env(database_browser.nr) eq "-"} {
        $nb1_tl_database_browser columnconfigure 1 -hide yes
    }
    if {$env(database_browser.length) eq "-"} {
        $nb1_tl_database_browser columnconfigure 3 -hide yes
    }
    if {$env(database_browser.numreads) eq "-"} {
        $nb1_tl_database_browser columnconfigure 4 -hide yes
    }
    if {$env(database_browser.description) eq "-"} {
        $nb1_tl_database_browser columnconfigure 5 -hide yes
    }
    if {$env(database_browser.proteins) eq "-"} {
        $nb1_tl_database_browser columnconfigure 6 -hide yes
    }
    if {$env(database_browser.blast) eq "-"} {
        $nb1_tl_database_browser columnconfigure 7 -hide yes
    }
    if {$env(database_browser.blastprodom) eq "-"} {
        $nb1_tl_database_browser columnconfigure 8 -hide yes
    }
    if {$env(database_browser.coil) eq "-"} {
        $nb1_tl_database_browser columnconfigure 9 -hide yes
    }
    if {$env(database_browser.gene3d) eq "-"} {
        $nb1_tl_database_browser columnconfigure 10 -hide yes
    }
    if {$env(database_browser.go) eq "-"} {
        $nb1_tl_database_browser columnconfigure 11 -hide yes
    }
    if {$env(database_browser.interpro) eq "-"} {
        $nb1_tl_database_browser columnconfigure 12 -hide yes
    }
    if {$env(database_browser.kegg) eq "-"} {
        $nb1_tl_database_browser columnconfigure 13 -hide yes
    }
    if {$env(database_browser.panther) eq "-"} {
        $nb1_tl_database_browser columnconfigure 14 -hide yes
    }
    if {$env(database_browser.pfam) eq "-"} {
        $nb1_tl_database_browser columnconfigure 15 -hide yes
    }
    if {$env(database_browser.pir) eq "-"} {
        $nb1_tl_database_browser columnconfigure 16 -hide yes
    }
    if {$env(database_browser.patternscan) eq "-"} {
        $nb1_tl_database_browser columnconfigure 17 -hide yes
    }
    if {$env(database_browser.profilescan) eq "-"} {
        $nb1_tl_database_browser columnconfigure 18 -hide yes
    }
    if {$env(database_browser.smart) eq "-"} {
        $nb1_tl_database_browser columnconfigure 19 -hide yes
    }
    if {$env(database_browser.superfamily) eq "-"} {
        $nb1_tl_database_browser columnconfigure 20 -hide yes
    }
    if {$env(database_browser.tigr) eq "-"} {
        $nb1_tl_database_browser columnconfigure 21 -hide yes
    }
    if {$env(database_browser.coverage) eq "-"} {
        $nb1_tl_database_browser columnconfigure 22 -hide yes
    }
    
    pack $frame.0.feat -side left
    pack $frame.0.exit -side right
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0 -side top -fill both
    pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    # bind a right click (button 3) to view 0 (top left view window)
    set tl .result.notebook1.nb.f$page.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set db \[lindex \[$tl get \$y\] 24\]
    set id \[lindex \[$tl get \$y\] 23\]
    set page \[.result.notebook1.nb raise\]
    rightmenu \$page \$db \$id \$coord
    "
}

proc create_tab {mode} {
    global tabArr
    global env
    
    if {$tabArr($mode.exist) eq 0} {
        set frame [.result.$tabArr($mode.notebook).nb insert end $mode -text "$tabArr($mode.name)" -raisecmd "catch {update_info_$mode}"]
        .result.$tabArr($mode.notebook).nb raise $mode
        set tabArr($mode.exist) 1
        if {$mode eq "process"} {
            .result.notebook1.nb.fprocess.1.table.l delete 0 end
            foreach process $env(processL) {
                .result.notebook1.nb.fprocess.1.table.l insert end $process
            }
            bind [.result.notebook1.nb.fprocess.1.table.l bodypath] <Button-1> "
            catch {
                set y \[.result.notebook1.nb.fprocess.1.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
                .result.notebook1.nb.fprocess.2.panel delete 1.0 end
                .result.notebook1.nb.fprocess.2.panel insert end \[lindex \[.result.notebook1.nb.fprocess.1.table.l get \$y\] 4\]
            }
            "
        }
    }
}

proc close_tab {tab} {
    global tabArr
    set tabArr($tab.exist) 0; .result.$tabArr($tab.notebook).nb delete $tab 0
}

proc config_database {} {
    global env
    
    variable host
    variable port
    variable user
    variable parentDB
    variable folderServer
    variable userServer
    variable passwdServer
    
    if {[catch {set host [string trim $env(host)]}]} {
        set host ""
    }
    if {[catch {set port [string trim $env(port)]}]} {
        set port ""
    }
    if {[catch {set parentDB [string trim $env(parentDB)]}]} {
        set parentDB ""
    }
    if {[catch {set folderServer [string trim $env(folderServer)]}]} {
        set folderServer ""
    }
    if {[catch {set userServer [string trim $env(userServer)]}]} {
        set userServer ""
    }
    if {[catch {set passwdServer [string trim $env(passwdServer)]}]} {
        set passwdServer ""
    }
    
    set t .database_config
    toplevel $t
    wm title $t "Database Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.db
    frame $t.db.conn
    label $t.db.conn.label -text "Name:"
    ComboBox $t.db.conn.cb -modifycmd {config_database_server_change; focus .database_config.db.host.ent} -width 20 -hottrack 1 -background white -text [string trim $env(currentConnection)] -values [string trim $env(connections)] -state normal
    frame $t.db.host
    label $t.db.host.label -text "Host:"
    entry $t.db.host.ent -width 15 -background white -textvariable host
    frame $t.db.port
    label $t.db.port.label -text "Port:"
    entry $t.db.port.ent -width 15 -background white -textvariable port
    frame $t.db.parentDB
    label $t.db.parentDB.label -text "Parent DB:"
    entry $t.db.parentDB.ent -width 15 -background white -textvariable parentDB
    label $t.db.label -text "\nServer authentification"
    frame $t.db.folderServer
    label $t.db.folderServer.label -text "Folder:"
    entry $t.db.folderServer.ent -width 15 -background white -textvariable folderServer
    frame $t.db.userServer
    label $t.db.userServer.label -text "User:"
    entry $t.db.userServer.ent -width 15 -background white -textvariable userServer
    frame $t.db.passwdServer
    label $t.db.passwdServer.label -text "Password:"
    entry $t.db.passwdServer.ent -width 15 -background white -textvariable passwdServer
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "config_change database"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.db.conn.label -side left -fill both; pack $t.db.conn.cb -side right -fill both
    pack $t.db.host.label -side left -fill both; pack $t.db.host.ent -side right -fill both
    pack $t.db.port.label -side left -fill both; pack $t.db.port.ent -side right -fill both
    pack $t.db.parentDB.label -side left -fill both; pack $t.db.parentDB.ent -side right -fill both
    pack $t.db.folderServer.label -side left -fill both; pack $t.db.folderServer.ent -side right -fill both
    pack $t.db.userServer.label -side left -fill both; pack $t.db.userServer.ent -side right -fill both
    pack $t.db.passwdServer.label -side left -fill both; pack $t.db.passwdServer.ent -side right -fill both
    pack $t.db.conn $t.db.host $t.db.port $t.db.parentDB $t.db.label $t.db.folderServer $t.db.userServer $t.db.passwdServer -side top -fill both
    
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.db $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc config_database_server_change {} {
    global env
    
    set conn [.database_config.db.conn.cb get]
    
    .database_config.db.host.ent -text $env(host_$conn)
    .database_config.db.port.ent -text $env(port_$conn)
    .database_config.db.parentDB.ent -text $env(parentDB_$conn)
    .database_config.db.folderServer.ent -text $env(folderServer_$conn)
    .database_config.db.userServer.ent -text $env(userServer_$conn)
    .database_config.db.passwdServer.ent -text $env(passwdServer_$conn)
}

proc config_save {} {
    set f [browse save {{{T-ACE config} {.conf} } {{All Files} * }} "conf.conf"]
    config_change "configSave {$f}"
}

proc config_load {} {
    global env
    
    global database_browser_showSeq
    global database_browser_idOrderCheck
    global database_browser_lengthOrderCheck
    global database_browser_numreadsOrderCheck
    global database_browser_goOrderCheck
    global database_browser_interproOrderCheck
    
    set f [browse open {{{T-ACE config} {.conf} } {{All Files} * }} -]
    if {[catch {set ft [open $f r]}]} {
        if {$f ne ""} {
            errorPopUp "Error" "ERROR: Could not open:\n$f"
        }
    } else {
        #Database_browser
        gets $ft line
        gets $ft line
        set env(database_browser.nr) [lindex $line 1]
        set env(database_browser.length) [lindex $line 2]
        set env(database_browser.description) [lindex $line 3]
        set env(database_browser.proteins) [lindex $line 4]
        set env(database_browser.blast) [lindex $line 5]
        set env(database_browser.blastprodom) [lindex $line 6]
        set env(database_browser.coil) [lindex $line 7]
        set env(database_browser.gene3d) [lindex $line 8]
        set env(database_browser.go) [lindex $line 9]
        set env(database_browser.interpro) [lindex $line 10]
        set env(database_browser.kegg) [lindex $line 11]
        set env(database_browser.panther) [lindex $line 12]
        set env(database_browser.pfam) [lindex $line 13]
        set env(database_browser.pir) [lindex $line 14]
        set env(database_browser.patternscan) [lindex $line 15]
        set env(database_browser.profilescan) [lindex $line 16]
        set env(database_browser.smart) [lindex $line 17]
        set env(database_browser.superfamily) [lindex $line 18]
        set env(database_browser.tigr) [lindex $line 19]
        set env(database_browser.numreads) [lindex $line 20]
        set env(database_browser.coverage) [lindex $line 21]
        gets $ft line
        set database_browser_idOrderCheck [lindex $line 0]
        set database_browser_lengthOrderCheck [lindex $line 1]
        set database_browser_numreadsOrderCheck [lindex $line 2]
        set database_browser_goOrderCheck [lindex $line 3]
        set database_browser_interproOrderCheck [lindex $line 4]
        #Database_info
        gets $ft line
        gets $ft line
        set env(db_info.assembled) [lindex $line 0]
        set env(db_info.comment) [lindex $line 1]
        set env(db_info.data) [lindex $line 2]
        set env(db_info.dateIn) [lindex $line 3]
        set env(db_info.dateOut) [lindex $line 4]
        set env(db_info.description) [lindex $line 5]
        set env(db_info.id_run) [lindex $line 6]
        set env(db_info.runs) [lindex $line 7]
        set env(db_info.sequencer) [lindex $line 8]
        set env(db_info.sequences) [lindex $line 9]
        set env(db_info.singletons) [lindex $line 10]
        set env(db_info.treatment) [lindex $line 11]
        set env(db_info.type) [lindex $line 12]
        #HomeFolder
        gets $ft line
        gets $ft line
        set env(homeFolder) $line
        #BrowserPath
        gets $ft line
        gets $ft line
        if {$line ne ""} {
            set env(browserPath) $line
        } else {
            set env(browserPath) " "
        }
        #ProteinTranslationTable
        gets $ft line
        gets $ft line
        if {$line ne ""} {
            set env(translateTableProtPath) $line
        }
    }
}

proc config_database_browser {} {
    global env
    global database_browser_sequenceType
    global database_browser_showSeq
    global database_browser_idOrderCheck
    global database_browser_lengthOrderCheck
    global database_browser_numreadsOrderCheck
    global database_browser_goOrderCheck
    global database_browser_interproOrderCheck
    
    variable database_browser_showSeq 
    
    set t .database_browser_config
    toplevel $t
    wm title $t "Database Browser Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.showSeq
    label $t.showSeq.label -text "Number of displayed rows: "
    entry $t.showSeq.ent -textvariable database_browser_showSeq -width 5 -background white
    
    frame $t.show
    frame $t.show.showColumn -bd 2 -relief groove
    label $t.show.showColumn.label -text "Columns displayed: "
    checkbutton $t.show.showColumn.nr -text "nr" -variable env(database_browser.nr) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.length -text "length" -variable env(database_browser.length) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.reads -text "reads" -variable env(database_browser.numreads) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.proteins -text "proteins" -variable env(database_browser.proteins) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.description -text "description" -variable env(database_browser.description) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.blast -text "blast" -variable env(database_browser.blast) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.blastprodom -text "blastprodom" -variable env(database_browser.blastprodom) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.coil -text "coil" -variable env(database_browser.coil) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.gene3d -text "gene3d" -variable env(database_browser.gene3d) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.go -text "go" -variable env(database_browser.go) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.interpro -text "interpro" -variable env(database_browser.interpro) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.panther -text "panther" -variable env(database_browser.panther) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.pfam -text "pfam" -variable env(database_browser.pfam) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.pir -text "pir" -variable env(database_browser.pir) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.patternscan -text "patternscan" -variable env(database_browser.patternscan) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.profilescan -text "profilescan" -variable env(database_browser.profilescan) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.smart -text "smart" -variable env(database_browser.smart) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.superfamily -text "superfamily" -variable env(database_browser.superfamily) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.tigr -text "tigr" -variable env(database_browser.tigr) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.coverage -text "coverage" -variable env(database_browser.coverage) -offvalue "-" -onvalue "+"
    
    frame $t.show.order -bd 2 -relief groove
    label $t.show.order.label -text "Order table by: "
    checkbutton $t.show.order.id -text "id" -variable database_browser_idOrderCheck
    checkbutton $t.show.order.length -text "length" -variable database_browser_lengthOrderCheck
    checkbutton $t.show.order.reads -text "reads" -variable database_browser_numreadsOrderCheck
    checkbutton $t.show.order.go -text "go" -variable database_browser_goOrderCheck
    checkbutton $t.show.order.interpro -text "interpro" -variable database_browser_interproOrderCheck
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "config_change database_browser; getRefs .result.notebook1.nb.fdbb.0.feat; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.showSeq.label $t.showSeq.ent -side left -fill both
    pack $t.show.showColumn.label $t.show.showColumn.nr $t.show.showColumn.length $t.show.showColumn.reads $t.show.showColumn.description $t.show.showColumn.proteins \
            $t.show.showColumn.blast $t.show.showColumn.blastprodom $t.show.showColumn.coil \
            $t.show.showColumn.gene3d $t.show.showColumn.go $t.show.showColumn.interpro $t.show.showColumn.panther \
            $t.show.showColumn.patternscan $t.show.showColumn.pfam $t.show.showColumn.pir $t.show.showColumn.profilescan \
            $t.show.showColumn.smart $t.show.showColumn.superfamily $t.show.showColumn.tigr $t.show.showColumn.coverage -side top -anchor w
    pack $t.show.order.label $t.show.order.id $t.show.order.length $t.show.order.reads $t.show.order.go $t.show.order.interpro -side top -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.show.showColumn $t.show.order -side left -fill both
    pack $t.showSeq $t.show $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc config_database_info {} {
    global env
    
    set t .database_info_config
    toplevel $t
    wm title $t "Database Info Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.show
    frame $t.show.showColumn -bd 2 -relief groove
    label $t.show.showColumn.label -text "Columns displayed: "
    checkbutton $t.show.showColumn.assembled -text "assembled" -variable env(db_info.assembled) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.comment -text "comment" -variable env(db_info.comment) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.data -text "data" -variable env(db_info.data) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.dateIn -text "date in" -variable env(db_info.dateIn) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.dateOut -text "date out" -variable env(db_info.dateOut) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.description -text "description" -variable env(db_info.description) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.id_run -text "run id" -variable env(db_info.id_run) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.runs -text "runs" -variable env(db_info.runs) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.sequencer -text "sequencer" -variable env(db_info.sequencer) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.sequences -text "sequences" -variable env(db_info.sequences) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.singletons -text "singletons" -variable env(db_info.singletons) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.treatment -text "treatment" -variable env(db_info.treatment) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.type -text "type" -variable env(db_info.type) -offvalue "-" -onvalue "+"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "config_change db_info; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"

    pack $t.show.showColumn.label $t.show.showColumn.assembled $t.show.showColumn.comment $t.show.showColumn.data $t.show.showColumn.dateIn $t.show.showColumn.dateOut \
            $t.show.showColumn.description $t.show.showColumn.id_run $t.show.showColumn.runs $t.show.showColumn.sequencer $t.show.showColumn.sequences \
            $t.show.showColumn.singletons $t.show.showColumn.treatment $t.show.showColumn.type -side top -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.show.showColumn -side left -fill both
    pack $t.show $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc config_tabs {} {
    global tabArr
    global tabL
    
    set t .tab_config
    catch {destroy $t}
    toplevel $t
    wm title $t "Tab Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.showColumn
    foreach tab $tabL {
        global $tab.global
        set $tab.global $tabArr($tab.exist)
        checkbutton $t.showColumn.$tab -text "$tabArr($tab.name)" -variable $tab.global -command "config_tabs_modify $tab"
        pack $t.showColumn.$tab -side top -anchor w
    }
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "config_tabs_modify all; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"

    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.showColumn $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc config_tabs_modify {tab} {
    global tabArr
    global tabL
    
    if {$tab eq "all"} {
        set ft [open [pwd]/conf/tabs_tace.conf w]
        foreach tab $tabL {
            puts $ft "{$tabArr($tab.name)}\t$tab\t$tabArr($tab.notebook)\t$tabArr($tab.exist)"
            if {$tabArr($tab.exist)} {
                set tabArr($tab.exist) 0
                if {[catch {create_tab $tab}]} {
                    set tabArr($tab.exist) 1
                }
            } else {
                catch {.result.$tabArr($tab.notebook).nb delete $tab 0}
            }
        }
        close $ft
    } else {
        if {$tabArr($tab.exist)} {
            set tabArr($tab.exist) 0
        } else {
            set tabArr($tab.exist) 1
        }
    }
}

proc database_browser_showSeq {mode} {
    global seq_info
    global database_browser_showSeq
    global database_browser_goto
    
    if {$seq_info ne ""} {
        set s [.result.notebook1.nb.fdbb.0.label1 cget -text]
        if {[llength $seq_info] < $database_browser_showSeq} {
            set db_showSeq [llength $seq_info]
        } else {
            set db_showSeq $database_browser_showSeq
        }
        
        if {$mode eq 0} {
            .result.notebook1.nb.fdbb.0.label1 configure -text " 1"
            .result.notebook1.nb.fdbb.0.label3 configure -text "$db_showSeq"
            .result.notebook1.nb.fsb.0.label1 configure -text " 1"
            .result.notebook1.nb.fsb.0.label3 configure -text "$db_showSeq"
            fillTable .result.notebook1.nb.fdbb.1.table.l 0 $db_showSeq
        } elseif {$mode eq 1} {
            .result.notebook1.nb.fdbb.0.label1 configure -text " [expr [llength $seq_info] - $db_showSeq + 1]"
            .result.notebook1.nb.fdbb.0.label3 configure -text "[llength $seq_info]"
            .result.notebook1.nb.fsb.0.label1 configure -text " [expr [llength $seq_info] - $db_showSeq + 1]"
            .result.notebook1.nb.fsb.0.label3 configure -text "[llength $seq_info]"
            fillTable .result.notebook1.nb.fdbb.1.table.l [expr [llength $seq_info] - $db_showSeq] [llength $seq_info]
        } elseif {$mode eq 2} {
            set start [expr $s - $db_showSeq - 1]
            if {$start <= 0} {
                set start 0
            }
            set end [expr $start + $db_showSeq]
            .result.notebook1.nb.fdbb.0.label1 configure -text " [expr $start + 1]"
            .result.notebook1.nb.fdbb.0.label3 configure -text "$end"
            .result.notebook1.nb.fsb.0.label1 configure -text " [expr $start + 1]"
            .result.notebook1.nb.fsb.0.label3 configure -text "$end"
            fillTable .result.notebook1.nb.fdbb.1.table.l $start $end
        } elseif {$mode eq 3} {
            set start [expr $s + $db_showSeq - 1]
            if {$start >= [llength $seq_info]} {
                set start [expr [llength $seq_info] - $db_showSeq]
            }
            set end [expr $start + $db_showSeq]
            if {$end > [llength $seq_info]} {
                set end [llength $seq_info]
            }
            .result.notebook1.nb.fdbb.0.label1 configure -text " [expr $start + 1]"
            .result.notebook1.nb.fdbb.0.label3 configure -text "$end"
            .result.notebook1.nb.fsb.0.label1 configure -text " [expr $start + 1]"
            .result.notebook1.nb.fsb.0.label3 configure -text "$end"
            fillTable .result.notebook1.nb.fdbb.1.table.l $start $end
        } elseif {$mode eq 4 || $mode eq 5} {
            if {$mode eq 4} {
                set database_browser_goto [.result.notebook1.nb.fdbb.0.goto.ent get]
            } else {
                set database_browser_goto [.result.notebook1.nb.fsb.0.goto.ent get]
            }
            .result.notebook1.nb.fdbb.0.goto.ent configure -text ""
            if {[string is integer $database_browser_goto]} {
                set start [expr $database_browser_goto - 1]
            } else {
                set start [lsearch -index 1 $seq_info $database_browser_goto]
            }
            if {$start ne "" && $start ne "-1"} {
                if {$start <= 0} {
                    set start 0
                } elseif {$start >= [llength $seq_info]} {
                    set start [expr [llength $seq_info] - $db_showSeq]
                }
                set end [expr $start + $db_showSeq]
                .result.notebook1.nb.fdbb.0.label1 configure -text " [expr $start + 1]"
                .result.notebook1.nb.fdbb.0.label3 configure -text "$end"
                .result.notebook1.nb.fsb.0.label1 configure -text " [expr $start + 1]"
                .result.notebook1.nb.fsb.0.label3 configure -text "$end"
                fillTable .result.notebook1.nb.fdbb.1.table.l $start $end
            }
        }
    } else {
        .result.notebook1.nb.fdbb.0.label1 configure -text " 0"
        .result.notebook1.nb.fdbb.0.label3 configure -text "0"
        .result.notebook1.nb.fsb.0.label1 configure -text " 0"
        .result.notebook1.nb.fsb.0.label3 configure -text "0"
        .result.notebook1.nb.fdbb.1.table.l delete 0 end
    }
}

proc update_info_get_name {id mode} {
    global env
    global seq_all
    
    if {$id ne "" && $env(contig.dbName) ne ""} {
        set inf ""
        if {[.result.notebook1.nb raise] eq "blast"} {
            set dbNameTmp [split $env(contig.dbName) _]
            if {[lindex $dbNameTmp end] eq "prot"} {
                set env(contig.dbType) "protein"
                set env(contig.dbName) [string range $env(contig.dbName) 0 [expr [string length $env(contig.dbName)] - 6]]
            } elseif {[lindex $dbNameTmp end] eq "reads"} {
                set env(contig.dbType) "reads"
                set env(contig.dbName) [string range $env(contig.dbName) 0 [expr [string length $env(contig.dbName)] - 7]]
            } elseif {[lindex $dbNameTmp end] eq "singletons"} {
                if {[string tolower $env(dbName)] eq $env(contig.dbName)} {
                    set env(contig.dbType) "nucleotide"
                } else {
                    set env(contig.dbType) "reads"
                    set env(contig.dbName) [string range $env(contig.dbName) 0 [expr [string length $env(contig.dbName)] - 12]]
                }
            } else {
                set env(contig.dbType) "nucleotide"
            }
        } else {
            set env(contig.dbType) $env(sequence_type)
        }
        
        if {$env(contig.dbType) eq "nucleotide"} {
            if {$env(sequence_type) eq "nucleotide"} {
                if {$mode eq "id"} {
                    set id [lsearch -index 0 $seq_all $id]
                } elseif {$mode eq "name"} {
                    set id [lsearch -index 1 $seq_all $id]
                }
                if {$id ne -1} {
                    set inf [lindex $seq_all $id]
                }
            } else {
                if {$mode eq "id"} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE id_seq = '$id'"}}]]
                } elseif {$mode eq "name"} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE name = '$id'"}}]]
                }
                foreach ent $sql_res {
                    set inf "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} N/A {[lindex $ent 5]} [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $env(dbName)"
                }
                unset sql_res
            }
        } elseif {$env(contig.dbType) eq "protein"} {
            if {$env(sequence_type) eq "protein"} {
                if {$mode eq "id"} {
                    set id [lsearch -index 0 $seq_all $id]
                } elseif {$mode eq "name"} {
                    set id [lsearch -index 1 $seq_all $id]
                }
                if {$id ne -1} {
                    set inf [lindex $seq_all $id]
                }
            } else {
                if {$mode eq "id"} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr FROM $env(dbName).prot_info WHERE id_prot = '$id'"}}]]
                } elseif {$mode eq "name"} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr FROM $env(dbName).prot_info WHERE name = '$id'"}}]]
                }
                foreach ent $sql_res {
                    set inf "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A N/A N/A [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] N/A $env(dbName)"
                }
                unset sql_res
            }
        } elseif {$env(contig.dbType) eq "reads"} {
            if {$mode eq "id"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_read, name, length FROM $env(dbName).sequences_read WHERE id_read = '$id'"}}]]
            } elseif {$mode eq "name"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_read, name, length FROM $env(dbName).sequences_read WHERE name = '$id'"}}]]
            }
            foreach ent $sql_res {
                set inf "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A N/A N/A 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 N/A $env(dbName)"
            }
        }
        
        if {$inf ne ""} {      
            if {$env(contig.dbType) eq "nucleotide"} {
                update_info_nuc $inf
            } elseif {$env(contig.dbType) eq "protein"} {
                update_info_prot $inf
            } elseif {$env(contig.dbType) eq "reads"} {
                update_info_read $inf
            }
        } else {
            errorPopUp "Error" "Could not find selected entry."
        }
    }   
}

proc update_info_nuc {ent} {
    global env
    global tabArr
    global tabL

    if {$ent ne ""} {
        set env(contig.id_seq) [lindex $ent 0]
        set env(contig.name) [lindex $ent 1]
        set env(contig.length) [lindex $ent 2]
        set env(contig.numreads) [lindex $ent 3]
        set env(contig.prot_ids) [lindex $ent 4]
        set env(contig.proteins) [lindex $ent 6]
        set env(contig.blast) [lindex $ent 7]
        set env(contig.blastprodom) [lindex $ent 8]
        set env(contig.coil) [lindex $ent 9]
        set env(contig.gene3d) [lindex $ent 10]
        set env(contig.go) [lindex $ent 11]
        set env(contig.interpro) [lindex $ent 12]
        set env(contig.kegg) [lindex $ent 13]
        set env(contig.panther) [lindex $ent 14]
        set env(contig.patternscan) [lindex $ent 15]
        set env(contig.pfam) [lindex $ent 16]
        set env(contig.pir) [lindex $ent 17]
        set env(contig.profilescan) [lindex $ent 18]
        set env(contig.smart) [lindex $ent 19]
        set env(contig.superfamily) [lindex $ent 20]
        set env(contig.tigr) [lindex $ent 21]
        set env(contig.coverage) [lindex $ent 22]
        
        set rowCount 0
        set seqRowPos ""
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence FROM $env(contig.dbName).sequences_nucleotide WHERE id_seq = '$env(contig.id_seq)'"}}]] 
        foreach ent $sql_res {
            set env(contig.sequence) [lindex $ent 0]
            set rowCount 3
        }
        unset sql_res
        set env(contig.ipsHitL) " "
        set env(contig.goHitL) " "
        set env(contig.proteinL) " "
        set tmp_proteinL ""
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT frame, orf, length, id_prot, name, sequence FROM $env(contig.dbName).sequences_protein WHERE id_seq = '$env(contig.id_seq)'"}}]]
        foreach ent $sql_res {
            incr rowCount
            lappend tmp_proteinL "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 4] [lindex $ent 5]"
            lappend seqRowPos "[lindex $ent 3] [lindex $ent 4] $rowCount"
            incr rowCount
        }
        unset sql_res
        set protIDL ""
        set tmp ""
        set name ""
        set row ""
        foreach ref {blastprodom_hits coil_hits gene3d_hits go_hits panther_hits pfam_hits pir_hits interpro_hits patternscan_hits profilescan_hits smart_hits superfamily_hits tigr_hits} {
            if {$env(contig.[lindex [split $ref _] 0]) ne 0 && $env(interproscan_results.[lindex [split $ref _] 0]) eq "+"} {
                if {$ref eq "interpro_hits" || $ref eq "go_hits"} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot, id FROM $env(contig.dbName).$ref WHERE id_seq = '$env(contig.id_seq)'"}}]]
                    foreach ent $sql_res {
                        if {[lindex $ent 0] eq "" || [lindex $ent 0] eq "-1"} {
                            set id_prot N/A
                            set name N/A
                            set row ""
                        } else {
                            lappend protIDL [lindex $ent 0]
                            set id_prot [lindex $ent 0]
                            set i [lsearch -index 0 $seqRowPos [lindex $ent 0]]
                            if {$i ne -1} {
                                set name [lindex [lindex $seqRowPos $i] 1]
                                set row [lindex [lindex $seqRowPos $i] 2]
                            }
                        }
                        lappend tmp "$id_prot $name [lindex [split $ref _] 0] [lindex $ent 1] N/A N/A N/A N/A $env(contig.id_seq) {$row}"
                    }
                    unset sql_res
                } elseif {$ref eq "patternscan_hits"} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot, id, \\\"start\\\", \\\"end\\\", length FROM $env(contig.dbName).$ref WHERE id_seq = '$env(contig.id_seq)'"}}]]
                    foreach ent $sql_res {
                        lappend protIDL [lindex $ent 0]
                        set i [lsearch -index 0 $seqRowPos [lindex $ent 0]]
                        if {$i ne -1} {
                            set name [lindex [lindex $seqRowPos $i] 1]
                            set row [lindex [lindex $seqRowPos $i] 2]
                        }
                        lappend tmp "[lindex $ent 0] $name [lindex [split $ref _] 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 4] N/A $env(contig.id_seq) {$row}"
                    }
                    unset sql_res
                } else {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot, id, \\\"start\\\", \\\"end\\\", length, evalue FROM $env(contig.dbName).$ref WHERE id_seq = '$env(contig.id_seq)' ORDER BY CAST(evalue AS numeric)"}}]]
                    foreach ent $sql_res {
                        lappend protIDL [lindex $ent 0]
                        set i [lsearch -index 0 $seqRowPos [lindex $ent 0]]
                        if {$i ne -1} {
                            set name [lindex [lindex $seqRowPos $i] 1]
                            set row [lindex [lindex $seqRowPos $i] 2]
                        }
                        lappend tmp "[lindex $ent 0] $name [lindex [split $ref _] 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] $env(contig.id_seq) {$row}"
                    }
                    unset sql_res
                }
            }
        }
        unset seqRowPos; unset name; unset row
        set protIDL [lsort -unique $protIDL]
        foreach ent $tmp_proteinL {
            set i [lsearch $protIDL [lindex $ent 3]]
            if {$i ne -1} {
                lappend env(contig.proteinL) "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] 1 [lindex $ent 4] [lindex $ent 5]"
            } else {
                lappend env(contig.proteinL) "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] 0 [lindex $ent 4] [lindex $ent 5]"
            }
        }
        unset protIDL; unset tmp_proteinL
        foreach t $tmp {
            if {[lindex $t 2] eq "go"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT category, \\\"name\\\", description FROM refdb.go WHERE id = '[lindex $t 3]'"}}]]
                foreach ent $sql_res {
                    lappend env(contig.ipsHitL) "[lrange $t 0 3] {[lindex $ent 1]} [lrange $t 4 end]"
                    lappend env(contig.goHitL) "[lrange $t 0 1] [lindex $t 3] [lindex $ent 0] {[lindex $ent 1]} {[lindex $ent 2]} [lindex $t end]"
                }
                unset sql_res
            } else {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT description FROM refdb.[lindex $t 2] WHERE id = '[lindex $t 3]'"}}]]
                foreach ent $sql_res {
                    lappend env(contig.ipsHitL) "[lrange $t 0 3] {[lindex $ent 0]} [lrange $t 4 end]"
                }
                unset sql_res
            }
        }
        unset tmp
    }
    catch {update_info_[.result.notebook2.nb raise]}
    catch {update_info_[.result.notebook1.nb raise]}
}

proc update_info_prot {ent} {
    global env
    global tabArr
    global tabL
    
    if {$ent ne ""} {
        set env(contig.id_prot) [lindex $ent 0]
        set env(contig.name) [lindex $ent 1]
        set env(contig.length) [lindex $ent 2]
        set env(contig.blast) [lindex $ent 4]
        set env(contig.blastprodom) [lindex $ent 5]
        set env(contig.coil) [lindex $ent 6]
        set env(contig.gene3d) [lindex $ent 7]
        set env(contig.go) [lindex $ent 8]
        set env(contig.interpro) [lindex $ent 9]
        set env(contig.kegg) [lindex $ent 10]
        set env(contig.panther) [lindex $ent 11]
        set env(contig.patternscan) [lindex $ent 12]
        set env(contig.pfam) [lindex $ent 13]
        set env(contig.pir) [lindex $ent 14]
        set env(contig.profilescan) [lindex $ent 15]
        set env(contig.smart) [lindex $ent 16]
        set env(contig.superfamily) [lindex $ent 17]
        set env(contig.tigr) [lindex $ent 18]
        
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, sequence FROM $env(contig.dbName).sequences_protein WHERE id_prot = '$env(contig.id_prot)'"}}]]
        foreach sRes $sql_res {
            set env(contig.id_seq) [lindex $sRes 0]
            set env(contig.sequence) [lindex $sRes 1]
        }
        unset sql_res
        set env(contig.ipsHitL) " "
        set env(contig.goHitL) " "
        set env(contig.proteinL) " "
        set protIDL ""
        foreach ref {blastprodom_hits coil_hits gene3d_hits go_hits panther_hits pfam_hits pir_hits interpro_hits patternscan_hits profilescan_hits smart_hits superfamily_hits tigr_hits} {
            if {$env(interproscan_results.[lindex [split $ref _] 0]) eq "+"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT id_prot FROM $env(contig.dbName).$ref WHERE id_prot = '$env(contig.id_prot)'"}}]]
                foreach sRes $sql_res {
                    lappend protIDL [lindex $sRes 0]
                }
                unset sql_res
            }    
        }
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot, frame, orf, length, name, sequence FROM $env(contig.dbName).sequences_protein WHERE id_prot = '$env(contig.id_prot)'"}}]]
        foreach sRes $sql_res {
            set i [lsearch $protIDL [lindex $sRes 0]]
            if {$i ne -1} {
                lappend env(contig.proteinL) "[lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] [lindex $sRes 0] 1 [lindex $sRes 4] [lindex $sRes 5]"
            } else {
                lappend env(contig.proteinL) "[lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] [lindex $sRes 0] 0 [lindex $sRes 4] [lindex $sRes 5]"
            }
        }
        unset sql_res; unset protIDL
        set tmp ""
        foreach ref {blastprodom_hits coil_hits gene3d_hits go_hits panther_hits pfam_hits pir_hits interpro_hits patternscan_hits profilescan_hits smart_hits superfamily_hits tigr_hits} {
            if {$env(contig.[lindex [split $ref _] 0]) ne 0 && $env(interproscan_results.[lindex [split $ref _] 0]) eq "+"} {
                if {$ref eq "interpro_hits" || $ref eq "go_hits"} {
                    set num 0
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, id FROM $env(contig.dbName).$ref WHERE id_prot = '$env(contig.id_prot)'"}}]]
                    foreach sRes $sql_res {
                        lappend tmp "[lindex $sRes 0] $env(contig.name) [lindex [split $ref _] 0] [lindex $sRes 1] N/A N/A N/A N/A $env(contig.id_prot) 1"
                        incr num
                    }
                    unset sql_res
                } elseif {$ref eq "patternscan_hits"} {
                    set num 0
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, id, \\\"start\\\", \\\"end\\\", length FROM $env(contig.dbName).$ref WHERE id_prot = '$env(contig.id_prot)'"}}]]
                    foreach sRes $sql_res {
                        lappend tmp "[lindex $sRes 0] $env(contig.name) [lindex [split $ref _] 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] [lindex $sRes 4] N/A $env(contig.id_prot) 1"
                        incr num
                    }
                    unset sql_res
                } else {
                    set num 0
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, id, \\\"start\\\", \\\"end\\\", length, evalue FROM $env(contig.dbName).$ref WHERE id_prot = '$env(contig.id_prot)' ORDER BY CAST(evalue AS numeric)"}}]]
                    foreach sRes $sql_res {
                        lappend tmp "[lindex $sRes 0] $env(contig.name) [lindex [split $ref _] 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] [lindex $sRes 4] [lindex $sRes 5] $env(contig.id_prot) 1"
                        incr num
                    }
                    unset sql_res
                }
            }
        }
        foreach t $tmp {
            if {[lindex $t 2] eq "go"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT \\\"name\\\", category, description FROM refdb.go WHERE id = '[lindex $t 3]'"}}]]
                foreach sRes $sql_res {
                    lappend env(contig.ipsHitL) "[lrange $t 0 3] {[lindex $sRes 0]} [lrange $t 4 end]"
                    lappend env(contig.goHitL) "[lrange $t 0 1] [lindex $t 3] [lindex $sRes 1] {[lindex $sRes 0]} {[lindex $sRes 2]} [lindex $t end]"
                }
                unset sql_res
            } else {
                set description ""
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT description FROM refdb.[lindex $t 2] WHERE id = '[lindex $t 3]'"}}]]
                foreach sRes $sql_res {
                    set description [lindex $sRes 0]
                }
                unset sql_res
                lappend env(contig.ipsHitL) "[lrange $t 0 3] {$description} [lrange $t 4 end]"
            }
        }
        unset tmp
    }
    catch {update_info_[.result.notebook2.nb raise]}
    catch {update_info_[.result.notebook1.nb raise]}
}

proc update_info_read {ent} {
    global env
    global tabArr
    global tabL
    
    if {$ent ne ""} {
        set env(contig.id_read) [lindex $ent 0]
        set env(contig.name) [lindex $ent 1]
        set env(contig.length) [lindex $ent 2]
        set env(contig.blast) [lindex $ent 4]
        set env(contig.blastprodom) [lindex $ent 5]
        set env(contig.coil) [lindex $ent 6]
        set env(contig.gene3d) [lindex $ent 7]
        set env(contig.go) [lindex $ent 8]
        set env(contig.interpro) [lindex $ent 9]
        set env(contig.kegg) [lindex $ent 10]
        set env(contig.panther) [lindex $ent 11]
        set env(contig.patternscan) [lindex $ent 12]
        set env(contig.pfam) [lindex $ent 13]
        set env(contig.pir) [lindex $ent 14]
        set env(contig.profilescan) [lindex $ent 15]
        set env(contig.smart) [lindex $ent 16]
        set env(contig.superfamily) [lindex $ent 17]
        set env(contig.tigr) [lindex $ent 18]
        
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence FROM $env(contig.dbName).sequences_read WHERE id_read = '$env(contig.id_read)'"}}]]
        foreach sRes $sql_res {
            set env(contig.sequence) [lindex $sRes 0]
        }
        unset sql_res
        set env(contig.ipsHitL) " "
        set env(contig.goHitL) " "
        set env(contig.proteinL) " "
    }
    catch {update_info_[.result.notebook2.nb raise]}
    catch {update_info_[.result.notebook1.nb raise]}
}

proc createTextY {text wid start end color tl row col w} {
    text $w -height 1 -width 85 -background white -font courier -wrap none -xscrollcommand ".readMap_align.1.x set"
    $w tag configure markedYellow -background $color
    $w insert end "$text"
    $w tag add markedYellow 1.$start 1.$end
}

proc createTextG {text wid start end tl row col w} {
    text $w -height 1 -width 85 -background white -font courier -wrap none -xscrollcommand ".readMap_align.1.x set"
    $w tag configure markedGreen -background green
    $w insert end "$text"
    $w tag add markedGreen 1.$start 1.$end
    $w configure -state disabled
}

proc move args {
    set x [lindex $args 0]
    if {[lindex $args 1] eq "moveto"} {
        for {set i 0} {$i <= $x} {incr i} {
            catch {
                [.readMap_align.1.table windowpath $i,1] xview moveto [lindex $args 2]
            }
        }
    } elseif {[lindex $args 1] eq "scroll"} {
        for {set i 0} {$i <= $x} {incr i} {
            catch {
                [.readMap_align.1.table windowpath $i,1] xview scroll [lindex $args 2] pages
            }
        }
    }
}

#gets list of available databases
proc getDBs {} {
    global env
    
    set datnames ""; set owner ""
    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, owner FROM dbs WHERE owner LIKE '%$env(user)%'"}}]] 
    foreach sRes $sql_res {
        foreach owner [lindex $sRes 1] {
            if {[lindex $owner 0] eq $env(user)} {
                lappend datnames "[lindex $sRes 0] [lindex $owner 1]"
                break
            }
        }
    }
    unset sql_res; unset owner
    set datnames [lsort $datnames]
    return $datnames
}

#gets information from the selected database
proc dbEvnt {database mode} {
    global env
    global seq_info
    global blastRefDBL
    global database_browser_showSeq
    global checkedImg
    global uncheckedImg
    if {$database ne $env(dbName)} {
        set env(dbName) $database
        catch {.result.notebook1.nb.fsb.1.table.l delete 0 end}
        catch {.result.notebook2.nb.fbr.1.table.l delete 0 end}
        catch {.result.notebook2.nb.fips.1.table.l delete 0 end}
        catch {.result.notebook2.nb.fgo.1.table.l delete 0 end}
        catch {.result.notebook2.nb.fprimer.1.table.l delete 0 end}
        catch {.result.notebook2.nb.frepeat.1.table.l delete 0 end}
        catch {.result.notebook2.nb.fpv.1.tab.table.l delete 0 end}
        catch {.result.notebook2.nb.fsv.1.table.l delete 0 end}
        catch {.result.notebook2.nb.fkeggM.1.2.1.table.l delete 0 end}
        .status.lab configure -text "Connected to $env(dbName)."
        wm title . "$env(dbName) - T-ACE"
    }
    
    set env(dbbCBL) "{all} {with hits} {without hits}"
    catch {
        set env(blastRefDBL) " "
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT db FROM $env(dbName).blast_hits"}}]]
        if {[lindex $sql_res end] ne "Fehler"} {
            foreach sRes $sql_res {
                lappend env(blastRefDBL) [lindex $sRes 0]
                lappend env(dbbCBL) "blast -> [lindex $sRes 0]"
            }
        }
        if {$env(blastRefDBL) ne " "} {
            lappend env(dbbCBL) "blast"
        }
        unset sql_res
    }
    
    foreach ref {nucseq protseq readseq blast blastprodom coil gene3d go panther pfam pir smart interpro kegg patternscan profilescan superfamily tigr minnuc avgnuc maxnuc minprot avgprot maxprot minread avgread maxread rassembled rsingletons n50 gc_content at_gc_ratio} {
        set $ref ""
    }
    
    set comment ""
    catch {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT nucseq, protseq, readseq, blast, blastprodom, coil, gene3d, go, panther, pfam, pir, smart, interpro, kegg, patternscan, profilescan, superfamily, tigr, minnuc, avgnuc, maxnuc, minprot, avgprot, maxprot, minread, avgread, maxread, rassembled, rsingletons, n50, gc_content, at_gc_ratio FROM $env(dbName).db_info"}}]]
        if {[lindex $sql_res end] ne "Fehler"} {
            foreach sRes $sql_res {
                set i 0
                foreach ref {nucseq protseq readseq blast blastprodom coil gene3d go panther pfam pir smart interpro kegg patternscan profilescan superfamily tigr minnuc avgnuc maxnuc minprot avgprot maxprot minread avgread maxread rassembled rsingletons n50 gc_content at_gc_ratio} {
                    set $ref [lindex $sRes $i]
                    incr i
                }
            }
        }
        unset i; unset sql_res
        if {$blastprodom ne 0} {
            lappend env(dbbCBL) blastprodom
        }
        if {$coil ne 0} {
            lappend env(dbbCBL) coil
        }
        if {$gene3d ne 0} {
            lappend env(dbbCBL) gene3d
        }
        if {$go ne 0} {
            lappend env(dbbCBL) go
        }
        if {$interpro ne 0} {
            lappend env(dbbCBL) interpro
        }
        if {$kegg ne 0} {
            lappend env(dbbCBL) kegg
        }
        if {$panther ne 0} {
            lappend env(dbbCBL) panther
        }
        if {$patternscan ne 0} {
            lappend env(dbbCBL) patternscan
        }
        if {$pfam ne 0} {
            lappend env(dbbCBL) pfam
        }
        if {$pir ne 0} {
            lappend env(dbbCBL) pir
        }
        if {$profilescan ne 0} {
            lappend env(dbbCBL) profilescan
        }
        if {$smart ne 0} {
            lappend env(dbbCBL) smart
        }
        if {$superfamily ne 0} {
            lappend env(dbbCBL) superfamily
        }
        if {$tigr ne 0} {
            lappend env(dbbCBL) tigr
        }
    }
    lappend env(dbbCBL) "with comment"
    .result.notebook1.nb.fdbb.0.feat configure -values $env(dbbCBL) -state normal
    catch {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT comment FROM $env(dbName).db_comment"}}]]
        if {[lindex $sql_res end] ne "Fehler"} {
            foreach sRes $sql_res {
                set comment [regsub -all {#zub#} [lindex $sRes 0] "\n"]
            }
        }
        unset sql_res
    }
    .result.notebook1.nb.fdb_info.1.table.l delete 0 end
    catch {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_run, description, treatment, sequences, assembled, singleton, sequencer, \\\"type\\\", runs, datein, dateout, data, \\\"comment\\\", color, a_b FROM $env(dbName).run_info ORDER BY id_run"}}]]
        set color ""
        if {[lindex [lindex [regsub -all {["]} $sql_res ""] 0] 0] ne "Fehler:" && [lindex $sql_res 1] ne "Fehler"} {
            foreach sRes $sql_res {
                set color [lindex $sRes 13]
                if {$color eq ""} {
                    set color blue
                }
                .result.notebook1.nb.fdb_info.1.table.l insert end "1 {} {} [lindex $sRes 0] {[lindex $sRes 1]} {[lindex $sRes 2]} [lindex $sRes 3] [lindex $sRes 4] [lindex $sRes 5] {[lindex $sRes 6]} {[lindex $sRes 7]} [lindex $sRes 8] {[lindex $sRes 9]} {[lindex $sRes 10]} {[lindex $sRes 11]} {[lindex $sRes 12]}"
                .result.notebook1.nb.fdb_info.1.table.l cellconfigure end,0 -image [expr {1 ? $checkedImg : $uncheckedImg}]
                .result.notebook1.nb.fdb_info.1.table.l cellconfigure end,1 -window "fillTable_createColorButton $color"
                .result.notebook1.nb.fdb_info.1.table.l cellconfigure end,2 -window "fillTable_createComboBox [lindex $sRes 14]"
            }
        } else {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_run, description, treatment, sequences, assembled, singleton, sequencer, \\\"type\\\", runs, datein, dateout, data, \\\"comment\\\", color, control_stress FROM $env(dbName).run_info ORDER BY id_run"}}]]
            set color ""
            if {[lindex [lindex [regsub -all {["]} $sql_res ""] 0] 0] ne "Fehler:"} {
                foreach sRes $sql_res {
                    set color [lindex $sRes 13]
                    if {$color eq ""} {
                        set color blue
                    }
                    set type [lindex $sRes 14]
                    if {$type eq "stress"} {
                        set type B
                    } elseif {$type eq "control"} {
                        set type A
                    }
                    .result.notebook1.nb.fdb_info.1.table.l insert end "1 {} {} [lindex $sRes 0] {[lindex $sRes 1]} {[lindex $sRes 2]} [lindex $sRes 3] [lindex $sRes 4] [lindex $sRes 5] {[lindex $sRes 6]} {[lindex $sRes 7]} [lindex $sRes 8] {[lindex $sRes 9]} {[lindex $sRes 10]} {[lindex $sRes 11]} {[lindex $sRes 12]}"
                    .result.notebook1.nb.fdb_info.1.table.l cellconfigure end,0 -image [expr {1 ? $checkedImg : $uncheckedImg}]
                    .result.notebook1.nb.fdb_info.1.table.l cellconfigure end,1 -window "fillTable_createColorButton $color"
                    .result.notebook1.nb.fdb_info.1.table.l cellconfigure end,2 -window "fillTable_createComboBox $type"
                }
            }
        }
        unset color; unset sql_res
    }
    
    catch {
        set percent ""
        .result.notebook2.nb.fkeggM.1.1.1.table.l delete 0 end
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $env(dbName).kegg_stat.id AS id_map, $env(dbName).kegg_stat.ko_num AS ko_num, $env(dbName).kegg_stat.ko_hits AS ko_hits, $env(dbName).kegg_stat.id_seql AS seql, refdb.kegg_maps.name AS name FROM $env(dbName).kegg_stat INNER JOIN refdb.kegg_maps ON $env(dbName).kegg_stat.id = refdb.kegg_maps.id_map ORDER BY name"}}]]
        set percent ""
        foreach sRes $sql_res {
            set percent [split [expr 100.0 * [lindex $sRes 2].0 / [lindex $sRes 1].0] .]
            .result.notebook2.nb.fkeggM.1.1.1.table.l insert end "[lindex $sRes 0] {[lindex $sRes 2]/[lindex $sRes 1]} [lindex $percent 0].[string range [lindex $percent 1] 0 1] [llength [lindex $sRes 3]] {[lindex $sRes 4]} {[lindex $sRes 3]}"
            .result.notebook2.nb.fkeggM.1.1.1.table.l cellconfigure end,0 -window fillTable_createButton
        }
        unset percent; unset sql_res
    }
    # Bindings.
    bind [.result.notebook2.nb.fkeggM.1.1.1.table.l bodypath] <Button-1> "
    set y \[.result.notebook2.nb.fkeggM.1.1.1.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
    set id_seqL \[lindex \[.result.notebook2.nb.fkeggM.1.1.1.table.l get \$y\] end\]
    update_info_kegg_maps \$id_seqL
    "
    
    set bNum 0
    set bNum2 0
    .result.notebook1.nb.fdb_info.panel delete 1.0 end
    .result.notebook1.nb.fdb_info.panel insert end "Database:\t$env(dbName) " hel
    set bNuc ".result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Nuc"
    set bProt ".result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Prot"
    set bRead ".result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Read"
    set bFeat ".result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Feat"
    set name [split $env(dbName) _]
    set date [split [lindex $name 2] .]
    set id "[lindex $name 0]_[lindex $name 1]_[lindex $date 2][lindex $date 1][lindex $date 0]_1-1000"
    set comm "execLink $id DB"
    unset name; unset date; unset id
    set comm "dbEvnt_createFastaWindow nuc"
    if {[catch {button $bNuc -text Export -command $comm}]} {
        destroy $bNuc
        button $bNuc -text Export -command $comm -state disabled
        
    }
    set comm "dbEvnt_createFastaWindow prot"
    if {[catch {button $bProt -text Export -command $comm}]} {
        destroy $bProt
        button $bProt -text Export -command $comm -state disabled
    }
    set comm "dbEvnt_createFastaWindow reads"
    if {[catch {button $bRead -text Export -command $comm}]} {
        destroy $bRead
        button $bRead -text Export -command $comm -state disabled
    }
    set comm "dbEvnt_featureHitListWindow $env(dbName)"
    if {[catch {button $bFeat -text Export -command $comm}]} {
        destroy $bFeat
        button $bFeat -text Export -command $comm
    }
    .result.notebook1.nb.fdb_info.panel insert end "\n\n$comment\n"
    unset comment
    .result.notebook1.nb.fdb_info.panel insert end "\n\n"
    .result.notebook1.nb.fdb_info.panel window create end -window $bNuc
    .result.notebook1.nb.fdb_info.panel insert end "Number of Nucleotide Sequences:" bold12
    .result.notebook1.nb.fdb_info.panel insert end "\t$nucseq\n"
    .result.notebook1.nb.fdb_info.panel insert end "\tmin. Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $minnuc\t"
    .result.notebook1.nb.fdb_info.panel insert end "   average Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $avgnuc\t"
    .result.notebook1.nb.fdb_info.panel insert end "   max. Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $maxnuc\n\n"
    .result.notebook1.nb.fdb_info.panel insert end "       N50:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $n50\t"
    .result.notebook1.nb.fdb_info.panel insert end "   GC-Content:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " [lindex [split $gc_content .] 0],[string range [lindex [split $gc_content .] 1] 0 1]\t"
    .result.notebook1.nb.fdb_info.panel insert end "   AT/GC-ratio:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " [lindex [split $at_gc_ratio .] 0],[string range [lindex [split $at_gc_ratio .] 1] 0 1]\n\n"
    .result.notebook1.nb.fdb_info.panel window create end -window $bProt
    .result.notebook1.nb.fdb_info.panel insert end "Number of Protein Sequences:" bold12
    .result.notebook1.nb.fdb_info.panel insert end "\t$protseq\n"
    .result.notebook1.nb.fdb_info.panel insert end "\tmin. Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $minprot\t"
    .result.notebook1.nb.fdb_info.panel insert end "   average Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $avgprot\t"
    .result.notebook1.nb.fdb_info.panel insert end "   max. Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $maxprot\n\n"
    .result.notebook1.nb.fdb_info.panel window create end -window $bRead
    .result.notebook1.nb.fdb_info.panel insert end "Number of Read Sequences:" bold12
    .result.notebook1.nb.fdb_info.panel insert end "\t$readseq\n"
    .result.notebook1.nb.fdb_info.panel insert end "\tmin. Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $minread\t"
    .result.notebook1.nb.fdb_info.panel insert end "   average Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $avgread\t"
    .result.notebook1.nb.fdb_info.panel insert end "   max. Size:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $maxread\n\n"
    .result.notebook1.nb.fdb_info.panel insert end "\tAssembled:" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $rassembled\t"
    .result.notebook1.nb.fdb_info.panel insert end " Singletons:\t" bold11
    .result.notebook1.nb.fdb_info.panel insert end " $rsingletons\n\n"
    .result.notebook1.nb.fdb_info.panel window create end -window $bFeat
    .result.notebook1.nb.fdb_info.panel insert end "\tFeature:\t\tEntries:" bold11
    .result.notebook1.nb.fdb_info.panel insert end "\n\tBlast\t\t$blast\n\tBlastProDom\t\t$blastprodom\n\tCoil\t\t$coil\n\tGene3D\t\t$gene3d\n\tGO\t\t$go\n\tInterPro\t\t$interpro\n\tKEGG\t\t$kegg\n\tPanther\t\t$panther\n\tPatternScan\t\t$patternscan\n\tPfam\t\t$pfam\n\tPIR\t\t$pir\n\tProfileScan\t\t$profilescan\n\tSmart\t\t$smart\n\tSuperfamily\t\t$superfamily\n\tTigr\t\t$tigr\n"
    
    if {$nucseq eq 0} {
        set env(sequence_type) protein; .status.lab2 configure -text "Mode: protein"
    } else {
        set env(sequence_type) nucleotide; .status.lab2 configure -text "Mode: nucleotide"
    }
    
    if {$mode} {
        catch {.result.notebook1.nb.fblast.2.params1.type configure -text "Database"}
        catch {blast_dbL}
        if {$env(sequence_type) eq "nucleotide"} {
            get_seq_info "all" seq_info
        } elseif {$env(sequence_type) eq "protein"} {
            get_prot_info "all" prot_info
        }
    }
}

proc dbEvnt_config {mode} {
    global env
    
    if {$mode eq "owner"} {
        .menubar.file.menu entryconfigure "Delete selected DB" -state normal
        .menubar.file.menu entryconfigure "Export..." -state normal
        .menubar.edit.menu entryconfigure "Edit DB..." -state normal
        .menubar.tool.menu entryconfigure "InterProScan" -state normal
        .result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Nuc configure -state normal
        .result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Prot configure -state normal
        .result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Read configure -state normal
    } elseif {$mode eq "guest"} {
        .menubar.file.menu entryconfigure "Delete selected DB" -state disabled
        .menubar.file.menu entryconfigure "Export..." -state disabled
        .menubar.edit.menu entryconfigure "Edit DB..." -state disabled
        .menubar.tool.menu entryconfigure "InterProScan" -state disabled
        .result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Nuc configure -state disabled
        .result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Prot configure -state disabled
        .result.notebook1.nb.fdb_info.panel.[regsub -all . [string tolower $env(dbName)] \"\"]Read configure -state disabled
    }
}

proc dbEvnt_seqAll {seqL} {
    global seq_all
    set seq_all "$seqL"
}

proc get_seq_info {feat mode} {
    global env
    global seq_all
    global database_browser_idOrderCheck
    global database_browser_lengthOrderCheck
    global database_browser_numreadsOrderCheck
    global database_browser_goOrderCheck
    global database_browser_interproOrderCheck
    
    if {$mode eq "seq_info"} {
        set order ""
        if {$database_browser_interproOrderCheck} {
            append order ", interpro"
        }
        if {$database_browser_goOrderCheck} {
            append order ", go"
        }
        if {$database_browser_lengthOrderCheck} {
            append order ", length DESC"
        }
        if {$database_browser_idOrderCheck} {
            append order ", id_seq"
        }
        if {$database_browser_numreadsOrderCheck} {
            append order ", numreads DESC"
        }
        if {$order ne ""} {
            set order [string range $order 2 end]
        } else {
            set order "id_seq"
        }
        if {$feat eq "all" || $feat eq "with hits" || $feat eq "without hits" || $env(database_browser.description) eq "-"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 5 -hide yes
        } elseif {$env(database_browser.description) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 5 -hide no
        }
        
        eval [subst {thread::send -async $::threadGet_seq_info {get_seq_infoT "$feat" $env(mainThreadID) $env(phpThreadID) "$order" $env(database_browser.description)}}]
        
    } elseif {$mode eq "id_seq"} {
        if {$feat eq "all"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $env(dbName).seq_info ORDER BY id_seq"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        } elseif {$feat eq "with hits"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $env(dbName).seq_info WHERE gotHits = 1 ORDER BY id_seq"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        } elseif {$feat eq "without hits"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $env(dbName).seq_info WHERE gotHits = 0 ORDER BY id_seq"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        } elseif {[lindex $feat 0] eq "blast_noDB"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT id_seq FROM $env(dbName).seq_info WHERE id_seq NOT IN (SELECT DISTINCT id_seq FROM $env(dbName).blast_hits WHERE db = 'nt') ORDER BY id_seq"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        } else {
            if {$feat eq "with comment"} {
                set feat comment
                set f $feat
            } else {
                set f $feat
            }
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $env(dbName).seq_info WHERE $feat != 0 ORDER BY id_seq"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        }
        return $returnL
    }
}

proc get_prot_info {feat mode} {
    global env
    global seq_info
    global seq_all
    global min_contig_size
    global database_browser_idOrderCheck
    global database_browser_lengthOrderCheck
    global database_browser_numreadsOrderCheck
    global database_browser_goOrderCheck
    global database_browser_interproOrderCheck
    
    if {$mode eq "prot_info"} {
        set order ""
        if {$database_browser_interproOrderCheck} {
            append order ", interpro"
        }
        if {$database_browser_goOrderCheck} {
            append order ", go"
        }
        if {$database_browser_lengthOrderCheck} {
            append order ", length DESC"
        }
        if {$database_browser_idOrderCheck} {
            append order ", id_prot"
        }
        if {$order ne ""} {
            set order [string range $order 2 end]
        } else {
            set order "id_prot"
        }
        .result.notebook1.nb.fdbb.1.table.l columnconfigure 4 -hide yes
        .result.notebook1.nb.fdbb.1.table.l columnconfigure 6 -hide yes
        .result.notebook1.nb.fdbb.1.table.l columnconfigure 22 -hide yes
        if {$feat eq "all" || $feat eq "with hits" || $feat eq "without hits" || $env(database_browser.description) eq "-"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 5 -hide yes
        } elseif {$env(database_browser.description) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 5 -hide no
        }
        
        eval [subst {thread::send -async $::threadGet_prot_info {get_prot_infoT "$feat" $env(mainThreadID) $env(phpThreadID) "$order" $env(database_browser.description)}}]
        
    } elseif {$mode eq "id_prot"} {
        if {$feat eq "all"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot FROM $env(dbName).prot_info ORDER BY id_prot"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        } elseif {$feat eq "with hits"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot FROM $env(dbName).prot_info WHERE gotHits = 1 ORDER BY id_prot"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        } elseif {$feat eq "without hits"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot FROM $env(dbName).prot_info WHERE gotHits = 0 ORDER BY id_prot"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        } else {
            if {$feat eq "with comment"} {
                set feat comment
                set f $feat
            } else {
                set f $feat
            }
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot FROM $env(dbName).prot_info WHERE $feat != 0 ORDER BY id_prot"}}]]
            foreach sRes $sql_res {
                lappend returnL [lindex $sRes 0]
            }
            unset sql_res
        }
        return $returnL
    }
}

proc contig_size_confirm {} {
    global min_contig_size
    global seq_all
    global seq_info
    
    set min_contig_size [.result.notebook1.nb.fdbb.0.size.ent get]
     
    unset seq_info
    set seq_info ""
    foreach seq $seq_all {
        if {[lindex $seq 2] >= $min_contig_size} {
            lappend seq_info $seq
        }
    }
    .result.notebook1.nb.fdbb.0.label4 configure -text " of  [llength $seq_info] "
    .result.notebook1.nb.fsb.0.label4 configure -text " of  [llength $seq_info] "
}

proc table_col_sh {t tab col} {
    global env
    if {$env($tab) eq "+"} {
        if {$col ne "-"} {
            if {[lindex [split $t .] 2] eq "notebook1" && ($t eq ".result.notebook1.nb.fdbb.1.table.l" || [string range [.result.notebook1.nb raise] 0 2] eq "prj")} {
                foreach page [.result.notebook1.nb pages] {
                    if {[string range $page 0 2] eq "prj" || $page eq "dbb"} {
                        foreach c $col {
                            .result.notebook1.nb.f$page.1.table.l columnconfigure $c -hide yes
                        }
                    }
                }
            } else {
                foreach c $col {
                    $t columnconfigure $c -hide yes
                }
            }
        }
        set env($tab) -
    } else {
        if {$col ne "-"} {
            if {[lindex [split $t .] 2] eq "notebook1" && ($t eq ".result.notebook1.nb.fdbb.1.table.l" || [string range [.result.notebook1.nb raise] 0 2] eq "prj")} {
                foreach page [.result.notebook1.nb pages] {
                    if {[string range $page 0 2] eq "prj" || $page eq "dbb"} {
                        foreach c $col {
                            .result.notebook1.nb.f$page.1.table.l columnconfigure $c -hide no
                        }
                    }
                }
            } else {
                foreach c $col {
                    $t columnconfigure $c -hide no
                }
            }
        }
        
        set env($tab) +
    } 
}

proc table_selection {tl col} {
    global checkedImg
    global uncheckedImg
    
    $tl finishediting
    if {[$tl columncget $col -labelimage] eq "image1"} {
        set use 0
    } else {
        set use 1
    }
    
    $tl columnconfigure $col -labelimage [expr {$use ? $checkedImg : $uncheckedImg}]
    set rows [$tl index end]
    for {set i 0} {$i < $rows} {incr i} {
        $tl cellconfigure $i,$col -text $use -image [expr {$use ? $checkedImg : $uncheckedImg}]
    }
}

proc table_copy {mode t} {
    global env
    set i 0
    set tab ""
    if {$mode eq "all"} {
        set colNum [$t columncount]
        for {set i 0} {$i < $colNum} {incr i} {
            if {[$t columncget $i -hide] ne 1} {
                lappend colL $i
                append tab "[$t columncget $i -title]\t"
            }
        }
        append tab "\n"
        set entL [$t getcolumns $colL]
        set colNum [llength $entL]
        set i 0
        while {[lindex [lindex $entL 0] $i] ne ""} {
            foreach e $entL {
                append tab "[lindex $e $i]\t"
            }
            append tab "\n"
            incr i
        }
        unset entL; unset colNum; unset colL
    } elseif {[lindex $mode 0] eq "column"} {
        append tab "[$t columncget [$t containingcolumn [lindex $mode 1]] -title]\n"
        foreach e [$t getcolumns [$t containingcolumn [lindex $mode 1]]] {
            append tab "$e\n"
        }
    } elseif {[lindex $mode 0] eq "row"} {
        set ent [$t get [$t nearest [lindex $mode 1]]]
        set colNum [$t columncount]
        for {set i 0} {$i < $colNum} {incr i} {
            if {[$t columncget $i -hide] ne 1} {
                append header "[$t columncget $i -title]\t"
                append tab "[lindex $ent $i]\t"
            }
        }
        set tab "$header\n$tab"
        unset header; unset ent; unset colNum
    } elseif {[lindex $mode 0] eq "cell"} {
        set tab [$t cellcget [$t containingcell [lindex $mode 1] [lindex $mode 2]] -text]
    } elseif {[lindex $mode 0] eq "sequence"} {
        if {$env(sequence_type) eq "nucleotide"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM [lindex $mode 2].sequences_nucleotide WHERE id_seq = '[lindex $mode 1]'"}}]]
            foreach ent $sql_res {
                set tab ">[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]\n[lindex $ent 3]"
            }
            unset sql_res
        } else {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, frame, orf, sequence FROM [lindex $mode 2].sequences_protein WHERE id_prot = '[lindex $mode 1]'"}}]]
            foreach ent $sql_res {
                set tab ">[lindex $ent 0] length=[lindex $ent 1] frame=[lindex $ent 2] orf=[lindex $ent 3]\n[lindex $ent 4]"
            }
            unset sql_res
        }
    }
    
    clipboard clear; clipboard append "$tab"
    unset tab; unset i
}

proc table_save {} {
    global seq_info
    
    set ofile [browse save {{{Text Files} {.txt} } {{All Files} * }} "descriptions.txt"]
    set output "Contig\tlength\tnumreads\tdescription\n\n"
    if {[.result.notebook1.nb raise] eq "sb" || [.result.notebook1.nb raise] eq "dbb"} {
        foreach ent $seq_info {
            append output "[lindex $ent 1]\t[lindex $ent 2]\t[lindex $ent 3]\t[lindex $ent 5]\n"
        }
    } else {
        set t .result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l
        $t finishediting
        set stop 1
        set i 0
        while {$stop} {
            if {[lindex [$t get $i] 0] eq 1} {
                append output "[lindex [$t get $i] 2]\t[lindex [$t get $i] 3]\t[lindex [$t get $i] 4]\t[lindex [$t get $i] 5]\n"
            } elseif {[lindex [$t get $i] 0] eq ""} {
                set stop 0
            }
            incr i
        }
    }
    if {[catch {set fs [open $ofile w]} ]} {
    } else {
        puts -nonewline $fs $output
        unset output
        close $fs
    }
}

proc fillTable_custom {t title columns updateBind checkColumns hideColumns entL} {
    global env
    global checkedImg
    global uncheckedImg
    
    catch {destroy $t}
    toplevel $t
    wm title $t $title
    frame $t.1
    frame $t.1.table
    scrollbar $t.1.y -orient vertical -command "$t.1.table.l yview"
    scrollbar $t.x -orient horizontal -command "$t.1.table.l xview"
    foreach col $columns {
        append colString "0 \"$col\" "
    }
    tablelist::tablelist $t.1.table.l \
            -width 80 -height 10 -showseparators 1 -stripebackground lightblue\
            -columns $colString \
            -labelcommand "$t.1.table.l finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch all \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$t.1.y set" \
            -xscrollcommand "$t.x set" \
            -background white
            
    foreach c $checkColumns {
        $t.1.table.l columnconfigure $c \
                -sortmode integer \
                -editable yes \
                -editwindow checkbutton \
                -formatcommand emptystr \
                -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
                -labelcommand "table_selection"
    }
    
    foreach c $hideColumns {
        $t.1.table.l columnconfigure $c -hide yes
    }
   
    pack $t.1.table.l -side left -fill both -expand true
    pack $t.1.y -side left -fill both; pack $t.1.table -side left -fill both -expand true
    pack $t.1 -side top -fill both -expand true
    pack $t.x -side top -fill both
    
    foreach ent $entL {
        $t.1.table.l insert end $ent
        foreach c $checkColumns {
            $t.1.table.l cellconfigure end,$c -image [expr {1 ? $checkedImg : $uncheckedImg}]
        }
    }
    
    # Bindings.
    bind [$t.1.table.l bodypath] <Button-1> "
    set y \[$t.1.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
    set row \[lrange \[$t.1.table.l get \$y\] 1 end\]
    set env(contig.dbName) \[lindex \[$t.1.table.l get \$y\] end\]
    $updateBind \$row
    "
}

proc fillTable {tl start end} {
    global env
    global checkedImg
    global uncheckedImg
    global blastArr
    global seq_info
    global search_results
    global tabArr
    
    $tl finishediting
    if {[$tl columncget 0 -labelimage] eq "image1"} {
        set use 1
    } else {
        set use 0
    }

    set entries ""
    if {$tl eq ".result.notebook1.nb.fdbb.1.table.l"} {
        if {$end > [llength $seq_info]} {
            set end [llength $seq_info]
        }
        for {set i $start} {$i < $end} {incr i} {
            set ent [lindex $seq_info $i]
            set cover [split [lindex $ent 22] .]
            lappend entries [list $use [expr $i + 1] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 5] \
                [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] \
                [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] \
                [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] "[lindex $cover 0],[string range [lindex $cover 1] 0 1]" [lindex $ent 0] [lindex $ent 23]]
        }
    } elseif {$tl eq ".result.notebook2.nb.fbr.1.table.l"} {
        foreach ent $env(contig.blastResultL) {
            lappend entries [list $use [lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 4] [lindex $ent 5]\
                    [lindex $ent 11] [lindex $ent 12] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 13]]
        }
    } elseif {$tl eq ".result.notebook2.nb.fips.1.table.l"} {
        foreach ent $env(contig.ipsHitL) {
            lappend entries [list $use [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] \
                    [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 0] [lindex $ent 9] [lindex $ent 10]]
        }
    } elseif {$tl eq ".result.notebook2.nb.fgo.1.table.l"} {
        foreach ent $env(contig.goHitL) {
            lappend entries [list $use [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] [lindex $ent 0] [lindex $ent 6]]
        }
    } elseif {$tl eq ".result.notebook2.nb.fpv.1.tab.table.l"} {
        foreach ent $env(contig.proteinL) {
            lappend entries [list "" [lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 4]]
        }
    } elseif {$tl eq ".result.notebook2.nb.fkegg.1.table.l"} {
        foreach ent $env(contig.keggL) {
            lappend entries "$use $ent"
        }
    } elseif {$tl eq ".result.notebook1.nb.fblast.1.tab.table.l"} {
        set i 0
        foreach ent $blastArr(blastHitL) {
            lappend entries [list $use [lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] \
                    [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] $i [lindex $ent 13]]
            incr i
        }
        .result.notebook1.nb.fblast.0.results select
        pack forget .result.notebook1.nb.fblast.2
        pack .result.notebook1.nb.fblast.1 -side top -fill both -expand true
    } else {
        for {set i $start} {$i < $end} {incr i} {
            set ent [lindex $search_results $i]
            set cover [split [lindex $ent 22] .]
            lappend entries [list 1 [expr $i + 1] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] \
                    [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] \
                    [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] \
                    [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] \
                    [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] "[lindex $cover 0],[string range [lindex $cover 1] 0 1]" [lindex $ent 0] [lindex $ent 23]]
        }
    }
    
    $tl delete 0 end
    if {$tl eq ".result.notebook1.nb.fdbb.1.table.l"} {
        .result.notebook1.nb.fsb.1.table.l delete 0 end
    }
    foreach ent $entries {
        $tl insert end $ent
        if {$tl ne ".result.notebook2.nb.fpv.1.tab.table.l"} {
            $tl cellconfigure end,0 -image [expr {[lindex $ent 0] ? $checkedImg : $uncheckedImg}]
        }
        if {$tl eq ".result.notebook1.nb.fdbb.1.table.l"} {
            if {$tabArr(sb.exist)} {
                .result.notebook1.nb.fsb.1.table.l insert end "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 23] [lindex $ent 24]"
                .result.notebook1.nb.fsb.1.table.l cellconfigure end,0 -image [expr {[lindex $ent 0] ? $checkedImg : $uncheckedImg}]
            }
        }
        if {$tl eq ".result.notebook1.nb.fdbb.1.table.l"} {
            #$tl cellconfigure end,2 -window fillTable_createButton
        } elseif {$tl eq ".result.notebook2.nb.fips.1.table.l"} {
            $tl cellconfigure end,3 -window fillTable_createButton
        } elseif {$tl eq ".result.notebook2.nb.fbr.1.table.l"} {
            $tl cellconfigure end,2 -window fillTable_createButton
        } elseif {$tl eq ".result.notebook2.nb.fgo.1.table.l"} {
            $tl cellconfigure end,2 -window fillTable_createButton
        } elseif {$tl eq ".result.notebook2.nb.fpv.1.tab.table.l"} {
            $tl cellconfigure end,0 -window fillTable_createButton
        } elseif {$tl eq ".result.notebook2.nb.fkegg.1.table.l"} {
            $tl cellconfigure end,1 -window fillTable_createButton
        }
    }
    unset entries
    
    if {$tl eq ".result.notebook1.nb.fdbb.1.table.l"} {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl get \$y\] 2\]
        set env(contig.dbName) \[lindex \[$tl get \$y\] end\]
        update_info_get_name \$name name
        "
        if {$tabArr(sb.exist)} {
            bind [.result.notebook1.nb.fsb.1.table.l bodypath] <Button-1> "
            set y \[.result.notebook1.nb.fsb.1.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
            set name \[lindex \[.result.notebook1.nb.fsb.1.table.l get \$y\] 2\]
            set env(contig.dbName) \[lindex \[.result.notebook1.nb.fsb.1.table.l get \$y\] end\]
            update_info_get_name \$name name
            "
        }
    } elseif {$tl eq ".result.notebook2.nb.fbr.1.table.l"} {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set start \[lindex \[$tl get \$y\] 9\]
        set end \[lindex \[$tl get \$y\] 10\]
        update_info_br_table \$start \$end
        "
    } elseif {$tl eq ".result.notebook2.nb.fips.1.table.l"} {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl get \$y\] 1\]
        set start \[lindex \[$tl get \$y\] 5\]
        set end \[lindex \[$tl get \$y\] 6\]
        set row \[lindex \[$tl get \$y\] 11\]
        update_info_ips_table \$name \$start \$end \$row
        "
    } elseif {$tl eq ".result.notebook2.nb.fgo.1.table.l"} {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl get \$y\] 1\]
        set row \[lindex \[$tl get \$y\] 7\]
        update_info_go_table \$name \$row
        "
    } elseif {$tl eq ".result.notebook2.nb.fpv.1.tab.table.l"} {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl get \$y\] 4\]
        update_info_pv_table \$name
        "
    } elseif {$tl eq ".result.notebook2.nb.fprimer.1.table.l"} {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set row \[lrange \[$tl get \$y\] 1 end\]
        update_info_primer_table \$row
        "
    } elseif {$tl eq ".result.notebook2.nb.fkegg.1.table.l"} {
        
    } elseif {$tl eq ".result.notebook1.nb.fblast.1.tab.table.l"} {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl get \$y\] 2\]
        set nr \[lindex \[$tl get \$y\] 11\]
        set env(contig.dbName) \[string tolower \[lindex \[$tl get \$y\] end\]\]
        update_info_blast_table \$name \$nr
        "
    } else {
        # Bindings.
        bind [$tl bodypath] <Button-1> "
        set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
        set name \[lindex \[$tl get \$y\] 2\]
        set env(contig.dbName) \[lindex \[$tl get \$y\] end\]
        update_info_get_name \$name name
        "
    }
    set search_results ""
}

proc fillTable_createColorButton {color tl row col w} {
    set comm "selectColor $w"
    
    image create photo c$color
    for {set j 0} {$j < 15} {incr j} {
        lappend line "$color"
    }
    for {set i 0} {$i < 15} {incr i} {
        lappend data "$line"
    }
    c$color put $data -to 0 0
    button $w -image c$color -highlightthickness 0 -takefocus 0 -command $comm
}

proc selectColor {w} {
    set color [SelectColor .selectColor]
    if {$color ne ""} {
        image create photo c$color
        for {set j 0} {$j < 15} {incr j} {
            lappend line "$color"
        }
        for {set i 0} {$i < 15} {incr i} {
            lappend data "$line"
        }
        c$color put $data -to 0 0
        $w configure -image c$color
    }   
}

proc fillTable_createButton {tl row col w} {
    global env
    global linkImg
    global linkRedImg
    global linkGreenImg
    
    if {$tl eq ".result.notebook1.nb.fdbb.1.table.l"} {
        set name [lindex [$tl get $row] 2]
        set comm "gBrowse $name $env(contig.dbName)"
        button $w -image $linkImg -highlightthickness 0 -takefocus 0 -command $comm
    } elseif {$tl eq ".result.notebook2.nb.fpv.1.tab.table.l"} {
        set hits [lindex [$tl get $row] 5]
        set id_prot [lindex [$tl get $row] 4]
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence FROM $env(contig.dbName).sequences_protein WHERE id_prot = '$id_prot'"}}]]
        foreach sRes $sql_res {
            set sequence [lindex $sRes 0]
        }
        unset sql_res
        set comm "execLink $sequence protein"
        unset sequence
        if {$hits} {
            button $w -image $linkGreenImg -highlightthickness 0 -takefocus 0 -command $comm
        } else {
            button $w -image $linkRedImg -highlightthickness 0 -takefocus 0 -command $comm
        }
    } else {
        if {$tl eq ".result.notebook2.nb.fips.1.table.l"} {
            set linkRef [lindex [$tl get $row] 2]
            set linkID [lindex [$tl get $row] 3]
        } elseif {$tl eq ".result.notebook2.nb.fbr.1.table.l"} {
            set linkRef [lindex [$tl get $row] 1]
            set linkID [lindex [$tl get $row] 2]
        } elseif {$tl eq ".result.notebook2.nb.fgo.1.table.l"} {
            set linkRef go
            set linkID [lindex [$tl get $row] 2]
        } elseif {$tl eq ".result.notebook2.nb.fdomain.1.tab.table.l"} {
            set linkRef [lindex [$tl get $row] 0]
            set linkID [lindex [$tl get $row] 1]
        } elseif {$tl eq ".result.notebook2.nb.fkegg.1.table.l"} {
            set linkRef kegg
            set linkID [lindex [$tl get $row] 1]
        } elseif {$tl eq ".result.notebook2.nb.fkeggM.1.1.1.table.l"} {
            set linkRef kegg
            set linkID [lindex [$tl get $row] 0]
        } elseif {$tl eq ".result.notebook2.nb.fkeggM.1.2.1.table.l"} {
            set linkRef kegg
            set linkID [lindex [$tl get $row] 2]
        }
        
        if {$linkRef eq "superfamily"} {
            set linkID [string range $linkID 3 end]
        }
        
        set key [$tl getkeys $row]
        set comm "execLink $linkID $linkRef"
        button $w -image $linkImg -highlightthickness 0 -takefocus 0 -command $comm
    }  
}

proc fillTable_createComboBox {ab tl row col w} {
    ComboBox $w -width 1 -height 2 -hottrack 1 -background white -values {A B} -text $ab
}

#exports nucleotide or protein sequences of a database to fasta file
proc dbEvnt_createFastaWindow {mode} {
    global env
    global checkOrder
    global dbEvnt_createFasta_withDescriptionCheck
    set checkOrder "ORDER BY length DESC"
    set dbEvnt_createFasta_withDescriptionCheck 0
    
    set t .createFasta
    catch {destroy $t}
    toplevel $t
    wm title $t "Export to FASTA"
    wm resizable $t 0 0
    
    variable f
    
    set comm "dbEvnt_createFasta $mode"
    
    frame $t.param
    if {$mode eq "reads"} {
        set stop 1
        set i 0
        set id_runL "all assembled singletons"
        while {$stop} {
            set id_run [lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3]
            if {$id_run eq ""} {
                set stop 0
            } else {
                lappend id_runL $id_run
            }
            incr i
        }
        label $t.param.l -text "Choose read List:"
        ComboBox $t.param.cb -width 15 -hottrack 1 -background white -text "all" -values $id_runL
        label $t.param.l2 -text "Order by:"
        radiobutton $t.param.name -text "Name" -variable checkOrder -value "ORDER BY name"
        radiobutton $t.param.length -text "Length" -variable checkOrder -value "ORDER BY length DESC"
    } else {
        if {$mode eq "nuc"} {
            label $t.param.l -text "Choose contig List:"
            radiobutton $t.param.reads -text "Number of Reads" -variable checkOrder -value "ORDER BY numreads DESC"
            set values ""
            foreach ent [lrange $env(dbbCBL) 3 end] {
                if {$ent ne "blast"} {
                    lappend values $ent
                }
            }
            ComboBox $t.param.cb -width 15 -hottrack 1 -background white -text "all" -values "[lrange $env(dbbCBL) 0 2] {selected runs} $values"
            unset values
        } elseif {$mode eq "prot"} {
            label $t.param.l -text "Choose protein List:"
            set values ""
            foreach ent $env(dbbCBL) {
                if {$ent ne "blast"} {
                    lappend values $ent
                }
            }
            ComboBox $t.param.cb -width 15 -hottrack 1 -background white -text "all" -values $values
            unset values
        }
        
        label $t.param.l2 -text "Order by:"
        radiobutton $t.param.name -text "Name" -variable checkOrder -value "ORDER BY id_seq"
        radiobutton $t.param.length -text "Length" -variable checkOrder -value "ORDER BY length DESC"
        checkbutton $t.param.des -text "with description" -variable dbEvnt_createFasta_withDescriptionCheck
    }
    
    frame $t.buts
    button $t.buts.ok -text "Export" -command $comm
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.param.l $t.param.cb $t.param.l2 $t.param.name $t.param.length -side top -anchor w
    if {$mode eq "nuc"} {
        pack $t.param.reads -side top -anchor w
    }
    if {$mode ne "reads"} {
        pack $t.param.des -side top -anchor w
    }
    pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
    pack $t.param $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc dbEvnt_createFasta {mode} {
    global dbEvnt_createFasta_withDescriptionCheck
    global env
    
    if {$mode eq "reads"} {
        set seqFile "$env(dbName)_reads.fasta"
    } elseif {$mode eq "nuc"} {
        set seqFile "$env(dbName)_contigs.fasta"
    } else {
        set seqFile "$env(dbName)_proteins.fasta"
    }
    
    set ofile [browse save {{{Fasta Files} {.fasta} } {{All Files} * }} $seqFile]
    if {$ofile ne ""} {
        set feat [.createFasta.param.cb get]
        if {$mode eq "reads"} {
            set idL ", $feat"
        } else {
            if {$feat eq "all"} {
                set idL ", all"
            } elseif {$feat eq "with hits"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $env(dbName).seq_info WHERE gotHits = 1 ORDER BY id_seq"}}]]
                foreach sRes $sql_res {
                    append idL ", '[lindex $sRes 0]'"
                }
                unset sql_res
            } elseif {$feat eq "without hits"} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $env(dbName).seq_info WHERE gotHits = 0 ORDER BY id_seq"}}]]
                foreach sRes $sql_res {
                    append idL ", '[lindex $sRes 0]'"
                }
                unset sql_res
            } elseif {$feat eq "selected runs"} {
                set stop 1
                set i 0
                .result.notebook1.nb.fdb_info.1.table.l finishediting
                set runs ""
                while {$stop} {
                    if {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq ""} {
                        set stop 0
                    } elseif {[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 0] eq "1"} {
                        append runs " OR runid_[lindex [.result.notebook1.nb.fdb_info.1.table.l get $i] 3] > 0"
                    }
                    incr i
                }
                set runs [string range $runs 4 end]
                if {$runs ne ""} {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $env(dbName).read_distribution WHERE $runs ORDER BY id_seq"}}]]
                    foreach sRes $sql_res {
                        append idL ", '[lindex $sRes 0]'"
                    }
                    unset sql_res
                } else {
                    errorPopUp "Error" "No runs selected."
                }
            } else {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT id_seq FROM $env(dbName).seq_info WHERE $env(dbName).seq_info.$feat != 0 ORDER BY id_seq"}}]]
                foreach sRes $sql_res {
                    append idL ", '[lindex $sRes 0]'"
                }
                unset sql_res
            }
        }
        set idL [string range $idL 2 end]
        destroy .createFasta
        if {$dbEvnt_createFasta_withDescriptionCheck} {
            sequences_save "$ofile" $mode $idL sequences $feat
        } else {
            sequences_save "$ofile" $mode $idL sequences ""
        }       
    }
}

#creates interface for exporting result lists of the different features
proc dbEvnt_featureHitListWindow {dbName} {
    global env
    global dbEvnt_featureHitList_contigsCheck
    global dbEvnt_featureHitList_evalueCheck
    global dbEvnt_featureHitListArr
    
    variable ffeat
    variable evalue
    set evalue 10
    set ffeat "$dbName"
    set dbEvnt_featureHitList_contigsCheck 1
    append ffeat "_#.txt"
    
    set t .exportFeat
    catch {destroy $t}
    toplevel $t
    wm title .exportFeat "Export HitLists"
    wm resizable $t 0 0
    
    frame $t.f
    
    frame $t.f.features -bd 2 -relief groove
    label $t.f.features.label -text "Features:"
    foreach feat $env(dbbCBL) {
        if {[lindex $feat 0] eq "blast"} {
            if {[lindex $feat 2] eq ""} {
                set gfeat "${feat}CheckFeat"
                global $gfeat
                checkbutton $t.f.features.$feat -text "$feat" -variable dbEvnt_featureHitListArr($gfeat)
                pack $t.f.features.$feat -side top -expand 1 -anchor w
            } else {
                set gfeat "[lindex $feat 0]_[lindex $feat 2]CheckFeat"
                global $gfeat
                checkbutton $t.f.features.[lindex $feat 2] -text "[lindex $feat 0] -> [lindex $feat 2]" -variable dbEvnt_featureHitListArr($gfeat)
                pack $t.f.features.[lindex $feat 2] -side top -expand 1 -anchor w
            }
        } elseif {$feat ne "all" && $feat ne "with hits" && $feat ne "without hits" && $feat ne "with comment"} {
            set gfeat "${feat}CheckFeat"
            global $gfeat
            checkbutton $t.f.features.$feat -text "$feat" -variable dbEvnt_featureHitListArr($gfeat)
            pack $t.f.features.$feat -side top -expand 1 -anchor w
        }
    }
    unset feat; unset gfeat
    frame $t.f.param
    frame $t.f.param.evalue
    checkbutton $t.f.param.evalue.cb -text "max. eValue:" -variable dbEvnt_featureHitList_evalueCheck
    entry $t.f.param.evalue.ent -textvariable evalue -width 5 -background white
    checkbutton $t.f.param.contigs -text "with contigs" -variable dbEvnt_featureHitList_contigsCheck
    
    frame $t.export -bd 2 -relief groove
    label $t.export.label -text "File names: "
    entry $t.export.ent -textvariable ffeat -width 25 -background white
    label $t.label2 -text "The '#'-symbol will be replaced with the feature name."
    
    frame $t.buts
    button $t.buts.ok -text "Export" -command "dbEvnt_featureHitList $dbName"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.export.label $t.export.ent -side left -expand 1 -anchor c
    pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
    pack $t.f.param.evalue.cb $t.f.param.evalue.ent -side left -anchor w
    pack $t.f.param.evalue $t.f.param.contigs -side top -anchor w
    pack $t.f.features $t.f.param -side left -anchor w
    pack $t.f $t.export $t.label2 $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

#calls export method for selected features
proc dbEvnt_featureHitList {dbName} {
    global env
    global dbEvnt_featureHitList_contigsCheck
    global dbEvnt_featureHitList_evalueCheck
    global dbEvnt_featureHitListArr
    
    foreach feat $env(dbbCBL) {
        if {[lindex $feat 0] eq "blast"} {
            if {[lindex $feat 2] eq ""} {
                set gfeat "${feat}CheckFeat"
                global $gfeat
                lappend refL "$feat all $gfeat"
            } else {
                set gfeat "[lindex $feat 0]_[lindex $feat 2]CheckFeat"
                global $gfeat
                lappend refL "[lindex $feat 0] [lindex $feat 2] $gfeat"
            }
        } elseif {$feat ne "all" && $feat ne "with hits" && $feat ne "without hits" && $feat ne "with comment"} {
            set gfeat "${feat}CheckFeat"
            global $gfeat
            lappend refL "$feat $gfeat"
        }
    }
    unset feat; unset gfeat
    
    set ofile "[browse dir - -]"
    if {$ofile ne ""} {
        append ofile "/[.exportFeat.export.ent get]"
        
        if {$dbEvnt_featureHitList_evalueCheck} {
            set evalue [.exportFeat.f.param.evalue.ent get]
        } else {
            set evalue 1000
        }
        destroy .exportFeat
        
        foreach ref $refL {
            if {$dbEvnt_featureHitListArr([lindex $ref end])} {
                if {[lindex $ref 0] eq "blast"} {
                    set feat "blast_hits [lindex $ref 1]"
                } else {
                    set feat "[lindex $ref 0]_hits"
                }
                dbEvnt_featureHitList_export $dbName "$feat" $ofile $dbEvnt_featureHitList_contigsCheck $evalue
            }
        }
        unset refL
    }  
}

#exports result lists of a feature to txt file
proc dbEvnt_featureHitList_export {dbName feat ofile contigsCheck evalue} {
    global env
    
    set ofile [split $ofile #]
    if {[llength $ofile] > 1} {
        set tmp [lindex $ofile 0]
        if {[lindex $feat 0] eq "blast_hits"} {
            append tmp "[lindex [split [lindex $feat 0] _] 0]_[lindex $feat 1]_[lindex $ofile 1]"
        } else {
            append tmp "[lindex [split $feat _] 0][lindex $ofile 1]"
        }
        set ofile $tmp
        unset tmp
    }
    set res ""
    set refL ""
    set tmpString ""
    if {$contigsCheck} {
        set id ""
        if {[lindex $feat 0] eq "blast_hits"} {
            set res "ID\tOrganism\tDescription\tProtein\teValue\tContigs"
            if {[lindex $feat 1] eq "all"} {
                set feat [lindex $feat 0]
                foreach db $env(blastRefDBL) {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.seq_info.name AS seq_name, A.id AS id, A.organism AS organism, A.product AS product, A.description AS description, A.evalue AS evalue FROM $dbName.seq_info INNER JOIN (SELECT $dbName.$feat.id_seq AS id_seq, $dbName.$feat.id AS id, refdb.$db.organism AS organism, refdb.$db.description AS description, refdb.$db.product AS product, $dbName.$feat.evalue AS evalue FROM $dbName.$feat INNER JOIN refdb.$db ON $dbName.$feat.id = refdb.$db.id WHERE CAST($dbName.$feat.evalue AS numeric) <= $evalue) A ON $dbName.seq_info.id_seq = A.id_seq ORDER BY A.description, A.product"}}]]
                    foreach sRes $sql_res {
                        if {$id eq [lindex $sRes 1]} {
                            append res "\t[lindex $sRes 0]"
                        } else {
                            append res "\n$db\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 0]"
                            set id [lindex $sRes 1]
                        }
                    }
                    unset sql_res
                }
            } else {
                set db [lindex $feat 1]
                set feat [lindex $feat 0]
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.seq_info.name AS seq_name, A.id AS id, A.organism AS organism, A.product AS product, A.description AS description, A.evalue AS evalue FROM $dbName.seq_info INNER JOIN (SELECT $dbName.$feat.id_seq AS id_seq, $dbName.$feat.id AS id, refdb.$db.organism AS organism, refdb.$db.description AS description, refdb.$db.product AS product, $dbName.$feat.evalue AS evalue FROM $dbName.$feat INNER JOIN refdb.$db ON $dbName.$feat.id = refdb.$db.id WHERE CAST($dbName.$feat.evalue AS numeric) <= $evalue) A ON $dbName.seq_info.id_seq = A.id_seq ORDER BY A.description, A.product"}}]]
                foreach sRes $sql_res {
                    if {$id eq [lindex $sRes 1]} {
                        append res "\t[lindex $sRes 0]"
                    } else {
                        append res "\n$db\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 4]\t[lindex $sRes 5]\t[lindex $sRes 0]"
                        set id [lindex $sRes 1]
                    }
                }
                unset sql_res
            }
        } elseif {$feat eq "go_hits"} {
            set res "ID\tCategory\tName\tContigs"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.seq_info.name AS seq_name, A.id AS id, A.category AS category, A.name AS name FROM $dbName.seq_info INNER JOIN (SELECT $dbName.go_hits.id_seq AS id_seq, $dbName.go_hits.id AS id, refdb.go.category AS category, refdb.go.name AS name FROM $dbName.go_hits INNER JOIN refdb.go ON $dbName.go_hits.id = refdb.go.id) A ON $dbName.seq_info.id_seq = A.id_seq ORDER BY A.name"}}]]
            foreach sRes $sql_res {
                if {$id eq [lindex $sRes 1]} {
                    append res "\t[lindex $sRes 0]"
                } else {
                    append res "\n[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 0]"
                    set id [lindex $sRes 1]
                }
            }
            unset sql_res
        } elseif {$feat eq "interpro_hits"} {
            set res "ID\tDescription\tContigs"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.seq_info.name AS seq_name, A.id AS id, A.description AS description FROM $dbName.seq_info INNER JOIN (SELECT $dbName.$feat.id_seq AS id_seq, $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id) A ON $dbName.seq_info.id_seq = A.id_seq ORDER BY A.description"}}]]
            foreach sRes $sql_res {
                if {$id eq [lindex $sRes 1]} {
                    append res "\t[lindex $sRes 0]"
                } else {
                    append res "\n[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 0]"
                    set id [lindex $sRes 1]
                }
            }
            unset sql_res
        } elseif {$feat eq "kegg_hits"} {
            set res "ID\tName\tDescription\tContigs"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.seq_info.name AS seq_name, A.id AS id, A.name AS name, A.description AS description FROM $dbName.seq_info INNER JOIN (SELECT $dbName.$feat.id_seq AS id_seq, $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].name AS name, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id) A ON $dbName.seq_info.id_seq = A.id_seq ORDER BY A.name"}}]]
            foreach sRes $sql_res {
                if {$id eq [lindex $sRes 1]} {
                    append res "\t[lindex $sRes 0]"
                } else {
                    append res "\n[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]\t[lindex $sRes 0]"
                    set id [lindex $sRes 1]
                }
            }
            unset sql_res
        } elseif {$feat eq "patternscan_hits"} {
            set res "ID\tDescription\tContigs"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.seq_info.name AS seq_name, A.id AS id, A.description AS description FROM $dbName.seq_info INNER JOIN (SELECT $dbName.$feat.id_seq AS id_seq, $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id) A ON $dbName.seq_info.id_seq = A.id_seq ORDER BY A.description"}}]]
            foreach sRes $sql_res {
                if {$id eq [lindex $sRes 1]} {
                    append res "\t[lindex $sRes 0]"
                } else {
                    append res "\n[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 0]"
                    set id [lindex $sRes 1]
                }
            }
            unset sql_res
        } else {
            set res "ID\tDescription\tContigs"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.seq_info.name AS seq_name, A.id AS id, A.description AS description FROM $dbName.seq_info INNER JOIN (SELECT $dbName.$feat.id_seq AS id_seq, $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id WHERE CAST($dbName.$feat.evalue AS numeric) <= $evalue) A ON $dbName.seq_info.id_seq = A.id_seq ORDER BY A.description"}}]]
            foreach sRes $sql_res {
                if {$id eq [lindex $sRes 1]} {
                    append res "\t[lindex $sRes 0]"
                } else {
                    append res "\n[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 0]"
                    set id [lindex $sRes 1]
                }
            }
            unset sql_res
        }
    } else {
        if {[lindex $feat 0] eq "blast_hits"} {
            set res "ID\tOrganism\tDescription\tProtein"
            if {[lindex $feat 1] eq "all"} {
                set feat [lindex $feat 0]
                foreach db $env(blastRefDBL) {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.$feat.id AS id, refdb.$db.organism AS organism, refdb.$db.product AS product, refdb.$db.description AS description FROM $dbName.$feat INNER JOIN refdb.$db ON $dbName.$feat.id = refdb.$db.id WHERE CAST($dbName.$feat.evalue AS numeric) <= $evalue ORDER BY refdb.$db.description, refdb.$db.product"}}]]
                    foreach sRes $sql_res {
                        append res "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]"
                    }
                    unset sql_res
                }
            } else {
                set db [lindex $feat 1]
                set feat [lindex $feat 0]
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT $dbName.$feat.id AS id, refdb.$db.organism AS organism, refdb.$db.product AS product, refdb.$db.description AS description FROM $dbName.$feat INNER JOIN refdb.$db ON $dbName.$feat.id = refdb.$db.id WHERE CAST($dbName.$feat.evalue AS numeric) <= $evalue ORDER BY refdb.$db.description, refdb.$db.product"}}]]
                foreach sRes $sql_res {
                    append res "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]\t[lindex $sRes 3]"
                }
                unset sql_res
            }
        } elseif {$feat eq "go_hits"} {
            set res "ID\tCategory\tName"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT $dbName.go_hits.id AS id, refdb.go.category AS category, refdb.go.name AS name FROM $dbName.go_hits INNER JOIN refdb.go ON $dbName.go_hits.id = refdb.go.id ORDER BY refdb.go.name"}}]]
            foreach sRes $sql_res {
                append res "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]"
            }
            unset sql_res
        } elseif {$feat eq "interpro_hits"} {
            set res "ID\tDescription"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id ORDER BY refdb.[lindex [split $feat _] 0].description"}}]]
            foreach sRes $sql_res {
                append res "\n[lindex $sRes 0]\t[lindex $sRes 1]"
            }
            unset sql_res
        } elseif {$feat eq "kegg_hits"} {
            set res "ID\tName\tDescription"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].name AS name, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id ORDER BY refdb.[lindex [split $feat _] 0].name"}}]]
            foreach sRes $sql_res {
                append res "\n[lindex $sRes 0]\t[lindex $sRes 1]\t[lindex $sRes 2]"
            }
            unset sql_res
        } elseif {$feat eq "patternscan_hits"} {
            set res "ID\tDescription"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id ORDER BY refdb.[lindex [split $feat _] 0].description"}}]]
            foreach sRes $sql_res {
                append res "\n[lindex $sRes 0]\t[lindex $sRes 1]"
            }
            unset sql_res
        } else {
            set res "ID\tDescription"
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT $dbName.$feat.id AS id, refdb.[lindex [split $feat _] 0].description AS description FROM $dbName.$feat INNER JOIN refdb.[lindex [split $feat _] 0] ON $dbName.$feat.id = refdb.[lindex [split $feat _] 0].id WHERE CAST($dbName.$feat.evalue AS numeric) <= $evalue ORDER BY refdb.[lindex [split $feat _] 0].description"}}]]
            foreach sRes $sql_res {
                append res "\n[lindex $sRes 0]\t[lindex $sRes 1]"
            }
            unset sql_res
        }
    }
    if {$res ne ""} {
        set out [open "$ofile" w]
        puts -nonewline $out $res
        close $out
    }
    unset res; unset refL; unset tmpString  
}

proc getRefs {w} {
    global env
    global database_browser_showSeq
    set refName [$w get]
    if {[string trim $env(dbName)] ne ""} {
        if {$refName ne "all" || $refName ne "with hits" || $refName ne "without hits"} {
            set env(database_browser.description) +
        } else {
            set env(database_browser.description) -
        }
        
        if {$env(dbName) eq " "} {
            .status.lab configure -text "No database selected."
        } else {
            .status.lab configure -text "Connected to $env(dbName), searching for $refName."
        }
        
        if {$env(sequence_type) eq "nucleotide"} {
            get_seq_info "$refName" seq_info
        } elseif {$env(sequence_type) eq "protein"} {
            get_prot_info "$refName" prot_info
        }
    }
}

#browsing for file or folder
proc browse {mode types ifile} {
    global env
       
    if {$mode eq "save"} {
        set files [tk_getSaveFile -filetypes $types -initialfile $ifile -initialdir $env(homeFolder)]
        if {$files != ""} {
            return $files
        }
    } elseif {$mode eq "open"} {
        set files [tk_getOpenFile -filetypes $types -initialdir $env(currentFolder)]
        if {$files != ""} {
            set f [split $files /]
            set env(currentFolder) ""
            for {set i 1} {$i < [expr [llength $f] - 1]} {incr i} {
                append env(currentFolder) "/[lindex $f $i]"
            }
            unset f
            return $files
        }
    } elseif {$mode eq "dir"} {
        set dir [tk_chooseDirectory -initialdir $env(homeFolder)]
        if {$dir != ""} {
            return $dir
        }
    } elseif {$mode eq "setHome"} {
        set dir [tk_chooseDirectory -initialdir $env(homeFolder)]
        if {$dir != ""} {
            set env(homeFolder) $dir
            config_change 0
        }
    } elseif {$mode eq "setIPR"} {
        set dir [tk_chooseDirectory -initialdir $env(database_interpro.location_path)]
        if {$dir != ""} {
            set env(database_interpro.location_path) $dir
            config_change 0
        }
    } elseif {$mode eq "setBrowser"} {
        set files [tk_getOpenFile -filetypes $types -initialdir $env(homeFolder)]
        if {$files != ""} {
            set env(browserPath) $files
            config_change 0
        }
    } elseif {$mode eq "setTranslateTableProtPath"} {
        set files [tk_getOpenFile -filetypes $types -initialdir $env(homeFolder)]
        if {$files != ""} {
            set env(translateTableProtPath) $files
            config_change translateTableProtPath
        }
    } elseif {$mode eq "savePrj"} {
        set files [tk_getSaveFile -filetypes $types -initialfile $ifile -initialdir $env(homeFolder)]
        if {$files != ""} {
            project_save $files
        }
    }
}

#opens a browser window with the given website
proc execLink {linkID linkRef} {
    global env
    global execLinkArr
    
    if {[string length $env(browserPath)] <= 1} {
        errorPopUp "Error" "Please set BrowserPath."
    } else {
        catch {eval exec {$env(browserPath)} "$execLinkArr($linkRef)" &}
    }
}

proc search_pattern_window {rProc panel} {
    global search_pattern_string
    global search_pattern_result
    
    set search_pattern_result ""
    
    if {[llength $panel] > 1} {
        set reference [lindex $panel 1]
        set panel [lindex $panel 0]
    } else {
        set reference [string toupper [$panel get -displaychars 1.0 end]]
    }
    
    set t .search_pattern
    catch {destroy $t}
    toplevel $t
    wm title $t "Search"
    wm resizable $t 0 0
    
    variable search_pattern_string
    
    frame $t.top
    
    label $t.top.l -text "Search string:"
    entry $t.top.ent -width 30 -background white -textvariable search_pattern_string
    
    frame $t.bottom
    button $t.bottom.prev -text "<" -command "search_pattern prev 0 $rProc \"$panel\""
    label $t.bottom.l1 -text "0"
    label $t.bottom.l2 -text " of "
    label $t.bottom.l3 -text "0"
    button $t.bottom.next -text ">" -command "search_pattern next 0 $rProc \"$panel\""
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Search" -command "search_pattern search \"$reference\" $rProc \"$panel\""
    button $t.buts.cancel -text "Cancel" -command "set search_pattern_result \"\"; destroy $t"
    
    pack $t.top.l $t.top.ent -side left -fill both -anchor w
    pack $t.bottom.prev $t.bottom.l1 $t.bottom.l2 $t.bottom.l3 $t.bottom.next -side left -fill both -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.top $t.bottom $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc search_pattern {mode reference rProc panel} {
    global search_pattern_string
    global search_pattern_result
    
    
    if {$mode eq "search"} {
        set search_pattern_result ""
        set search_pattern_string [string toupper [.search_pattern.top.ent get]]
        set newline [lsort -integer -index 0 -unique [regexp -all -indices -nocase -inline "\\n" "$reference"]]
        set gaps [lsort -integer -index 0 -unique [regexp -all -indices -nocase -inline {[*]} "$reference"]]
        set tmp [lsort -integer -index 0 -unique [regexp -all -indices -nocase -inline "$search_pattern_string" "[regsub -all {\*} $reference ""]"]]
        foreach ent $tmp {
            set line 1
            if {$gaps ne ""} {
                foreach gap $gaps {
                    if {[lindex $ent 0] < [lindex $gap 0]} {
                        break
                    } else {
                        set ent "[expr [lindex $ent 0] + 1] [expr [lindex $ent 1] + 1]"
                    }
                }
            }
            if {$newline ne ""} {
                set lastline 0
                foreach new $newline {
                    if {[lindex $ent 0] < [lindex $new 0]} {
                        lappend search_pattern_result "[expr [lindex $ent 0] - $lastline] [expr [lindex $ent 1] - $lastline] $line"
                        break
                    }
                    incr line
                    set lastline [expr [lindex $new 0] + 1]
                }
            } else {
                lappend search_pattern_result "[lindex $ent 0] [lindex $ent 1] 1"
            }
        }
        unset tmp; unset newline; catch {unset line; unset lastline; unset new; unset ent}
        if {$search_pattern_result eq ""} {
            .search_pattern.bottom.l1 configure -text 0
            .search_pattern.bottom.l3 configure -text 0
        } else {
            .search_pattern.bottom.l1 configure -text 1
            .search_pattern.bottom.l3 configure -text [llength $search_pattern_result]
            $rProc "$panel" [lindex $search_pattern_result 0]
        }
        
    } elseif {$mode eq "prev"} {
        set i [expr [.search_pattern.bottom.l1 cget -text] - 1]
        if {$i > 0} {
            .search_pattern.bottom.l1 configure -text $i
            $rProc "$panel" [lindex $search_pattern_result [expr $i - 1]]
        }
    } elseif {$mode eq "next"} {
        set i [expr [.search_pattern.bottom.l1 cget -text] + 1]
        if {$i <= [llength $search_pattern_result]} {
            .search_pattern.bottom.l1 configure -text $i
            $rProc "$panel" [lindex $search_pattern_result [expr $i - 1]]
        }
    }
}

proc search_pattern_mark {t pos} {
    global search_pattern_markSeq
    
    catch {$t tag remove markedGreen 1.0 end}
    $t tag add markedGreen [lindex $pos 2].[lindex $pos 0] [lindex $pos 2].[expr [lindex $pos 1] + 1]
}

proc search_window {} {
    global env
    global searchDBarr
    global searchFeatArr
    global searchFeatAll
    global checkedImg
    global uncheckedImg
    
    variable search_search1
    variable search_search2
    variable search_search3
    
    variable search_contigLength
    
    variable search_hitLength
    variable search_evalue
    variable search_perfection
    variable search_score
    
    if {$env(dbName) ne " "} {
        set t .search
        catch {destroy $t}
        toplevel $t
        wm title $t "Search"
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.top
        frame $t.top.l
        frame $t.top.m
        frame $t.top.r
        
        frame $t.top.l.dbs -bd 2 -relief groove
        label $t.top.l.dbs.label -text "Databases:"
        frame $t.top.l.dbs.table
        scrollbar $t.top.l.dbs.table.y -orient vertical -command "$t.top.l.dbs.table.l yview"
        tablelist::tablelist $t.top.l.dbs.table.l \
                -width 40 -height 18 -showseparators 1 \
                -columns {0 "" 0 "Database"} \
                -labelcommand "$t.top.l.dbs.table.l finishediting; tablelist::sortByColumn" \
                -exportselection 0 \
                -stretch {1} \
                -selectmode single \
                -editendcommand editEndCmd \
                -yscrollcommand "$t.top.l.dbs.table.y set" \
                -background white
        $t.top.l.dbs.table.l columnconfigure 0 \
                -editable yes \
                -editwindow checkbutton \
                -formatcommand emptystr \
                -labelimage [expr {0 ? $checkedImg : $uncheckedImg}] \
                -labelcommand "table_selection"
        
        set i 0
        set searchFeatAll 1
        foreach db $env(dbL) {
            if {[lindex $db 0] eq $env(dbName)} {
                $t.top.l.dbs.table.l insert end "1 [string tolower [lindex $db 0]]"
                $t.top.l.dbs.table.l cellconfigure end,0 -image [expr {1 ? $checkedImg : $uncheckedImg}]
            } else {
                $t.top.l.dbs.table.l insert end "0 [string tolower [lindex $db 0]]"
                $t.top.l.dbs.table.l cellconfigure end,0 -image [expr {0 ? $checkedImg : $uncheckedImg}]
            }
        }
        frame $t.top.m.feats
        label $t.top.m.feats.label -text "Features:"
        frame $t.top.m.feats.all
        checkbutton $t.top.m.feats.all.cb -text "all/none" -variable searchFeatAll -command "search_all_check"
        foreach item {blast blastprodom gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr} {
            frame $t.top.m.feats.$item
            checkbutton $t.top.m.feats.$item.cb -text "$item" -variable searchFeatArr($item)
        }
        
        frame $t.top.r.search1
        label $t.top.r.search1.label -text "Search 1:"
        entry $t.top.r.search1.ent -width 20 -background white -textvariable search_search1
        frame $t.top.r.search2
        label $t.top.r.search2.label -text "Search 2:"
        entry $t.top.r.search2.ent -width 20 -background white -textvariable search_search2
        frame $t.top.r.search3
        label $t.top.r.search3.label -text "Search 3:"
        entry $t.top.r.search3.ent -width 20 -background white -textvariable search_search3
        
        frame $t.top.r.contigLength
        label $t.top.r.contigLength.label -text "min. contig length (bp):"
        entry $t.top.r.contigLength.ent -width 10 -background white -textvariable search_contigLength
        frame $t.top.r.hitLength
        label $t.top.r.hitLength.label -text "min. hit length (bp):"
        entry $t.top.r.hitLength.ent -width 10 -background white -textvariable search_hitLength
        frame $t.top.r.perfection
        label $t.top.r.perfection.label -text "min. perfection (%):"
        entry $t.top.r.perfection.ent -width 10 -background white -textvariable search_perfection
        frame $t.top.r.evalue
        label $t.top.r.evalue.label -text "min. eValue:"
        entry $t.top.r.evalue.ent -width 10 -background white -textvariable search_evalue
        frame $t.top.r.score
        label $t.top.r.score.label -text "min. score:"
        entry $t.top.r.score.ent -width 10 -background white -textvariable search_score
        
        frame $t.top.r.types -bd 2 -relief groove
        label $t.top.r.types.label -text "Search types:"
        foreach item {ID Description Organism Product} {
            global search_[string tolower $item]
            set search_[string tolower $item] 0
            frame $t.top.r.types.[string tolower $item]
            checkbutton $t.top.r.types.[string tolower $item].cb -text "$item" -variable search_[string tolower $item]
        }
        set search_description 1
        set search_product 1
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "Search" -command "search_run"
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.top.l.dbs.label -side top -fill both
        set i 0
        
        pack $t.top.m.feats.label -side top -fill both
        foreach item {all blast blastprodom gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr} {
            pack $t.top.m.feats.[string tolower $item].cb -side left -fill both -anchor w
            pack $t.top.m.feats.[string tolower $item] -side top -fill both
        }
        
        pack $t.top.r.search1.label -side left -fill both -anchor w; pack $t.top.r.search1.ent -side right -fill both -anchor e
        pack $t.top.r.search2.label -side left -fill both -anchor w; pack $t.top.r.search2.ent -side right -fill both -anchor e
        pack $t.top.r.search3.label -side left -fill both -anchor w; pack $t.top.r.search3.ent -side right -fill both -anchor e
        
        pack $t.top.r.contigLength.label -side left -fill both -anchor w; pack $t.top.r.contigLength.ent -side right -fill both -anchor e
        pack $t.top.r.hitLength.label -side left -fill both -anchor w; pack $t.top.r.hitLength.ent -side right -fill both -anchor e
        pack $t.top.r.perfection.label -side left -fill both -anchor w; pack $t.top.r.perfection.ent -side right -fill both -anchor e
        pack $t.top.r.evalue.label -side left -fill both -anchor w; pack $t.top.r.evalue.ent -side right -fill both -anchor e
        pack $t.top.r.score.label -side left -fill both -anchor w; pack $t.top.r.score.ent -side right -fill both -anchor e
        
        pack $t.top.r.types.label -side top -fill both
        foreach item {ID Description Organism Product} {
            pack $t.top.r.types.[string tolower $item].cb -side left -fill both -anchor w
            pack $t.top.r.types.[string tolower $item] -side top -fill both
        }
        
        pack $t.top.l.dbs.table.y $t.top.l.dbs.table.l -side left -fill both
        pack $t.top.l.dbs $t.top.l.dbs.table -side top -fill both
        pack $t.top.m.feats -side top -fill both
        
        label $t.top.r.l0; label $t.top.r.l1; label $t.top.r.l2
        pack $t.top.r.search1 $t.top.r.search2 $t.top.r.search3 $t.top.r.l0 $t.top.r.contigLength $t.top.r.l1 \
                $t.top.r.hitLength $t.top.r.perfection $t.top.r.evalue $t.top.r.score $t.top.r.l2 $t.top.r.types \
                -side top -fill both
        
        pack $t.buts.ok $t.buts.cancel -side left -fill both
        pack $t.top.l $t.top.m $t.top.r -side left -fill both
        pack $t.top $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    } else {
        errorPopUp "Error" "No database selected."
    }
}

proc search_all_check {} {
    global searchFeatArr
    global searchFeatAll
    
    if {$searchFeatAll} {
        foreach item {blast blastprodom gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr} {
            set searchFeatArr($item) 1
        }
    } else {
        foreach item {blast blastprodom gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr} {
            set searchFeatArr($item) 0
        }
    }
}

proc search_run {} {
    global env
    global searchDBarr
    global searchFeatArr
    global search_results
    global search_id
    global search_organism
    global search_product
    global search_description
    global page_counter
    
    set t .search
    
    set search_contigLength [$t.top.r.contigLength.ent get]
    
    set dbList ""
    set blastRefDBL ""
    $t.top.l.dbs.table.l finishediting
    set stop 0
    set i 0
    while {$stop ne 1} {
        if {[lindex [$t.top.l.dbs.table.l get $i] 0] eq 1} {
            lappend dbList "[lindex [$t.top.l.dbs.table.l get $i] 1]"
            catch {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT db FROM [lindex [$t.top.l.dbs.table.l get $i] 1].blast_hits"}}]]
                foreach sRes $sql_res {
                    lappend blastRefDBL [lindex $sRes 0]
                    
                }
                unset sql_res
            }
        } elseif {[lindex [$t.top.l.dbs.table.l get $i] 0] eq ""} {
            set stop 1
        }
        incr i
    }
    set blastRefDBL [lsort -unique $blastRefDBL]
    foreach feat {blast blastprodom gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr} {
        if {$searchFeatArr($feat)} {
            lappend searchFeatL $feat
        }
    }
    if {$dbList eq ""} {
        errorPopUp "Error - Search" "Cannot perform search, no database selected."
    } else {
        lappend searchL [$t.top.r.search1.ent get]
        lappend searchL [$t.top.r.search2.ent get]
        lappend searchL [$t.top.r.search3.ent get]
        set search_hitLength [.search.top.r.hitLength.ent get]
        set search_evalue [.search.top.r.evalue.ent get]
        set search_perfection [.search.top.r.perfection.ent get]
        set search_score [.search.top.r.score.ent get]
        
        set ::threadSearchRun [thread::create {
            proc search_run {dbName processID mainThreadID phpThreadID searchL dbList blastRefDBL searchFeatL search_id search_organism search_product search_description search_contigLength search_hitLength search_evalue search_perfection search_score process} {
                set id_seqL ""
                set noKeyWords 1
                foreach search $searchL {
                    if {$search ne ""} {
                        set noKeyWords 0
                        foreach s $search {append tmpString ", '$s'"}
                        set tmpString [string range $tmpString 2 end]]
                        foreach feat $searchFeatL {
                            set sql "SELECT id FROM "
                            set run 0; set or 0
                            if {$feat eq "blast"} {
                                foreach blastRefDB $blastRefDBL {
                                    catch {
                                        set sql "SELECT id FROM "
                                        set run 0; set or 0
                                        append sql "refdb.$blastRefDB WHERE "
                                        if {$search_organism} {
                                            set run 1; set or 1
                                            set and 0
                                            foreach s $search {
                                                if {$and} {
                                                    append sql " AND "
                                                }
                                                set and 1
                                                append sql "upper(organism) LIKE upper('%$s%')"
                                            }
                                        }
                                        if {$search_id} {
                                            if {$or} {
                                                append sql " OR "
                                            }
                                            set run 1; set or 1
                                            set and 0
                                            foreach s $search {
                                                if {$and} {
                                                    append sql " AND "
                                                }
                                                set and 1
                                                append sql "upper(id) LIKE upper('%$s%')"
                                            }
                                        }
                                        if {$search_description} {
                                            if {$or} {
                                                append sql " OR "
                                            }
                                            set run 1; set or 1
                                            set and 0
                                            foreach s $search {
                                                if {$and} {
                                                    append sql " AND "
                                                }
                                                set and 1
                                                append sql "upper(description) LIKE upper('%$s%')"
                                            }
                                        }
                                        if {$search_product} {
                                            set run 1
                                            if {$or} {
                                                append sql " OR "
                                            }
                                            set and 0
                                            foreach s $search {
                                                if {$and} {
                                                    append sql " AND "
                                                }
                                                set and 1
                                                append sql "upper(product) LIKE upper('%$s%')"
                                            }
                                        }
                                        if {$run} {
                                            append id_seqL " [search_get_id_seq $phpThreadID $sql $feat $dbList $search_hitLength $search_evalue $search_perfection $search_score]"
                                        }
                                    }
                                }
                            } elseif {$feat eq "go"} {
                                append sql "refdb.$feat WHERE "
                                if {$search_id} {
                                    set run 1; set or 1
                                    set and 0
                                    foreach s $search {
                                        if {$and} {
                                            append sql " AND "
                                        }
                                        set and 1
                                        append sql "upper(id) LIKE upper('%$s%')"
                                    }
                                }
                                if {$search_description} {
                                    if {$or} {
                                        append sql " OR "
                                    }
                                    set and 0
                                    foreach s $search {
                                        set run 1
                                        if {$and} {
                                            append sql " AND "
                                        }
                                        set and 1
                                        append sql "upper(name) LIKE upper('%$s%')"
                                    }
                                }
                                if {$run} {
                                    append id_seqL " [search_get_id_seq $phpThreadID $sql $feat $dbList $search_hitLength $search_evalue $search_perfection $search_score]"
                                }
                            } else {
                                append sql "refdb.$feat WHERE "
                                if {$search_id} {
                                    set or 1
                                    set and 0
                                    foreach s $search {
                                        if {$and} {
                                            append sql " AND "
                                        }
                                        set and 1
                                        append sql "upper(id) LIKE upper('%$s%')"
                                    }
                                }
                                if {$search_description} {
                                    if {$or} {
                                        append sql " OR "
                                    }
                                    set and 0
                                    foreach s $search {
                                        set run 1
                                        if {$and} {
                                            append sql " AND "
                                        }
                                        set and 1
                                        append sql "upper(description) LIKE upper('%$s%')"
                                    }
                                }
                                if {$run} {
                                    append id_seqL " [search_get_id_seq $phpThreadID $sql $feat $dbList $search_hitLength $search_evalue $search_perfection $search_score]"
                                }
                            }
                        }
                    }
                }
                if {$noKeyWords} {
                    foreach feat {blast blastprodom gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr} {
                        if {$searchFeatArr($feat)} {
                            set sql "SELECT id FROM refdb.$feat"
                            append id_seqL " [search_get_id_seq $phpThreadID $sql $feat $dbList $search_hitLength $search_evalue $search_perfection $search_score]"
                        }
                    }
                }
                set search_results ""
                if {$id_seqL ne ""} {
                    set refList {id_seq name length numreads id_prot description prot blast blastprodom coil gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr coverage}
                    set id_seqL [lsort -unique -dictionary $id_seqL]
                    foreach db $dbList {
                        set tmpString ""
                        foreach id $id_seqL {
                            if {[lindex $id 0] eq $db} {
                                append tmpString ", '[lindex $id 1]'"
                            }
                        }
                        set tmpString [string range $tmpString 2 end]
                        if {$tmpString ne ""} {
                            if {$search_contigLength ne ""} {
                                set select "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $db.seq_info WHERE id_seq IN ($tmpString) AND length >= $search_contigLength"
                            } else {
                                set select "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $db.seq_info WHERE id_seq IN ($tmpString)"
                            }
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "$select"}}]]
                            foreach sRes $sql_res {
                                lappend search_results "[lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] {[lindex $sRes 4]} N/A [lindex $sRes 5] [lindex $sRes 6] [lindex $sRes 7] [lindex $sRes 8] [lindex $sRes 9] [lindex $sRes 10] [lindex $sRes 11] [lindex $sRes 12] [lindex $sRes 13] [lindex $sRes 14] [lindex $sRes 15] [lindex $sRes 16] [lindex $sRes 17] [lindex $sRes 18] [lindex $sRes 19] [lindex $sRes 20] [lindex $sRes 21] $db"
                            }
                            unset sql_res
                        }
                    }
                    unset id_seqL
                    if {$search_results ne ""} {
                        returnResult $processID finished "$process" "$search_results" "$dbName" $mainThreadID
                    } else  {
                        returnResult $processID finished "$process" "No results" "$dbName" $mainThreadID
                    }
                    unset search_results
                }
            }
            proc search_get_id_seq {phpThreadID sql feat dbL search_hitLength search_evalue search_perfection search_score} {
                set params ""
                if {$feat ne "interpro" && $feat ne "go"} {
                    if {$feat eq "blast"} {
                        if {$search_hitLength ne ""} {
                            append params "AND length >= $search_hitLength "
                        }
                        if {$search_evalue ne "" && $feat ne "patternscan"} {
                            append params "AND CAST(evalue AS numeric) <= $search_evalue "
                        }
                        if {$search_perfection ne ""} {
                            append params "AND CAST(perfection AS numeric) >= $search_perfection "
                        }
                        if {$search_score ne ""} {
                            append params "AND CAST(score AS numeric) >= $search_score "
                        }
                    } else {
                        if {$search_hitLength ne ""} {
                            append params "AND length >= $search_hitLength "
                        }
                        if {$search_evalue ne ""} {
                            append params "AND CAST(evalue AS numeric) <= $search_evalue "
                        }
                    }
                }
                
                set idL ""
                set id_seqL ""
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "$sql"}}]]
                foreach sRes $sql_res {
                    lappend idL [lindex $sRes 0]
                    
                }
                unset sql_res
                
                if {$idL ne ""} {
                    append feat "_hits"
                    foreach db $dbL {
                        set tmpString ""
                        foreach id $idL {append tmpString ", '$id'"}
                        set tmpString [string range $tmpString 2 end]
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT id_seq FROM $db.$feat WHERE id IN ($tmpString) $params"}}]]
                        foreach sRes $sql_res {
                            lappend id_seqL "$db [lindex $sRes 0]"
                            
                        }
                        unset sql_res
                    }
                    unset idL
                }
                return $id_seqL
            }
            proc returnResult {processID status process result dbName mainThreadID} {
                if {$result ne "No results"} {
                    eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" "$dbName" 1}}]
                    eval [subst {thread::send -async $mainThreadID {::search_fillTable "$result" "[lrange $process 2 end]"}}]
                } else {
                    eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process ### No results ###" "$dbName" "$result"}}]
                }
            }
            thread::wait
        }]
        
        set processID [llength $env(processL)]
        set process "Search for: "
        set i 0
        foreach search $searchL {
            incr i
            if {$search ne ""} {
                if {$i eq 1} {
                    append process "$i. $search"
                } else {
                    append process ", $i. $search"
                }
            }
        }
        process_update $processID running $process $env(dbName) 0
        eval [subst {thread::send -async $::threadSearchRun {::search_run "$env(dbName)" $processID $env(mainThreadID) $env(phpThreadID) {$searchL} {$dbList} {$blastRefDBL} {$searchFeatL} $search_id $search_organism $search_product $search_description "$search_contigLength" "$search_hitLength" "$search_evalue" "$search_perfection" "$search_score" "$process"}}]
        destroy $t
    }
}

proc search_fillTable {sr process} {
    global search_results
    global page_counter
    incr page_counter
    set search_results $sr
    create_project_tab prj_$page_counter "$process"
    fillTable .result.notebook1.nb.fprj_$page_counter.1.table.l 0 [llength $search_results]
}

proc search_quick {mode} {
    global env
    global database_browser_search
    global seq_info
    global search_results
    global page_counter
    incr page_counter
    
    set search_results ""
    if {$mode} {
        set database_browser_search [.result.notebook1.nb.fdbb.0.search.ent get]
    } else {
        set database_browser_search [.result.notebook1.nb.fsb.0.search.ent get]
    }
    
    foreach seq $seq_info {
        set hit 1
        foreach str $database_browser_search {
            if {[lsearch -regexp [string toupper [lindex $seq 5]] [string toupper $str]] eq -1} {
                set hit 0
                break
            }
        }
        if {$hit} {
            lappend search_results "$seq $env(dbName)"
        }
    }
    
    if {$search_results ne ""} {
        create_project_tab prj_$page_counter $database_browser_search
        fillTable .result.notebook1.nb.fprj_$page_counter.1.table.l 0 [llength $search_results]
    }   
}

proc search_right {feat id} {
    global env
    global search_results
    global page_counter
    incr page_counter
    
    if {$env(dbName) ne " "} {
        set id_seqL ""
        if {$feat eq "id_seqL"} {
            set name [lindex $id 0]
            set id_seqL [lindex $id 1]
        } elseif {$feat eq "go_stat"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name FROM refdb.go WHERE id = '$id'"}}]]
            foreach sRes $sql_res {
                set name [lindex $sRes 0]
            }
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT members FROM refdb.gotree WHERE id = '$id'"}}]]
            foreach sRes $sql_res {
                set members [lsort -unique [lindex $sRes 0]]
            }
            set tmpString "'$id'"
            foreach member $members {append tmpString ", '$member'"}
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT id_seq FROM $env(dbName).go_hits WHERE id IN ($tmpString)"}}]]
            foreach sRes $sql_res {
                lappend id_seqL [lindex $sRes 0]
            }
            unset sql_res
        } elseif {[lindex $feat 0] eq "keggM"} {
            set name [lindex $feat 1]
            set id_seqL $id
        } elseif {$feat eq "go"} {
            set name $id
            if {[catch {set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT id_seq FROM $env(dbName).${feat}_hits WHERE id = (SELECT DISTINCT main_id FROM refdb.go WHERE alt_id LIKE '%$id%')"}}]]}]} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT id_seq FROM $env(dbName).${feat}_hits WHERE id = '$id'"}}]]
            }
            foreach sRes $sql_res {
                lappend id_seqL [lindex $sRes 0]
            }
            unset sql_res
        } else {
            set name $id
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT id_seq FROM $env(dbName).${feat}_hits WHERE id = '$id'"}}]]
            foreach sRes $sql_res {
                lappend id_seqL [lindex $sRes 0]
            }
            unset sql_res
        }
        
        set tmpString ""
        if {$id_seqL eq ""} {
            if {$feat eq "id_seqL"} {
                errorPopUp "Error" "There are no database entries for [lindex [lindex $id 0] 0] id: [lindex [lindex $id 0] 2]"
            } else {
                errorPopUp "Error" "There are no database entries for $feat id: $id"
            }
        } else {
            foreach id_seq $id_seqL {append tmpString ", '$id_seq'"}
            set tmpString [string range $tmpString 2 end]
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE id_seq IN ($tmpString)"}}]]
            foreach sRes $sql_res {
                lappend search_results "[lindex $sRes 0] [lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] {[lindex $sRes 4]} N/A [lindex $sRes 5] [lindex $sRes 6] [lindex $sRes 7] [lindex $sRes 8] [lindex $sRes 9] [lindex $sRes 10] [lindex $sRes 11] [lindex $sRes 12] [lindex $sRes 13] [lindex $sRes 14] [lindex $sRes 15] [lindex $sRes 16] [lindex $sRes 17] [lindex $sRes 18] [lindex $sRes 19] [lindex $sRes 20] [lindex $sRes 21] $env(dbName)"
            }
            unset sql_res
            if {$search_results ne ""} {
                create_project_tab prj_$page_counter $name
                fillTable .result.notebook1.nb.fprj_$page_counter.1.table.l 0 [llength $search_results]
            }
            unset tmpString
        }
    } 
}

proc translateNuc {nuc protein frame} {
    global env
    set pStartL ""
    set pStopL ""

    set end [string length $nuc]
    switch $frame {
        + {set h 0; set i 0}
        - {set h 1; set i 0}
        1 {set h 0; set i 0}
        2 {set h 0; set i 1}
        3 {set h 0; set i 2}
        4 {set h 1; set i 0}
        5 {set h 1; set i 1}
        6 {set h 1; set i 2}
    }
    set tries 1
    if {$h} {
        set tmp ""
        # R = G A
        # Y = C T
        # W = A T
        # K = G T
        # M = C A
        # S = G C
        # H = C A T
        # D = G A T
        # B = G C T
        # V = G C A
        # N = G C A T 
        set nuc [string map {A T T A G C C G a t t a g c c g R Y Y R K M M K H D D H B V V B r y y r k m m k h d d h b v v b} $nuc]
        for {set n [expr [string length $nuc] - 1]} {$n >= 0} {set n [expr $n - 1]} {
            append tmp [string index $nuc $n]
        }
        set nuc $tmp
        unset tmp
        set tries 3
    }
    
    set gaps [regexp -all {[*:]} [string range $nuc 0 $i]]
    set i [expr $i + $gaps]
    while {$tries > 0} {
        set j $i
        set prot ""
        set prot2 ""
        set orf 1
        set yes 1
        while {$end > $i} {
            set window 1
            set ok 0
            while {$ok ne 2} {
                incr window
                set gaps [regexp -all {[*:]} [string range $nuc $i [expr $i + $window]]]
                set ok [expr $window - $gaps]
            }
            set triplet [string tolower [regsub -all {\*} [string range $nuc $i [expr $i + $window]] ""]]
            set p [lindex $env(translateTableProt) [lsearch -regexp $env(translateTableProt) $triplet]]
            if {$p ne ""} {
                if {[lindex $p 0] eq "*" || [lindex $p 0] eq ":"} {
                    if {$yes} {
                        lappend protL "$orf $prot"; incr orf
                    }
                    set yes 0; append prot2 *; set prot ""
                    if {$h} {
                        lappend pStopL [expr $end - $i + 1]
                    } else {
                        lappend pStopL $i
                    }
                } elseif {[lindex $p 2] eq "Start"} {
                    append prot [lindex $p 0]; append prot2 [lindex $p 0]; set yes 1
                    if {$h} {
                        lappend pStartL [expr $end - $i]
                    } else {
                        lappend pStartL $i
                    }
                } else {
                    if {$yes} {append prot [lindex $p 0]}; append prot2 [lindex $p 0]
                }
            } else {
                if {$yes} {append prot x}
            }
            
            set i [expr $i + 1 + $window]
        }
        if {$yes} {
            lappend protL "$orf $prot"
        }
        if {$protein eq 0} {
            unset prot2; unset protein; unset nuc
            return "{$pStartL} {$pStopL}"
        } elseif {$protein eq "T"} {
            unset prot2; unset protein; unset nuc
            return "{$pStartL} {$pStopL} {$protL}"
        } elseif {$protein eq "A"} {
            return $prot2
        } else {
            set start [expr 3 * [string last $protein $prot2]]
            if {$start < 0} {
                set tries [expr $tries - 1]
                if {$frame eq 4} {
                    set i 1
                    set frame 5
                } elseif {$frame eq 5} {
                    set i 2
                    set frame 6
                } elseif {$frame eq 6} {
                    set i 0
                    set frame 4
                }
                set start 0
            } else {
                set tries 0
                set start [expr $start + $j]
                set end [expr 3 * [string length $protein] + $start]
                unset prot2; unset protein; unset nuc
                return "$start $end"
            }
        }
    }       
}

proc editEndCmd {tbl row col text} {
    global checkedImg
    global uncheckedImg

    if {$col eq 0} {
        set img [expr {$text ? $checkedImg : $uncheckedImg}]
        $tbl cellconfigure $row,$col -image $img
    } elseif {$col eq 5} {
        $tbl cellconfigure $row,$col -text $text
    }
    return $text
}

proc emptystr {args} { return "" }

proc config_refresh {} {
    global env
    
    global database_browser_showSeq
    global database_browser_idOrderCheck
    global database_browser_lengthOrderCheck
    global database_browser_numreadsOrderCheck
    global database_browser_goOrderCheck
    global database_browser_interproOrderCheck
    
    global execLinkArr
    
    auto_mkindex [pwd]/modules *.tcl
    global auto_path
    lappend auto_path [pwd]/modules

    if {[catch {set ft [open [pwd]/conf/T-ACE.conf r]} ]} {
        errorPopUp "Error" "Could not open config file."
    } else {
        #Database_browser
        gets $ft line
        gets $ft line
        set database_browser_showSeq [lindex $line 0]
        set env(database_browser.nr) [lindex $line 1]
        set env(database_browser.length) [lindex $line 2]
        set env(database_browser.description) [lindex $line 3]
        set env(database_browser.proteins) [lindex $line 4]
        set env(database_browser.blast) [lindex $line 5]
        set env(database_browser.blastprodom) [lindex $line 6]
        set env(database_browser.coil) [lindex $line 7]
        set env(database_browser.gene3d) [lindex $line 8]
        set env(database_browser.go) [lindex $line 9]
        set env(database_browser.interpro) [lindex $line 10]
        set env(database_browser.kegg) [lindex $line 11]
        set env(database_browser.panther) [lindex $line 12]
        set env(database_browser.pfam) [lindex $line 13]
        set env(database_browser.pir) [lindex $line 14]
        set env(database_browser.patternscan) [lindex $line 15]
        set env(database_browser.profilescan) [lindex $line 16]
        set env(database_browser.smart) [lindex $line 17]
        set env(database_browser.superfamily) [lindex $line 18]
        set env(database_browser.tigr) [lindex $line 19]
        set env(database_browser.numreads) [lindex $line 20]
        set env(database_browser.coverage) [lindex $line 21]
        gets $ft line
        set database_browser_idOrderCheck [lindex $line 0]
        set database_browser_lengthOrderCheck [lindex $line 1]
        set database_browser_numreadsOrderCheck [lindex $line 2]
        set database_browser_goOrderCheck [lindex $line 3]
        set database_browser_interproOrderCheck [lindex $line 4]
        #Database_info
        gets $ft line
        gets $ft line
        set env(db_info.assembled) [lindex $line 0]
        set env(db_info.comment) [lindex $line 1]
        set env(db_info.data) [lindex $line 2]
        set env(db_info.dateIn) [lindex $line 3]
        set env(db_info.dateOut) [lindex $line 4]
        set env(db_info.description) [lindex $line 5]
        set env(db_info.id_run) [lindex $line 6]
        set env(db_info.runs) [lindex $line 7]
        set env(db_info.sequencer) [lindex $line 8]
        set env(db_info.sequences) [lindex $line 9]
        set env(db_info.singletons) [lindex $line 10]
        set env(db_info.treatment) [lindex $line 11]
        set env(db_info.type) [lindex $line 12]
        #HomeFolder
        gets $ft line
        gets $ft line
        set env(homeFolder) $line
        #BrowserPath
        gets $ft line
        gets $ft line
        if {$line ne ""} {
            set env(browserPath) $line
        } else {
            set env(browserPath) " "
        }
        #ProteinTranslationTable
        gets $ft line
        gets $ft line
        if {$line ne ""} {
            set env(translateTableProtPath) $line
        }
    }
    
    if {[catch {set ft [open [pwd]/conf/links_tace.conf r]} ]} {
        errorPopUp "Error" "Could not open file:\n[pwd]/conf/links_tace.conf"
    } else {
        while {[gets $ft line] ne -1} {
            set execLinkArr([lindex $line 0]) [lindex $line 1]
        }
    }
    
    if {[catch {set ft [open "$env(translateTableProtPath)" r]} ]} {
        errorPopUp "Error" "Could not open file:\n$env(translateTableProtPath)"
    } else {
        set env(translateTableProt) " "
        while {[gets $ft line] ne -1} {
            set line "{[regsub -all {\t} $line "\} \{"]}"
            if {[llength $line] > 1} {
                foreach ent $line {
                    lappend env(translateTableProt) $ent
                }
            }
        }
    }
    
    #Loading Modules
    menu_load_modules $env(loaded_modules)
    
    #Loading Tab Configuration
    if {[catch {set ft [open [pwd]/conf/tabs_tace.conf r]} ]} {
        errorPopUp "Error" "Could not open file:\n[pwd]/conf/tabs_tace.conf"
    } else {
        while {[gets $ft line] != -1} {
            lappend tabL [lindex $line 1]
            set tabArr([lindex $line 1].name) [lindex $line 0]
            set tabArr([lindex $line 1].notebook) [lindex $line 2]
            set tabArr([lindex $line 1].exist) [lindex $line 3]
        }
        foreach tab $tabL {
            if {$tabArr($tab.exist) eq 0} {
                catch {.result.$tabArr($tab.notebook).nb delete $tab 0}
            }
        }
    }
}

proc config_change {mode} {
    global env
    
    global database_browser_showSeq
    global database_browser_idOrderCheck
    global database_browser_lengthOrderCheck
    global database_browser_numreadsOrderCheck
    global database_browser_goOrderCheck
    global database_browser_interproOrderCheck
    
    set out "[pwd]/conf/T-ACE.conf"
    
    if {$mode eq "database"} {
        if {[string length [string trim [.database_config.db.conn.cb get]]] ne 0 \
            && [string length [string trim [.database_config.db.host.ent get]]] ne 0 \
            && [string length [string trim [.database_config.db.port.ent get]]] ne 0 \
            && [string length [string trim [.database_config.db.parentDB.ent get]]] ne 0} {
            set env(currentConnection) [.database_config.db.conn.cb get]
            lappend env(connections) [.database_config.db.conn.cb get]
            set env(connections) [lsort -unique $env(connections)]
            
            set env(host_$env(currentConnection)) [.database_config.db.host.ent get]
            set env(host) [.database_config.db.host.ent get]
            set env(port_$env(currentConnection)) [.database_config.db.port.ent get]
            set env(port) [.database_config.db.port.ent get]
            set env(parentDB_$env(currentConnection)) [.database_config.db.parentDB.ent get]
            set env(parentDB) [.database_config.db.parentDB.ent get]
            if {[.database_config.db.folderServer.ent get] eq ""} {
                set env(folderServer_$env(currentConnection)) " "
                set env(folderServer) " "
            } else {
                set env(folderServer_$env(currentConnection)) [.database_config.db.folderServer.ent get]
                set env(folderServer) [.database_config.db.folderServer.ent get]
            }
            if {[.database_config.db.userServer.ent get] eq ""} {
                set env(userServer_$env(currentConnection)) " "
                set env(userServer) " "
            } else {
                set env(userServer_$env(currentConnection)) [.database_config.db.userServer.ent get]
                set env(userServer) [.database_config.db.userServer.ent get]
            }
            if {[.database_config.db.passwdServer.ent get] eq ""} {
                set env(passwdServer_$env(currentConnection)) " "
                set env(passwdServer) " "
            } else {
                set env(passwdServer_$env(currentConnection)) [.database_config.db.passwdServer.ent get]
                set env(passwdServer) [.database_config.db.passwdServer.ent get]
            }
            
            set env(dbName) " "
            set env(dbL) " "
            destroy .database_config
        } else {
            set mode "error"
            set err "Parameter missing."
        }
    } elseif {$mode eq "database_browser"} {
        set database_browser_showSeq [.database_browser_config.showSeq.ent get]
        if {$env(database_browser.nr) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 1 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 1 -hide yes
        }
        if {$env(database_browser.length) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 3 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 3 -hide yes
        }
        if {$env(database_browser.numreads) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 4 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 4 -hide yes
        }
        if {$env(database_browser.description) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 5 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 5 -hide yes
        }
        if {$env(database_browser.proteins) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 6 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 6 -hide yes
        }
        if {$env(database_browser.blast) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 7 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 7 -hide yes
        }
        if {$env(database_browser.blastprodom) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 8 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 8 -hide yes
        }
        if {$env(database_browser.coil) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 9 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 9 -hide yes
        }
        if {$env(database_browser.gene3d) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 10 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 10 -hide yes
        }
        if {$env(database_browser.go) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 11 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 11 -hide yes
        }
        if {$env(database_browser.interpro) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 12 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 12 -hide yes
        }
        if {$env(database_browser.kegg) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 13 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 13 -hide yes
        }
        if {$env(database_browser.panther) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 14 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 14 -hide yes
        }
        if {$env(database_browser.pfam) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 15 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 15 -hide yes
        }
        if {$env(database_browser.pir) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 16 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 16 -hide yes
        }
        if {$env(database_browser.patternscan) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 17 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 17 -hide yes
        }
        if {$env(database_browser.profilescan) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 18 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 18 -hide yes
        }
        if {$env(database_browser.smart) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 19 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 19 -hide yes
        }
        if {$env(database_browser.superfamily) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 20 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 20 -hide yes
        }
        if {$env(database_browser.tigr) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 21 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 21 -hide yes
        }
        if {$env(database_browser.coverage) eq "+"} {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 22 -hide no
        } else {
            .result.notebook1.nb.fdbb.1.table.l columnconfigure 22 -hide yes
        }
    } elseif {$mode eq "db_info"} {       
        if {$env(db_info.assembled) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 7 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 7 -hide yes
        }
        if {$env(db_info.data) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 15 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 15 -hide yes
        }
        if {$env(db_info.comment) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 14 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 14 -hide yes
        }
        if {$env(db_info.dateIn) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 12 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 12 -hide yes
        }
        if {$env(db_info.dateOut) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 13 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 13 -hide yes
        }
        if {$env(db_info.description) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 4 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 4 -hide yes
        }
        if {$env(db_info.id_run) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 3 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 3 -hide yes
        }
        if {$env(db_info.runs) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 11 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 11 -hide yes
        }
        if {$env(db_info.sequencer) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 9 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 9 -hide yes
        }
        if {$env(db_info.sequences) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 6 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 6 -hide yes
        }
        if {$env(db_info.singletons) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 8 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 8 -hide yes
        }
        if {$env(db_info.treatment) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 5 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 5 -hide yes
        }
        if {$env(db_info.type) eq "+"} {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 10 -hide no
        } else {
            .result.notebook1.nb.fdb_info.1.table.l columnconfigure 10 -hide yes
        }
    } elseif {$mode eq "translateTableProtPath"} {
        if {[catch {set ft [open "$env(translateTableProtPath)" r]} ]} {
            errorPopUp "Error" "Could not open file."
        } else {
            set env(translateTableProt) " "
            while {[gets $ft line] ne -1} {
                set line "{[regsub -all {\t} $line "\} \{"]}"
                if {[llength $line] > 1} {
                    foreach ent $line {
                        lappend env(translateTableProt) $ent
                    }
                }
            }
        }
        if {[llength $env(translateTableProt)] < 64} {
            errorPopUp "Error" "File in wrong format or empty."
            set env(translateTableProt) " "
            lappend env(translateTableProt) "A gct"
            lappend env(translateTableProt) "A gcc"
            lappend env(translateTableProt) "A gca"
            lappend env(translateTableProt) "A gcg"
            lappend env(translateTableProt) "R cgt"
            lappend env(translateTableProt) "R cgc"
            lappend env(translateTableProt) "R cga"
            lappend env(translateTableProt) "R aga"
            lappend env(translateTableProt) "R agg"
            lappend env(translateTableProt) "R cgg"
            lappend env(translateTableProt) "N aat"
            lappend env(translateTableProt) "N aac"
            lappend env(translateTableProt) "D gat"
            lappend env(translateTableProt) "D gac"
            lappend env(translateTableProt) "C tgt"
            lappend env(translateTableProt) "C tgc"
            lappend env(translateTableProt) "Q caa"
            lappend env(translateTableProt) "Q cag"
            lappend env(translateTableProt) "E gaa"
            lappend env(translateTableProt) "E gag"
            lappend env(translateTableProt) "G ggt"
            lappend env(translateTableProt) "G ggc"
            lappend env(translateTableProt) "G gga"
            lappend env(translateTableProt) "G ggg"
            lappend env(translateTableProt) "H cat"
            lappend env(translateTableProt) "H cac"
            lappend env(translateTableProt) "I att"
            lappend env(translateTableProt) "I atc"
            lappend env(translateTableProt) "I ata"
            lappend env(translateTableProt) "M atg Start"
            lappend env(translateTableProt) "L tta"
            lappend env(translateTableProt) "L ttg"
            lappend env(translateTableProt) "L ctt"
            lappend env(translateTableProt) "L ctc"
            lappend env(translateTableProt) "L cta"
            lappend env(translateTableProt) "L ctg"
            lappend env(translateTableProt) "K aaa"
            lappend env(translateTableProt) "K aag"
            lappend env(translateTableProt) "F ttc"
            lappend env(translateTableProt) "F ttt"
            lappend env(translateTableProt) "P cct"
            lappend env(translateTableProt) "P cca"
            lappend env(translateTableProt) "P ccc"
            lappend env(translateTableProt) "P ccg"
            lappend env(translateTableProt) "S tct"
            lappend env(translateTableProt) "S tcc"
            lappend env(translateTableProt) "S tca"
            lappend env(translateTableProt) "S tcg"
            lappend env(translateTableProt) "S agt"
            lappend env(translateTableProt) "S agc"
            lappend env(translateTableProt) "T act"
            lappend env(translateTableProt) "T acc"
            lappend env(translateTableProt) "T aca"
            lappend env(translateTableProt) "T acg"
            lappend env(translateTableProt) "W tgg"
            lappend env(translateTableProt) "Y tat"
            lappend env(translateTableProt) "Y tac"
            lappend env(translateTableProt) "V gtt"
            lappend env(translateTableProt) "V gtc"
            lappend env(translateTableProt) "V gta"
            lappend env(translateTableProt) "V gtg"
            lappend env(translateTableProt) "* tag"
            lappend env(translateTableProt) "* tga"
            lappend env(translateTableProt) "* taa"
        }
    } elseif {[lindex $mode 0] eq "configSave"} {
        set out [lindex $mode 1]
    }
    
    if {$mode eq "database"} {
        if {[catch {set ft [open [pwd]/conf/db_connections.conf w]} ]} {
            errorPopUp "Error" "Could not save database connections."
        } else {
            foreach conn $env(connections) {
                puts $ft "\{$conn\}\t$env(host_$conn)\t$env(port_$conn)\t$env(parentDB_$conn)\t$env(folderServer_$conn)\t$env(userServer_$conn)\t$env(passwdServer_$conn)"
            }
            close $ft
            database_login_window
        }
    } elseif {$mode eq "error"} {
        errorPopUp "Error" "$err"
    } else {
        if {[catch {set ft [open $out w]} ]} {
        } else {
            puts $ft "Database_browser"
            puts $ft "$database_browser_showSeq \
                    $env(database_browser.nr) \
                    $env(database_browser.length) \
                    $env(database_browser.proteins) \
                    $env(database_browser.description) \
                    $env(database_browser.blast) \
                    $env(database_browser.blastprodom) \
                    $env(database_browser.coil) \
                    $env(database_browser.gene3d) \
                    $env(database_browser.go) \
                    $env(database_browser.interpro) \
                    $env(database_browser.kegg) \
                    $env(database_browser.panther) \
                    $env(database_browser.pfam) \
                    $env(database_browser.pir) \
                    $env(database_browser.patternscan) \
                    $env(database_browser.profilescan) \
                    $env(database_browser.smart) \
                    $env(database_browser.superfamily) \
                    $env(database_browser.tigr) \
                    $env(database_browser.coverage) \
                    $env(database_browser.numreads)"
            puts $ft "$database_browser_idOrderCheck \
                    $database_browser_lengthOrderCheck \
                    $database_browser_numreadsOrderCheck \
                    $database_browser_goOrderCheck \
                    $database_browser_interproOrderCheck"
            puts $ft "Database_info"
            puts $ft "$env(db_info.assembled) \
                    $env(db_info.comment) \
                    $env(db_info.data) \
                    $env(db_info.dateIn) \
                    $env(db_info.dateOut) \
                    $env(db_info.description) \
                    $env(db_info.id_run) \
                    $env(db_info.runs) \
                    $env(db_info.sequencer) \
                    $env(db_info.sequences) \
                    $env(db_info.singletons) \
                    $env(db_info.treatment) \
                    $env(db_info.type)"
            puts $ft "HomeFolder"
            puts $ft $env(homeFolder)
            puts $ft "BrowserPath"
            puts $ft $env(browserPath)
            puts $ft "ProteinTranslationTable"
            puts $ft $env(translateTableProtPath)
            close $ft
        }
    }
}

proc errorPopUp {mode txt} {
    set title "$mode"
    set t .errorPopUp
    catch {destroy $t}
    
    if {$txt ne ""} {
        toplevel $t
        wm title $t $title
        wm resizable $t 0 0
        wm minsize $t 200 100
        wm attributes $t -topmost 1
        
        frame $t.ptitle
        label $t.ptitle.label -text $txt
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command "destroy $t"
        
        pack $t.ptitle.label -side left -fill both -expand 1
        pack $t.buts.ok -expand 1 -anchor c
        pack $t.ptitle -expand 1 -side top -fill both
        pack $t.buts -side bottom -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    }   
}

proc areYouSurePopUp {mode txt cmd} {
    set title "$mode"
    set t .areYouSurePopUp
    catch {destroy .database_login_window}
    catch {destroy $t}
    
    if {$txt ne ""} {
        toplevel $t
        wm title $t $title
        wm resizable $t 0 0
        wm attributes $t -topmost 1
        
        frame $t.ptitle
        label $t.ptitle.label -height 5 -text $txt
        
        frame $t.buts -bd 2 -relief groove
        button $t.buts.ok -text "OK" -command "$cmd; destroy $t"
        button $t.buts.cancel -text "Cancel" -command "destroy $t"
        
        pack $t.ptitle.label -side left -fill both
        pack $t.buts.ok -side left -expand 1 -anchor c
        pack $t.buts.cancel -side left -expand 1 -anchor c
        pack $t.ptitle $t.buts -side top -fill both
        
        wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
        raise $t
    }
}

proc menu_configure_modules {} {
    global checkedImg
    global uncheckedImg
    
    foreach module "[glob -path [pwd]/modules/ -tails *.tcl]" {
        if {$module ne "toolTip_tace.tcl" && $module ne "menu_tace.tcl" && $module ne "rightmenu_tace.tcl"} {
            lappend moduleList [lindex [split $module .] 0]
            set moduleArr([lindex [split $module .] 0]) 0
        }
    }
    set moduleList [lsort -unique -dictionary $moduleList]
    
    #Loading Modules List
    set notLoad_moduleList ""
    if {[catch {set ft [open [pwd]/conf/modules.conf r]} ]} {
    } else {
        while {[gets $ft line] != -1} {
            catch {set moduleArr($line) 1}
            lappend notLoad_moduleList $line 
        }
    }
    
    set t .configure_modules
    catch {destroy $t}
    toplevel $t
    wm title $t "Add/Remove modules"
    wm attributes $t -topmost 1
    wm minsize $t 100 400
    
    label $t.lbl -text "Select modules:"
    frame $t.tab -bd 2 -relief groove
    scrollbar $t.tab.y -orient vertical -command "$t.tab.table yview"
    scrollbar $t.x -orient horizontal -command "$t.tab.table xview"
    tablelist::tablelist $t.tab.table \
            -width 60 -height 1 -showseparators 1 -stripebackground lightblue \
            -columns {0 "" 0 "Module"} \
            -labelcommand "$t.tab finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch {1} \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$t.tab.y set" \
            -xscrollcommand "$t.x set" \
            -background white
    $t.tab.table columnconfigure 0 \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelcommand "table_selection"
    $t.tab.table columnconfigure 1 -sortmode dictionary -align left
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "OK" -command "menu_update_module_status \"$notLoad_moduleList\""
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.tab.y -side left -expand 0 -fill both; pack $t.tab.table -side left -expand 1 -fill both
    pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
    pack $t.lbl -side top -anchor w
    pack $t.tab -expand 1 -fill both
    pack $t.x $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
    
    foreach module $moduleList {
        $t.tab.table insert end "$moduleArr($module) $module"
        $t.tab.table cellconfigure end,0 -image [expr {$moduleArr($module) ? $checkedImg : $uncheckedImg}]
    }
    
    unset notLoad_moduleList
    unset moduleList
}

proc menu_update_module_status {notLoad_moduleList} {
    
    .configure_modules.tab.table finishediting
    set i 0
    set stop 1
    set ft [open [pwd]/conf/modules.conf w]
    set remove_moduleList ""
    while {$stop} {
        if {[lindex [.configure_modules.tab.table get $i] 0] ne ""} {
            if {[lindex [.configure_modules.tab.table get $i] 0] eq 1} {
                puts $ft [lindex [.configure_modules.tab.table get $i] 1]
            } else {
                if {[lsearch $notLoad_moduleList [lindex [.configure_modules.tab.table get $i] 1]] ne -1} {
                    lappend remove_moduleList [lindex [.configure_modules.tab.table get $i] 1]
                }
            }
                incr i
        } else {
            set stop 0
        }
    }
    close $ft
    destroy .configure_modules
    
    menu_load_modules $notLoad_moduleList
    menu_remove_modules $remove_moduleList
}

proc menu_load_modules {notLoad_moduleList} {
    global env
    
    #Loading Modules List
    catch {[menu_init]}
    if {[catch {set ft [open [pwd]/conf/modules.conf r]} ]} {
    } else {
        while {[gets $ft line] != -1} {
            set i [lsearch $notLoad_moduleList $line]
            if {$i eq -1} {
                set out ""
                if {[string range $line [expr [string length $line] - 5] end] eq "_tace"} {
                    catch {
                        [string range $line 0 [expr [string length $line] - 6]]_init
                    } out
                } else {
                    catch {
                        ${line}_init    
                    } out
                }
                if {$out ne ""} {
                    puts "LoadErr: ($line) $out"
                } else {
                    lappend env(loaded_modules) $line
                }
            }
        }
    }
    catch {[rightmenu_bind]}
    catch {[toolTip_init]}
}

proc menu_remove_modules {remove_moduleList} {
    global env
    
    #Removing Modules List
    foreach module $remove_moduleList {
        set out ""
        if {[string range $module [expr [string length $module] - 5] end] eq "_tace"} {
            catch {[string range $module 0 [expr [string length $module] - 6]]_remove} out
            set tmpL ""
            foreach m $env(loaded_modules) {
                if {$m ne $module} {
                    lappend tmpL $m
                }
            }
            set env(loaded_modules) $tmpL
            unset tmpL
        } else {
            catch {
                ${module}_remove
                set tmpL ""
                foreach m $env(loaded_modules) {
                    if {$m ne $module} {
                        lappend tmpL $m
                    }
                }
                set env(loaded_modules) $tmpL
                unset tmpL
            } out
        }
        if {$out ne ""} {
            puts "RemoveErr: ($module) $out"
        }
    }
}

proc help {} {
    global env

    if {[string length $env(browserPath)] <= 1} {
        errorPopUp "Error" "Please set BrowserPath."
    } else {
        catch {eval exec \"$env(browserPath)\" \"file:[pwd]/doc/html/index.html\" &}
    }
}

proc about_window {} {
    set t .about
    catch {destroy $t}
    toplevel $t
    wm title $t "About T-ACE"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.ptitle
    label $t.ptitle.label -height 5 -text "T-ACE v1.9.4\n(c) 2011, Lars Kraemer\n\nPlease report any comments or bugs to\nl.kraemer@ikmb.uni-kiel.de"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Close" -command "destroy $t"
    
    pack $t.ptitle.label -side left -fill both
    pack $t.buts.ok -expand 1 -anchor c
    pack $t.ptitle $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

#THREADS

set ::threadPHP [thread::create {
    package require http
    package require base64
    
    proc php_checkConncetion {} {
        global env

        set bound "-----NEXT_PART_[clock seconds].[pid]"
        set outputData "--$bound\nContent-Disposition: form-data; name=\"SQL\"; filename=\"sql.txt\"\n\ncheckConnection\n$env(port) $env(parentDB) $env(user) $env(password)\n--${bound}--"
        
        set request [list ::http::geturl http://$env(host)/$env(folderServer)/T-ACE.php \
                -type "multipart/form-data; boundary=$bound" \
                -query $outputData \
                -headers [list Authorization "Basic [base64::encode $env(userServer):$env(passwdServer)]"]]
        
        set token [eval $request]
        ::http::wait $token
        set str [::http::data $token]
        http::cleanup $token
        unset outputData; unset bound
        
        set r 0
        set res ""
        if {[catch {
                foreach ent $str {
                    if {$ent eq "start_result"} {
                        set r 1
                    } elseif {$ent eq "end_result"} {
                        break
                    } elseif {$r} {
                        lappend res $ent
                    }
                }
            }]} {
            set r 0
            set res ""
        }
        if {$res eq "" && $r eq 0} {
            return "{{$str}}"
        } else {
            unset str
            return $res
        }
    }
    
    proc php_getSQLresults {sql} {
        global env
        
        set bound "-----NEXT_PART_[clock seconds].[pid]"
        set outputData "--$bound\nContent-Disposition: form-data; name=\"SQL\"; filename=\"sql.txt\"\n\nsql\n$env(port) $env(parentDB) $env(user) $env(password)\n$sql\n--${bound}--"
        
        set request [list ::http::geturl http://$env(host)/$env(folderServer)/T-ACE.php \
                -type "multipart/form-data; boundary=$bound" \
                -query $outputData \
                -headers [list Authorization "Basic [base64::encode $env(userServer):$env(passwdServer)]"]]
        
        set token [eval $request]
        ::http::wait $token
        set str [::http::data $token]
        http::cleanup $token
        unset outputData; unset bound

        set r 0
        set res ""
        if {[catch {
            foreach ent $str {
                if {$ent eq "start_result"} {
                    set r 1
                } elseif {$ent eq "end_result"} {
                    break
                } elseif {$r} {
                    lappend res $ent
                }
            }
        }]} {
            set r 0
            set res ""
        }
        
        if {$res eq "" && $r eq 0} {
            return "{{$str}}"
        } else {
            unset str
            return $res
        }
    }
    
    proc php_getDBupload {table input} {
        global env
        
        set bound "-----NEXT_PART_[clock seconds].[pid]"
        set outputData "--$bound\nContent-Disposition: form-data; name=\"SQL\"; filename=\"sql.txt\"\n\nupload\n$env(port) $env(parentDB) $env(user) $env(password)\n$table\n--$bound\nContent-Disposition: form-data; name=\"input\"; filename=\"input.txt\"\n\n$input\n--${bound}--"
        
        set request [list ::http::geturl http://$env(host)/$env(folderServer)/T-ACE.php \
                -type "multipart/form-data; boundary=$bound" \
                -query $outputData \
                -headers [list Authorization "Basic [base64::encode $env(userServer):$env(passwdServer)]"]]
        
        #if {[info exists opts(USER)] && [info exists opts(PASSWD)]} #{
        #package require base64
        #lappend request -headers [list Authorization \
        #"Basic [base64::encode $opts(USER):$opts(PASSWD)]"]
        #}
        
        set token [eval $request]
        ::http::wait $token
        set str [::http::data $token]
        http::cleanup $token
        unset outputData; unset bound
        set r 0
        set res ""
        set str [regsub -all < $str " "]
        foreach ent $str {
            if {$ent eq "start_result"} {
                set r 1
            } elseif {$ent eq "end_result"} {
                break
            } elseif {$r} {
                lappend res $ent
            }
        }
        if {$res eq "" && $r eq 0} {
            return $str
        } else {
            unset str
            return $res
        }
    }
    
    proc php_SQLfromFile {f} {
        global env
        
        set bound "-----NEXT_PART_[clock seconds].[pid]"
        set outputData "--$bound\nContent-Disposition: form-data; name=\"SQL\"; filename=\"sql.txt\"\n\nsql\n$env(port) $env(parentDB) $env(user) $env(password)\n$sql\n--${bound}--"
        
        set request [list ::http::geturl http://$env(host)/$env(folderServer)/T-ACE.php \
                -type "multipart/form-data; boundary=$bound" \
                -query $outputData \
                -headers [list Authorization "Basic [base64::encode $env(userServer):$env(passwdServer)]"]]
        
        set token [eval $request]
        ::http::wait $token
        set str [::http::data $token]
        http::cleanup $token
        unset outputData; unset bound
        
        set r 0
        set res ""
        foreach ent $str {
            if {$ent eq "start_result"} {
                set r 1
            } elseif {$ent eq "end_result"} {
                break
            } elseif {$r} {
                lappend res $ent
            }
        }
        if {$res eq "" && $r eq 0} {
            return $str
        } else {
            unset str
            return $res
        }
    }
    thread::wait
}]

set ::threadGet_seq_info [thread::create {
    proc get_seq_infoT {feat mainThreadID phpThreadID order database_browser_descriptionCheck} {
        global env
        eval [subst {thread::send $mainThreadID {.result.notebook1.nb.fdbb.0.feat configure -text "loading..." -state disabled}}]
        
        set tmp ""
        set seq_all ""
        
        set refList {id_seq name length numreads id_prot description prot blast blastprodom coil gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr coverage}
        if {$feat eq "all"} {
            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info ORDER BY $order"}}]]
            foreach ent $sql_res {
                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} N/A {[lindex $ent 5]} [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $env(dbName)"
            }
            unset sql_res
        } elseif {$feat eq "with hits"} {
            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE gotHits = 1 ORDER BY $order"}}]]
            foreach ent $sql_res {
                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} N/A {[lindex $ent 5]} [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $env(dbName)"
            }
            unset sql_res
        } elseif {$feat eq "without hits"} {
            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE gotHits = 0 ORDER BY $order"}}]]
            foreach ent $sql_res {
                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} N/A {[lindex $ent 5]} [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $env(dbName)"
            }
            unset sql_res
        } else {
            if {$feat eq "with comment"} {
                set feat comment
                set f $feat
            } else {
                set f $feat
            }
            set id2 ""
            if {$database_browser_descriptionCheck eq "+"} {
                if {[lindex $feat 0] eq "blast"} {
                    if {[lindex $feat 2] ne ""} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).seq_info.id_seq AS id_seq, $env(dbName).seq_info.name AS name, $env(dbName).seq_info.length AS length, $env(dbName).seq_info.numreads AS numreads, $env(dbName).seq_info.id_prot AS id_prot, $env(dbName).sequences_nucleotide_description.[lindex $feat 0] AS description, $env(dbName).seq_info.prot AS prot, $env(dbName).seq_info.blast AS blast, $env(dbName).seq_info.blastprodom AS blastprodom, $env(dbName).seq_info.coil AS coil, $env(dbName).seq_info.gene3d AS gene3d, $env(dbName).seq_info.go AS go, $env(dbName).seq_info.interpro AS interpro, $env(dbName).seq_info.kegg AS kegg, $env(dbName).seq_info.panther AS panther, $env(dbName).seq_info.patternscan AS patternscan, $env(dbName).seq_info.pfam AS pfam, $env(dbName).seq_info.pir AS pir, $env(dbName).seq_info.profilescan AS profilescan, $env(dbName).seq_info.smart AS smart, $env(dbName).seq_info.superfamily AS superfamily, $env(dbName).seq_info.tigr AS tigr, $env(dbName).seq_info.coverage AS coverage FROM $env(dbName).seq_info INNER JOIN $env(dbName).sequences_nucleotide_description ON $env(dbName).seq_info.id_seq = $env(dbName).sequences_nucleotide_description.id_seq WHERE $env(dbName).seq_info.blast != 0 ORDER BY $env(dbName).seq_info.$order"}}]]
                        foreach ent $sql_res {
                            set description ""
                            foreach des [lindex $ent 5] {
                                if {[lindex $des 0] eq [lindex $feat 2]} {
                                    set description [lindex $des 1]
                                    break
                                }
                            }
                            if {$description ne ""} {
                                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} {[regsub -all {\}} [regsub -all {\{} $description "("] ")"]} {[lindex $ent 6]} [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] [lindex $ent 22] $env(dbName)"
                            }
                        }
                        unset sql_res
                    } else {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).seq_info.id_seq AS id_seq, $env(dbName).seq_info.name AS name, $env(dbName).seq_info.length AS length, $env(dbName).seq_info.numreads AS numreads, $env(dbName).seq_info.id_prot AS id_prot, $env(dbName).sequences_nucleotide_description.$feat AS description, $env(dbName).seq_info.prot AS prot, $env(dbName).seq_info.blast AS blast, $env(dbName).seq_info.blastprodom AS blastprodom, $env(dbName).seq_info.coil AS coil, $env(dbName).seq_info.gene3d AS gene3d, $env(dbName).seq_info.go AS go, $env(dbName).seq_info.interpro AS interpro, $env(dbName).seq_info.kegg AS kegg, $env(dbName).seq_info.panther AS panther, $env(dbName).seq_info.patternscan AS patternscan, $env(dbName).seq_info.pfam AS pfam, $env(dbName).seq_info.pir AS pir, $env(dbName).seq_info.profilescan AS profilescan, $env(dbName).seq_info.smart AS smart, $env(dbName).seq_info.superfamily AS superfamily, $env(dbName).seq_info.tigr AS tigr, $env(dbName).seq_info.coverage AS coverage FROM $env(dbName).seq_info INNER JOIN $env(dbName).sequences_nucleotide_description ON $env(dbName).seq_info.id_seq = $env(dbName).sequences_nucleotide_description.id_seq WHERE $env(dbName).seq_info.blast != 0 ORDER BY $env(dbName).seq_info.$order"}}]]
                        foreach ent $sql_res {
                            set description [lindex [lindex [lindex $ent 5] 0] 1]
                            if {$description ne ""} {
                                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} {[regsub -all {\}} [regsub -all {\{} $description "("] ")"]} {[lindex $ent 6]} [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] [lindex $ent 22] $env(dbName)"
                            }
                        }
                        unset sql_res
                    }
                } elseif {$feat eq "coil"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE $env(dbName).seq_info.$f != 0 ORDER BY $order"}}]]
                    foreach ent $sql_res {
                        lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} coiled-coil {[lindex $ent 5]} [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $env(dbName)"
                    }
                    unset sql_res
                } elseif {$feat eq "comment"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).seq_info.id_seq AS id_seq, $env(dbName).seq_info.name AS name, $env(dbName).seq_info.length AS length, $env(dbName).seq_info.numreads AS numreads, $env(dbName).seq_info.id_prot AS id_prot, $env(dbName).sequences_nucleotide_description.$feat AS description, $env(dbName).seq_info.prot AS prot, $env(dbName).seq_info.blast AS blast, $env(dbName).seq_info.blastprodom AS blastprodom, $env(dbName).seq_info.coil AS coil, $env(dbName).seq_info.gene3d AS gene3d, $env(dbName).seq_info.go AS go, $env(dbName).seq_info.interpro AS interpro, $env(dbName).seq_info.kegg AS kegg, $env(dbName).seq_info.panther AS panther, $env(dbName).seq_info.patternscan AS patternscan, $env(dbName).seq_info.pfam AS pfam, $env(dbName).seq_info.pir AS pir, $env(dbName).seq_info.profilescan AS profilescan, $env(dbName).seq_info.smart AS smart, $env(dbName).seq_info.superfamily AS superfamily, $env(dbName).seq_info.tigr AS tigr, $env(dbName).seq_info.coverage AS coverage FROM $env(dbName).seq_info INNER JOIN $env(dbName).sequences_nucleotide_description ON $env(dbName).seq_info.id_seq = $env(dbName).sequences_nucleotide_description.id_seq WHERE $env(dbName).sequences_nucleotide_description.$f != '\'\'' AND $env(dbName).sequences_nucleotide_description.$f != '' ORDER BY $env(dbName).seq_info.$order"}}]]
                    foreach ent $sql_res {
                        if {[string trim [lindex $ent 5]] ne ""} {
                            lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} {[regsub -all {\}} [regsub -all {\{} [lindex $ent 5] "("] ")"]} {[lindex $ent 6]} [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] [lindex $ent 22] $env(dbName)"
                        }
                    }    
                    unset sql_res
                } else {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).seq_info.id_seq AS id_seq, $env(dbName).seq_info.name AS name, $env(dbName).seq_info.length AS length, $env(dbName).seq_info.numreads AS numreads, $env(dbName).seq_info.id_prot AS id_prot, $env(dbName).sequences_nucleotide_description.$feat AS description, $env(dbName).seq_info.prot AS prot, $env(dbName).seq_info.blast AS blast, $env(dbName).seq_info.blastprodom AS blastprodom, $env(dbName).seq_info.coil AS coil, $env(dbName).seq_info.gene3d AS gene3d, $env(dbName).seq_info.go AS go, $env(dbName).seq_info.interpro AS interpro, $env(dbName).seq_info.kegg AS kegg, $env(dbName).seq_info.panther AS panther, $env(dbName).seq_info.patternscan AS patternscan, $env(dbName).seq_info.pfam AS pfam, $env(dbName).seq_info.pir AS pir, $env(dbName).seq_info.profilescan AS profilescan, $env(dbName).seq_info.smart AS smart, $env(dbName).seq_info.superfamily AS superfamily, $env(dbName).seq_info.tigr AS tigr, $env(dbName).seq_info.coverage AS coverage FROM $env(dbName).seq_info INNER JOIN $env(dbName).sequences_nucleotide_description ON $env(dbName).seq_info.id_seq = $env(dbName).sequences_nucleotide_description.id_seq WHERE $env(dbName).seq_info.$f != 0 ORDER BY $env(dbName).seq_info.$order"}}]]
                    foreach ent $sql_res {
                        if {[lindex $ent 5] ne ""} {
                            lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} {[regsub -all {\}} [regsub -all {\{} [lindex $ent 5] "("] ")"]} {[lindex $ent 6]} [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] [lindex $ent 22] $env(dbName)"
                        }
                    }
                    unset sql_res
                }
            } else {
                if {[lindex $feat 0] eq "blast"} {
                    set feat "blast"
                }
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, name, length, numreads, id_prot, prot, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr, coverage FROM $env(dbName).seq_info WHERE $env(dbName).seq_info.$f != 0 ORDER BY $order"}}]]
                foreach ent $sql_res {
                    lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] [lindex $ent 3] {[lindex $ent 4]} N/A {[regsub -all {\}} [regsub -all {\{} [lindex $ent 5] "("] ")"]} [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] [lindex $ent 19] [lindex $ent 20] [lindex $ent 21] $env(dbName)"
                }
                unset sql_res
            }
        }
        
        set seq_all [regsub -all {\]} [regsub -all {\[} $seq_all "("] ")"]

        if {[catch {
                eval [subst {thread::send $mainThreadID {::dbEvnt_seqAll {$seq_all}}}]
                eval [subst {thread::send $mainThreadID {::contig_size_confirm}}]
                eval [subst {thread::send $mainThreadID {::database_browser_showSeq 0}}]
            } err]} {
            eval [subst {thread::send $mainThreadID {::errorPopUp "Error" "Could not load contig list."}}]
        }      
        eval [subst {thread::send $mainThreadID {.result.notebook1.nb.fdbb.0.feat configure -text "$feat" -state normal}}]
    }
    thread::wait
}]

set ::threadGet_prot_info [thread::create {
    proc get_prot_infoT {feat mainThreadID phpThreadID order database_browser_descriptionCheck} {
        global env
        eval [subst {thread::send $mainThreadID {.result.notebook1.nb.fdbb.0.feat configure -text "loading..." -state disabled}}]
        
        set tmp ""
        set seq_all ""
        set refList {id_prot name length na na description na blast blastprodom coil gene3d go interpro kegg panther patternscan pfam pir profilescan smart superfamily tigr na}
        if {$feat eq "all"} {
            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr FROM $env(dbName).prot_info ORDER BY $order"}}]]
            foreach ent $sql_res {
                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A N/A N/A [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] N/A $env(dbName)"
            }
            unset sql_res
        } elseif {$feat eq "with hits"} {
            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr FROM $env(dbName).prot_info WHERE gotHits = 1 ORDER BY $order"}}]]
            foreach ent $sql_res {
                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A N/A N/A [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] N/A $env(dbName)"
            }
            unset sql_res
        } elseif {$feat eq "without hits"} {
            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr FROM $env(dbName).prot_info WHERE gotHits = 0 ORDER BY $order"}}]]
            foreach ent $sql_res {
                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A N/A N/A [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] N/A $env(dbName)"
            }
            unset sql_res
        } else {
            if {$feat eq "with comment"} {
                set feat comment
                set f $feat
            } else {
                set f $feat
            }
            set id2 ""
            if {$database_browser_descriptionCheck eq "+"} {
                if {[lindex $feat 0] eq "blast"} {
                    if {[lindex $feat 2] ne ""} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).prot_info.id_prot AS id_prot, $env(dbName).prot_info.name AS name, $env(dbName).prot_info.length AS length, $env(dbName).sequences_protein_description.blast AS description, $env(dbName).prot_info.blast AS blast, $env(dbName).prot_info.blastprodom AS blastprodom, $env(dbName).prot_info.coil AS coil, $env(dbName).prot_info.gene3d AS gene3d, $env(dbName).prot_info.go AS go, $env(dbName).prot_info.interpro AS interpro, $env(dbName).prot_info.kegg AS kegg, $env(dbName).prot_info.panther AS panther, $env(dbName).prot_info.patternscan AS patternscan, $env(dbName).prot_info.pfam AS pfam, $env(dbName).prot_info.pir AS pir, $env(dbName).prot_info.profilescan AS profilescan, $env(dbName).prot_info.smart AS smart, $env(dbName).prot_info.superfamily AS superfamily, $env(dbName).prot_info.tigr AS tigr FROM $env(dbName).prot_info INNER JOIN $env(dbName).sequences_protein_description ON $env(dbName).prot_info.id_prot = $env(dbName).sequences_protein_description.id_prot WHERE $env(dbName).prot_info.blast != 0 ORDER BY $env(dbName).prot_info.$order"}}]]
                        foreach ent $sql_res {
                            set description ""
                            foreach des [lindex $ent 3] {
                                if {[lindex $des 0] eq [lindex $feat 2]} {
                                    set description [regsub -all {[\[]} [regsub -all {[\]]} [lindex $des 1] ")"] "("]
                                    break
                                }
                            }
                            if {$description ne ""} {
                                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A {$description} N/A [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] N/A $env(dbName)"
                            }
                        }
                        unset sql_res
                    } else {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).prot_info.id_prot AS id_prot, $env(dbName).prot_info.name AS name, $env(dbName).prot_info.length AS length, $env(dbName).sequences_protein_description.$feat AS description, $env(dbName).prot_info.blast AS blast, $env(dbName).prot_info.blastprodom AS blastprodom, $env(dbName).prot_info.coil AS coil, $env(dbName).prot_info.gene3d AS gene3d, $env(dbName).prot_info.go AS go, $env(dbName).prot_info.interpro AS interpro, $env(dbName).prot_info.kegg AS kegg, $env(dbName).prot_info.panther AS panther, $env(dbName).prot_info.patternscan AS patternscan, $env(dbName).prot_info.pfam AS pfam, $env(dbName).prot_info.pir AS pir, $env(dbName).prot_info.profilescan AS profilescan, $env(dbName).prot_info.smart AS smart, $env(dbName).prot_info.superfamily AS superfamily, $env(dbName).prot_info.tigr AS tigr FROM $env(dbName).prot_info INNER JOIN $env(dbName).sequences_protein_description ON $env(dbName).prot_info.id_prot = $env(dbName).sequences_protein_description.id_prot WHERE $env(dbName).prot_info.blast != 0 ORDER BY $env(dbName).prot_info.$order"}}]]
                        foreach ent $sql_res {
                            set description [regsub -all {[\[]} [regsub -all {[\]]} [lindex [lindex [lindex $ent 3] 0] 1] ")"] "("]
                            if {$description ne ""} {
                                lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A {$description} N/A [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] N/A $env(dbName)"
                            }
                        }
                        unset sql_res
                    }
                } elseif {$feat eq "coil"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr FROM $env(dbName).prot_info WHERE  $env(dbName).prot_info.$f != 0 ORDER BY $order"}}]]
                    foreach ent $sql_res {
                        lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A coiled-coil N/A [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] N/A $env(dbName)"
                    }
                    unset sql_res
                } elseif {$feat eq "comment"} {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).prot_info.id_prot AS id_prot, $env(dbName).prot_info.name AS name, $env(dbName).prot_info.length AS length, $env(dbName).sequences_protein_description.$feat AS description, $env(dbName).prot_info.blast AS blast, $env(dbName).prot_info.blastprodom AS blastprodom, $env(dbName).prot_info.coil AS coil, $env(dbName).prot_info.gene3d AS gene3d, $env(dbName).prot_info.go AS go, $env(dbName).prot_info.interpro AS interpro, $env(dbName).prot_info.kegg AS kegg, $env(dbName).prot_info.panther AS panther, $env(dbName).prot_info.patternscan AS patternscan, $env(dbName).prot_info.pfam AS pfam, $env(dbName).prot_info.pir AS pir, $env(dbName).prot_info.profilescan AS profilescan, $env(dbName).prot_info.smart AS smart, $env(dbName).prot_info.superfamily AS superfamily, $env(dbName).prot_info.tigr AS tigr FROM $env(dbName).prot_info INNER JOIN $env(dbName).sequences_protein_description ON $env(dbName).prot_info.id_prot = $env(dbName).sequences_protein_description.id_prot WHERE $env(dbName).sequences_protein_description.$f != '\\\"\\\"' ORDER BY $env(dbName).prot_info.$order"}}]]
                    foreach ent $sql_res {
                        if {[lindex $ent 3] ne ""} {
                            lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A {[lindex $ent 3]} N/A [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] N/A $env(dbName)"
                        }
                    }
                    unset sql_res
                } else {
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT DISTINCT $env(dbName).prot_info.id_prot AS id_prot, $env(dbName).prot_info.name AS name, $env(dbName).prot_info.length AS length, $env(dbName).sequences_protein_description.$feat AS description, $env(dbName).prot_info.blast AS blast, $env(dbName).prot_info.blastprodom AS blastprodom, $env(dbName).prot_info.coil AS coil, $env(dbName).prot_info.gene3d AS gene3d, $env(dbName).prot_info.go AS go, $env(dbName).prot_info.interpro AS interpro, $env(dbName).prot_info.kegg AS kegg, $env(dbName).prot_info.panther AS panther, $env(dbName).prot_info.patternscan AS patternscan, $env(dbName).prot_info.pfam AS pfam, $env(dbName).prot_info.pir AS pir, $env(dbName).prot_info.profilescan AS profilescan, $env(dbName).prot_info.smart AS smart, $env(dbName).prot_info.superfamily AS superfamily, $env(dbName).prot_info.tigr AS tigr FROM $env(dbName).prot_info INNER JOIN $env(dbName).sequences_protein_description ON $env(dbName).prot_info.id_prot = $env(dbName).sequences_protein_description.id_prot WHERE $env(dbName).prot_info.$f != 0 ORDER BY $env(dbName).prot_info.$order"}}]]
                    foreach ent $sql_res {
                        if {[lindex $ent 3] ne ""} {
                            lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A {[lindex $ent 3]} N/A [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] [lindex $ent 18] N/A $env(dbName)"
                        }
                    }
                    unset sql_res
                }
            } else {
                if {[lindex $feat 0] eq "blast"} {
                    set feat "blast"
                }
                set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_prot, name, length, blast, blastprodom, coil, gene3d, go, interpro, kegg, panther, patternscan, pfam, pir, profilescan, smart, superfamily, tigr FROM $env(dbName).prot_info WHERE $env(dbName).prot_info.$f != 0 ORDER BY $order"}}]]
                foreach ent $sql_res {
                    lappend seq_all "[lindex $ent 0] [lindex $ent 1] [lindex $ent 2] N/A N/A N/A N/A [lindex $ent 3] [lindex $ent 4] [lindex $ent 5] [lindex $ent 6] [lindex $ent 7] [lindex $ent 8] [lindex $ent 9] [lindex $ent 10] [lindex $ent 11] [lindex $ent 12] [lindex $ent 13] [lindex $ent 14] [lindex $ent 15] [lindex $ent 16] [lindex $ent 17] N/A $env(dbName)"
                }
                unset sql_res
            }
        }
        eval [subst {thread::send $mainThreadID {::dbEvnt_seqAll "$seq_all"}}]
        eval [subst {thread::send $mainThreadID {::contig_size_confirm}}]
        eval [subst {thread::send $mainThreadID {::database_browser_showSeq 0}}]
        eval [subst {thread::send $mainThreadID {.result.notebook1.nb.fdbb.0.feat configure -text "$feat" -state normal}}]
    }
    thread::wait
}]

init