proc blast_results_init {} {
    global env
    global closeImg
    global checkedImg
    global uncheckedImg
    
    #Creating menu buttons
    .menubar.config.menu add command -label "Blast results" -command "blast_results_config"
    .menubar.tab.menu add command -label "Blast results" -command "catch {create_tab br}"
    
    if {[catch {set ft [open [pwd]/conf/blast_result_tace.conf r]} ]} {
        #Blast_results
        set env(blast_results.db) +
        set env(blast_results.id1) +
        set env(blast_results.id2) +
        set env(blast_results.length) +
        set env(blast_results.organism) +
        set env(blast_results.description) +
        set env(blast_results.product) +
        set env(blast_results.start) +
        set env(blast_results.end) +
        set env(blast_results.evalue) +
        set env(blast_results.score) +
        set env(blast_results.coverage) +
        set env(blast_results.perfection) +
    } else {
        #Blast_results
        gets $ft line
        gets $ft line
        set env(blast_results.db) [lindex $line 0]
        set env(blast_results.id1) [lindex $line 1]
        set env(blast_results.id2) [lindex $line 2]
        set env(blast_results.organism) [lindex $line 3]
        set env(blast_results.product) [lindex $line 4]
        set env(blast_results.description) [lindex $line 5]
        set env(blast_results.coverage) [lindex $line 6]
        set env(blast_results.perfection) [lindex $line 7]
        set env(blast_results.start) [lindex $line 8]
        set env(blast_results.end) [lindex $line 9]
        set env(blast_results.length) [lindex $line 10]
        set env(blast_results.evalue) [lindex $line 11]
        set env(blast_results.score) [lindex $line 12]
    }
    
    # Blastresults
    set notebook .result.notebook2.nb
    set frame [$notebook insert end br -text "Blast results" -raisecmd "catch {update_info_br}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab br"
    frame $frame.1
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb2_tl_blast_results $frame.1.table.l
    tablelist::tablelist $nb2_tl_blast_results \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {
                0 "" 0 "DB" \
                0 "id 1" 0 "id 2" 0 "organism" 0 "product" 0 "description" 0 "coverage" \
                0 "perfection" 0 "start" 0 "end" 0 "length" 0 "eValue" 0 "score" 0 "id_seq"} \
            -labelcommand "$nb2_tl_blast_results finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch {1 2 3 4 5 6 7 8 9 10 11 12 13} \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb2_tl_blast_results columnconfigure 0 \
            -sortmode integer \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    
    $nb2_tl_blast_results columnconfigure 14 -hide yes
    for {set i 6} {$i <= 12} {incr i} {
        $nb2_tl_blast_results columnconfigure $i -sortmode real
    }
    for {set i 1} {$i <= 5} {incr i} {
        $nb2_tl_blast_results columnconfigure $i -sortmode dictionary
    }
    
    if {$env(blast_results.db) eq "-"} {
        $nb2_tl_blast_results columnconfigure 1 -hide yes
    }
    if {$env(blast_results.id1) eq "-"} {
        $nb2_tl_blast_results columnconfigure 2 -hide yes
    }
    if {$env(blast_results.id2) eq "-"} {
        $nb2_tl_blast_results columnconfigure 3 -hide yes
    }
    if {$env(blast_results.organism) eq "-"} {
        $nb2_tl_blast_results columnconfigure 4 -hide yes
    }
    if {$env(blast_results.product) eq "-"} {
        $nb2_tl_blast_results columnconfigure 5 -hide yes
    }
    if {$env(blast_results.description) eq "-"} {
        $nb2_tl_blast_results columnconfigure 6 -hide yes
    }
    if {$env(blast_results.coverage) eq "-"} {
        $nb2_tl_blast_results columnconfigure 7 -hide yes
    }
    if {$env(blast_results.perfection) eq "-"} {
        $nb2_tl_blast_results columnconfigure 8 -hide yes
    }
    if {$env(blast_results.start) eq "-"} {
        $nb2_tl_blast_results columnconfigure 9 -hide yes
    }
    if {$env(blast_results.end) eq "-"} {
        $nb2_tl_blast_results columnconfigure 10 -hide yes
    }
    if {$env(blast_results.length) eq "-"} {
        $nb2_tl_blast_results columnconfigure 11 -hide yes
    }
    if {$env(blast_results.evalue) eq "-"} {
        $nb2_tl_blast_results columnconfigure 12 -hide yes
    }
    if {$env(blast_results.score) eq "-"} {
        $nb2_tl_blast_results columnconfigure 13 -hide yes
    }
    
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0.label1 -side left -fill both -anchor w; pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    #Blast_results rightmenu
    set tl .result.notebook2.nb.fbr.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set feat \[lindex \[$tl get \$y\] 1\]
    set id \[lindex \[$tl get \$y\] 2\]
    rightmenu_blast_result br \$feat \$id \$coord
    "
}

proc blast_results_remove {} {
    #Remove menu buttons
    .menubar.config.menu delete "Blast results"
    .menubar.tab.menu delete "Blast results"
    .result.notebook2.nb delete br
}

proc update_info_br {} {
    global env
    set env(contig.blastResultL) " "
    if {$env(contig.blast) ne 0} {
        set tmp ""
        if {$env(sequence_type) eq "nucleotide"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, db, id, \\\"start\\\", \\\"end\\\", length, evalue, score, perfection FROM $env(contig.dbName).blast_hits WHERE id_seq = '$env(contig.id_seq)' ORDER BY CAST(evalue AS numeric)"}}]]
        } elseif {$env(sequence_type) eq "protein"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_prot, db, id, \\\"start\\\", \\\"end\\\", length, evalue, score, perfection FROM $env(contig.dbName).blast_hits WHERE id_prot = '$env(contig.id_prot)' ORDER BY CAST(evalue AS numeric)"}}]]
        }
        foreach sRes $sql_res {
            if {[lindex $sRes 3] > [lindex $sRes 4]} {
                set coverage [split [expr (100.0 / $env(contig.length).0) * ([lindex $sRes 3].0 - [lindex $sRes 4].0)] .]
                set coverage "[lindex $coverage 0].[string range [lindex $coverage] 0 1]"
            } else {
                set coverage [split [expr (100.0 / $env(contig.length).0) * ([lindex $sRes 4].0 - [lindex $sRes 3].0)] .]
                set coverage "[lindex $coverage 0].[string range [lindex $coverage] 0 1]"
            }
            lappend tmp "[lindex $sRes 1] [lindex $sRes 2] [lindex $sRes 3] [lindex $sRes 4] [lindex $sRes 5] [lindex $sRes 6] [lindex $sRes 7] $coverage [lindex $sRes 8] [lindex $sRes 0]"
        }
        unset sql_res
        for {set i 0} {$i < [llength $tmp]} {incr i}  {
            set description "N/A"
            set organism "N/A"
            set product "N/A"
            set id2 "N/A"
            catch {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id2, organism, product, description FROM refdb.[lindex [lindex $tmp $i] 0] WHERE id = '[lindex [lindex $tmp $i] 1]'"}}]]
                foreach sRes $sql_res {
                    set id2 [lindex $sRes 0]
                    set organism [lindex $sRes 1]
                    if {[string length [lindex $sRes 2]] > 100} {
                        set product [string range [regsub -all {\}} [regsub -all {\{} [lindex $sRes 2] "("] ")"] 0 99]
                    } else {
                        set product [lindex $sRes 2]
                    }
                    if {[string length [lindex $sRes 3]] > 100} {
                        set description [string range [regsub -all {\}} [regsub -all {\{} [lindex $sRes 3] "("] ")"] 0 99]
                    } else {
                        set description [lindex $sRes 3]
                    }
                }
                unset sql_res
            }
            lappend env(contig.blastResultL) "[lrange [lindex $tmp $i] 0 1] $id2 {$organism} {$product} {$description} [lrange [lindex $tmp $i] 2 end]"
        }
        unset tmp
    }
    .result.notebook2.nb.fbr.0.label1 configure -text $env(contig.name)
    fillTable .result.notebook2.nb.fbr.1.table.l 0 0
}

proc update_info_br_table {start end} {
    global tabArr
    if {$tabArr(sb.exist) && $start ne ""} {
        .result.notebook1.nb.fsb.1.panel tag remove markedYellow 2.0 2.end
        .result.notebook1.nb.fsb.1.panel tag remove markedGreen 2.0 2.end
        .result.notebook1.nb.fsb.1.panel tag remove markedOrange 2.0 2.end
        if {$start ne "N/A"} {
            if {$start > $end} {
                .result.notebook1.nb.fsb.1.panel tag add markedYellow 2.[expr $end] 2.[expr $start]
            } else {
                .result.notebook1.nb.fsb.1.panel tag add markedYellow 2.[expr $start] 2.[expr $end]
            }
        }
    }
}

proc blast_results_config {} {
    global env
    
    set t .blast_results_config
    toplevel $t
    wm title $t "Blast Results Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.show
    
    frame $t.showColumn -bd 2 -relief groove
    label $t.showColumn.label -text "Columns displayed: "
    checkbutton $t.showColumn.db -text "db" -variable env(blast_results.db) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.seqname -text "seq name" -variable env(blast_results.seqname) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.organism -text "organism" -variable env(blast_results.organism) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.product -text "product" -variable env(blast_results.product) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.description -text "description" -variable env(blast_results.description) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.coverage -text "coverage" -variable env(blast_results.coverage) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.perfection -text "perfection" -variable env(blast_results.perfection) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.start -text "start" -variable env(blast_results.start) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.end -text "end" -variable env(blast_results.end) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.length -text "length" -variable env(blast_results.length) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.evalue -text "evalue" -variable env(blast_results.evalue) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.score -text "score" -variable env(blast_results.score) -offvalue "-" -onvalue "+"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "blast_result_changeConfig; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.showColumn.db $t.showColumn.seqname $t.showColumn.organism $t.showColumn.product $t.showColumn.description \
            $t.showColumn.coverage $t.showColumn.perfection $t.showColumn.start $t.showColumn.end \
            $t.showColumn.length $t.showColumn.evalue $t.showColumn.score -side top -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.showColumn $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc blast_result_changeConfig {} {
    global env
    
    if {$env(blast_results.db) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 1 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 1 -hide yes
    }
    if {$env(blast_results.id1) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 2 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 2 -hide yes
    }
    if {$env(blast_results.id2) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 3 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 3 -hide yes
    }
    if {$env(blast_results.organism) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 4 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 4 -hide yes
    }
    if {$env(blast_results.product) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 5 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 5 -hide yes
    }
    if {$env(blast_results.description) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 6 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 6 -hide yes
    }
    if {$env(blast_results.coverage) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 7 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 7 -hide yes
    }
    if {$env(blast_results.perfection) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 8 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 8 -hide yes
    }
    if {$env(blast_results.start) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 9 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 9 -hide yes
    }
    if {$env(blast_results.end) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 10 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 10 -hide yes
    }
    if {$env(blast_results.length) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 11 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 11 -hide yes
    }
    if {$env(blast_results.evalue) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 12 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 12 -hide yes
    }
    if {$env(blast_results.score) eq "+"} {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 13 -hide no
    } else {
        .result.notebook2.nb.fbr.1.table.l columnconfigure 13 -hide yes
    }
    
    if {[catch {set ft [open [pwd]/conf/blast_result_tace.conf w]} ]} {
        puts "error"
    } else {
        puts $ft "Blast_results"
        puts $ft "$env(blast_results.db) \
                $env(blast_results.id1) \
                $env(blast_results.id2) \
                $env(blast_results.organism) \
                $env(blast_results.product) \
                $env(blast_results.description) \
                $env(blast_results.coverage) \
                $env(blast_results.perfection) \
                $env(blast_results.start) \
                $env(blast_results.end) \
                $env(blast_results.length) \
                $env(blast_results.evalue) \
                $env(blast_results.score)"
        close $ft
    }
}

proc rightmenu_blast_result {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
   
    .rightmenu add command -label "Show all hits" -command "catch {search_right blast $id}"
    .rightmenu add separator
    .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.coverage) coverage" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.coverage 7"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.db) db" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.db 1"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.description) description" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.description 6"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.end) end" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.end 9"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.evalue) evalue" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.evalue 12"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.id1) id 1" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.id1 2"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.id2) id 2" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.id2 3"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.length) length" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.length 11"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.organism) organism" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.organism 4"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.perfection) perfection" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.perfection 8"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.product) product" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.product 5"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.score) score" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.score 13"
    .rightmenu.hidemenuColumn add command -label "$env(blast_results.start) start" -command "table_col_sh .result.notebook2.nb.fbr.1.table.l blast_results.start 9"
    .rightmenu add separator
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fbr.1.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fbr.1.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fbr.1.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fbr.1.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}