proc kegg_init {} {
    global closeImg
    global checkedImg
    global uncheckedImg
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "KEGG" -command "catch {create_tab kegg}"
    .menubar.tab.menu add command -label "KEGG Maps" -command "catch {create_tab keggM}"
    
    #KEGG Hits
    set notebook .result.notebook2.nb
    set frame [$notebook insert end kegg -text "KEGG" -raisecmd "catch {update_info_kegg}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab kegg"
    frame $frame.1
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb2_tl_kegg $frame.1.table.l
    tablelist::tablelist $nb2_tl_kegg \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {
                0 "" \
                0 "id" 0 "name" 0 "description"} \
            -labelcommand "$nb2_tl_kegg finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch 4 \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb2_tl_kegg columnconfigure 0 \
            -sortmode integer \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    
    $nb2_tl_kegg columnconfigure 1 -sortmode dictionary
    $nb2_tl_kegg columnconfigure 2 -sortmode dictionary
    
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0.label1 -side left -fill both -anchor w; pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    #KEGG Maps
    set frame [$notebook insert end keggM -text "KEGG Maps"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab keggM"
    frame $frame.1
    frame $frame.1.1
    frame $frame.1.1.1
    frame $frame.1.1.1.table
    scrollbar $frame.1.1.1.y -orient vertical -command "$frame.1.1.1.table.l yview"
    scrollbar $frame.1.1.x -orient horizontal -command "$frame.1.1.1.table.l xview"
    set nb2_tl_keggM $frame.1.1.1.table.l
    tablelist::tablelist $nb2_tl_keggM \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "ID" 0 "ko" 0 "ko %" 0 "contigs" 0 "description" 0 "id_seqL"} \
            -labelcommand "$nb2_tl_keggM finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch 4 \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.1.1.y set" \
            -xscrollcommand "$frame.1.1.x set" \
            -background white
    
    $nb2_tl_keggM columnconfigure 4 -sortmode dictionary
    $nb2_tl_keggM columnconfigure 2 -sortmode real
    $nb2_tl_keggM columnconfigure 5 -hide yes
    
    frame $frame.1.2
    frame $frame.1.2.1
    frame $frame.1.2.1.table
    scrollbar $frame.1.2.1.y -orient vertical -command "$frame.1.2.1.table.l yview"
    scrollbar $frame.1.2.x -orient horizontal -command "$frame.1.2.1.table.l xview"
    set nb2_tl_keggM2 $frame.1.2.1.table.l
    tablelist::tablelist $nb2_tl_keggM2 \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "" 0 "contig" 0 "ko" 0 "name" 0 "description" 0 "id_seq"} \
            -labelcommand "$nb2_tl_keggM2 finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch 4 \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.2.1.y set" \
            -xscrollcommand "$frame.1.2.x set" \
            -background white
    $nb2_tl_keggM2 columnconfigure 0 \
            -sortmode integer \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    
    $nb2_tl_keggM2 columnconfigure 1 -sortmode dictionary
    $nb2_tl_keggM2 columnconfigure 3 -sortmode dictionary
    $nb2_tl_keggM2 columnconfigure 4 -sortmode dictionary
    $nb2_tl_keggM2 columnconfigure 5 -hide yes
    
    pack $frame.1.1.1.table.l -side left -fill both -expand true
    pack $frame.1.1.1.y -side left -fill both; pack $frame.1.1.1.table -side left -fill both -expand true
    pack $frame.1.1.1 -side top -fill both -expand true; pack $frame.1.1.x -side top -fill both
    pack $frame.1.2.1.table.l -side left -fill both -expand true
    pack $frame.1.2.1.y -side left -fill both; pack $frame.1.2.1.table -side left -fill both -expand true
    pack $frame.1.2.1 -side top -fill both -expand true; pack $frame.1.2.x -side top -fill both
    pack $frame.1.1 $frame.1.2 -side left -fill both -expand true
    pack $frame.0.label1 -side left -fill both -anchor w; pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    #KEGG
    set tl .result.notebook2.nb.fkegg.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 1\]
    rightmenu_kegg kegg kegg \$id \$coord
    "
    #KEGG_maps
    set tl .result.notebook2.nb.fkeggM.1.1.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set name \[lindex \[$tl get \$y\] 4\]
    set idL \[lindex \[$tl get \$y\] 5\]
    rightmenu_kegg keggM \$name \$idL \$coord
    "
    #KEGG_maps
    set tl .result.notebook2.nb.fkeggM.1.2.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 5\]
    rightmenu_kegg keggM2 keggM2 \$id \$coord
    "
}

proc kegg_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "KEGG"
    .menubar.tab.menu delete "KEGG Maps"
    .result.notebook2.nb delete kegg
    .result.notebook2.nb delete keggM
}

proc update_info_kegg {} {
    global env
    
    set env(contig.keggL) " "
    if {$env(contig.kegg) ne 0} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id, name, description FROM refdb.kegg WHERE id IN (SELECT id FROM $env(contig.dbName).kegg_hits WHERE id_seq = '$env(contig.id_seq)')"}}]]
        foreach sRes $sql_res {
            lappend env(contig.keggL) "[lindex $sRes 0] {[lindex $sRes 1]} {[lindex $sRes 2]}"
        }
        unset sql_res
    }
    .result.notebook2.nb.fkegg.0.label1 configure -text $env(contig.name)
    fillTable .result.notebook2.nb.fkegg.1.table.l 0 0
}

proc update_info_kegg_maps {id_seqL} {
    global env
    global checkedImg
    global uncheckedImg
    
    set tmpString ""
    foreach id_seq $id_seqL {
        append tmpString ", '$id_seq'"
    }
    set tmpString [string range $tmpString 2 end]
    .result.notebook2.nb.fkeggM.1.2.1.table.l delete 0 end
    if {$tmpString ne ""} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT DISTINCT A.id_seq AS id_seq, A.ko_id AS ko_id, A.name AS ko_name, A.des AS des, $env(dbName).sequences_nucleotide.name AS name FROM (SELECT DISTINCT $env(dbName).kegg_hits.id_seq AS id_seq, $env(dbName).kegg_hits.id AS ko_id, refdb.kegg.name AS name, refdb.kegg.description AS des FROM $env(dbName).kegg_hits INNER JOIN refdb.kegg ON $env(dbName).kegg_hits.id = refdb.kegg.id WHERE $env(dbName).kegg_hits.id_seq IN ($tmpString)) A INNER JOIN $env(dbName).sequences_nucleotide ON $env(dbName).sequences_nucleotide.id_seq = A.id_seq ORDER BY A.des"}}]]
        foreach sRes $sql_res {
            .result.notebook2.nb.fkeggM.1.2.1.table.l insert end "1 [lindex $sRes 4] [lindex $sRes 1] {[lindex $sRes 2]} {[lindex $sRes 3]} [lindex $sRes 0]"
            .result.notebook2.nb.fkeggM.1.2.1.table.l cellconfigure end,0 -image [expr {1 ? $checkedImg : $uncheckedImg}]
            .result.notebook2.nb.fkeggM.1.2.1.table.l cellconfigure end,2 -window fillTable_createButton
        }
        unset sql_res
    }
    unset tmpString
    
    set env(contig.dbName) $env(dbName)
    # Bindings.
    bind [.result.notebook2.nb.fkeggM.1.2.1.table.l bodypath] <Button-1> "
    set y \[.result.notebook2.nb.fkeggM.1.2.1.table.l nearest \[expr {%y + \[winfo y %W\]}\]\]
    set name \[lindex \[.result.notebook2.nb.fkeggM.1.2.1.table.l get \$y\] 1\]
    update_info_get_name \$name name
    "
}

proc rightmenu_kegg {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    if {$mode eq "keggM"} {
        #KEGG_maps
        .rightmenu add command -label "Show all hits" -command "search_right {$mode {$feat}} {$id}"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fkeggM.1.1.1.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fkeggM.1.1.1.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fkeggM.1.1.1.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fkeggM.1.1.1.table.l}"
    } elseif {$mode eq "keggM2"} {
        #KEGG_maps
        .rightmenu add command -label "Add to blast" -command "catch {blast_add_seq $feat $id}"
        .rightmenu add command -label "Export read distribution" -command "db_info_export_readDistribution keggM2"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fkeggM.1.2.1.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fkeggM.1.2.1.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fkeggM.1.2.1.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fkeggM.1.2.1.table.l}"
    } elseif {$mode eq "kegg"} {
        #KEGG
        .rightmenu add command -label "Show all hits" -command "catch {search_right kegg $id}"
        .rightmenu add separator
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fkegg.1.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fkegg.1.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fkegg.1.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fkegg.1.table.l}"
    }
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}