proc protein_viewer_init {} {
    global env
    global closeImg
    global checkedImg
    global uncheckedImg
    global pv_markL
    
    set env(protein_mark.aliphatic) -
    set env(protein_mark.aromatic) -
    set env(protein_mark.big) -
    set env(protein_mark.charged) -
    set env(protein_mark.hydrophobic) -
    set env(protein_mark.negative) -
    set env(protein_mark.polar) -
    set env(protein_mark.positive) -
    set env(protein_mark.serthr) -
    set env(protein_mark.small) -
    set env(protein_mark.tiny) -
    
    set pv_markL "0 0 0 0 0 0 0 0 0 0 0"
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "Protein viewer" -command "catch {create_tab pv}"
    
    # Protein Viewer
    set notebook .result.notebook2.nb 
    set frame [$notebook insert end pv -text "Protein viewer" -raisecmd "catch {update_info_pv}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab pv"
    frame $frame.1
    frame $frame.1.tab
    frame $frame.1.tab.table
    scrollbar $frame.1.tab.y -orient vertical -command "$frame.1.tab.table.l yview"
    set nb2_tl_pv $frame.1.tab.table.l
    tablelist::tablelist $nb2_tl_pv \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "Hit" 0 "frame" 0 "orf" 0 "length" 0 "id_prot" 0 "hits"} \
            -exportselection 0 \
            -stretch {1 2 3} \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.tab.y set" \
            -background white
    $nb2_tl_pv columnconfigure 4 -hide yes
    $nb2_tl_pv columnconfigure 5 -hide yes
    text $frame.1.panel -background white -width 100 -height 1
    
    pack $frame.0.label1 -side left -fill both -anchor w
    pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.1.tab.table.l -fill both -side top -expand true
    pack $frame.1.tab.table -fill both -side left -expand true; pack $frame.1.tab.y -fill both -side left
    pack $frame.1.tab $frame.1.panel -fill both -side left -expand true
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    .result.notebook2.nb.fpv.1.panel tag configure bold12 -font {-family courier -size 12 -weight bold}
    .result.notebook2.nb.fpv.1.panel tag configure bold11 -font {-family courier -size 11 -weight bold}
    .result.notebook2.nb.fpv.1.panel tag configure bold11r -font {-family courier -size 11 -weight bold} -foreground red2
    .result.notebook2.nb.fpv.1.panel tag configure bold_italics -font {-family courier -size 12 -weight bold -slant italic}
    .result.notebook2.nb.fpv.1.panel tag configure hel -font {-family helvetica -size 16 -weight bold}
    .result.notebook2.nb.fpv.1.panel tag configure helred -font {-family helvetica -size 16 -weight bold} -foreground red4
    .result.notebook2.nb.fpv.1.panel tag configure color1 -foreground red
    .result.notebook2.nb.fpv.1.panel tag configure smallBut -font {-family courier -size 6 -weight bold}
    .result.notebook2.nb.fpv.1.panel tag configure sunken -relief sunken -borderwidth 1
    
    .result.notebook2.nb.fpv.1.panel tag configure markedYellow -background yellow
    .result.notebook2.nb.fpv.1.panel tag configure markedGreen -background green
    .result.notebook2.nb.fpv.1.panel tag configure markedOrange -background orange
    .result.notebook2.nb.fpv.1.panel tag configure markedRed -background red
    .result.notebook2.nb.fpv.1.panel tag configure markedBlue -background blue
    .result.notebook2.nb.fpv.1.panel tag configure unmarked -background white
    .result.notebook2.nb.fpv.1.panel tag configure textGreen -foreground green
    
    #Protein_viewer rightmenu
    set tl .result.notebook2.nb.fpv.1.tab.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 2\]
    rightmenu_protein_viewer pv pv \$id \$coord
    "
    #Protein_viewer text field rightmenu
    global pv_markL
    set tl .result.notebook2.nb.fpv.1.panel
    bind $tl <Button-3> "
    rightmenu_protein_viewer pv_text - - -
    "
}

proc protein_viewer_mark {mode} {
    global pv_markL
    global env
    
    #Alanin            Ala    A
    #Arginin           Arg    R
    #Asparagin         Asn    N
    #Asparaginsäure   Asp    D
    #Cystein           Cys    C
    #Glutamin          Gln    Q
    #Glutaminsäure    Glu    E
    #Glycin            Gly    G
    #Histidin          His    H
    #Isoleucin         Ile    I
    #Leucin            Leu    L
    #Lysin             Lys    K
    #Methionin 	       Met    M
    #Phenylalanin 	    Phe    F
    #Prolin 	          Pro    P
    #Serin 	           Ser    S
    #Threonin 	        Thr    T
    #Tryptophan 	      Trp    W
    #Tyrosin 	         Tyr    Y
    #Valin             Val    V
    
    #Aliphatic         I L V
    #Aromatic          H F W Y
    #Big               R Q E H I L K M F W Y
    #Charged           R D E H K
    #Hydrophobic       A C G H I L M F T W Y V
    #Negative          D E
    #Polar             R N D C Q E H K S T
    #Positive          R H K
    #Ser/Thr           S T
    #Small             A N D C G P S T
    #Tiny              A G S
    
    if {$mode eq "update"} {
    } elseif {$mode eq "all"} {
        foreach ent {aliphatic aromatic big charged hydrophobic negative polar positive serthr small tiny} {
            set env(protein_mark.$ent) +
        }
    } elseif {$mode eq "none"} {
        foreach ent {aliphatic aromatic big charged hydrophobic negative polar positive serthr small tiny} {
            set env(protein_mark.$ent) -
        }
    } elseif {$env(protein_mark.$mode) eq "+"} {
        set env(protein_mark.$mode) -
    } else {
        set env(protein_mark.$mode) +
    }
    
    foreach aa {A R N D C Q E G H I L K M F P S T W Y V} {
        catch {.result.notebook2.nb.fpv.1.panel tag remove $aa 2.0 end}
        catch {.result.notebook2.nb.fpv.1.panel delete 3.0 end}
        set $aa "255 255 255"
    }
    
    foreach ent {aliphatic aromatic big charged hydrophobic negative polar positive serthr small tiny} {
        switch $ent {
            aliphatic    {if {$env(protein_mark.$ent) eq "+"} {set I [protein_viewer_mark_rgb $I "255 236 139"]; set L [protein_viewer_mark_rgb $L "255 236 139"]; set V [protein_viewer_mark_rgb $V "255 236 139"]}}
            aromatic     {if {$env(protein_mark.$ent) eq "+"} {set H [protein_viewer_mark_rgb $H "255 165 79"]; set F [protein_viewer_mark_rgb $F "255 165 79"]; set W [protein_viewer_mark_rgb $W "255 165 79"]; set Y [protein_viewer_mark_rgb $Y "255 165 79"]}}
            big          {if {$env(protein_mark.$ent) eq "+"} {set R [protein_viewer_mark_rgb $R "121 205 205"]; set Q [protein_viewer_mark_rgb $Q "121 205 205"]; set E [protein_viewer_mark_rgb $E "121 205 205"]; set H [protein_viewer_mark_rgb $H "121 205 205"]; set I [protein_viewer_mark_rgb $I "121 205 205"]; set L [protein_viewer_mark_rgb $L "121 205 205"]; set K [protein_viewer_mark_rgb $K "121 205 205"]; set M [protein_viewer_mark_rgb $M "121 205 205"]; set F [protein_viewer_mark_rgb $F "121 205 205"]; set W [protein_viewer_mark_rgb $W "121 205 205"]; set Y [protein_viewer_mark_rgb $Y "121 205 205"]}}
            charged      {if {$env(protein_mark.$ent) eq "+"} {set R [protein_viewer_mark_rgb $R "238 106 167"]; set D [protein_viewer_mark_rgb $D "238 106 167"]; set E [protein_viewer_mark_rgb $E "238 106 167"]; set H [protein_viewer_mark_rgb $H "238 106 167"]; set K [protein_viewer_mark_rgb $K "238 106 167"]}}
            hydrophobic  {if {$env(protein_mark.$ent) eq "+"} {set A [protein_viewer_mark_rgb $A "179 238 58"]; set C [protein_viewer_mark_rgb $C "179 238 58"]; set G [protein_viewer_mark_rgb $G "179 238 58"]; set H [protein_viewer_mark_rgb $H "179 238 58"]; set I [protein_viewer_mark_rgb $I "179 238 58"]; set L [protein_viewer_mark_rgb $L "179 238 58"]; set M [protein_viewer_mark_rgb $M "179 238 58"]; set T [protein_viewer_mark_rgb $T "179 238 58"]; set F [protein_viewer_mark_rgb $F "179 238 58"]; set W [protein_viewer_mark_rgb $W "179 238 58"]; set Y [protein_viewer_mark_rgb $Y "179 238 58"]; set V [protein_viewer_mark_rgb $V "179 238 58"]}}
            negative     {if {$env(protein_mark.$ent) eq "+"} {set D [protein_viewer_mark_rgb $D "238 59 59"]; set E [protein_viewer_mark_rgb $E "238 59 59"]}}
            polar        {if {$env(protein_mark.$ent) eq "+"} {set R [protein_viewer_mark_rgb $R "154 50 205"]; set N [protein_viewer_mark_rgb $N "154 50 205"]; set D [protein_viewer_mark_rgb $D "154 50 205"]; set C [protein_viewer_mark_rgb $C "154 50 205"]; set Q [protein_viewer_mark_rgb $Q "154 50 205"]; set E [protein_viewer_mark_rgb $E "154 50 205"]; set H [protein_viewer_mark_rgb $H "154 50 205"]; set K [protein_viewer_mark_rgb $K "154 50 205"]; set S [protein_viewer_mark_rgb $S "154 50 205"]; set T [protein_viewer_mark_rgb $T "154 50 205"]}}
            positive     {if {$env(protein_mark.$ent) eq "+"} {set R [protein_viewer_mark_rgb $R "105 89 205"]; set H [protein_viewer_mark_rgb $H "105 89 205"]; set K [protein_viewer_mark_rgb $K "105 89 205"]}}
            serthr       {if {$env(protein_mark.$ent) eq "+"} {set S [protein_viewer_mark_rgb $S "50 205 50"]; set T [protein_viewer_mark_rgb $T "50 205 50"]}}
            small        {if {$env(protein_mark.$ent) eq "+"} {set A [protein_viewer_mark_rgb $A "238 106 167"]; set N [protein_viewer_mark_rgb $N "238 106 167"]; set D [protein_viewer_mark_rgb $D "238 106 167"]; set C [protein_viewer_mark_rgb $C "238 106 167"]; set G [protein_viewer_mark_rgb $G "238 106 167"]; set P [protein_viewer_mark_rgb $P "238 106 167"]; set S [protein_viewer_mark_rgb $S "238 106 167"]; set T [protein_viewer_mark_rgb $T "238 106 167"]}}
            tiny         {if {$env(protein_mark.$ent) eq "+"} {set A [protein_viewer_mark_rgb $A "84 255 159"]; set G [protein_viewer_mark_rgb $G "84 255 159"]; set S [protein_viewer_mark_rgb $S "84 255 159"]}}
        }
    }
    foreach aa {A R N D C Q E G H I L K M F P S T W Y V} {
        switch $aa {
            A    {set A [toHex $A]; .result.notebook2.nb.fpv.1.panel tag configure A -background #$A; .result.notebook2.nb.fpv.1.panel insert end "\n\nA : alanine\n"}
            R    {set R [toHex $R]; .result.notebook2.nb.fpv.1.panel tag configure R -background #$R; .result.notebook2.nb.fpv.1.panel insert end "R : arginine\n"}
            N    {set N [toHex $N]; .result.notebook2.nb.fpv.1.panel tag configure N -background #$N; .result.notebook2.nb.fpv.1.panel insert end "N : asparagine\n"}
            D    {set D [toHex $D]; .result.notebook2.nb.fpv.1.panel tag configure D -background #$D; .result.notebook2.nb.fpv.1.panel insert end "D : aspartic acid\n"}
            C    {set C [toHex $C]; .result.notebook2.nb.fpv.1.panel tag configure C -background #$C; .result.notebook2.nb.fpv.1.panel insert end "C : cysteine\n"}
            Q    {set Q [toHex $Q]; .result.notebook2.nb.fpv.1.panel tag configure Q -background #$Q; .result.notebook2.nb.fpv.1.panel insert end "Q : glutamine\n"}
            E    {set E [toHex $E]; .result.notebook2.nb.fpv.1.panel tag configure E -background #$E; .result.notebook2.nb.fpv.1.panel insert end "E : glutamic acid\n"}
            G    {set G [toHex $G]; .result.notebook2.nb.fpv.1.panel tag configure G -background #$G; .result.notebook2.nb.fpv.1.panel insert end "G : glycine\n"}
            H    {set H [toHex $H]; .result.notebook2.nb.fpv.1.panel tag configure H -background #$H; .result.notebook2.nb.fpv.1.panel insert end "H : histidine\n"}
            I    {set I [toHex $I]; .result.notebook2.nb.fpv.1.panel tag configure I -background #$I; .result.notebook2.nb.fpv.1.panel insert end "I : isoleucine\n"}
            L    {set L [toHex $L]; .result.notebook2.nb.fpv.1.panel tag configure L -background #$L; .result.notebook2.nb.fpv.1.panel insert end "L : leucine\n"}
            K    {set K [toHex $K]; .result.notebook2.nb.fpv.1.panel tag configure K -background #$K; .result.notebook2.nb.fpv.1.panel insert end "K : lysine\n"}
            M    {set M [toHex $M]; .result.notebook2.nb.fpv.1.panel tag configure M -background #$M; .result.notebook2.nb.fpv.1.panel insert end "M : methionine\n"}
            F    {set F [toHex $F]; .result.notebook2.nb.fpv.1.panel tag configure F -background #$F; .result.notebook2.nb.fpv.1.panel insert end "F : phenylalanine\n"}
            P    {set P [toHex $P]; .result.notebook2.nb.fpv.1.panel tag configure P -background #$P; .result.notebook2.nb.fpv.1.panel insert end "P : proline\n"}
            S    {set S [toHex $S]; .result.notebook2.nb.fpv.1.panel tag configure S -background #$S; .result.notebook2.nb.fpv.1.panel insert end "S : serine\n"}
            T    {set T [toHex $T]; .result.notebook2.nb.fpv.1.panel tag configure T -background #$T; .result.notebook2.nb.fpv.1.panel insert end "T : threonine\n"}
            W    {set W [toHex $W]; .result.notebook2.nb.fpv.1.panel tag configure W -background #$W; .result.notebook2.nb.fpv.1.panel insert end "W : tryptophan\n"}
            Y    {set Y [toHex $Y]; .result.notebook2.nb.fpv.1.panel tag configure Y -background #$Y; .result.notebook2.nb.fpv.1.panel insert end "Y : tyrosine\n"}
            V    {set V [toHex $V]; .result.notebook2.nb.fpv.1.panel tag configure V -background #$V; .result.notebook2.nb.fpv.1.panel insert end "V : valine\n"}
        }
    }
    .result.notebook2.nb.fpv.1.panel tag configure markedGreen -background green
    
    set txt "{[regsub -all {\n} [.result.notebook2.nb.fpv.1.panel get -displaychars 2.0 end] "\} \{"]}"
    set r 2
    foreach row $txt {
        for {set i 0} {$i < [string length $row]} {incr i} {
            switch [string index $row $i] {
                A    {if {$A ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add A $r.$i $r.[expr $i + 1]}}
                R    {if {$R ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add R $r.$i $r.[expr $i + 1]}}
                N    {if {$N ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add N $r.$i $r.[expr $i + 1]}}
                D    {if {$D ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add D $r.$i $r.[expr $i + 1]}}
                C    {if {$C ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add C $r.$i $r.[expr $i + 1]}}
                Q    {if {$Q ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add Q $r.$i $r.[expr $i + 1]}}
                E    {if {$E ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add E $r.$i $r.[expr $i + 1]}}
                G    {if {$G ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add G $r.$i $r.[expr $i + 1]}}
                H    {if {$H ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add H $r.$i $r.[expr $i + 1]}}
                I    {if {$I ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add I $r.$i $r.[expr $i + 1]}}
                L    {if {$L ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add L $r.$i $r.[expr $i + 1]}}
                K    {if {$K ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add K $r.$i $r.[expr $i + 1]}}
                M    {if {$M ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add M $r.$i $r.[expr $i + 1]}}
                F    {if {$F ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add F $r.$i $r.[expr $i + 1]}}
                P    {if {$P ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add P $r.$i $r.[expr $i + 1]}}
                S    {if {$S ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add S $r.$i $r.[expr $i + 1]}}
                T    {if {$T ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add T $r.$i $r.[expr $i + 1]}}
                W    {if {$W ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add W $r.$i $r.[expr $i + 1]}}
                Y    {if {$Y ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add Y $r.$i $r.[expr $i + 1]}}
                V    {if {$V ne "FFFFFF"} {.result.notebook2.nb.fpv.1.panel tag add V $r.$i $r.[expr $i + 1]}}
            }
        }
        incr r
    }
}

proc protein_viewer_mark_rgb {color minus} {
    set r [expr [lindex $color 0] + [lindex $minus 0] - 255]
    set g [expr [lindex $color 1] + [lindex $minus 1] - 255]
    set b [expr [lindex $color 2] + [lindex $minus 2] - 255]
    if {$r < 80} {
        set r 80
    } elseif {$r > 255} {
        set r 255
    }
    if {$g < 80} {
        set g 80
    } elseif {$g > 255} {
        set g 255
    }
    if {$b < 80} {
        set b 80
    } elseif {$b > 255} {
        set b 255
    }
    return "$r $g $b"
}

proc toHex {rgb} {
    append hex "[string index "0123456789ABCDEF" [expr (([lindex $rgb 0]-[lindex $rgb 0]%16)/16)]][string index "0123456789ABCDEF" [expr [lindex $rgb 0]%16]]"
    append hex "[string index "0123456789ABCDEF" [expr (([lindex $rgb 1]-[lindex $rgb 1]%16)/16)]][string index "0123456789ABCDEF" [expr [lindex $rgb 1]%16]]"
    append hex "[string index "0123456789ABCDEF" [expr (([lindex $rgb 2]-[lindex $rgb 2]%16)/16)]][string index "0123456789ABCDEF" [expr [lindex $rgb 2]%16]]"
    return $hex
}


proc update_info_pv {} {
    global env
    .result.notebook2.nb.fpv.0.label1 configure -text $env(contig.name)
    .result.notebook2.nb.fpv.1.panel delete 1.0 end
    fillTable .result.notebook2.nb.fpv.1.tab.table.l 0 0
}

proc update_info_pv_table {id_prot} {
    global env
    global tabArr
    
    if {$id_prot ne ""} {
        if {$env(sequence_type) eq "nucleotide"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, frame, orf, length, sequence FROM $env(contig.dbName).sequences_protein WHERE id_prot = '$id_prot'"}}]]
            foreach sRes $sql_res {
                set name [lindex $sRes 0]
                set frame [lindex $sRes 1]
                set orf [lindex $sRes 2]
                set length [lindex $sRes 3]
                set sequence [lindex $sRes 4]
            }
            unset sql_res
            
            switch $frame {
                + {set h 0; set i 0}
                - {set h 1; set i 0}
                1 {set h 0; set i 0}
                2 {set h 0; set i 1}
                3 {set h 0; set i 2}
                4 {set h 1; set i 0}
                5 {set h 1; set i 1}
                6 {set h 1; set i 2}
            }
            
            set pos [translateNuc $env(contig.sequence) $sequence $frame]
            if {$pos ne ""} {
                if {$h} {
                    set nstart [expr [string length $env(contig.sequence)] - [lindex $pos 1]]
                    set nend [expr [string length $env(contig.sequence)] - [lindex $pos 0]]
                    set tstart [expr $nstart - 1]
                    set tend [expr $nend]
                } else {
                    set nstart [expr [lindex $pos 0]]
                    set nend [lindex $pos 1]
                    set tstart [expr $nstart + 1]
                    set tend [expr $nend]
                }
                if {$tabArr(sb.exist)} {
                    catch {.result.notebook1.nb.fsb.1.panel tag remove markedGreen 1.0 1000.end}
                    .result.notebook1.nb.fsb.1.panel tag add markedGreen 2.$nstart 2.$nend
                }
            } else {
                set nstart ""
                set nend ""
                set tstart ???
                set tend ???
            }
            .result.notebook2.nb.fpv.1.panel delete 1.0 end
            .result.notebook2.nb.fpv.1.panel insert end ">$name\tframe=$frame\torf=$orf\tlength=$length\tstart=$tstart\tend=$tend\n" bold11
            .result.notebook2.nb.fpv.1.panel insert end "$sequence\n"
            unset nstart; unset nend; unset tstart; unset tend
        } elseif {$env(sequence_type) eq "protein"} {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT frame, orf FROM $env(contig.dbName).sequences_protein WHERE id_prot = '$id_prot'"}}]]
            foreach sRes $sql_res {
                set frame [lindex $sRes 0]
                set orf [lindex $sRes 1]
            }
            unset sql_res
            if {$frame ne -1} {
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT sequence FROM $env(contig.dbName).sequences_nucleotide WHERE id_seq = '$env(contig.id_seq)'"}}]]
                foreach sRes $sql_res {
                    set sequence [lindex $sRes 0]
                }
                unset sql_res
                
                switch $frame {
                    + {set h 0; set i 0}
                    - {set h 1; set i 0}
                    1 {set h 0; set i 0}
                    2 {set h 0; set i 1}
                    3 {set h 0; set i 2}
                    4 {set h 1; set i 0}
                    5 {set h 1; set i 1}
                    6 {set h 1; set i 2}
                }
                
                set pos [translateNuc $sequence $env(contig.sequence) $frame]
                if {$pos ne ""} {
                    if {$h} {
                        set nstart [expr [string length $sequence] - [lindex $pos 1]]
                        set nend [expr [string length $sequence] - [lindex $pos 0]]
                        set tstart [expr $nstart - 1]
                        set tend [expr $nend]
                    } else {
                        set nstart [expr [lindex $pos 0]]
                        set nend [lindex $pos 1]
                        set tstart [expr $nstart + 1]
                        set tend [expr $nend]
                    }
                    if {$tabArr(sb.exist)} {
                        catch {.result.notebook1.nb.fsb.1.panel tag remove markedGreen 1.0 1000.end}
                        .result.notebook1.nb.fsb.1.panel tag add markedGreen 5.$nstart 5.$nend
                    }
                } else {
                    set nstart ""
                    set nend ""
                    set tstart ???
                    set tend ???
                }
                .result.notebook2.nb.fpv.1.panel delete 1.0 end
                .result.notebook2.nb.fpv.1.panel insert end ">$env(contig.name)\tframe=$frame\torf=$orf\tlength=$env(contig.length)\tstart=$tstart\tend=$tend\n" bold11
                .result.notebook2.nb.fpv.1.panel insert end "$env(contig.sequence)\n"
                unset nstart; unset nend; unset tstart; unset tend
            }
        }
        protein_viewer_mark update
    }
}

proc rightmenu_protein_viewer {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    if {$mode eq "pv"} {
        #Protein_viewer
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fpv.1.tab.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fpv.1.tab.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fpv.1.tab.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fpv.1.tab.table.l}"
    } elseif {$mode eq "pv_text"} {
        #Protein_viewer text field
        .rightmenu add command -label "Search" -command "search_pattern_window search_pattern_mark .result.notebook2.nb.fpv.1.panel"
        .rightmenu add cascade -label "Mark..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "all" -command "catch {protein_viewer_mark all}"
        .rightmenu.copymenu add command -label "none" -command "catch {protein_viewer_mark none}"
        .rightmenu.copymenu add separator
        .rightmenu.copymenu add command -label "$env(protein_mark.aliphatic) Aliphatic" -command "catch {protein_viewer_mark aliphatic}"
        .rightmenu.copymenu add command -label "$env(protein_mark.aromatic) Aromatic" -command "catch {protein_viewer_mark aromatic}"
        .rightmenu.copymenu add command -label "$env(protein_mark.big) Big" -command "catch {protein_viewer_mark big}"
        .rightmenu.copymenu add command -label "$env(protein_mark.charged) Charged" -command "catch {protein_viewer_mark charged}"
        .rightmenu.copymenu add command -label "$env(protein_mark.hydrophobic) Hydrophobic" -command "catch {protein_viewer_mark hydrophobic}"
        .rightmenu.copymenu add command -label "$env(protein_mark.negative) Negative" -command "catch {protein_viewer_mark negative}"
        .rightmenu.copymenu add command -label "$env(protein_mark.polar) Polar" -command "catch {protein_viewer_mark polar}"
        .rightmenu.copymenu add command -label "$env(protein_mark.positive) Positive" -command "catch {protein_viewer_mark positive}"
        .rightmenu.copymenu add command -label "$env(protein_mark.serthr) Ser/Thr" -command "catch {protein_viewer_mark serthr}"
        .rightmenu.copymenu add command -label "$env(protein_mark.small) Small" -command "catch {protein_viewer_mark small}"
        .rightmenu.copymenu add command -label "$env(protein_mark.tiny) Tiny" -command "catch {protein_viewer_mark tiny}"
    }
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}